import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Animate from 'rc-animate';
import Icon from '../Icon';
import classNames from 'classnames';
function noop() {}
function getDataOrAriaProps(props) {
  var _context;
  return _reduceInstanceProperty(_context = _Object$keys(props)).call(_context, function (prev, key) {
    if ((key.substr(0, 5) === 'data-' || key.substr(0, 5) === 'aria-' || key === 'role') && key.substr(0, 7) !== 'data-__') {
      prev[key] = props[key];
    }
    return prev;
  }, {});
}
var Alert = /*#__PURE__*/function (_React$Component) {
  _inherits(Alert, _React$Component);
  var _super = _createSuper(Alert);
  function Alert(props) {
    var _this;
    _classCallCheck(this, Alert);
    _this = _super.call(this, props);
    _this.handleClose = function (e) {
      e.preventDefault();
      var dom = ReactDOM.findDOMNode(_assertThisInitialized(_this));
      dom.style.height = "".concat(dom.offsetHeight, "px");
      // Magic code
      // 重复一次后才能正确设置 height
      dom.style.height = "".concat(dom.offsetHeight, "px");
      _this.setState({
        closing: false
      });
      (_this.props.onClose || noop)(e);
    };
    _this.animationEnd = function () {
      _this.setState({
        closed: true,
        closing: true
      });
      (_this.props.afterClose || noop)();
    };
    _this.state = {
      closing: true,
      closed: false
    };
    return _this;
  }
  _createClass(Alert, [{
    key: "render",
    value: function render() {
      var _context2, _classNames;
      var _this$props = this.props,
        closable = _this$props.closable,
        description = _this$props.description,
        type = _this$props.type,
        _this$props$prefixCls = _this$props.prefixCls,
        prefixCls = _this$props$prefixCls === void 0 ? 'fishd-alert' : _this$props$prefixCls,
        message = _this$props.message,
        closeText = _this$props.closeText,
        showIcon = _this$props.showIcon,
        banner = _this$props.banner,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        style = _this$props.style,
        iconType = _this$props.iconType;
      // banner模式默认有 Icon
      showIcon = banner && showIcon === undefined ? true : showIcon;
      // banner模式默认为警告
      type = banner && type === undefined ? 'warning' : type || 'info';
      if (!iconType) {
        switch (type) {
          case 'success':
            iconType = 'hints-success';
            break;
          case 'info':
            iconType = 'hints-notification';
            break;
          case 'error':
            iconType = 'hints-error';
            break;
          case 'warning':
            iconType = 'hints-warning';
            break;
          // 展示空icon
          default:
            iconType = 'default';
        }
        // use outline icon in alert with description
        if (description) {
          iconType += '-o';
        }
      }
      var alertCls = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context2 = "".concat(prefixCls, "-")).call(_context2, type), true), _defineProperty(_classNames, "".concat(prefixCls, "-close"), !this.state.closing), _defineProperty(_classNames, "".concat(prefixCls, "-with-description"), !!description), _defineProperty(_classNames, "".concat(prefixCls, "-no-icon"), !showIcon), _defineProperty(_classNames, "".concat(prefixCls, "-banner"), !!banner), _classNames), className);
      // closeable when closeText is assigned
      if (closeText) {
        closable = true;
      }
      var closeIcon = closable ? /*#__PURE__*/React.createElement("a", {
        onClick: this.handleClose,
        className: "".concat(prefixCls, "-close-icon")
      }, closeText || /*#__PURE__*/React.createElement(Icon, {
        type: "close-modal-line"
      })) : null;
      var dataOrAriaProps = getDataOrAriaProps(this.props);
      return this.state.closed ? null : /*#__PURE__*/React.createElement(Animate, {
        component: "",
        showProp: "data-show",
        transitionName: "".concat(prefixCls, "-slide-up"),
        onEnd: this.animationEnd
      }, /*#__PURE__*/React.createElement("div", _Object$assign({
        "data-show": this.state.closing,
        className: alertCls,
        style: style
      }, dataOrAriaProps), showIcon ? /*#__PURE__*/React.createElement(Icon, {
        className: "".concat(prefixCls, "-icon"),
        type: iconType
      }) : null, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-message")
      }, message), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-description")
      }, description), closeIcon));
    }
  }]);
  return Alert;
}(React.Component);
export { Alert as default };