import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
var AnchorLink = /*#__PURE__*/function (_React$Component) {
  _inherits(AnchorLink, _React$Component);
  var _super = _createSuper(AnchorLink);
  function AnchorLink() {
    var _this;
    _classCallCheck(this, AnchorLink);
    _this = _super.apply(this, arguments);
    _this.handleClick = function (e) {
      var _this$context$fishdAn = _this.context.fishdAnchor,
        scrollTo = _this$context$fishdAn.scrollTo,
        onClick = _this$context$fishdAn.onClick;
      var _this$props = _this.props,
        href = _this$props.href,
        title = _this$props.title;
      if (onClick) {
        onClick(e, {
          title: title,
          href: href
        });
      }
      scrollTo(href);
    };
    return _this;
  }
  _createClass(AnchorLink, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.context.fishdAnchor.registerLink(this.props.href);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.href !== prevProps.href) {
        this.context.fishdAnchor.unregisterLink(prevProps.href);
        this.context.fishdAnchor.registerLink(this.props.href);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.context.fishdAnchor.unregisterLink(this.props.href);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        href = _this$props2.href,
        title = _this$props2.title,
        children = _this$props2.children;
      var active = this.context.fishdAnchor.activeLink === href;
      var wrapperClassName = classNames("".concat(prefixCls, "-link"), _defineProperty({}, "".concat(prefixCls, "-link-active"), active));
      var titleClassName = classNames("".concat(prefixCls, "-link-title"), _defineProperty({}, "".concat(prefixCls, "-link-title-active"), active));
      if (children) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-link-group")
        }, /*#__PURE__*/React.createElement("div", {
          className: wrapperClassName
        }, /*#__PURE__*/React.createElement("a", {
          className: titleClassName,
          // href={href}
          title: typeof title === 'string' ? title : '',
          onClick: this.handleClick
        }, title)), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-children")
        }, children));
      }
      return /*#__PURE__*/React.createElement("div", {
        className: wrapperClassName
      }, /*#__PURE__*/React.createElement("a", {
        className: titleClassName,
        // href={href}
        title: typeof title === 'string' ? title : '',
        onClick: this.handleClick
      }, title));
    }
  }]);
  return AnchorLink;
}(React.Component);
export { AnchorLink as default };
AnchorLink.defaultProps = {
  prefixCls: 'fishd-anchor',
  href: '#'
};
AnchorLink.contextTypes = {
  fishdAnchor: PropTypes.object
};