import React, { Component } from 'react';
export interface CollapsePanelProps {
    header: string | number | Function;
    onItemClick: () => void;
    disabled: boolean;
    onCloseItem: () => void;
    itemKey: string;
    className: string;
    prefixCls: string;
    showClose: boolean;
    style: React.CSSProperties;
    isActive: boolean;
}
export interface CollapsePanelState {
    isCustom: boolean;
}
declare class CollapsePanel extends Component<CollapsePanelProps, CollapsePanelState> {
    static propTypes: {
        itemKey: any;
        className: any;
        style: any;
        children: any;
        openAnimation: any;
        prefixCls: any;
        disabled: any;
        header: any;
        showClose: any;
        isActive: any;
        onItemClick: any;
        onCloseItem: any;
    };
    static defaultProps: {
        isActive: boolean;
        disabled: boolean;
        style: {};
        onItemClick(): void;
        onCloseItem(): void;
    };
    constructor(props: any);
    handleItemClick(): void;
    handleItemClose(e: any): void;
    getHeader: (status: any) => any;
    render(): JSX.Element;
}
export default CollapsePanel;
