import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Icon from '../Icon';
import PanelContent from './PanelContent';
var CollapsePanel = /*#__PURE__*/function (_Component) {
  _inherits(CollapsePanel, _Component);
  var _super = _createSuper(CollapsePanel);
  function CollapsePanel(props) {
    var _context, _context2;
    var _this;
    _classCallCheck(this, CollapsePanel);
    _this = _super.call(this, props);
    _this.getHeader = function (status) {
      var header = _this.props.header;
      if (typeof header === 'function') {
        return header(status);
      } else {
        return header;
      }
    };
    _this.handleItemClick = _bindInstanceProperty(_context = _this.handleItemClick).call(_context, _assertThisInitialized(_this));
    _this.handleItemClose = _bindInstanceProperty(_context2 = _this.handleItemClose).call(_context2, _assertThisInitialized(_this));
    _this.state = {
      isCustom: typeof _this.props.header === 'function' //是否显示箭头,不可关闭时不显示
    };
    return _this;
  }
  _createClass(CollapsePanel, [{
    key: "handleItemClick",
    value: function handleItemClick() {
      var _this$props = this.props,
        onItemClick = _this$props.onItemClick,
        disabled = _this$props.disabled;
      if (!disabled) {
        onItemClick();
      }
    }
  }, {
    key: "handleItemClose",
    value: function handleItemClose(e) {
      e.stopPropagation();
      var _this$props2 = this.props,
        onCloseItem = _this$props2.onCloseItem,
        disabled = _this$props2.disabled;
      if (!disabled) {
        onCloseItem();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames, _classNames2;
      var _this$props3 = this.props,
        itemKey = _this$props3.itemKey,
        className = _this$props3.className,
        prefixCls = _this$props3.prefixCls,
        disabled = _this$props3.disabled,
        showClose = _this$props3.showClose,
        style = _this$props3.style,
        children = _this$props3.children,
        isActive = _this$props3.isActive;
      var isCustom = this.state.isCustom;
      var headerCls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-header"), true), _defineProperty(_classNames, "".concat(prefixCls, "-header-disabled"), disabled), _defineProperty(_classNames, "".concat(prefixCls, "-header-close"), showClose), _defineProperty(_classNames, "".concat(prefixCls, "-header-custom"), isCustom), _classNames));
      var itemCls = classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-item"), true), _defineProperty(_classNames2, "".concat(prefixCls, "-item-active"), isActive), _defineProperty(_classNames2, className, className), _classNames2));
      var closeCls = classNames({
        close: true,
        'z-close-show': showClose
      });
      var getArrowIcon = function getArrowIcon(isActive) {
        if (isActive) {
          return /*#__PURE__*/React.createElement(Icon, {
            className: "icon",
            type: "top"
          });
        } else {
          return /*#__PURE__*/React.createElement(Icon, {
            className: "icon",
            type: "bottom"
          });
        }
      };
      return /*#__PURE__*/React.createElement("div", {
        className: itemCls,
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: headerCls,
        onClick: this.handleItemClick,
        role: "tab",
        "aria-expanded": isActive,
        ref: itemKey
      }, /*#__PURE__*/React.createElement("div", {
        className: "arrow"
      }, getArrowIcon(isActive)), /*#__PURE__*/React.createElement("div", {
        className: "title"
      }, this.getHeader(isActive)), /*#__PURE__*/React.createElement("div", {
        className: closeCls,
        onClick: this.handleItemClose
      }, /*#__PURE__*/React.createElement(Icon, {
        className: "icon",
        type: "picture-close"
      }))), /*#__PURE__*/React.createElement(PanelContent, {
        prefixCls: prefixCls,
        isActive: isActive
      }, children));
    }
  }]);
  return CollapsePanel;
}(Component);
CollapsePanel.propTypes = {
  itemKey: PropTypes.func,
  className: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
  style: PropTypes.object,
  children: PropTypes.node,
  openAnimation: PropTypes.object,
  prefixCls: PropTypes.string,
  disabled: PropTypes.bool,
  header: PropTypes.oneOfType([PropTypes.string, PropTypes.number, PropTypes.func]),
  showClose: PropTypes.bool,
  isActive: PropTypes.bool,
  onItemClick: PropTypes.func,
  onCloseItem: PropTypes.func
};
CollapsePanel.defaultProps = {
  isActive: false,
  disabled: false,
  style: {},
  onItemClick: function onItemClick() {},
  onCloseItem: function onCloseItem() {}
};
export default CollapsePanel;