import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import BasePicker from './BasePicker';
import TimeSelectPanel from './panel/TimeSelectPanel';
import ConfigConsumer from '../Config/Consumer';
var TimeSelect = /*#__PURE__*/function (_BasePicker) {
  _inherits(TimeSelect, _BasePicker);
  var _super = _createSuper(TimeSelect);
  function TimeSelect(props) {
    _classCallCheck(this, TimeSelect);
    //props, type, state
    return _super.call(this, props, 'timeselect', {});
  }
  _createClass(TimeSelect, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      return _get(_getPrototypeOf(TimeSelect.prototype), "isDateValid", this).call(this, value) &&
      // @ts-ignore
      TimeSelectPanel.isValid(this.dateToStr(value), this.props);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this = this;
      var value = state.value && this.isDateValid(state.value) ? this.dateToStr(state.value) : null;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(TimeSelectPanel, _Object$assign({}, _this.props, {
          value: value,
          onPicked: _this.onPicked,
          dateParser: function dateParser(str) {
            return str ? _this.parseDate(str) : null;
          }
        }));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return _Object$assign({}, {
        start: PropTypes.string,
        end: PropTypes.string,
        step: PropTypes.string,
        minTime: PropTypes.string,
        maxTime: PropTypes.string
      }, BasePicker.propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return _Object$assign({}, BasePicker.defaultProps);
    }
  }]);
  return TimeSelect;
}(BasePicker);
export { TimeSelect as default };