import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Popover from '../../Popover/index';
import scrollIntoView from 'dom-scroll-into-view';
var YearAndMonthPopover = /*#__PURE__*/function (_React$Component) {
  _inherits(YearAndMonthPopover, _React$Component);
  var _super = _createSuper(YearAndMonthPopover);
  function YearAndMonthPopover(props) {
    var _this;
    _classCallCheck(this, YearAndMonthPopover);
    _this = _super.call(this, props);
    _this.scrollToOption = function () {
      var menu = _this.refs.root;
      var active = menu.getElementsByClassName('active')[0];
      active && scrollIntoView(active, menu, {
        offsetTop: 91,
        alignWithTop: true
      });
    };
    _this.handleVisibleChange = function (visible) {
      _this.setState({
        visible: visible
      }, function () {
        if (visible) {
          _this.scrollToOption();
        }
      });
    };
    _this.state = {
      visible: false
    };
    return _this;
  }
  _createClass(YearAndMonthPopover, [{
    key: "handleOnClick",
    value: function handleOnClick(item) {
      var _this2 = this;
      this.setState({
        visible: false
      }, function () {
        _this2.props.onChange(item);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props = this.props,
        children = _this$props.children,
        sourceData = _this$props.sourceData,
        value = _this$props.value,
        prefixCls = _this$props.prefixCls;
      var content = function content() {
        return /*#__PURE__*/React.createElement("div", {
          ref: "root",
          className: "".concat(prefixCls, "-year-and-month-popover")
        }, _mapInstanceProperty(sourceData).call(sourceData, function (item) {
          var _classNames, _context;
          return /*#__PURE__*/React.createElement("li", {
            className: classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-year-and-month-popover-item"), true), _defineProperty(_classNames, "active", value == item || typeof item === 'string' && _sliceInstanceProperty(item).call(item, -1) == '月' && value == _sliceInstanceProperty(item).call(item, 0, -1)), _classNames)),
            key: item,
            onClick: _bindInstanceProperty(_context = _this3.handleOnClick).call(_context, _this3, item)
          }, item);
        }));
      };
      return /*#__PURE__*/React.createElement(Popover, {
        transitionName: '',
        content: content(),
        trigger: "click",
        placement: "bottom",
        visible: this.state.visible,
        onVisibleChange: this.handleVisibleChange,
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        },
        forceRender: true
      }, children);
    }
  }]);
  return YearAndMonthPopover;
}(React.Component);
export { YearAndMonthPopover as default };
YearAndMonthPopover.propTypes = {
  sourceData: PropTypes.array.isRequired,
  onChange: PropTypes.func,
  children: PropTypes.node,
  value: PropTypes.number,
  prefixCls: PropTypes.string
};
YearAndMonthPopover.defaultProps = {
  prefixCls: 'fishd'
};