import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
export var BAR_MAP = {
  vertical: {
    offset: 'offsetHeight',
    scroll: 'scrollTop',
    scrollSize: 'scrollHeight',
    size: 'height',
    key: 'vertical',
    axis: 'Y',
    client: 'clientY',
    direction: 'top'
  },
  horizontal: {
    offset: 'offsetWidth',
    scroll: 'scrollLeft',
    scrollSize: 'scrollWidth',
    size: 'width',
    key: 'horizontal',
    axis: 'X',
    client: 'clientX',
    direction: 'left'
  }
};
export function renderThumbStyle(_ref) {
  var _context;
  var move = _ref.move,
    size = _ref.size,
    bar = _ref.bar;
  var style = {};
  var translate = _concatInstanceProperty(_context = "translate".concat(bar.axis, "(")).call(_context, move, "%)");
  style[bar.size] = size;
  style.transform = translate;
  style.msTransform = translate;
  style.WebkitTransform = translate;
  return style;
}