import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import classNames from 'classnames';
export default function Divider(_a) {
  var _context, _context2, _classNames, _context3;
  var _a$prefixCls = _a.prefixCls,
    prefixCls = _a$prefixCls === void 0 ? 'fishd' : _a$prefixCls,
    _a$type = _a.type,
    type = _a$type === void 0 ? 'horizontal' : _a$type,
    _a$orientation = _a.orientation,
    orientation = _a$orientation === void 0 ? '' : _a$orientation,
    className = _a.className,
    children = _a.children,
    dashed = _a.dashed,
    textStyle = _a.textStyle,
    restProps = __rest(_a, ["prefixCls", "type", "orientation", "className", "children", "dashed", "textStyle"]);
  var orientationPrefix = orientation.length > 0 ? '-' + orientation : orientation;
  var classString = classNames(className, "".concat(prefixCls, "-divider"), _concatInstanceProperty(_context = "".concat(prefixCls, "-divider-")).call(_context, type), (_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context2 = "".concat(prefixCls, "-divider-with-text")).call(_context2, orientationPrefix), children), _defineProperty(_classNames, "".concat(prefixCls, "-divider-dashed"), dashed), _classNames));
  //纵向文字仅支持字符串格式
  var verticalText = type === 'vertical' && children && _mapInstanceProperty(_context3 = children.toString().split('')).call(_context3, function (text, i) {
    return /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-divider-vertical-child"),
      key: i
    }, text);
  });
  return /*#__PURE__*/React.createElement("div", _Object$assign({
    className: classString
  }, restProps), children && /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-divider-inner-text"),
    style: textStyle
  }, verticalText ? verticalText : children));
}