import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import RcDropdown from './src';
import classNames from 'classnames';
import warning from 'warning';
var Dropdown = /*#__PURE__*/function (_React$Component) {
  _inherits(Dropdown, _React$Component);
  var _super = _createSuper(Dropdown);
  function Dropdown() {
    _classCallCheck(this, Dropdown);
    return _super.apply(this, arguments);
  }
  _createClass(Dropdown, [{
    key: "getTransitionName",
    value: function getTransitionName() {
      var _this$props = this.props,
        _this$props$placement = _this$props.placement,
        placement = _this$props$placement === void 0 ? '' : _this$props$placement,
        transitionName = _this$props.transitionName;
      if (transitionName !== undefined) {
        return transitionName;
      }
      if (_indexOfInstanceProperty(placement).call(placement, 'top') >= 0) {
        return 'slide-down';
      }
      return 'slide-up';
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var overlay = this.props.overlay;
      if (overlay) {
        var overlayProps = overlay.props;
        warning(!overlayProps.mode || overlayProps.mode === 'vertical', "mode=\"".concat(overlayProps.mode, "\" is not supported for Dropdown's Menu."));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        children = _this$props2.children,
        prefixCls = _this$props2.prefixCls,
        overlayElements = _this$props2.overlay,
        trigger = _this$props2.trigger,
        disabled = _this$props2.disabled;
      var child = React.Children.only(children);
      var overlay = React.Children.only(overlayElements);
      var dropdownTrigger = /*#__PURE__*/React.cloneElement(child, {
        className: classNames(child.props.className, "".concat(prefixCls, "-trigger")),
        disabled: disabled
      });
      // menu cannot be selectable in dropdown defaultly
      // menu should be focusable in dropdown defaultly
      var _overlay$props = overlay.props,
        _overlay$props$select = _overlay$props.selectable,
        selectable = _overlay$props$select === void 0 ? false : _overlay$props$select,
        _overlay$props$focusa = _overlay$props.focusable,
        focusable = _overlay$props$focusa === void 0 ? true : _overlay$props$focusa;
      var fixedModeOverlay = typeof overlay.type === 'string' ? overlay : /*#__PURE__*/React.cloneElement(overlay, {
        mode: 'vertical',
        selectable: selectable,
        focusable: focusable
      });
      var triggerActions = disabled ? [] : trigger;
      var alignPoint;
      if (triggerActions && _indexOfInstanceProperty(triggerActions).call(triggerActions, 'contextMenu') !== -1) {
        alignPoint = true;
      }
      return /*#__PURE__*/React.createElement(RcDropdown, _Object$assign({
        alignPoint: alignPoint
      }, this.props, {
        transitionName: this.getTransitionName(),
        trigger: triggerActions,
        overlay: fixedModeOverlay
      }), dropdownTrigger);
    }
  }]);
  return Dropdown;
}(React.Component);
export { Dropdown as default };
Dropdown.defaultProps = {
  prefixCls: 'fishd-dropdown',
  mouseEnterDelay: 0.15,
  mouseLeaveDelay: 0.1,
  placement: 'bottomLeft'
};