import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import classNames from 'classnames';
import PropTypes from 'prop-types';
import ReactEcharts from 'echarts-for-react';
import defaultTheme from './default-theme';
var Echart = /*#__PURE__*/function (_Component) {
  _inherits(Echart, _Component);
  var _super = _createSuper(Echart);
  function Echart(props) {
    var _this;
    _classCallCheck(this, Echart);
    _this = _super.call(this, props);
    _this.echarts_react = null;
    return _this;
  }
  _createClass(Echart, [{
    key: "getInstance",
    value: function getInstance() {
      // @ts-ignore
      return this.echarts_react.getEchartsInstance();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        option = _this$props.option,
        opts = _this$props.opts,
        events = _this$props.events,
        notMerge = _this$props.notMerge,
        lazyUpdate = _this$props.lazyUpdate,
        onChartReady = _this$props.onChartReady,
        loadingOption = _this$props.loadingOption,
        showLoading = _this$props.showLoading;
      return /*#__PURE__*/React.createElement(ReactEcharts, {
        ref: function ref(e) {
          return _this2.echarts_react = e;
        },
        className: classNames(prefixCls, className),
        style: style,
        option: option,
        opts: opts,
        onEvents: events,
        theme: theme,
        notMerge: notMerge,
        lazyUpdate: lazyUpdate,
        onChartReady: onChartReady,
        loadingOption: loadingOption,
        showLoading: showLoading
      });
    }
  }]);
  return Echart;
}(Component);
export { Echart as default };
Echart.propTypes = {
  prefixCls: PropTypes.string,
  option: PropTypes.object,
  opts: PropTypes.object,
  events: PropTypes.object,
  className: PropTypes.string,
  style: PropTypes.object,
  theme: PropTypes.string,
  notMerge: PropTypes.bool,
  lazyUpdate: PropTypes.bool,
  onChartReady: PropTypes.func,
  loadingOption: PropTypes.object,
  showLoading: PropTypes.bool
};
Echart.defaultProps = {
  prefixCls: 'fishd-chart',
  theme: defaultTheme,
  notMerge: false,
  lazyUpdate: false,
  style: {
    height: '300px'
  },
  className: '',
  onChartReady: function onChartReady() {},
  showLoading: false,
  loadingOption: null,
  onEvents: {},
  opts: {}
};