import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Tooltip from '../Tooltip';
import EllipsisText from './EllipsisText';
/* eslint react/no-did-mount-set-state: 0 */
/* eslint no-param-reassign: 0 */
// @ts-ignore
var isSupportLineClamp = document.body.style.webkitLineClamp !== undefined;
var Ellipsis = /*#__PURE__*/function (_React$Component) {
  _inherits(Ellipsis, _React$Component);
  var _super = _createSuper(Ellipsis);
  function Ellipsis() {
    var _this;
    _classCallCheck(this, Ellipsis);
    _this = _super.apply(this, arguments);
    _this.state = {
      text: '',
      targetCount: 0,
      tooltipVisible: false
    };
    _this.getTargetNode = function () {
      var target;
      if (_this.props.width) {
        target = _this.widthNode;
      } else if (_this.props.lines && isSupportLineClamp) {
        target = _this.lineClampNode;
      }
      return target;
    };
    _this.computeLine = function () {
      var lines = _this.props.lines;
      if (lines && !isSupportLineClamp) {
        var text = _this.shadowChildren.innerText || _this.shadowChildren.textContent;
        var lineHeight = _parseInt(getComputedStyle(_this.root).lineHeight, 10);
        var targetHeight = lines * lineHeight;
        _this.content.style.height = "".concat(targetHeight, "px");
        var totalHeight = _this.shadowChildren.offsetHeight;
        var shadowNode = _this.shadow.firstChild;
        if (totalHeight <= targetHeight) {
          _this.setState({
            text: text,
            targetCount: text.length
          });
          return;
        }
        // bisection
        var len = text.length;
        var mid = Math.ceil(len / 2);
        var count = _this.bisection(targetHeight, mid, 0, len, text, shadowNode);
        _this.setState({
          text: text,
          targetCount: count
        });
      }
    };
    _this.bisection = function (th, m, b, e, text, shadowNode) {
      var suffix = '...';
      var mid = m;
      var end = e;
      var begin = b;
      shadowNode.innerHTML = text.substring(0, mid) + suffix;
      var sh = shadowNode.offsetHeight;
      if (sh <= th) {
        shadowNode.innerHTML = text.substring(0, mid + 1) + suffix;
        sh = shadowNode.offsetHeight;
        if (sh > th || mid === begin) {
          return mid;
        }
        begin = mid;
        if (end - begin === 1) {
          mid = 1 + begin;
        } else {
          mid = Math.floor((end - begin) / 2) + begin;
        }
        return _this.bisection(th, mid, begin, end, text, shadowNode);
      }
      if (mid - 1 < 0) {
        return mid;
      }
      shadowNode.innerHTML = text.substring(0, mid - 1) + suffix;
      sh = shadowNode.offsetHeight;
      if (sh <= th) {
        return mid - 1;
      }
      end = mid;
      mid = Math.floor((end - begin) / 2) + begin;
      return _this.bisection(th, mid, begin, end, text, shadowNode);
    };
    _this.handleRoot = function (n) {
      _this.root = n;
    };
    _this.handleContent = function (n) {
      _this.content = n;
    };
    _this.handleNode = function (n) {
      _this.node = n;
    };
    _this.handleShadow = function (n) {
      _this.shadow = n;
    };
    _this.handleShadowChildren = function (n) {
      _this.shadowChildren = n;
    };
    _this.handleTooltipVisibleChange = function (visible) {
      var node = _this.getTargetNode();
      if (!node) {
        return;
      }
      var tooltipVisible = visible && (node.offsetHeight < node.scrollHeight || node.offsetWidth < node.scrollWidth);
      _this.setState(function (state) {
        var shouldReset = state.tooltipVisible !== tooltipVisible;
        return shouldReset ? {
          tooltipVisible: tooltipVisible
        } : null;
      });
    };
    return _this;
  }
  _createClass(Ellipsis, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.node) {
        this.computeLine();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(perProps) {
      var _this$props = this.props,
        lines = _this$props.lines,
        children = _this$props.children;
      if (lines !== perProps.lines || children !== perProps.children) {
        this.computeLine();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this,
        _context;
      var _this$state = this.state,
        text = _this$state.text,
        targetCount = _this$state.targetCount,
        tooltipVisible = _this$state.tooltipVisible;
      var _a = this.props,
        children = _a.children,
        lines = _a.lines,
        length = _a.length,
        width = _a.width,
        className = _a.className,
        tooltip = _a.tooltip,
        style = _a.style,
        fullWidthRecognition = _a.fullWidthRecognition,
        prefix = _a.prefix,
        tooltipProps = _a.tooltipProps,
        restProps = __rest(_a, ["children", "lines", "length", "width", "className", "tooltip", "style", "fullWidthRecognition", "prefix", "tooltipProps"]);
      var cls = classNames("".concat(prefix, "-ellipsis"), className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefix, "-width-mode"), width), _defineProperty(_classNames, "".concat(prefix, "-line"), lines && !isSupportLineClamp), _defineProperty(_classNames, "".concat(prefix, "-lineClamp"), lines && isSupportLineClamp), _classNames));
      // 一种限制都没有返回原值
      if (!lines && !length && !width) {
        return /*#__PURE__*/React.createElement("span", _Object$assign({
          className: cls
        }, restProps), children);
      }
      // 宽度限制
      if (width) {
        var node = /*#__PURE__*/React.createElement("span", _Object$assign({
          ref: function ref(node) {
            return _this2.widthNode = node;
          },
          className: cls
        }, restProps, {
          style: _Object$assign(_Object$assign({}, style), {
            maxWidth: width
          })
        }), children);
        return tooltip ? /*#__PURE__*/React.createElement(Tooltip, _Object$assign({}, tooltipProps, {
          overlayClassName: "".concat(prefix, "-tooltip"),
          title: children,
          visible: tooltipVisible,
          onVisibleChange: this.handleTooltipVisibleChange
        }), node) : node;
      }
      // 字数限制
      if (length) {
        return /*#__PURE__*/React.createElement(EllipsisText, _Object$assign({
          prefix: prefix,
          className: cls,
          tooltipProps: tooltipProps,
          length: length,
          text: children || '',
          tooltip: tooltip,
          fullWidthRecognition: fullWidthRecognition
        }, restProps));
      }
      //行数限制
      var id = "fishd-ellipsis-".concat(_concatInstanceProperty(_context = "".concat(new Date().getTime())).call(_context, Math.floor(Math.random() * 100)));
      // support document.body.style.webkitLineClamp
      if (isSupportLineClamp) {
        var _context2;
        var _style = _concatInstanceProperty(_context2 = "#".concat(id, "{-webkit-line-clamp:")).call(_context2, lines, ";-webkit-box-orient: vertical;}");
        var _node = /*#__PURE__*/React.createElement("div", _Object$assign({
          ref: function ref(node) {
            return _this2.lineClampNode = node;
          },
          id: id,
          className: cls
        }, restProps), /*#__PURE__*/React.createElement("style", null, _style), children);
        return tooltip ? /*#__PURE__*/React.createElement(Tooltip, _Object$assign({}, tooltipProps, {
          overlayClassName: "".concat(prefix, "-tooltip"),
          title: children,
          visible: tooltipVisible,
          onVisibleChange: this.handleTooltipVisibleChange
        }), _node) : _node;
      }
      var childNode = /*#__PURE__*/React.createElement("span", {
        ref: this.handleNode
      }, targetCount > 0 && text.substring(0, targetCount), targetCount > 0 && targetCount < text.length && '...');
      return /*#__PURE__*/React.createElement("div", _Object$assign({}, restProps, {
        ref: this.handleRoot,
        className: cls
      }), /*#__PURE__*/React.createElement("div", {
        ref: this.handleContent
      }, tooltip ? /*#__PURE__*/React.createElement(Tooltip, {
        overlayClassName: "".concat(prefix, "-tooltip"),
        title: text
      }, childNode) : childNode, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "-shadow"),
        ref: this.handleShadowChildren
      }, children), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "-shadow"),
        ref: this.handleShadow
      }, /*#__PURE__*/React.createElement("span", null, text))));
    }
  }]);
  return Ellipsis;
}(React.Component);
export { Ellipsis as default };
Ellipsis.defaultProps = {
  prefix: 'fishd-ellipsis',
  fullWidthRecognition: false,
  tooltip: true,
  tooltipProps: {}
};
Ellipsis.propTypes = {
  prefix: PropTypes.string,
  lines: PropTypes.number,
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
  length: PropTypes.number,
  tooltip: PropTypes.bool,
  tooltipProps: PropTypes.object,
  fullWidthRecognition: PropTypes.bool,
  className: PropTypes.string,
  style: PropTypes.object,
  children: PropTypes.node
};