import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Number$parseInt from "@babel/runtime-corejs3/core-js-stable/number/parse-int";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { addEventListener } from '../../utils';
var FooterToolbar = /*#__PURE__*/function (_React$Component) {
  _inherits(FooterToolbar, _React$Component);
  var _super = _createSuper(FooterToolbar);
  function FooterToolbar(props) {
    var _this;
    _classCallCheck(this, FooterToolbar);
    _this = _super.call(this, props);
    _this.state = {
      offset: 0
    };
    _this.setToolbarPosition = function () {
      var target = _this.props.target;
      var _getComputedStyle = getComputedStyle(_this.wrapper),
        height = _getComputedStyle.height;
      var wrapperHeight = _Number$parseInt(height);
      var targetElement = document.documentElement;
      if (target && typeof target === 'function' && target() !== window) {
        targetElement = target();
      }
      var offsetObj = {
        containerHeight: targetElement.clientHeight,
        containerScrollTop: targetElement.scrollTop
      };
      var offset = offsetObj.containerHeight + offsetObj.containerScrollTop - wrapperHeight;
      var maxOffset = targetElement.scrollHeight - wrapperHeight;
      _this.setState({
        offset: offset > maxOffset ? maxOffset : offset
      });
    };
    return _this;
  }
  _createClass(FooterToolbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.setToolbarPosition();
      var target = this.props.target && this.props.target() || window;
      this.scrollListener = addEventListener(target, 'scroll', function () {
        _this2.setToolbarPosition();
      });
      this.resizeListener = addEventListener(window, 'resize', function () {
        _this2.setToolbarPosition();
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.scrollListener) {
        this.scrollListener.remove();
      }
      if (this.resizeListener) {
        this.resizeListener.remove();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this3 = this;
      var _this$props = this.props,
        children = _this$props.children,
        className = _this$props.className,
        prefixCls = _this$props.prefixCls,
        style = _this$props.style;
      var toolbarStyle = _Object$assign(_Object$assign({}, style), {
        position: 'absolute',
        top: this.state.offset
      });
      return /*#__PURE__*/React.createElement("div", {
        className: classNames((_classNames = {}, _defineProperty(_classNames, className, true), _defineProperty(_classNames, prefixCls, true), _classNames)),
        style: toolbarStyle,
        ref: function ref(wrapper) {
          _this3.wrapper = wrapper;
        }
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, children));
    }
  }]);
  return FooterToolbar;
}(React.Component);
FooterToolbar.defaultProps = {
  children: null,
  className: '',
  prefixCls: 'fishd-footer-toolbar'
};
FooterToolbar.propTypes = {
  children: PropTypes.node,
  className: PropTypes.string,
  prefixCls: PropTypes.string,
  target: PropTypes.func,
  style: PropTypes.object
};
export default FooterToolbar;