import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
var stringOrNumber = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);
var objectOrNumber = PropTypes.oneOfType([PropTypes.object, PropTypes.number]);
var Col = /*#__PURE__*/function (_React$Component) {
  _inherits(Col, _React$Component);
  var _super = _createSuper(Col);
  function Col() {
    _classCallCheck(this, Col);
    return _super.apply(this, arguments);
  }
  _createClass(Col, [{
    key: "render",
    value: function render() {
      var _context, _context12, _context13, _context14, _context15, _context16, _classNames;
      var props = this.props;
      var span = props.span,
        order = props.order,
        offset = props.offset,
        push = props.push,
        pull = props.pull,
        className = props.className,
        style = props.style,
        children = props.children,
        _props$prefixCls = props.prefixCls,
        prefixCls = _props$prefixCls === void 0 ? 'fishd-col' : _props$prefixCls,
        others = __rest(props, ["span", "order", "offset", "push", "pull", "className", "style", "children", "prefixCls"]);
      var sizeClassObj = {};
      _forEachInstanceProperty(_context = ['xs', 'sm', 'md', 'lg', 'xl', 'xxl']).call(_context, function (size) {
        var _context2, _context3, _context4, _context5, _context6, _context7, _context8, _context9, _context10, _context11, _Object$assign2;
        var sizeProps = {};
        if (typeof props[size] === 'number') {
          sizeProps.span = props[size];
        } else if (_typeof(props[size]) === 'object') {
          sizeProps = props[size] || {};
        }
        delete others[size];
        sizeClassObj = _Object$assign(_Object$assign({}, sizeClassObj), (_Object$assign2 = {}, _defineProperty(_Object$assign2, _concatInstanceProperty(_context2 = _concatInstanceProperty(_context3 = "".concat(prefixCls, "-")).call(_context3, size, "-")).call(_context2, sizeProps.span), sizeProps.span !== undefined), _defineProperty(_Object$assign2, _concatInstanceProperty(_context4 = _concatInstanceProperty(_context5 = "".concat(prefixCls, "-")).call(_context5, size, "-order-")).call(_context4, sizeProps.order), sizeProps.order || sizeProps.order === 0), _defineProperty(_Object$assign2, _concatInstanceProperty(_context6 = _concatInstanceProperty(_context7 = "".concat(prefixCls, "-")).call(_context7, size, "-offset-")).call(_context6, sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), _defineProperty(_Object$assign2, _concatInstanceProperty(_context8 = _concatInstanceProperty(_context9 = "".concat(prefixCls, "-")).call(_context9, size, "-push-")).call(_context8, sizeProps.push), sizeProps.push || sizeProps.push === 0), _defineProperty(_Object$assign2, _concatInstanceProperty(_context10 = _concatInstanceProperty(_context11 = "".concat(prefixCls, "-")).call(_context11, size, "-pull-")).call(_context10, sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _Object$assign2));
      });
      var classes = classNames((_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context12 = "".concat(prefixCls, "-")).call(_context12, span), span !== undefined), _defineProperty(_classNames, _concatInstanceProperty(_context13 = "".concat(prefixCls, "-order-")).call(_context13, order), order), _defineProperty(_classNames, _concatInstanceProperty(_context14 = "".concat(prefixCls, "-offset-")).call(_context14, offset), offset), _defineProperty(_classNames, _concatInstanceProperty(_context15 = "".concat(prefixCls, "-push-")).call(_context15, push), push), _defineProperty(_classNames, _concatInstanceProperty(_context16 = "".concat(prefixCls, "-pull-")).call(_context16, pull), pull), _classNames), className, sizeClassObj);
      return /*#__PURE__*/React.createElement("div", _Object$assign({}, others, {
        className: classes,
        style: style
      }), children);
    }
  }]);
  return Col;
}(React.Component);
export { Col as default };
Col.propTypes = {
  span: stringOrNumber,
  order: stringOrNumber,
  offset: stringOrNumber,
  push: stringOrNumber,
  pull: stringOrNumber,
  className: PropTypes.string,
  style: PropTypes.object,
  children: PropTypes.node,
  xs: objectOrNumber,
  sm: objectOrNumber,
  md: objectOrNumber,
  lg: objectOrNumber,
  xl: objectOrNumber,
  xxl: objectOrNumber
};