import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/// <reference module="dom">
// matchMedia polyfill for
// https://github.com/WickyNilliams/enquire.js/issues/82
var enquire;
if (typeof window !== 'undefined') {
  var matchMediaPolyfill = function matchMediaPolyfill(mediaQuery) {
    return {
      media: mediaQuery,
      matches: false,
      addListener: function addListener() {},
      removeListener: function removeListener() {}
    };
  };
  window.matchMedia = window.matchMedia || matchMediaPolyfill;
  enquire = require('enquire.js');
}
import * as React from 'react';
import { Children, cloneElement } from 'react';
import classNames from 'classnames';
import * as PropTypes from 'prop-types';
var responsiveArray = ['xxl', 'xl', 'lg', 'md', 'sm', 'xs'];
var responsiveMap = {
  xs: '(max-width: 575px)',
  sm: '(min-width: 576px)',
  md: '(min-width: 768px)',
  lg: '(min-width: 992px)',
  xl: '(min-width: 1200px)',
  xxl: '(min-width: 1600px)'
};
var Row = /*#__PURE__*/function (_React$Component) {
  _inherits(Row, _React$Component);
  var _super = _createSuper(Row);
  function Row() {
    var _this;
    _classCallCheck(this, Row);
    _this = _super.apply(this, arguments);
    _this.state = {
      screens: {}
    };
    return _this;
  }
  _createClass(Row, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _context,
        _this2 = this;
      _mapInstanceProperty(_context = _Object$keys(responsiveMap)).call(_context, function (screen) {
        return enquire.register(responsiveMap[screen], {
          match: function match() {
            if (_typeof(_this2.props.gutter) !== 'object') {
              return;
            }
            _this2.setState(function (prevState) {
              return {
                screens: _Object$assign(_Object$assign({}, prevState.screens), _defineProperty({}, screen, true))
              };
            });
          },
          unmatch: function unmatch() {
            if (_typeof(_this2.props.gutter) !== 'object') {
              return;
            }
            _this2.setState(function (prevState) {
              return {
                screens: _Object$assign(_Object$assign({}, prevState.screens), _defineProperty({}, screen, false))
              };
            });
          },
          // Keep a empty destory to avoid triggering unmatch when unregister
          destroy: function destroy() {}
        });
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _context2;
      _mapInstanceProperty(_context2 = _Object$keys(responsiveMap)).call(_context2, function (screen) {
        return enquire.unregister(responsiveMap[screen]);
      });
    }
  }, {
    key: "getGutter",
    value: function getGutter() {
      var gutter = this.props.gutter;
      if (_typeof(gutter) === 'object') {
        for (var i = 0; i <= responsiveArray.length; i++) {
          var breakpoint = responsiveArray[i];
          if (this.state.screens[breakpoint] && gutter[breakpoint] !== undefined) {
            return gutter[breakpoint];
          }
        }
      }
      return gutter;
    }
  }, {
    key: "render",
    value: function render() {
      var _context3, _context4, _context5, _context6, _context7, _classNames;
      var _a = this.props,
        type = _a.type,
        justify = _a.justify,
        align = _a.align,
        className = _a.className,
        style = _a.style,
        children = _a.children,
        _a$prefixCls = _a.prefixCls,
        prefixCls = _a$prefixCls === void 0 ? 'fishd-row' : _a$prefixCls,
        others = __rest(_a, ["type", "justify", "align", "className", "style", "children", "prefixCls"]);
      var gutter = this.getGutter();
      var classes = classNames((_classNames = {}, _defineProperty(_classNames, prefixCls, !type), _defineProperty(_classNames, _concatInstanceProperty(_context3 = "".concat(prefixCls, "-")).call(_context3, type), type), _defineProperty(_classNames, _concatInstanceProperty(_context4 = _concatInstanceProperty(_context5 = "".concat(prefixCls, "-")).call(_context5, type, "-")).call(_context4, justify), type && justify), _defineProperty(_classNames, _concatInstanceProperty(_context6 = _concatInstanceProperty(_context7 = "".concat(prefixCls, "-")).call(_context7, type, "-")).call(_context6, align), type && align), _classNames), className);
      var rowStyle = gutter > 0 ? _Object$assign({
        marginLeft: gutter / -2,
        marginRight: gutter / -2
      }, style) : style;
      var cols = _mapInstanceProperty(Children).call(Children, children, function (col) {
        if (!col) {
          return null;
        }
        if (col.props && gutter > 0) {
          return /*#__PURE__*/cloneElement(col, {
            style: _Object$assign({
              paddingLeft: gutter / 2,
              paddingRight: gutter / 2
            }, col.props.style)
          });
        }
        return col;
      });
      var otherProps = _Object$assign({}, others);
      delete otherProps.gutter;
      return /*#__PURE__*/React.createElement("div", _Object$assign({}, otherProps, {
        className: classes,
        style: rowStyle
      }), cols);
    }
  }]);
  return Row;
}(React.Component);
export { Row as default };
Row.defaultProps = {
  gutter: 0
};
Row.propTypes = {
  type: PropTypes.string,
  align: PropTypes.string,
  justify: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  children: PropTypes.node,
  gutter: PropTypes.oneOfType([PropTypes.object, PropTypes.number]),
  prefixCls: PropTypes.string
};