import React, { Component } from 'react';
import Driver from './src';
import './style/index.less';
interface GuideProps {
    allowClose?: boolean;
    className?: string;
    counter?: boolean;
    keyboardControl?: boolean;
    mask?: boolean;
    mode?: string;
    onClose?: () => void;
    steps?: any[];
    style?: React.CSSProperties;
    visible?: boolean;
    prefixCls?: string;
}
interface GuideState {
    visible: boolean;
    currentIndex: number;
}
declare class Guide extends Component<GuideProps, GuideState> {
    static propTypes: {
        prefixCls: any;
        className: any;
        style: any;
        mode: any;
        steps: any;
        visible: any;
        counter: any;
        mask: any;
        allowClose: any;
        keyboardControl: any;
        onClose: any;
    };
    static defaultProps: {
        prefixCls: string;
        mode: string;
        allowClose: boolean;
        keyboardControl: boolean;
        visible: boolean;
        counter: boolean;
        mask: boolean;
        steps: any[];
    };
    totalCount: number;
    driver: Driver;
    constructor(props: GuideProps);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    init: () => void;
    onKeyUp(event: any): void;
    handleClose: () => void;
    handleNext: () => void;
    handlePrev: () => void;
    renderTitle: (curStep: any) => any;
    render(): JSX.Element;
}
export default Guide;
