import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
/**
 * Responsible for validating positions and is used
 * when manipulating positions across the application
 */
var Position = /*#__PURE__*/function () {
  function Position(props) {
    _classCallCheck(this, Position);
    this.left = props.left || 0;
    this.right = props.right || 0;
    this.top = props.top || 0;
    this.bottom = props.bottom || 0;
  }
  /**
   * Checks if the position is valid to be highlighted
   * @returns {boolean}
   * @public
   */
  _createClass(Position, [{
    key: "canHighlight",
    value: function canHighlight() {
      return this.left < this.right && this.top < this.bottom;
    }
  }]);
  return Position;
}();
export { Position as default };