import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import omit from 'omit.js';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import TextArea from './TextArea';
function countValue(value) {
  return value.length;
}
var Counter = /*#__PURE__*/function (_React$Component) {
  _inherits(Counter, _React$Component);
  var _super = _createSuper(Counter);
  function Counter(props) {
    var _this;
    _classCallCheck(this, Counter);
    _this = _super.call(this, props);
    _this.saveTextarea = function (node) {
      _this.textarea = node;
    };
    _this.handleClick = function () {
      _this.focus();
    };
    _this.handleTextareaChange = function (e) {
      var onChange = _this.props.onChange;
      var textareaValue = _this.textarea && _this.textarea.textAreaRef.value;
      _this.setState({
        value: textareaValue
      });
      if (onChange) {
        onChange(e);
      }
    };
    _this.getCount = function () {
      var count = _this.props.count;
      var value = _this.state.value;
      if (!value) {
        return 0;
      }
      // 自定义计数方法
      if (count) {
        return count(String(value));
      }
      return countValue(String(value));
    };
    var value = '';
    if ('value' in props) {
      value = props.value;
    } else if ('defaultValue' in props) {
      value = props.defaultValue;
    }
    _this.state = {
      value: value,
      prevProps: props
    };
    return _this;
  }
  _createClass(Counter, [{
    key: "focus",
    value: function focus() {
      this.textarea.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.textarea.blur();
    }
  }, {
    key: "getTextAreaClassName",
    value: function getTextAreaClassName() {
      var _this$props = this.props,
        inputPrefixCls = _this$props.inputPrefixCls,
        className = _this$props.className,
        disabled = _this$props.disabled;
      return classNames(inputPrefixCls, className, _defineProperty({}, "".concat(inputPrefixCls, "-disabled"), disabled));
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames2;
      var _this$props2 = this.props,
        inputPrefixCls = _this$props2.inputPrefixCls,
        className = _this$props2.className,
        prefixCls = _this$props2.prefixCls,
        disabled = _this$props2.disabled,
        limit = _this$props2.limit;
      var inputClassName = classNames(className, (_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls), true), _defineProperty(_classNames2, "".concat(inputPrefixCls, "-disabled"), disabled), _classNames2));
      var textareaClassName = classNames(inputPrefixCls, className);
      var otherProps = omit(this.props, ['inputPrefixCls', 'prefixCls', 'limit', 'count', 'value', 'onChange']);
      var total = this.getCount();
      return /*#__PURE__*/React.createElement("span", {
        className: inputClassName,
        onClick: this.handleClick
      }, /*#__PURE__*/React.createElement(TextArea, _Object$assign({}, otherProps, {
        className: textareaClassName,
        maxLength: limit,
        onChange: this.handleTextareaChange,
        value: this.state.value,
        ref: this.saveTextarea
      })), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-footer")
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-indicator")
      }, total, "/", limit)));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      if (prevProps.value !== nextProps.value) {
        newState.value = nextProps.value;
      }
      return newState;
    }
  }]);
  return Counter;
}(React.Component);
Counter.defaultProps = {
  inputPrefixCls: 'fishd-input',
  prefixCls: 'fishd-input-counter'
};
polyfill(Counter);
export default Counter;