import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import { SubMenu as RcSubMenu } from './src';
var SubMenu = /*#__PURE__*/function (_React$Component) {
  _inherits(SubMenu, _React$Component);
  var _super = _createSuper(SubMenu);
  function SubMenu() {
    var _this;
    _classCallCheck(this, SubMenu);
    _this = _super.apply(this, arguments);
    _this.onKeyDown = function (e) {
      _this.subMenu.onKeyDown(e);
    };
    _this.saveSubMenu = function (subMenu) {
      _this.subMenu = subMenu;
    };
    return _this;
  }
  _createClass(SubMenu, [{
    key: "render",
    value: function render() {
      var _context;
      var _this$props = this.props,
        rootPrefixCls = _this$props.rootPrefixCls,
        className = _this$props.className;
      var theme = this.context.menuTheme;
      return /*#__PURE__*/React.createElement(RcSubMenu, _Object$assign({}, this.props, {
        ref: this.saveSubMenu,
        popupClassName: classNames(_concatInstanceProperty(_context = "".concat(rootPrefixCls, "-")).call(_context, theme), className)
      }));
    }
  }]);
  return SubMenu;
}(React.Component);
SubMenu.contextTypes = {
  menuTheme: PropTypes.string
};
// fix issue:https://github.com/ant-design/ant-design/issues/8666
SubMenu.isSubMenu = 1;
export default SubMenu;