declare const Embed: any;
interface createType {
    url: string;
    name: string;
    iconUrl?: string;
}
declare class Attach extends Embed {
    static blotName: string;
    static tagName: string;
    static formatCursor: boolean;
    static className: string;
    statics: {
        blotName: string;
        formatCursor: boolean;
    };
    domNode: HTMLElement;
    static create(data: createType): HTMLElement;
    static formats(node: HTMLElement): {
        'data-href'?: string;
        'data-title'?: string;
        'data-iconUrl'?: string;
    };
    format(name: string, data: any): void;
}
export { Attach as default };
