declare const Inline: any;
interface createType {
    url: string;
    type: string | null;
    name: string;
}
declare class Link extends Inline {
    static blotName: string;
    static tagName: string;
    static formatCursor: boolean;
    statics: {
        blotName: string;
        formatCursor: boolean;
    };
    domNode: HTMLElement;
    static create(data: createType): HTMLElement;
    static formats(node: HTMLElement): {
        url?: string;
        type?: string;
        name?: string;
    };
    format(name: string, data?: createType): void;
}
declare function sanitize(url: string, protocols: string): boolean;
export { Link as default, sanitize };
