import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from '../quill';
var Inline = Quill["import"]('blots/inline');
var setAttr = function setAttr(node, value) {
  if (typeof value == 'string' || typeof value == 'number') {
    node.style.fontSize = value;
  } else if (Object.prototype.toString.call(value) == '[object Object]') {
    if (value.editable != null) {
      node.setAttribute('contenteditable', value.editable);
    }
    if (value.fontSize != null) {
      node.style.fontSize = value.fontSize;
    }
    if (value.lineHeight) {
      node.style.lineHeight = value.lineHeight;
      node.style.display = 'inline-block';
    }
  }
  return node;
};
// 自定义span标签的字体大小和contenteditable属性
var CustomAttrBlot = /*#__PURE__*/function (_Inline) {
  _inherits(CustomAttrBlot, _Inline);
  var _super = _createSuper(CustomAttrBlot);
  function CustomAttrBlot() {
    _classCallCheck(this, CustomAttrBlot);
    return _super.apply(this, arguments);
  }
  _createClass(CustomAttrBlot, [{
    key: "format",
    value: function format(name, value) {
      if (name !== this.statics.blotName || !value) {
        _get(_getPrototypeOf(CustomAttrBlot.prototype), "format", this).call(this, name, value);
      } else {
        setAttr(this.domNode, value);
      }
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = _get(_getPrototypeOf(CustomAttrBlot), "create", this).call(this);
      return setAttr(node, value);
    }
  }, {
    key: "formats",
    value: function formats(node) {
      // 返回值不能为 null（Fix bug: Cannot read property 'mutations' of undefined）
      return {
        lineHeight: node.style.lineHeight,
        fontSize: node.style.fontSize,
        editable: node.getAttribute('contenteditable')
      };
    }
  }]);
  return CustomAttrBlot;
}(Inline);
CustomAttrBlot.blotName = 'customAttr';
CustomAttrBlot.tagName = 'span';
export default CustomAttrBlot;