import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import classNames from 'classnames';
var preClass = 'ql-table-popover';
var InsertTable = /*#__PURE__*/function (_Component) {
  _inherits(InsertTable, _Component);
  var _super = _createSuper(InsertTable);
  function InsertTable(props) {
    var _context;
    var _this;
    _classCallCheck(this, InsertTable);
    _this = _super.call(this, props);
    _this.cellClass = "".concat(preClass, "-cell");
    _this.state = {
      activeRow: 0,
      activeCol: 0
    };
    _this.mouseCallback = function (ev) {
      var target = ev.target;
      if (target.classList.contains(_this.cellClass)) {
        var position = target.dataset.position;
        if (position) {
          var tuple = position.split(',');
          _this.setState({
            activeRow: Number(tuple[0]),
            activeCol: Number(tuple[1])
          });
        }
      }
    };
    _this.mouseoverHandle = function (ev) {
      _this.mouseCallback(ev);
    };
    _this.clickHandle = function (ev) {
      var target = ev.target;
      if (target.classList.contains(_this.cellClass)) {
        var position = target.dataset.position;
        if (position) {
          var tuple = position.split(',');
          _this.props.chooseItemHandle(Number(tuple[0]) + 1, Number(tuple[1]) + 1);
        }
      }
    };
    _this.cellArr = _mapInstanceProperty(_context = _toConsumableArray(new Array(9))).call(_context, function (item) {
      return _toConsumableArray(new Array(9));
    });
    return _this;
  }
  _createClass(InsertTable, [{
    key: "render",
    value: function render() {
      var _context2,
        _this2 = this;
      var _this$state = this.state,
        activeCol = _this$state.activeCol,
        activeRow = _this$state.activeRow;
      var locale = this.props.locale;
      return /*#__PURE__*/React.createElement("div", {
        className: preClass
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(preClass, "-header")
      }, /*#__PURE__*/React.createElement("span", null, locale.tableDesc), /*#__PURE__*/React.createElement("span", null, activeCol + 1, "\xD7", activeRow + 1)), /*#__PURE__*/React.createElement("div", {
        className: "".concat(preClass, "-box"),
        onMouseMove: this.mouseoverHandle,
        onClick: this.clickHandle
      }, _mapInstanceProperty(_context2 = this.cellArr).call(_context2, function (row, rowIndex) {
        return _mapInstanceProperty(row).call(row, function (col, colIndex) {
          var _context3, _context4;
          return /*#__PURE__*/React.createElement("div", {
            "data-position": _concatInstanceProperty(_context3 = "".concat(rowIndex, ",")).call(_context3, colIndex),
            className: classNames(_this2.cellClass, {
              active: rowIndex <= activeRow && colIndex <= activeCol
            }),
            key: _concatInstanceProperty(_context4 = "".concat(rowIndex)).call(_context4, colIndex)
          });
        });
      })));
    }
  }]);
  return InsertTable;
}(Component);
InsertTable.getDerivedStateFromProps = function (nextProps) {
  if (!nextProps.visible) {
    return {
      activeRow: 0,
      activeCol: 0
    };
  }
  return null;
};
export default InsertTable;