import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from "../../../quill";
var Container = Quill["import"]('blots/container');
var Scroll = Quill["import"]('blots/scroll');
var ATTRIBUTES = ['data-embed-source', 'data-type', 'data-src', 'data-size', 'style'];
var Parchment = Quill["import"]('parchment');
var Embed = Quill["import"]('blots/block/embed');
var EmbedPlaceholder = /*#__PURE__*/function (_Embed) {
  _inherits(EmbedPlaceholder, _Embed);
  var _super = _createSuper(EmbedPlaceholder);
  function EmbedPlaceholder() {
    _classCallCheck(this, EmbedPlaceholder);
    return _super.apply(this, arguments);
  }
  _createClass(EmbedPlaceholder, [{
    key: "format",
    value: function format(name, value) {
      if (name === 'style') {
        this.domNode.style.cssText = value;
        return;
      }
      if (_indexOfInstanceProperty(ATTRIBUTES).call(ATTRIBUTES, name) === -1) {
        _get(_getPrototypeOf(EmbedPlaceholder.prototype), "format", this).call(this, name, value);
        return;
      }
      if (value) {
        this.domNode.setAttribute(name, value);
      } else {
        this.domNode.removeAttribute(name);
      }
    }
  }, {
    key: "handling",
    value: function handling(_handling) {
      this.domNode.__formats = this.constructor.formats(this.domNode);
      this.domNode.__handling = _handling;
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = _get(_getPrototypeOf(EmbedPlaceholder), "create", this).call(this);
      if (typeof value === 'string') {
        node.setAttribute(ATTRIBUTES[0], value);
      } else {
        for (var key in value) {
          if (!Object.prototype.hasOwnProperty.call(value, key)) continue;
          node.setAttribute(key, value[key]);
        }
      }
      node.setAttribute('contenteditable', false);
      node.setAttribute('unselectable', 'on');
      // node.setAttribute('title', node.textContent);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      if (domNode.__handling && domNode.__formats) {
        return domNode.__formats;
      }
      var attrList = _sliceInstanceProperty(ATTRIBUTES).call(ATTRIBUTES, 3);
      return _reduceInstanceProperty(attrList).call(attrList, function (formats, attribute) {
        if (domNode.hasAttribute(attribute)) {
          formats[attribute] = domNode.getAttribute(attribute);
        }
        return formats;
      }, {});
    }
  }, {
    key: "value",
    value: function value(domNode) {
      var attrs = _sliceInstanceProperty(ATTRIBUTES).call(ATTRIBUTES, 0, 3);
      var result = {};
      _forEachInstanceProperty(attrs).call(attrs, function (attr) {
        var res = '';
        if (domNode.hasAttribute(attr)) {
          res = domNode.getAttribute(attr);
        } else {
          switch (attr) {
            case ATTRIBUTES[0]:
              res = encodeURIComponent(domNode.outerHTML);
              break;
            case ATTRIBUTES[1]:
              res = domNode.tagName;
              break;
            case ATTRIBUTES[2]:
              res = domNode.getAttribute('src');
              break;
            case 'style':
              res = domNode.style.cssText;
              break;
            default:
              res = domNode[attr] || '';
          }
        }
        if (res) result[attr] = res;
      });
      return result;
    }
  }]);
  return EmbedPlaceholder;
}(Embed);
EmbedPlaceholder.blotName = 'embed-placeholder';
EmbedPlaceholder.tagName = 'span';
EmbedPlaceholder.scope = Parchment.Scope.INLINE_BLOT;
// Container.allowedChildren.push(EmbedPlaceholder)
Scroll.allowedChildren.push(EmbedPlaceholder);
var TagPlaceholder = /*#__PURE__*/function (_EmbedPlaceholder) {
  _inherits(TagPlaceholder, _EmbedPlaceholder);
  var _super2 = _createSuper(TagPlaceholder);
  function TagPlaceholder() {
    _classCallCheck(this, TagPlaceholder);
    return _super2.apply(this, arguments);
  }
  return _createClass(TagPlaceholder);
}(EmbedPlaceholder);
TagPlaceholder.tagName = ['video', 'iframe'];
var ClassNamePlaceholder = /*#__PURE__*/function (_EmbedPlaceholder2) {
  _inherits(ClassNamePlaceholder, _EmbedPlaceholder2);
  var _super3 = _createSuper(ClassNamePlaceholder);
  function ClassNamePlaceholder() {
    _classCallCheck(this, ClassNamePlaceholder);
    return _super3.apply(this, arguments);
  }
  return _createClass(ClassNamePlaceholder);
}(EmbedPlaceholder);
ClassNamePlaceholder.className = 'ql-embed-placeholder';
var tagReg = /<([\w-]+)((?:\s+[\w-:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*>([^<]*?)<\/\1>/g;
var attrReg = /([\w-:.]+)(?:\s*=\s*(?:"((?:\\.|[^"])*)"|'((?:\\.|[^'])*)'))?/g;
function convertPlaceholderHTML() {
  var _context;
  var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  if (!html) return '';
  var matchReg = new RegExp(_concatInstanceProperty(_context = "class\\s*=\\s*(?:\"[^\"]*\\b(".concat(ClassNamePlaceholder.className, ")\\b[^\"]*\"|'[^']*\\b(")).call(_context, ClassNamePlaceholder.className, ")\\b[^']*')") // eslint-disable-line
  );
  return html.replace(tagReg, function (m, tag) {
    var attrs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    if (!tag || tag.toLowerCase() !== EmbedPlaceholder.tagName || !matchReg.test(attrs)) {
      return m;
    }
    var attributes = getAttributes(attrs);
    var source = decodeURIComponent(attributes[ATTRIBUTES[0]]);
    // if (!attributes.style) return source
    return replaceHTMLAttr(source, {
      style: attributes.style,
      'data-size': attributes['data-size']
    });
  });
}
function getAttributes(str) {
  var attributes = {};
  str.replace(attrReg, function (m, name, attr1, attr2) {
    var _context2;
    var attr = _trimInstanceProperty(_context2 = attr1 || attr2 || '').call(_context2);
    attributes[name] = attr;
  });
  return attributes;
}
var sourceTagReg = /<([\w-]+)((?:\s+[\w-:.]*(?:\s*=\s*(?:(?:"[^"]*")|(?:'[^']*')|[^>\s]+))?)*)\s*>/;
function replaceHTMLAttr() {
  var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var attrs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return html.replace(sourceTagReg, function (m, tag) {
    var _context3, _context5;
    var attr = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
    var attributes = getAttributes(attr);
    _Object$assign(attributes, attrs);
    var attrsStr = _reduceInstanceProperty(_context3 = _Object$keys(attributes)).call(_context3, function (str, key) {
      var _context4;
      var val = attributes[key];
      if (val == null) return str;
      str += val === '' ? " ".concat(key) : _concatInstanceProperty(_context4 = " ".concat(key, "=\"")).call(_context4, val, "\"");
      return str;
    }, '');
    return _concatInstanceProperty(_context5 = "<".concat(tag)).call(_context5, attrsStr, ">");
  });
}
export default function register() {
  var formats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [TagPlaceholder];
  if (!_Array$isArray(formats)) formats = [formats];
  formats.push(ClassNamePlaceholder);
  _forEachInstanceProperty(formats).call(formats, function (fmt) {
    Quill.register(fmt, true);
    fmt.tagName = EmbedPlaceholder.tagName;
    fmt.className = ClassNamePlaceholder.className;
  });
}
export { EmbedPlaceholder, TagPlaceholder, ClassNamePlaceholder, convertPlaceholderHTML };