import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _get from "@babel/runtime-corejs3/helpers/get";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import Block from '../blots/block';
import Container from '../blots/container';
import Quill from '../core/quill';
var ListContainer = /*#__PURE__*/function (_Container) {
  _inherits(ListContainer, _Container);
  var _super = _createSuper(ListContainer);
  function ListContainer() {
    _classCallCheck(this, ListContainer);
    return _super.apply(this, arguments);
  }
  return _createClass(ListContainer);
}(Container);
ListContainer.blotName = 'list-container';
ListContainer.tagName = 'UL';
var ListItem = /*#__PURE__*/function (_Block) {
  _inherits(ListItem, _Block);
  var _super2 = _createSuper(ListItem);
  function ListItem(scroll, domNode) {
    _classCallCheck(this, ListItem);
    return _super2.call(this, scroll, domNode); // const ui = domNode.ownerDocument.createElement('span');
    // const listEventHandler = e => {
    //   if (!scroll.isEnabled()) return;
    //   const format = this.statics.formats(domNode, scroll);
    //   if (format === 'checked') {
    //     this.format('list', 'unchecked');
    //     e.preventDefault();
    //   } else if (format === 'unchecked') {
    //     this.format('list', 'checked');
    //     e.preventDefault();
    //   }
    // };
    // ui.addEventListener('mousedown', listEventHandler);
    // ui.addEventListener('touchstart', listEventHandler);
    // this.attachUI(ui);
  }
  _createClass(ListItem, [{
    key: "format",
    value: function format(name, value) {
      if (name === this.statics.blotName && value) {
        this.domNode.setAttribute('data-list', value);
      } else {
        _get(_getPrototypeOf(ListItem.prototype), "format", this).call(this, name, value);
      }
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = _get(_getPrototypeOf(ListItem), "create", this).call(this);
      node.setAttribute('data-list', value);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      return domNode.getAttribute('data-list') || undefined;
    }
  }, {
    key: "register",
    value: function register() {
      Quill.register(ListContainer);
    }
  }]);
  return ListItem;
}(Block);
ListItem.blotName = 'list';
ListItem.tagName = 'LI';
ListContainer.allowedChildren = [ListItem];
ListItem.requiredContainer = ListContainer;
export { ListContainer, ListItem as default };