import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import Picker from './picker';
var ColorPicker = /*#__PURE__*/function (_Picker) {
  _inherits(ColorPicker, _Picker);
  var _super = _createSuper(ColorPicker);
  function ColorPicker(select, label) {
    var _context, _context2;
    var _this;
    _classCallCheck(this, ColorPicker);
    _this = _super.call(this, select);
    _this.label.innerHTML = label;
    _this.container.classList.add('ql-color-picker');
    _forEachInstanceProperty(_context = _sliceInstanceProperty(_context2 = _Array$from(_this.container.querySelectorAll('.ql-picker-item'))).call(_context2, 0, 7)).call(_context, function (item) {
      item.classList.add('ql-primary');
    });
    return _this;
  }
  _createClass(ColorPicker, [{
    key: "buildItem",
    value: function buildItem(option) {
      var item = _get(_getPrototypeOf(ColorPicker.prototype), "buildItem", this).call(this, option);
      item.style.backgroundColor = option.getAttribute('value') || '';
      return item;
    }
  }, {
    key: "selectItem",
    value: function selectItem(item, trigger) {
      _get(_getPrototypeOf(ColorPicker.prototype), "selectItem", this).call(this, item, trigger);
      var colorLabel = this.label.querySelector('.ql-color-label');
      var value = item ? item.getAttribute('data-value') || '' : '';
      if (colorLabel) {
        if (colorLabel.tagName === 'line') {
          colorLabel.style.stroke = value;
        } else {
          colorLabel.style.fill = value;
        }
      }
    }
  }]);
  return ColorPicker;
}(Picker);
export default ColorPicker;