import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
var Option = /*#__PURE__*/function (_React$Component) {
  _inherits(Option, _React$Component);
  var _super = _createSuper(Option);
  function Option(props) {
    var _this;
    _classCallCheck(this, Option);
    _this = _super.call(this, props);
    _this.onOptionClick = function (e, option) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onOptionClick = _this$props.onOptionClick;
      if (!disabled) {
        onOptionClick && onOptionClick(e, option);
      }
    };
    return _this;
  }
  _createClass(Option, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        title = _this$props2.title,
        children = _this$props2.children,
        activeKey = _this$props2.activeKey,
        showOptionCheckedIcon = _this$props2.showOptionCheckedIcon,
        value = _this$props2.value,
        disabled = _this$props2.disabled,
        checked = _this$props2.checked,
        prefixCls = _this$props2.prefixCls;
      var label = children && children.length === 1 ? children[0] : children;
      var optionCls = classNames(_defineProperty({}, "".concat(prefixCls, "-item"), true), _defineProperty({}, "checked", !!checked), _defineProperty({}, "checked-icon", !!checked && showOptionCheckedIcon), _defineProperty({}, "active", 'activeKey' in this.props && activeKey === value), _defineProperty({}, "".concat(prefixCls, "-item-disabled"), !!disabled));
      return /*#__PURE__*/React.createElement("li", {
        title: title,
        className: optionCls,
        onClick: function onClick(e) {
          return _this2.onOptionClick(e, {
            label: label,
            title: title,
            key: value
          });
        }
      }, children);
    }
  }]);
  return Option;
}(React.Component);
export { Option as default };
Option.isSelectOption = true;
Option.propTypes = {
  activeKey: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  checked: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
  children: PropTypes.node,
  disabled: PropTypes.bool,
  onOptionClick: PropTypes.func,
  prefixCls: PropTypes.string,
  showOptionCheckedIcon: PropTypes.bool,
  title: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number, PropTypes.node])
};
Option.defaultProps = {
  prefixCls: 'fishd-select-dropdown-option',
  showOptionCheckedIcon: true
};