import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import RcSlider from './RcSlider';
import RcRange from './RcRange';
import RcHandle from './RcHandle';
import Tooltip from '../Tooltip';
var Slider = /*#__PURE__*/function (_React$Component) {
  _inherits(Slider, _React$Component);
  var _super = _createSuper(Slider);
  function Slider(props) {
    var _this;
    _classCallCheck(this, Slider);
    _this = _super.call(this, props);
    _this.toggleTooltipVisible = function (index, visible) {
      _this.setState(function (_ref) {
        var visibles = _ref.visibles;
        return {
          visibles: _Object$assign(_Object$assign({}, visibles), _defineProperty({}, index, visible))
        };
      });
    };
    _this.sliderHandle = function (_a) {
      var value = _a.value,
        dragging = _a.dragging,
        index = _a.index,
        restProps = __rest(_a, ["value", "dragging", "index"]);
      var _this$props = _this.props,
        tooltipPrefixCls = _this$props.tooltipPrefixCls,
        tipFormatter = _this$props.tipFormatter,
        _this$props$tipMode = _this$props.tipMode,
        tipMode = _this$props$tipMode === void 0 ? 'default' : _this$props$tipMode,
        handle = _this$props.handle;
      var visibles = _this.state.visibles;
      var visible = tipFormatter ? visibles[index] || dragging : false;
      if (tipMode === 'all') {
        return /*#__PURE__*/React.createElement(RcHandle, _Object$assign({}, restProps, {
          handle: handle,
          value: value
        }));
      }
      return /*#__PURE__*/React.createElement(Tooltip, {
        prefixCls: tooltipPrefixCls,
        title: tipFormatter ? tipFormatter(value) : '',
        visible: visible,
        placement: "top",
        transitionName: "zoom-down",
        key: index,
        stretch: "minWidth"
      }, /*#__PURE__*/React.createElement(RcHandle, _Object$assign({}, restProps, {
        value: value,
        handle: handle,
        onMouseEnter: function onMouseEnter() {
          return _this.toggleTooltipVisible(index, true);
        },
        onMouseLeave: function onMouseLeave() {
          return _this.toggleTooltipVisible(index, false);
        }
      })));
    };
    _this.saveSlider = function (node) {
      _this.rcSlider = node;
    };
    _this.state = {
      visibles: {}
    };
    return _this;
  }
  _createClass(Slider, [{
    key: "focus",
    value: function focus() {
      this.rcSlider.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.rcSlider.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
        range = _a.range,
        restProps = __rest(_a, ["range"]);
      if (range) {
        return /*#__PURE__*/React.createElement(RcRange, _Object$assign({}, restProps, {
          ref: this.saveSlider,
          handle: this.sliderHandle
        }));
      }
      return /*#__PURE__*/React.createElement(RcSlider, _Object$assign({}, restProps, {
        ref: this.saveSlider,
        handle: this.sliderHandle
      }));
    }
  }]);
  return Slider;
}(React.Component);
export { Slider as default };
Slider.defaultProps = {
  prefixCls: 'fishd-slider',
  tooltipPrefixCls: 'fishd-tooltip',
  tipFormatter: function tipFormatter(value) {
    return value.toString();
  }
};