import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import classNames from 'classnames';
import omit from 'omit.js';
import ConfigConsumer from "../Config/Consumer";
var TextLoading = function TextLoading(props) {
  var text = props.text,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$prefixCls = props.prefixCls,
    prefixCls = _props$prefixCls === void 0 ? 'fishd-spin' : _props$prefixCls;
  var otherProps = omit(props, ['className', 'prefixCls']);
  var classString = classNames("".concat(prefixCls, "-text-loading"), className);
  return /*#__PURE__*/React.createElement(ConfigConsumer, {
    componentName: "Spin"
  }, function (Locale) {
    return /*#__PURE__*/React.createElement("div", _Object$assign({}, otherProps, {
      className: classString
    }), text === undefined ? Locale.loading : text, /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-text-loading-dot")
    }, /*#__PURE__*/React.createElement("i", null, ".")));
  });
};
export default TextLoading;