import * as React from 'react';
import RcSwitch from './src/Switch';
export interface SwitchProps {
    prefixCls?: string;
    size?: 'small' | 'default' | 'large';
    className?: string;
    checked?: boolean;
    defaultChecked?: boolean;
    onChange?: (checked: boolean) => any;
    checkedChildren?: React.ReactNode;
    unCheckedChildren?: React.ReactNode;
    disabled?: boolean;
    loading?: boolean;
}
export default class Switch extends React.Component<SwitchProps, {}> {
    static defaultProps: {
        prefixCls: string;
    };
    static propTypes: {
        prefixCls: any;
        size: any;
        className: any;
    };
    private rcSwitch;
    focus(): void;
    blur(): void;
    saveSwitch: (node: typeof RcSwitch) => void;
    render(): JSX.Element;
}
