import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _Symbol from "@babel/runtime-corejs3/core-js-stable/symbol";
import _getIteratorMethod from "@babel/runtime-corejs3/core-js/get-iterator-method";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { var _context13; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty(_context13 = Object.prototype.toString.call(o)).call(_context13, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import { polyfill } from 'react-lifecycles-compat';
import Modal from '../Modal';
import Icon from '../Icon';
import ToolTip from '../Tooltip';
import Table from '../Table';
import TableDraggableHOC from './TableDraggableHOC';
import ConfigConsumer from '../Config/Consumer';
var getColumnKey = function getColumnKey(column) {
  if ('colSpan' in column) {
    return column.filtrateTitle || column.title;
  } else {
    return column.key || column.dataIndex || column.filtrateTitle || column.title;
  }
};
var flatten = function flatten(arr) {
  return _reduceInstanceProperty(arr).call(arr, function (prev, next) {
    return _concatInstanceProperty(prev).call(prev, _Array$isArray(next) ? flatten(next) : next);
  }, []);
};
var getCheckedOptions = function getCheckedOptions(columns, hideColumns, defaultColumns) {
  var _context, _context2, _context3;
  return _mapInstanceProperty(_context = _filterInstanceProperty(_context2 = _filterInstanceProperty(_context3 = _filterInstanceProperty(columns
  // 去除默认列
  ).call(columns
  // 去除默认列
  , function (column) {
    return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 去除表头合并不显示的列
  ).call(_context3, function (column) {
    return column.colSpan !== 0;
  })
  // 去除初始化就被隐藏的列
  ).call(_context2, function (column) {
    return _findIndexInstanceProperty(hideColumns).call(hideColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 只留uniqueId
  ).call(_context, function (column) {
    return getColumnKey(column);
  });
};
var getColSpanOption = function getColSpanOption(columns) {
  var colSpanOption = [];
  _forEachInstanceProperty(columns).call(columns, function (column, index) {
    if ('colSpan' in column && column.colSpan !== 0) {
      var _context4;
      colSpanOption.push({
        key: column.filtrateTitle || column.title,
        value: _mapInstanceProperty(_context4 = _sliceInstanceProperty(columns).call(columns, index, index + column.colSpan)).call(_context4, function (column) {
          return column.key || column.dataIndex;
        })
      });
    }
  });
  return colSpanOption;
};
var DraggableTable = null;
var ColumnFiltrateDraggableModal = /*#__PURE__*/function (_React$Component) {
  _inherits(ColumnFiltrateDraggableModal, _React$Component);
  var _super = _createSuper(ColumnFiltrateDraggableModal);
  function ColumnFiltrateDraggableModal(props) {
    var _this;
    _classCallCheck(this, ColumnFiltrateDraggableModal);
    _this = _super.call(this, props);
    _this.showModal = function () {
      _this.setState({
        visible: true
      });
    };
    _this.handleOk = function () {
      _this.setState({
        visible: false,
        checkedOptionConfirm: _this.state.checkedOption,
        okButtonDisabled: true
      }, function () {
        var _context5, _context6, _context9;
        // 被隐藏的列表key
        _this.props.onChange(flatten(_mapInstanceProperty(_context5 = _filterInstanceProperty(_context6 = _this.getOptions()).call(_context6, function (column) {
          var _context7;
          return _indexOfInstanceProperty(_context7 = _this.state.checkedOptionConfirm).call(_context7, column.value) === -1;
        })).call(_context5, function (column) {
          var _context8;
          var indexOfColSpan = _findIndexInstanceProperty(_context8 = _this.state.colSpanOption).call(_context8, function (option) {
            return option.key === column.value;
          });
          if (indexOfColSpan !== -1) {
            return _this.state.colSpanOption[indexOfColSpan].value;
          } else {
            return column.value;
          }
        })), _concatInstanceProperty(_context9 = _this.props.defaultColumns).call(_context9, _this.state.checkedOption));
      });
    };
    _this.handleCancel = function () {
      _this.setState({
        visible: false,
        checkedOption: _this.state.checkedOptionConfirm,
        okButtonDisabled: true
      });
    };
    _this.onChange = function (checkedOption) {
      _this.setState({
        checkedOption: checkedOption,
        okButtonDisabled: false
      });
    };
    _this.getOptions = function () {
      var _context10, _context11;
      var _this$props = _this.props,
        columns = _this$props.columns,
        defaultColumns = _this$props.defaultColumns;
      return _filterInstanceProperty(_context10 = _mapInstanceProperty(_context11 = _filterInstanceProperty(columns
      // 去除表头合并的不显示的
      ).call(columns
      // 去除表头合并的不显示的
      , function (column) {
        return column.colSpan !== 0;
      })
      // 获取他们的label、value、disabled
      ).call(_context11, function (column) {
        var uniqKey = getColumnKey(column);
        //fixed /分组不能控制显示隐藏
        var disabled = !!column.fixed || !!column.children || !!column.filtrateDefault;
        var title = column.filtrateTitle || column.title;
        return {
          label: /*#__PURE__*/React.createElement(ToolTip, {
            title: title
          }, title),
          value: uniqKey,
          disabled: disabled
        };
      })
      // 去除默认展示数据项
      ).call(_context10, function (column) {
        return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
          return key === column.value;
        }) === -1;
      });
    };
    _this.getDataSource = function () {
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        defaultColumns = _this$props2.defaultColumns;
      var checkedOption = _this.state.checkedOption;
      var selectRows = _filterInstanceProperty(columns).call(columns, function (column) {
        return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
          return key === getColumnKey(column);
        }) != -1;
      });
      var unSelectRows = [];
      var _iterator = _createForOfIteratorHelper(checkedOption),
        _step;
      try {
        var _loop = function _loop() {
          var key = _step.value;
          selectRows = _concatInstanceProperty(selectRows).call(selectRows, _filterInstanceProperty(columns).call(columns, function (each) {
            return each.key == key;
          }));
        };
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      var _iterator2 = _createForOfIteratorHelper(_filterInstanceProperty(columns).call(columns, function (column) {
          return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
            return key === getColumnKey(column);
          }) === -1;
        })),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var each = _step2.value;
          if (_includesInstanceProperty(checkedOption).call(checkedOption, each.key)) {
            each.selected = true;
          } else {
            each.selected = false;
            unSelectRows.push(each);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return _concatInstanceProperty(selectRows).call(selectRows, unSelectRows);
    };
    var _this$props3 = _this.props,
      columns = _this$props3.columns,
      hideColumns = _this$props3.hideColumns,
      defaultColumns = _this$props3.defaultColumns;
    var option = getCheckedOptions(columns, hideColumns, defaultColumns);
    _this.state = {
      visible: false,
      checkedOption: option,
      checkedOptionConfirm: option,
      okButtonDisabled: true,
      prevProps: props,
      colSpanOption: getColSpanOption(columns)
    };
    return _this;
  }
  _createClass(ColumnFiltrateDraggableModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      DraggableTable = TableDraggableHOC(Table, {
        dnd: true,
        renderBodyRow: function renderBodyRow(props) {
          var index = props.index,
            restProps = __rest(props, ["index"]);
          return /*#__PURE__*/React.createElement("tr", _Object$assign({}, restProps));
        },
        dndRow: function dndRow(props) {
          if (props.record.selected) {
            return true;
          } else {
            return false;
          }
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        defaultColumns = _this$props4.defaultColumns,
        locale = _this$props4.locale;
      var _this$state = this.state,
        visible = _this$state.visible,
        checkedOption = _this$state.checkedOption,
        okButtonDisabled = _this$state.okButtonDisabled;
      var draggableTableColumns = [{
        title: locale.draggableTitle,
        dataIndex: 'title',
        render: function render(val, row) {
          return /*#__PURE__*/React.createElement("span", null, val);
        }
      }, {
        title: locale.draggableAction,
        dataIndex: 'operate',
        render: function render(val, row) {
          var isDefault = _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
            return key === getColumnKey(row);
          }) != -1;
          if (_findIndexInstanceProperty(checkedOption).call(checkedOption, function (key) {
            return key === getColumnKey(row);
          }) != -1 && !isDefault) {
            return /*#__PURE__*/React.createElement(Icon, {
              type: "sound-drag"
            });
          } else {
            return null;
          }
        }
      }];
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Table"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Icon, {
          className: "".concat(prefixCls, "-filtrate-icon"),
          type: "Settingx",
          onClick: _this2.showModal
        }), /*#__PURE__*/React.createElement(Modal, {
          title: Locale.modalTitle,
          wrapClassName: "".concat(prefixCls, "-filtrate-modal"),
          visible: visible,
          width: 680,
          okButtonDisabled: okButtonDisabled,
          onOk: _this2.handleOk,
          onCancel: _this2.handleCancel,
          okText: Locale.okText,
          cancelText: Locale.cancelText
        }, DraggableTable ? /*#__PURE__*/React.createElement(DraggableTable, {
          rowKey: "key",
          columns: draggableTableColumns,
          dataSource: _this2.getDataSource(),
          pagination: false,
          rowSelection: {
            selectedRowKeys: checkedOption,
            hideDefaultSelections: true,
            showSelectAll: true,
            type: 'checkbox',
            onChange: _this2.onChange,
            getCheckboxProps: function getCheckboxProps(record) {
              var isDefault = _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
                return key === getColumnKey(record);
              }) != -1;
              return {
                disabled: isDefault || record.filtrateDefault,
                name: record.title,
                checked: isDefault || _findIndexInstanceProperty(checkedOption).call(checkedOption, function (key) {
                  return key === getColumnKey(record);
                }) != -1
              };
            }
          },
          onRowMoved: function onRowMoved(fields) {
            var _context12;
            var checkedOption = _mapInstanceProperty(_context12 = _filterInstanceProperty(fields).call(fields, function (each) {
              return each.selected;
            })).call(_context12, function (column) {
              return getColumnKey(column);
            });
            _this2.onChange(checkedOption);
          }
        }) : null));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      //监听column个数变化，重新初始化checkedOption
      if ('columns' in nextProps && nextProps.columns.length !== prevProps.columns.length) {
        var columns = nextProps.columns,
          hideColumns = nextProps.hideColumns,
          defaultColumns = nextProps.defaultColumns;
        var option = getCheckedOptions(columns, hideColumns, defaultColumns);
        newState.checkedOption = option;
        newState.checkedOptionConfirm = option;
        newState.colSpanOption = getColSpanOption(columns);
      }
      return newState;
    }
  }]);
  return ColumnFiltrateDraggableModal;
}(React.Component);
ColumnFiltrateDraggableModal.defaultProps = {
  columns: [],
  defaultColumns: [],
  hideColumns: []
};
polyfill(ColumnFiltrateDraggableModal);
export default ColumnFiltrateDraggableModal;