import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
import _Math$sign from "@babel/runtime-corejs3/core-js-stable/math/sign";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/* eslint-disable prefer-spread */
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import warning from 'warning';
import isEqual from 'lodash/isEqual';
import { polyfill } from 'react-lifecycles-compat';
import RcTable from './src';
import Pagination from '../Pagination';
import Icon from '../Icon';
import Spin from '../Spin';
import FilterDropdown from './filterDropdown';
import createStore from './createStore';
import SelectionBox from './SelectionBox';
import SelectionCheckboxAll from './SelectionCheckboxAll';
import ColumnFiltrateModal from './ColumnFiltrateModal';
import ColumnFiltrateDraggableModal from './ColumnFiltrateDraggableModal';
import Column from './Column';
import ColumnGroup from './ColumnGroup';
import createBodyRow from './createBodyRow';
import { flatArray, treeMap, flatFilter, normalizeColumns } from './util';
import ConfigConsumer from '../Config/Consumer';
function noop() {}
function stopPropagation(e) {
  e.stopPropagation();
  if (e.nativeEvent.stopImmediatePropagation) {
    e.nativeEvent.stopImmediatePropagation();
  }
}
function getRowSelection(props) {
  return props.rowSelection || {};
}
var defaultPagination = {
  onChange: noop,
  onShowSizeChange: noop
};
function getComponents(state) {
  var components = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var prevComponents = arguments.length > 2 ? arguments[2] : undefined;
  var bodyRow = components && components.body && components.body.row;
  var preBodyRow = prevComponents && prevComponents.body && prevComponents.body.row;
  var newState = {};
  if (!state.row || bodyRow !== preBodyRow) {
    newState.row = createBodyRow(bodyRow);
  }
  newState.components = _Object$assign(_Object$assign({}, components), {
    body: _Object$assign(_Object$assign({}, components.body), {
      row: newState.row || state.row
    })
  });
  return newState;
}
function getHideColumns(props) {
  var hideColumns = [];
  // 初始化隐藏列
  if (props.columnFiltrate && props.columnFiltrate.hideColumns) {
    hideColumns.push.apply(hideColumns, _toConsumableArray(props.columnFiltrate.hideColumns));
  }
  return hideColumns;
}
function isFiltersChanged(newFilters, prevFilters) {
  var filtersChanged = false;
  if (_Object$keys(newFilters).length !== _Object$keys(prevFilters).length) {
    filtersChanged = true;
  } else {
    var _context;
    _forEachInstanceProperty(_context = _Object$keys(newFilters)).call(_context, function (columnKey) {
      if (newFilters[columnKey] !== prevFilters[columnKey]) {
        filtersChanged = true;
      }
    });
  }
  return filtersChanged;
}
function getSortOrderColumns(columns) {
  return flatFilter(columns || [], function (column) {
    return 'sortOrder' in column;
  });
}
function getFilteredValueColumns(columns) {
  return flatFilter(columns || [], function (column) {
    return typeof column.filteredValue !== 'undefined';
  });
}
function getFiltersFromColumns(columns) {
  var _context2;
  var filters = {};
  _forEachInstanceProperty(_context2 = getFilteredValueColumns(columns)).call(_context2, function (col) {
    var colKey = getColumnKey(col);
    filters[colKey] = col.filteredValue;
  });
  return filters;
}
function getSortStateFromColumns(columns) {
  var _context3;
  // return first column which sortOrder is not falsy
  var sortedColumn = _filterInstanceProperty(_context3 = getSortOrderColumns(columns)).call(_context3, function (col) {
    return col.sortOrder;
  })[0];
  if (sortedColumn) {
    return {
      sortColumn: sortedColumn,
      sortOrder: sortedColumn.sortOrder
    };
  }
  return {
    sortColumn: null,
    sortOrder: null
  };
}
function getColumnKey(column, index) {
  return column.key || column.dataIndex || index;
}
/**
 * Avoid creating new object, so that parent component's shouldComponentUpdate
 * can works appropriately。
 */
var emptyObject = {};
var getColumns = function getColumns(props) {
  var _a, _b, _c;
  var columns = props.columns;
  var newColumns = columns || normalizeColumns(props.children);
  // 如果draggable模式，需要将columns按照 sortedColumns 排序
  if (((_a = props.columnFiltrate) === null || _a === void 0 ? void 0 : _a.draggable) && ((_b = props.columnFiltrate) === null || _b === void 0 ? void 0 : _b.sortedColumns) && ((_c = props.columnFiltrate) === null || _c === void 0 ? void 0 : _c.sortedColumns.length) > 0) {
    var sortedColumns = props.columnFiltrate.sortedColumns;
    _sortInstanceProperty(newColumns).call(newColumns, function (a, b) {
      var aKey = getColumnKey(a);
      var bKey = getColumnKey(b);
      if (_indexOfInstanceProperty(sortedColumns).call(sortedColumns, aKey) == -1) {
        sortedColumns.push(aKey);
      }
      if (_indexOfInstanceProperty(sortedColumns).call(sortedColumns, bKey) == -1) {
        sortedColumns.push(bKey);
      }
      return _indexOfInstanceProperty(sortedColumns).call(sortedColumns, aKey) - _indexOfInstanceProperty(sortedColumns).call(sortedColumns, bKey);
    });
  }
  return newColumns;
};
var Table = /*#__PURE__*/function (_React$Component) {
  _inherits(Table, _React$Component);
  var _super = _createSuper(Table);
  function Table(props) {
    var _this;
    _classCallCheck(this, Table);
    _this = _super.call(this, props);
    _this.getCheckboxPropsByItem = function (item, index) {
      var rowSelection = getRowSelection(_this.props);
      if (!rowSelection.getCheckboxProps) {
        return {};
      }
      return rowSelection.getCheckboxProps(item);
    };
    _this.onRow = function (record, index) {
      var _this$props = _this.props,
        onRow = _this$props.onRow,
        prefixCls = _this$props.prefixCls;
      var custom = onRow ? onRow(record, index) : {};
      return _Object$assign(_Object$assign({}, custom), {
        prefixCls: prefixCls,
        store: _this.store,
        rowKey: _this.getRecordKey(record, index)
      });
    };
    _this.handleFilter = function (column, nextFilters) {
      var _context4, _context5;
      var props = _this.props;
      var pagination = _Object$assign({}, _this.state.pagination);
      var filters = _Object$assign(_Object$assign({}, _this.state.filters), _defineProperty({}, _this.getColumnKey(column), nextFilters));
      // Remove filters not in current columns
      var currentColumnKeys = [];
      treeMap(_this.state.columns, function (c) {
        if (!c.children) {
          currentColumnKeys.push(_this.getColumnKey(c));
        }
      });
      _forEachInstanceProperty(_context4 = _Object$keys(filters)).call(_context4, function (columnKey) {
        if (_indexOfInstanceProperty(currentColumnKeys).call(currentColumnKeys, columnKey) < 0) {
          delete filters[columnKey];
        }
      });
      if (props.pagination) {
        // Reset current prop
        pagination.current = 1;
        pagination.onChange(pagination.current);
      }
      var newState = {
        pagination: pagination,
        filters: {}
      };
      var filtersToSetState = _Object$assign({}, filters);
      // Remove filters which is controlled
      _forEachInstanceProperty(_context5 = getFilteredValueColumns(_this.state.columns)).call(_context5, function (col) {
        var columnKey = _this.getColumnKey(col);
        if (columnKey) {
          delete filtersToSetState[columnKey];
        }
      });
      if (_Object$keys(filtersToSetState).length > 0) {
        newState.filters = filtersToSetState;
      }
      // Controlled current prop will not respond user interaction
      if (_typeof(props.pagination) === 'object' && 'current' in props.pagination) {
        newState.pagination = _Object$assign(_Object$assign({}, pagination), {
          current: _this.state.pagination.current
        });
      }
      _this.setState(newState, function () {
        _this.store.setState({
          selectionDirty: false
        });
        var onChange = _this.props.onChange;
        if (onChange) {
          onChange.apply(null, _this.prepareParamsArguments(_Object$assign(_Object$assign({}, _this.state), {
            selectionDirty: false,
            filters: filters,
            pagination: pagination
          })));
        }
      });
    };
    _this.handleSelect = function (record, rowIndex, e) {
      var _context6;
      var checked = e.target.checked;
      var nativeEvent = e.nativeEvent;
      var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
      var selectedRowKeys = _concatInstanceProperty(_context6 = _this.store.getState().selectedRowKeys).call(_context6, defaultSelection);
      var key = _this.getRecordKey(record, rowIndex);
      var pivot = _this.state.pivot;
      var rows = _this.getFlatCurrentPageData();
      var realIndex = rowIndex;
      if (_this.props.expandedRowRender) {
        realIndex = _findIndexInstanceProperty(rows).call(rows, function (row) {
          return _this.getRecordKey(row, rowIndex) === key;
        });
      }
      if (nativeEvent.shiftKey && pivot !== undefined && realIndex !== pivot) {
        var changeRowKeys = [];
        var direction = _Math$sign(pivot - realIndex);
        var dist = Math.abs(pivot - realIndex);
        var step = 0;
        var _loop = function _loop() {
          var i = realIndex + step * direction;
          step += 1;
          var row = rows[i];
          var rowKey = _this.getRecordKey(row, i);
          var checkboxProps = _this.getCheckboxPropsByItem(row, i);
          if (!checkboxProps.disabled) {
            if (_includesInstanceProperty(selectedRowKeys).call(selectedRowKeys, rowKey)) {
              if (!checked) {
                selectedRowKeys = _filterInstanceProperty(selectedRowKeys).call(selectedRowKeys, function (j) {
                  return rowKey !== j;
                });
                changeRowKeys.push(rowKey);
              }
            } else if (checked) {
              selectedRowKeys.push(rowKey);
              changeRowKeys.push(rowKey);
            }
          }
        };
        while (step <= dist) {
          _loop();
        }
        _this.setState({
          pivot: realIndex
        });
        _this.store.setState({
          selectionDirty: true
        });
        _this.setSelectedRowKeys(selectedRowKeys, {
          selectWay: 'onSelectMultiple',
          record: record,
          checked: checked,
          changeRowKeys: changeRowKeys,
          nativeEvent: nativeEvent
        });
      } else {
        if (checked) {
          selectedRowKeys.push(_this.getRecordKey(record, realIndex));
        } else {
          selectedRowKeys = _filterInstanceProperty(selectedRowKeys).call(selectedRowKeys, function (i) {
            return key !== i;
          });
        }
        _this.setState({
          pivot: realIndex
        });
        _this.store.setState({
          selectionDirty: true
        });
        _this.setSelectedRowKeys(selectedRowKeys, {
          selectWay: 'onSelect',
          record: record,
          checked: checked,
          changeRowKeys: void 0,
          nativeEvent: nativeEvent
        });
      }
    };
    _this.handleRadioSelect = function (record, rowIndex, e) {
      var _context7;
      var checked = e.target.checked;
      var nativeEvent = e.nativeEvent;
      var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
      var selectedRowKeys = _concatInstanceProperty(_context7 = _this.store.getState().selectedRowKeys).call(_context7, defaultSelection);
      var key = _this.getRecordKey(record, rowIndex);
      selectedRowKeys = [key];
      _this.store.setState({
        selectionDirty: true
      });
      _this.setSelectedRowKeys(selectedRowKeys, {
        selectWay: 'onSelect',
        record: record,
        checked: checked,
        changeRowKeys: void 0,
        nativeEvent: nativeEvent
      });
    };
    _this.handleSelectRow = function (selectionKey, index, onSelectFunc) {
      var _context8, _context9;
      var data = _this.getFlatCurrentPageData();
      var defaultSelection = _this.store.getState().selectionDirty ? [] : _this.getDefaultSelection();
      var selectedRowKeys = _concatInstanceProperty(_context8 = _this.store.getState().selectedRowKeys).call(_context8, defaultSelection);
      var changeableRowKeys = _mapInstanceProperty(_context9 = _filterInstanceProperty(data).call(data, function (item, i) {
        return !_this.getCheckboxPropsByItem(item, i).disabled;
      })).call(_context9, function (item, i) {
        return _this.getRecordKey(item, i);
      });
      var changeRowKeys = [];
      var selectWay = 'onSelectAll';
      var checked;
      // handle default selection
      switch (selectionKey) {
        case 'all':
          _forEachInstanceProperty(changeableRowKeys).call(changeableRowKeys, function (key) {
            if (_indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, key) < 0) {
              selectedRowKeys.push(key);
              changeRowKeys.push(key);
            }
          });
          selectWay = 'onSelectAll';
          checked = true;
          break;
        case 'removeAll':
          _forEachInstanceProperty(changeableRowKeys).call(changeableRowKeys, function (key) {
            if (_indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, key) >= 0) {
              _spliceInstanceProperty(selectedRowKeys).call(selectedRowKeys, _indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, key), 1);
              changeRowKeys.push(key);
            }
          });
          selectWay = 'onSelectAll';
          checked = false;
          break;
        case 'invert':
          _forEachInstanceProperty(changeableRowKeys).call(changeableRowKeys, function (key) {
            if (_indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, key) < 0) {
              selectedRowKeys.push(key);
            } else {
              _spliceInstanceProperty(selectedRowKeys).call(selectedRowKeys, _indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, key), 1);
            }
            changeRowKeys.push(key);
            selectWay = 'onSelectInvert';
          });
          break;
        default:
          break;
      }
      _this.store.setState({
        selectionDirty: true
      });
      // when select custom selection, callback selections[n].onSelect
      var rowSelection = _this.props.rowSelection;
      var customSelectionStartIndex = 2;
      if (rowSelection && rowSelection.hideDefaultSelections) {
        customSelectionStartIndex = 0;
      }
      if (index >= customSelectionStartIndex && typeof onSelectFunc === 'function') {
        return onSelectFunc(changeableRowKeys);
      }
      _this.setSelectedRowKeys(selectedRowKeys, {
        selectWay: selectWay,
        checked: checked,
        changeRowKeys: changeRowKeys
      });
    };
    _this.handlePageChange = function (current) {
      var _context10;
      var props = _this.props;
      var pagination = _Object$assign({}, _this.state.pagination);
      if (current) {
        pagination.current = current;
      } else {
        pagination.current = pagination.current || 1;
      }
      for (var _len = arguments.length, otherArguments = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        otherArguments[_key - 1] = arguments[_key];
      }
      pagination.onChange.apply(pagination, _concatInstanceProperty(_context10 = [pagination.current]).call(_context10, otherArguments));
      var newState = {
        pagination: pagination
      };
      // Controlled current prop will not respond user interaction
      if (props.pagination && _typeof(props.pagination) === 'object' && 'current' in props.pagination) {
        newState.pagination = _Object$assign(_Object$assign({}, pagination), {
          current: _this.state.pagination.current
        });
      }
      _this.setState(newState);
      _this.store.setState({
        selectionDirty: false
      });
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange.apply(null, _this.prepareParamsArguments(_Object$assign(_Object$assign({}, _this.state), {
          selectionDirty: false,
          pagination: pagination
        })));
      }
    };
    _this.renderSelectionBox = function (type) {
      return function (_, record, index) {
        var rowIndex = _this.getRecordKey(record, index); // 从 1 开始
        var props = _this.getCheckboxPropsByItem(record, index);
        var handleChange = function handleChange(e) {
          type === 'radio' ? _this.handleRadioSelect(record, rowIndex, e) : _this.handleSelect(record, rowIndex, e);
        };
        return /*#__PURE__*/React.createElement("span", {
          onClick: stopPropagation
        }, /*#__PURE__*/React.createElement(SelectionBox, _Object$assign({
          type: type,
          store: _this.store,
          rowIndex: rowIndex,
          onChange: handleChange,
          defaultSelection: _this.getDefaultSelection()
        }, props)));
      };
    };
    _this.getRecordKey = function (record, index) {
      var rowKey = _this.props.rowKey;
      var recordKey = typeof rowKey === 'function' ? rowKey(record, index) : record[rowKey];
      warning(recordKey !== undefined, 'Each record in dataSource of table should have a unique `key` prop, ' + 'or set `rowKey` of Table to an unique primary key, ' + 'see https://u.ant.design/table-row-key');
      return recordKey === undefined ? index : recordKey;
    };
    _this.getPopupContainer = function () {
      return ReactDOM.findDOMNode(_assertThisInitialized(_this));
    };
    _this.handleColumnsFiltrateDraggableChange = function (hideColumns, sortedColumns) {
      var columnFiltrate = _this.props.columnFiltrate;
      if (columnFiltrate && columnFiltrate.hideColumnsChange) {
        columnFiltrate.hideColumnsChange(hideColumns);
      }
      if (columnFiltrate && columnFiltrate.sortedColumnsChange) {
        columnFiltrate.sortedColumnsChange(sortedColumns);
      }
      _this.setState({
        hideColumns: hideColumns
      });
    };
    _this.handleColumnsFiltrateChange = function (hideColumns) {
      var columnFiltrate = _this.props.columnFiltrate;
      if (columnFiltrate && columnFiltrate.hideColumnsChange) {
        columnFiltrate.hideColumnsChange(hideColumns);
      }
      _this.setState({
        hideColumns: hideColumns
      });
    };
    _this.handleShowSizeChange = function (current, pageSize) {
      var pagination = _this.state.pagination;
      pagination.onShowSizeChange(current, pageSize);
      var nextPagination = _Object$assign(_Object$assign({}, pagination), {
        pageSize: pageSize,
        current: current
      });
      _this.setState({
        pagination: nextPagination
      });
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange.apply(null, _this.prepareParamsArguments(_Object$assign(_Object$assign({}, _this.state), {
          pagination: nextPagination
        })));
      }
    };
    _this.renderTable = function (loading, Locale) {
      var _context11, _classNames;
      var filterTitle = Locale.filterTitle,
        filterConfirm = Locale.filterConfirm,
        filterReset = Locale.filterReset,
        emptyText = Locale.emptyText,
        selectAll = Locale.selectAll,
        selectInvert = Locale.selectInvert,
        draggableTitle = Locale.draggableTitle,
        draggableAction = Locale.draggableAction;
      var localeDefault = {
        filterTitle: filterTitle,
        filterConfirm: filterConfirm,
        filterReset: filterReset,
        emptyText: emptyText,
        selectAll: selectAll,
        selectInvert: selectInvert,
        draggableTitle: draggableTitle,
        draggableAction: draggableAction
      };
      var locale = _Object$assign(_Object$assign({}, localeDefault), _this.props.locale);
      var _a = _this.props,
        style = _a.style,
        className = _a.className,
        prefixCls = _a.prefixCls,
        showHeader = _a.showHeader,
        activeRowByClick = _a.activeRowByClick,
        restProps = __rest(_a, ["style", "className", "prefixCls", "showHeader", "activeRowByClick"]);
      var data = _this.getCurrentPageData();
      var expandIconAsCell = _this.props.expandedRowRender && _this.props.expandIconAsCell !== false;
      var classString = classNames((_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context11 = "".concat(prefixCls, "-")).call(_context11, _this.props.size), true), _defineProperty(_classNames, "".concat(prefixCls, "-bordered"), _this.props.bordered), _defineProperty(_classNames, "".concat(prefixCls, "-empty"), !data.length), _defineProperty(_classNames, "".concat(prefixCls, "-without-column-header"), !showHeader), _classNames));
      var columns = _this.renderRowSelection(locale);
      columns = _this.renderColumnsFiltrate(columns, locale);
      columns = _this.renderColumnsDropdown(columns, locale);
      columns = _filterInstanceProperty(columns).call(columns, function (column) {
        var _context12;
        return _indexOfInstanceProperty(_context12 = _this.state.hideColumns).call(_context12, column.key && column.key.toString() || column.dataIndex) === -1;
      });
      columns = _mapInstanceProperty(columns).call(columns, function (column, i) {
        var newColumn = _Object$assign({}, column);
        newColumn.key = _this.getColumnKey(newColumn, i);
        return newColumn;
      });
      var expandIconColumnIndex = columns[0] && columns[0].key === 'selection-column' ? 1 : 0;
      if ('expandIconColumnIndex' in restProps) {
        expandIconColumnIndex = restProps.expandIconColumnIndex;
      }
      return /*#__PURE__*/React.createElement(RcTable, _Object$assign({
        key: "table"
      }, restProps, {
        onRow: _this.onRow,
        components: _this.state.components,
        prefixCls: prefixCls,
        data: data,
        columns: columns,
        showHeader: showHeader,
        activeRowByClick: activeRowByClick,
        className: classString,
        expandIconColumnIndex: expandIconColumnIndex,
        expandIconAsCell: expandIconAsCell,
        emptyText: !loading.spinning && locale.emptyText
      }));
    };
    warning(!('columnsPageRange' in props || 'columnsPageSize' in props), '`columnsPageRange` and `columnsPageSize` are removed, please use ' + 'fixed columns instead, see: https://u.ant.design/fixed-columns.');
    var columns = getColumns(props);
    var hideColumns = getHideColumns(props);
    _this.state = _Object$assign(_Object$assign(_Object$assign(_Object$assign({}, _this.getDefaultSortOrder(columns)), {
      // 减少状态
      filters: getFiltersFromColumns(columns),
      pagination: _this.getDefaultPagination(props),
      pivot: undefined,
      columns: columns,
      hideColumns: hideColumns
    }), getComponents({}, props.components)), {
      prevProps: props
    });
    _this.store = createStore({
      selectedRowKeys: getRowSelection(props).selectedRowKeys || [],
      selectionDirty: false
    });
    return _this;
  }
  _createClass(Table, [{
    key: "getDefaultSelection",
    value: function getDefaultSelection() {
      var _context13,
        _context14,
        _this2 = this;
      var rowSelection = getRowSelection(this.props);
      if (!rowSelection.getCheckboxProps) {
        return [];
      }
      return _mapInstanceProperty(_context13 = _filterInstanceProperty(_context14 = this.getFlatData()).call(_context14, function (item, rowIndex) {
        return _this2.getCheckboxPropsByItem(item, rowIndex).defaultChecked;
      })).call(_context13, function (record, rowIndex) {
        return _this2.getRecordKey(record, rowIndex);
      });
    }
  }, {
    key: "getDefaultPagination",
    value: function getDefaultPagination(props) {
      var pagination = props.pagination || {};
      return this.hasPagination(props) ? _Object$assign(_Object$assign(_Object$assign({}, defaultPagination), pagination), {
        current: pagination.defaultCurrent || pagination.current || 1,
        pageSize: pagination.defaultPageSize || pagination.pageSize || 10
      }) : {};
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.rowSelection && 'selectedRowKeys' in this.props.rowSelection && (!prevProps.rowSelection || !prevProps.rowSelection.selectedRowKeys || !isEqual(this.props.rowSelection.selectedRowKeys, prevProps.rowSelection.selectedRowKeys))) {
        this.store.setState({
          selectedRowKeys: this.props.rowSelection.selectedRowKeys || []
        });
      }
      if ('dataSource' in this.props && !isEqual(this.props.dataSource, prevProps.dataSource)) {
        this.store.setState({
          selectionDirty: false
        });
      }
    }
  }, {
    key: "setSelectedRowKeys",
    value: function setSelectedRowKeys(selectedRowKeys, selectionInfo) {
      var _this3 = this;
      var selectWay = selectionInfo.selectWay,
        record = selectionInfo.record,
        checked = selectionInfo.checked,
        changeRowKeys = selectionInfo.changeRowKeys,
        nativeEvent = selectionInfo.nativeEvent;
      var rowSelection = getRowSelection(this.props);
      if (rowSelection && !('selectedRowKeys' in rowSelection)) {
        this.store.setState({
          selectedRowKeys: selectedRowKeys
        });
      }
      var data = this.getFlatData();
      if (!rowSelection.onChange && !rowSelection[selectWay]) {
        return;
      }
      var selectedRows = _filterInstanceProperty(data).call(data, function (row, i) {
        return _indexOfInstanceProperty(selectedRowKeys).call(selectedRowKeys, _this3.getRecordKey(row, i)) >= 0;
      });
      if (rowSelection.onChange) {
        rowSelection.onChange(selectedRowKeys, selectedRows);
      }
      if (selectWay === 'onSelect' && rowSelection.onSelect) {
        rowSelection.onSelect(record, checked, selectedRows, nativeEvent);
      } else if (selectWay === 'onSelectMultiple' && rowSelection.onSelectMultiple) {
        var changeRows = _filterInstanceProperty(data).call(data, function (row, i) {
          return _indexOfInstanceProperty(changeRowKeys).call(changeRowKeys, _this3.getRecordKey(row, i)) >= 0;
        });
        rowSelection.onSelectMultiple(checked, selectedRows, changeRows);
      } else if (selectWay === 'onSelectAll' && rowSelection.onSelectAll) {
        var _changeRows = _filterInstanceProperty(data).call(data, function (row, i) {
          return _indexOfInstanceProperty(changeRowKeys).call(changeRowKeys, _this3.getRecordKey(row, i)) >= 0;
        });
        rowSelection.onSelectAll(checked, selectedRows, _changeRows);
      } else if (selectWay === 'onSelectInvert' && rowSelection.onSelectInvert) {
        rowSelection.onSelectInvert(selectedRowKeys);
      }
    }
  }, {
    key: "hasPagination",
    value: function hasPagination(props) {
      return (props || this.props).pagination !== false;
    }
  }, {
    key: "getDefaultSortOrder",
    value: function getDefaultSortOrder(columns) {
      var definedSortState = getSortStateFromColumns(columns);
      var defaultSortedColumn = flatFilter(columns || [], function (column) {
        return column.defaultSortOrder != null;
      })[0];
      if (defaultSortedColumn && !definedSortState.sortColumn) {
        return {
          sortColumn: defaultSortedColumn,
          sortOrder: defaultSortedColumn.defaultSortOrder
        };
      }
      return definedSortState;
    }
  }, {
    key: "getSorterFn",
    value: function getSorterFn() {
      var _this$state = this.state,
        sortOrder = _this$state.sortOrder,
        sortColumn = _this$state.sortColumn;
      if (!sortOrder || !sortColumn || typeof sortColumn.sorter !== 'function') {
        return;
      }
      return function (a, b) {
        var result = sortColumn.sorter(a, b, sortOrder);
        if (result !== 0) {
          return sortOrder === 'descend' ? -result : result;
        }
        return 0;
      };
    }
  }, {
    key: "toggleSortOrder",
    value: function toggleSortOrder(order, column) {
      var _this$state2 = this.state,
        sortColumn = _this$state2.sortColumn,
        sortOrder = _this$state2.sortOrder;
      // 只同时允许一列进行排序，否则会导致排序顺序的逻辑问题
      var isSortColumn = this.isSortColumn(column);
      if (!isSortColumn) {
        // 当前列未排序
        sortOrder = order;
        sortColumn = column;
      } else {
        // 当前列已排序
        if (sortOrder === order) {
          // 切换为未排序状态
          sortOrder = undefined;
          sortColumn = null;
        } else {
          // 切换为排序状态
          sortOrder = order;
        }
      }
      var newState = {
        sortOrder: sortOrder,
        sortColumn: sortColumn
      };
      // Controlled
      if (getSortOrderColumns(this.state.columns).length === 0) {
        this.setState(newState);
      }
      var onChange = this.props.onChange;
      if (onChange) {
        onChange.apply(null, this.prepareParamsArguments(_Object$assign(_Object$assign({}, this.state), newState)));
      }
    }
  }, {
    key: "toggleTwoStateSortOrder",
    value: function toggleTwoStateSortOrder(order, column) {
      var _this$state3 = this.state,
        sortColumn = _this$state3.sortColumn,
        sortOrder = _this$state3.sortOrder;
      // 只同时允许一列进行排序，否则会导致排序顺序的逻辑问题
      var isSortColumn = this.isSortColumn(column);
      if (!isSortColumn) {
        // 当前列未排序
        sortOrder = order;
        sortColumn = column;
      } else {
        // 当前列已排序
        if (order === 'ascend') {
          sortOrder = 'descend';
        } else if (order === 'descend') {
          sortOrder = 'ascend';
        }
      }
      var newState = {
        sortOrder: sortOrder,
        sortColumn: sortColumn
      };
      // Controlled
      if (getSortOrderColumns(this.state.columns).length === 0) {
        this.setState(newState);
      }
      var onChange = this.props.onChange;
      if (onChange) {
        onChange.apply(null, this.prepareParamsArguments(_Object$assign(_Object$assign({}, this.state), newState)));
      }
    }
  }, {
    key: "renderRowSelection",
    value: function renderRowSelection(locale) {
      var _context15,
        _this4 = this;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        rowSelection = _this$props2.rowSelection;
      var columns = _concatInstanceProperty(_context15 = this.state.columns).call(_context15);
      if (rowSelection) {
        var _context16;
        var data = _filterInstanceProperty(_context16 = this.getFlatCurrentPageData()).call(_context16, function (item, index) {
          if (rowSelection.getCheckboxProps) {
            return !_this4.getCheckboxPropsByItem(item, index).disabled;
          }
          return true;
        });
        var selectionColumnClass = classNames("".concat(prefixCls, "-selection-column"), _defineProperty({}, "".concat(prefixCls, "-selection-column-custom"), rowSelection.selections));
        var selectionColumn = {
          key: 'selection-column',
          render: this.renderSelectionBox(rowSelection.type),
          className: selectionColumnClass,
          fixed: rowSelection.fixed,
          width: rowSelection.columnWidth,
          title: rowSelection.columnTitle
        };
        var _rowSelection$showSel = rowSelection.showSelectAll,
          showSelectAll = _rowSelection$showSel === void 0 ? true : _rowSelection$showSel;
        if (rowSelection.type !== 'radio' && showSelectAll) {
          var checkboxAllDisabled = _everyInstanceProperty(data).call(data, function (item, index) {
            return _this4.getCheckboxPropsByItem(item, index).disabled;
          });
          selectionColumn.title = /*#__PURE__*/React.createElement(SelectionCheckboxAll, {
            store: this.store,
            locale: locale,
            data: data,
            getCheckboxPropsByItem: this.getCheckboxPropsByItem,
            getRecordKey: this.getRecordKey,
            disabled: checkboxAllDisabled,
            prefixCls: prefixCls,
            onSelect: this.handleSelectRow,
            selections: rowSelection.selections,
            hideDefaultSelections: rowSelection.hideDefaultSelections,
            getPopupContainer: this.getPopupContainer
          });
        }
        if ('fixed' in rowSelection) {
          selectionColumn.fixed = rowSelection.fixed;
        } else if (_someInstanceProperty(columns).call(columns, function (column) {
          return column.fixed === 'left' || column.fixed === true;
        })) {
          selectionColumn.fixed = 'left';
        }
        if (columns[0] && columns[0].key === 'selection-column') {
          columns[0] = selectionColumn;
        } else {
          columns.unshift(selectionColumn);
        }
      }
      return columns;
    }
  }, {
    key: "renderColumnsFiltrate",
    value: function renderColumnsFiltrate(columnsProps, locale) {
      var _this$props3 = this.props,
        prefixCls = _this$props3.prefixCls,
        columnFiltrate = _this$props3.columnFiltrate;
      var columns = _concatInstanceProperty(columnsProps).call(columnsProps);
      if (columnFiltrate) {
        var filtrateColumn = {
          key: 'filtrate-column',
          className: classNames("".concat(prefixCls, "-filtrate-column")),
          width: 50,
          title: columnFiltrate.draggable ? /*#__PURE__*/React.createElement(ColumnFiltrateDraggableModal, {
            locale: locale,
            prefixCls: prefixCls,
            columns: this.state.columns,
            hideColumns: this.state.hideColumns,
            defaultColumns: columnFiltrate.defaultColumns,
            onChange: this.handleColumnsFiltrateDraggableChange
          }) : /*#__PURE__*/React.createElement(ColumnFiltrateModal, {
            prefixCls: prefixCls,
            columns: this.state.columns,
            hideColumns: this.state.hideColumns,
            defaultColumns: columnFiltrate.defaultColumns,
            onChange: this.handleColumnsFiltrateChange
          })
        };
        if (_typeof(columnFiltrate) === 'object' && 'fixed' in columnFiltrate) {
          filtrateColumn.fixed = columnFiltrate.fixed;
        } else if (_someInstanceProperty(columns).call(columns, function (column) {
          return column.fixed === 'right' || column.fixed === true;
        })) {
          filtrateColumn.fixed = 'right';
        }
        if (columns[columns.length - 1] && columns[columns.length - 1].key === 'filtrate-column') {
          columns[columns.length - 1] = filtrateColumn;
        } else {
          columns.push(filtrateColumn);
        }
      }
      return columns;
    }
  }, {
    key: "getColumnKey",
    value: function getColumnKey(column, index) {
      return column.key || column.dataIndex || index;
    }
  }, {
    key: "getMaxCurrent",
    value: function getMaxCurrent(total) {
      var _this$state$paginatio = this.state.pagination,
        current = _this$state$paginatio.current,
        pageSize = _this$state$paginatio.pageSize;
      if ((current - 1) * pageSize >= total) {
        return Math.floor((total - 1) / pageSize) + 1;
      }
      return current;
    }
  }, {
    key: "isSortColumn",
    value: function isSortColumn(column) {
      var sortColumn = this.state.sortColumn;
      if (!column || !sortColumn) {
        return false;
      }
      return this.getColumnKey(sortColumn) === this.getColumnKey(column);
    }
  }, {
    key: "renderColumnsDropdown",
    value: function renderColumnsDropdown(columns, locale) {
      var _this5 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        dropdownPrefixCls = _this$props4.dropdownPrefixCls;
      var sortOrder = this.state.sortOrder;
      return treeMap(columns, function (originColumn, i) {
        var column = _Object$assign({}, originColumn);
        var key = _this5.getColumnKey(column, i);
        var filterDropdown;
        var sortButton;
        if (column.filters && column.filters.length > 0 || column.filterDropdown) {
          var colFilters = _this5.state.filters[key] || [];
          filterDropdown = /*#__PURE__*/React.createElement(FilterDropdown, {
            locale: locale,
            column: column,
            selectedKeys: colFilters,
            confirmFilter: _this5.handleFilter,
            prefixCls: "".concat(prefixCls, "-filter"),
            dropdownPrefixCls: dropdownPrefixCls || 'fishd-dropdown',
            getPopupContainer: _this5.getPopupContainer
          });
        }
        if (column.sorter) {
          var isSortColumn = _this5.isSortColumn(column);
          if (isSortColumn) {
            column.className = classNames(column.className, _defineProperty({}, "".concat(prefixCls, "-column-sort"), sortOrder));
          }
          var isAscend = isSortColumn && sortOrder === 'ascend';
          var isDescend = isSortColumn && sortOrder === 'descend';
          if (column.sorterType === 'firstLetter') {
            var sortButtonInner = function sortButtonInner() {
              if (isAscend) {
                var _context17;
                return /*#__PURE__*/React.createElement("span", {
                  className: _concatInstanceProperty(_context17 = "".concat(prefixCls, "-column-sorter-up ")).call(_context17, isAscend ? 'on' : 'off'),
                  onClick: function onClick() {
                    return _this5.toggleTwoStateSortOrder('ascend', column);
                  }
                }, /*#__PURE__*/React.createElement(Icon, {
                  type: "a-z"
                }));
              } else if (isDescend) {
                var _context18;
                return /*#__PURE__*/React.createElement("span", {
                  className: _concatInstanceProperty(_context18 = "".concat(prefixCls, "-column-sorter-down ")).call(_context18, isDescend ? 'on' : 'off'),
                  onClick: function onClick() {
                    return _this5.toggleTwoStateSortOrder('descend', column);
                  },
                  style: {
                    top: -2
                  }
                }, /*#__PURE__*/React.createElement(Icon, {
                  type: "z-a"
                }));
              } else {
                return /*#__PURE__*/React.createElement("span", {
                  className: "".concat(prefixCls, "-column-sorter-up"),
                  onClick: function onClick() {
                    return _this5.toggleTwoStateSortOrder('ascend', column);
                  }
                }, /*#__PURE__*/React.createElement(Icon, {
                  type: "a-z"
                }));
              }
            };
            sortButton = /*#__PURE__*/React.createElement("div", {
              className: "".concat(prefixCls, "-column-sorter")
            }, sortButtonInner());
          } else {
            var _context19, _context20;
            sortButton = /*#__PURE__*/React.createElement("div", {
              className: "".concat(prefixCls, "-column-sorter")
            }, /*#__PURE__*/React.createElement("span", {
              className: _concatInstanceProperty(_context19 = "".concat(prefixCls, "-column-sorter-up ")).call(_context19, isAscend ? 'on' : 'off'),
              title: "\u2191",
              onClick: function onClick() {
                return _this5.toggleSortOrder('ascend', column);
              }
            }, /*#__PURE__*/React.createElement(Icon, {
              type: "up-fill"
            })), /*#__PURE__*/React.createElement("span", {
              className: _concatInstanceProperty(_context20 = "".concat(prefixCls, "-column-sorter-down ")).call(_context20, isDescend ? 'on' : 'off'),
              title: "\u2193",
              onClick: function onClick() {
                return _this5.toggleSortOrder('descend', column);
              }
            }, /*#__PURE__*/React.createElement(Icon, {
              type: "down-fill"
            })));
          }
        }
        column.title = /*#__PURE__*/React.createElement("span", {
          key: key
        }, column.title, sortButton, filterDropdown);
        if (sortButton || filterDropdown) {
          column.className = classNames("".concat(prefixCls, "-column-has-filters"), column.className);
        }
        return column;
      });
    }
  }, {
    key: "renderPagination",
    value: function renderPagination(paginationPosition) {
      // 强制不需要分页
      if (!this.hasPagination()) {
        return null;
      }
      var size = 'default';
      var pagination = this.state.pagination;
      if (pagination.size) {
        size = pagination.size;
      } else if (this.props.size === 'small') {
        size = 'small';
      }
      var position = pagination.position || 'bottom';
      var total = pagination.total || this.getLocalData().length;
      return total > 0 && (position === paginationPosition || position === 'both') ? /*#__PURE__*/React.createElement(Pagination, _Object$assign({
        key: "pagination-".concat(paginationPosition)
      }, pagination, {
        className: classNames(pagination.className, "".concat(this.props.prefixCls, "-pagination")),
        onChange: this.handlePageChange,
        total: total,
        size: size,
        current: this.getMaxCurrent(total),
        onShowSizeChange: this.handleShowSizeChange
      })) : null;
    }
    // Get pagination, filters, sorter
  }, {
    key: "prepareParamsArguments",
    value: function prepareParamsArguments(state) {
      var pagination = _Object$assign({}, state.pagination);
      // remove useless handle function in Table.onChange
      delete pagination.onChange;
      delete pagination.onShowSizeChange;
      var filters = state.filters;
      var sorter = {};
      if (state.sortColumn && state.sortOrder) {
        sorter.column = state.sortColumn;
        sorter.order = state.sortOrder;
        sorter.field = state.sortColumn.dataIndex;
        sorter.columnKey = this.getColumnKey(state.sortColumn);
      }
      return [pagination, filters, sorter];
    }
  }, {
    key: "findColumn",
    value: function findColumn(myKey) {
      var _this6 = this;
      var column;
      treeMap(this.state.columns, function (c) {
        if (_this6.getColumnKey(c) === myKey) {
          column = c;
        }
      });
      return column;
    }
  }, {
    key: "getCurrentPageData",
    value: function getCurrentPageData() {
      var data = this.getLocalData();
      var current;
      var pageSize;
      var state = this.state;
      // 如果没有分页的话，默认全部展示
      if (!this.hasPagination()) {
        pageSize = Number.MAX_VALUE;
        current = 1;
      } else {
        pageSize = state.pagination.pageSize;
        current = this.getMaxCurrent(state.pagination.total || data.length);
      }
      // 分页
      // ---
      // 当数据量少于等于每页数量时，直接设置数据
      // 否则进行读取分页数据
      if (data.length > pageSize || pageSize === Number.MAX_VALUE) {
        data = _filterInstanceProperty(data).call(data, function (_, i) {
          return i >= (current - 1) * pageSize && i < current * pageSize;
        });
      }
      return data;
    }
  }, {
    key: "getFlatData",
    value: function getFlatData() {
      return flatArray(this.getLocalData());
    }
  }, {
    key: "getFlatCurrentPageData",
    value: function getFlatCurrentPageData() {
      return flatArray(this.getCurrentPageData());
    }
  }, {
    key: "recursiveSort",
    value: function recursiveSort(data, sorterFn) {
      var _context21,
        _this7 = this;
      var _this$props$childrenC = this.props.childrenColumnName,
        childrenColumnName = _this$props$childrenC === void 0 ? 'children' : _this$props$childrenC;
      return _mapInstanceProperty(_context21 = _sortInstanceProperty(data).call(data, sorterFn)).call(_context21, function (item) {
        return item[childrenColumnName] ? _Object$assign(_Object$assign({}, item), _defineProperty({}, childrenColumnName, _this7.recursiveSort(item[childrenColumnName], sorterFn))) : item;
      });
    }
  }, {
    key: "getLocalData",
    value: function getLocalData() {
      var _this8 = this;
      var state = this.state;
      var dataSource = this.props.dataSource;
      var data = dataSource || [];
      // 优化本地排序
      data = _sliceInstanceProperty(data).call(data, 0);
      var sorterFn = this.getSorterFn();
      if (sorterFn) {
        data = this.recursiveSort(data, sorterFn);
      }
      // 筛选
      if (state.filters) {
        var _context22;
        _forEachInstanceProperty(_context22 = _Object$keys(state.filters)).call(_context22, function (columnKey) {
          var col = _this8.findColumn(columnKey);
          if (!col) {
            return;
          }
          var values = state.filters[columnKey] || [];
          if (values.length === 0) {
            return;
          }
          var onFilter = col.onFilter;
          data = onFilter ? _filterInstanceProperty(data).call(data, function (record) {
            return _someInstanceProperty(values).call(values, function (v) {
              return onFilter(v, record);
            });
          }) : data;
        });
      }
      return data;
    }
  }, {
    key: "render",
    value: function render() {
      var _this9 = this;
      var _this$props5 = this.props,
        style = _this$props5.style,
        className = _this$props5.className,
        prefixCls = _this$props5.prefixCls;
      var data = this.getCurrentPageData();
      var loading = this.props.loading;
      if (typeof loading === 'boolean') {
        loading = {
          spinning: loading
        };
      }
      // if there is no pagination or no data,
      // the height of spin should decrease by half of pagination
      var paginationPatchClass = this.hasPagination() && data && data.length !== 0 ? "".concat(prefixCls, "-with-pagination") : "".concat(prefixCls, "-without-pagination");
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Table"
      }, function (Locale) {
        var _context23;
        return /*#__PURE__*/React.createElement("div", {
          className: classNames("".concat(prefixCls, "-wrapper"), className),
          style: style
        }, /*#__PURE__*/React.createElement(Spin, _Object$assign({}, loading, {
          className: loading.spinning ? _concatInstanceProperty(_context23 = "".concat(paginationPatchClass, " ")).call(_context23, prefixCls, "-spin-holder") : ''
        }), _this9.renderPagination('top'), /*#__PURE__*/React.createElement("div", null, _this9.renderTable(loading, Locale)), _this9.renderPagination('bottom')));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      var columns = getColumns(nextProps);
      newState.columns = columns;
      if ('pagination' in nextProps || 'pagination' in prevProps) {
        var newPagination = _Object$assign(_Object$assign(_Object$assign({}, defaultPagination), prevState.pagination), nextProps.pagination);
        newPagination.current = newPagination.current || 1;
        newPagination.pageSize = newPagination.pageSize || 10;
        newState.pagination = nextProps.pagination !== false ? newPagination : emptyObject;
      }
      if (getSortOrderColumns(columns).length > 0) {
        var sortState = getSortStateFromColumns(columns);
        if (sortState.sortColumn !== prevState.sortColumn || sortState.sortOrder !== prevState.sortOrder) {
          newState = _Object$assign(_Object$assign({}, newState), sortState);
        }
      }
      var filteredValueColumns = getFilteredValueColumns(columns);
      if (filteredValueColumns.length > 0) {
        var _context24;
        var filtersFromColumns = getFiltersFromColumns(columns);
        var newFilters = _Object$assign({}, prevState.filters);
        _forEachInstanceProperty(_context24 = _Object$keys(filtersFromColumns)).call(_context24, function (key) {
          newFilters[key] = filtersFromColumns[key];
        });
        if (isFiltersChanged(newFilters, prevState.filters)) {
          newState.filters = newFilters;
        }
      }
      return _Object$assign(_Object$assign({}, newState), getComponents(prevState, nextProps.components, prevProps.components));
    }
  }]);
  return Table;
}(React.Component);
Table.Column = Column;
Table.ColumnGroup = ColumnGroup;
Table.propTypes = {
  dataSource: PropTypes.array,
  columns: PropTypes.array,
  activeRowByClick: PropTypes.bool,
  prefixCls: PropTypes.string,
  useFixedHeader: PropTypes.bool,
  rowSelection: PropTypes.object,
  columnFiltrate: PropTypes.object,
  className: PropTypes.string,
  size: PropTypes.string,
  loading: PropTypes.oneOfType([PropTypes.bool, PropTypes.object]),
  bordered: PropTypes.bool,
  onChange: PropTypes.func,
  locale: PropTypes.object,
  dropdownPrefixCls: PropTypes.string
};
Table.defaultProps = {
  activeRowByClick: false,
  dataSource: [],
  prefixCls: 'fishd-table',
  useFixedHeader: false,
  className: '',
  size: 'default',
  loading: false,
  bordered: false,
  indentSize: 20,
  locale: {},
  rowKey: 'key',
  showHeader: true
};
polyfill(Table);
export default Table;