import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import warning from 'warning';
import PropTypes from 'prop-types';
var TabBarTabsNode = /*#__PURE__*/function (_React$Component) {
  _inherits(TabBarTabsNode, _React$Component);
  var _super = _createSuper(TabBarTabsNode);
  function TabBarTabsNode() {
    _classCallCheck(this, TabBarTabsNode);
    return _super.apply(this, arguments);
  }
  _createClass(TabBarTabsNode, [{
    key: "render",
    value: function render() {
      var _context,
        _this = this;
      var _this$props = this.props,
        children = _this$props.panels,
        activeKey = _this$props.activeKey,
        prefixCls = _this$props.prefixCls,
        tabBarGutter = _this$props.tabBarGutter;
      var rst = [];
      _forEachInstanceProperty(_context = React.Children).call(_context, children, function (child, index) {
        if (!child) {
          return;
        }
        var key = child.key;
        var cls = activeKey === key ? "".concat(prefixCls, "-tab-active") : '';
        cls += " ".concat(prefixCls, "-tab");
        var events = {};
        if (child.props.disabled) {
          cls += " ".concat(prefixCls, "-tab-disabled");
        } else {
          var _context2;
          events = {
            onClick: _bindInstanceProperty(_context2 = _this.props.onTabClick).call(_context2, _this, key)
          };
        }
        var ref = {};
        if (activeKey === key) {
          ref.ref = _this.props.saveRef('activeTab');
        }
        warning('tab' in child.props, 'There must be `tab` property on children of Tabs.');
        rst.push( /*#__PURE__*/React.createElement("div", _Object$assign({
          role: "tab",
          "aria-disabled": child.props.disabled ? 'true' : 'false',
          "aria-selected": activeKey === key ? 'true' : 'false'
        }, events, {
          className: cls,
          key: key,
          style: {
            marginRight: tabBarGutter && index === children.length - 1 ? 0 : tabBarGutter
          }
        }, ref), child.props.tab));
      });
      return rst;
    }
  }]);
  return TabBarTabsNode;
}(React.Component);
export { TabBarTabsNode as default };
TabBarTabsNode.propTypes = {
  activeKey: PropTypes.string.isRequired,
  panels: PropTypes.node,
  prefixCls: PropTypes.string,
  tabBarGutter: PropTypes.number,
  onTabClick: PropTypes.func,
  saveRef: PropTypes.func
};
TabBarTabsNode.defaultProps = {
  panels: [],
  prefixCls: [],
  tabBarGutter: null,
  onTabClick: function onTabClick() {},
  saveRef: function saveRef() {}
};