import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _reverseInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reverse";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import classNames from 'classnames';
import TimelineItem from './TimelineItem';
import Icon from '../Icon';
var Timeline = /*#__PURE__*/function (_React$Component) {
  _inherits(Timeline, _React$Component);
  var _super = _createSuper(Timeline);
  function Timeline() {
    _classCallCheck(this, Timeline);
    return _super.apply(this, arguments);
  }
  _createClass(Timeline, [{
    key: "render",
    value: function render() {
      var _context, _classNames, _context2, _context3, _context4, _context5;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        _a$pending = _a.pending,
        pending = _a$pending === void 0 ? null : _a$pending,
        pendingDot = _a.pendingDot,
        children = _a.children,
        className = _a.className,
        reverse = _reverseInstanceProperty(_a),
        mode = _a.mode,
        restProps = __rest(_a, ["prefixCls", "pending", "pendingDot", "children", "className", "reverse", "mode"]);
      var pendingNode = typeof pending === 'boolean' ? null : pending;
      var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-pending"), !!pending), _defineProperty(_classNames, "".concat(prefixCls, "-reverse"), !!reverse), _defineProperty(_classNames, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, mode), !!mode), _classNames), className);
      var pendingItem = pending ? /*#__PURE__*/React.createElement(TimelineItem, {
        pending: !!pending,
        dot: pendingDot || /*#__PURE__*/React.createElement(Icon, {
          type: "load-line",
          spinning: true
        })
      }, pendingNode) : null;
      var timeLineItems = reverse ? _concatInstanceProperty(_context2 = [pendingItem]).call(_context2, _toConsumableArray(_reverseInstanceProperty(_context3 = React.Children.toArray(children)).call(_context3))) : _concatInstanceProperty(_context4 = []).call(_context4, _toConsumableArray(React.Children.toArray(children)), [pendingItem]);
      // Remove falsy items
      var truthyItems = _filterInstanceProperty(timeLineItems).call(timeLineItems, function (item) {
        return !!item;
      });
      var itemsCount = React.Children.count(truthyItems);
      var lastCls = "".concat(prefixCls, "-item-last");
      var items = _mapInstanceProperty(_context5 = React.Children).call(_context5, truthyItems, function (ele, idx) {
        return /*#__PURE__*/React.cloneElement(ele, {
          className: classNames([ele.props.className, !reverse && !!pending ? idx === itemsCount - 2 ? lastCls : '' : idx === itemsCount - 1 ? lastCls : '', mode === 'alternate' ? idx % 2 === 0 ? "".concat(prefixCls, "-item-left") : "".concat(prefixCls, "-item-right") : mode === 'right' ? "".concat(prefixCls, "-item-right") : ''])
        });
      });
      return /*#__PURE__*/React.createElement("ul", _Object$assign({}, restProps, {
        className: classString
      }), items);
    }
  }]);
  return Timeline;
}(React.Component);
export { Timeline as default };
Timeline.Item = TimelineItem;
Timeline.defaultProps = {
  prefixCls: 'fishd-timeline',
  reverse: false,
  mode: ''
};