import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import classNames from 'classnames';
import PureRenderMixin from '../Checkbox/src/PureRenderMixin';
import Checkbox from '../Checkbox';
import Icon from '../Icon';
import Lazyload from 'react-lazy-load';
var Item = /*#__PURE__*/function (_React$Component) {
  _inherits(Item, _React$Component);
  var _super = _createSuper(Item);
  function Item() {
    _classCallCheck(this, Item);
    return _super.apply(this, arguments);
  }
  _createClass(Item, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return PureRenderMixin.shouldComponentUpdate.apply(this, args);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        mode = _this$props.mode,
        direction = _this$props.direction,
        renderedText = _this$props.renderedText,
        renderedEl = _this$props.renderedEl,
        item = _this$props.item,
        lazy = _this$props.lazy,
        checked = _this$props.checked,
        prefixCls = _this$props.prefixCls,
        onClick = _this$props.onClick,
        onClose = _this$props.onClose;
      var className = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-content-item"), true), _defineProperty(_classNames, "".concat(prefixCls, "-content-item-disabled"), item.disabled), _classNames));
      var listItem = /*#__PURE__*/React.createElement("li", {
        className: className,
        title: renderedText
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-content-item-text"),
        onClick: item.disabled ? undefined : function () {
          return onClick(item, direction);
        }
      }, mode === 'multiple' ? /*#__PURE__*/React.createElement(Checkbox, {
        checked: checked,
        disabled: item.disabled
      }) : null, /*#__PURE__*/React.createElement("span", null, renderedEl)), mode === 'single' && direction === 'right' ? /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-content-item-close"),
        onClick: item.disabled ? undefined : function () {
          return onClose(item);
        }
      }, /*#__PURE__*/React.createElement(Icon, {
        type: "close-modal-line"
      })) : null);
      var children = null;
      if (lazy) {
        var lazyProps = _Object$assign({
          height: 32,
          offset: 500,
          throttle: 0,
          debounce: false
        }, lazy);
        children = /*#__PURE__*/React.createElement(Lazyload, _Object$assign({}, lazyProps), listItem);
      } else {
        children = listItem;
      }
      return children;
    }
  }]);
  return Item;
}(React.Component);
export { Item as default };