import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _everyInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/every";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import classNames from 'classnames';
import Checkbox from '../Checkbox';
import PureRenderMixin from '../Checkbox/src/PureRenderMixin';
import Search from './Search';
import Item from './Item';
import Animate from 'rc-animate';
import triggerEvent from '../../utils/triggerEvent';
// case sensitive
function isIEorEDGE() {
  return document.documentMode || /Edge/.test(navigator.userAgent);
}
function noop() {}
function isRenderResultPlainObject(result) {
  return result && ! /*#__PURE__*/React.isValidElement(result) && Object.prototype.toString.call(result) === '[object Object]';
}
var TransferList = /*#__PURE__*/function (_React$Component) {
  _inherits(TransferList, _React$Component);
  var _super = _createSuper(TransferList);
  function TransferList(props) {
    var _this;
    _classCallCheck(this, TransferList);
    _this = _super.call(this, props);
    _this.handleSelect = function (selectedItem, direction) {
      var _this$props = _this.props,
        checkedKeys = _this$props.checkedKeys,
        mode = _this$props.mode;
      if (mode === 'single') {
        if (direction === 'right') {
          return;
        }
        _this.props.handleSelect(selectedItem, true);
      } else {
        var result = _someInstanceProperty(checkedKeys).call(checkedKeys, function (key) {
          return key === selectedItem.key;
        });
        _this.props.handleSelect(selectedItem, !result);
      }
    };
    // single模式下，点击目标列表中的关闭按钮
    _this.handleClose = function (selectedItem) {
      _this.props.handleClose(selectedItem);
    };
    _this.handleFilter = function (e) {
      _this.props.handleFilter(e);
      if (!e.target.value) {
        return;
      }
      // Manually trigger scroll event for lazy search bug
      // https://github.com/ant-design/ant-design/issues/5631
      _this.triggerScrollTimer = _setTimeout(function () {
        var transferNode = ReactDOM.findDOMNode(_assertThisInitialized(_this));
        var listNode = transferNode.querySelectorAll('.fishd-transfer-list-content')[0];
        if (listNode) {
          triggerEvent(listNode, 'scroll');
        }
      }, 0);
      _this.fixIERepaint();
    };
    _this.handleClear = function () {
      _this.props.handleClear();
      _this.fixIERepaint();
    };
    _this.matchFilter = function (text, item) {
      var _this$props2 = _this.props,
        filter = _filterInstanceProperty(_this$props2),
        filterOption = _this$props2.filterOption;
      if (filterOption) {
        return filterOption(filter, item);
      }
      return _indexOfInstanceProperty(text).call(text, filter) >= 0;
    };
    _this.renderItem = function (item) {
      var _this$props$render = _this.props.render,
        render = _this$props$render === void 0 ? noop : _this$props$render;
      var renderResult = render(item);
      var isRenderResultPlain = isRenderResultPlainObject(renderResult);
      return {
        renderedText: isRenderResultPlain ? renderResult.value : renderResult,
        renderedEl: isRenderResultPlain ? renderResult.label : renderResult
      };
    };
    _this.saveNotFoundRef = function (node) {
      _this.notFoundNode = node;
    };
    _this.state = {
      mounted: false
    };
    return _this;
  }
  _createClass(TransferList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.timer = _setTimeout(function () {
        _this2.setState({
          mounted: true
        });
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      clearTimeout(this.triggerScrollTimer);
      clearTimeout(this.fixIERepaintTimer);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return PureRenderMixin.shouldComponentUpdate.apply(this, args);
    }
  }, {
    key: "getCheckStatus",
    value: function getCheckStatus(filteredDataSource) {
      var checkedKeys = this.props.checkedKeys;
      if (checkedKeys.length === 0) {
        return 'none';
      } else if (_everyInstanceProperty(filteredDataSource).call(filteredDataSource, function (item) {
        return _indexOfInstanceProperty(checkedKeys).call(checkedKeys, item.key) >= 0;
      })) {
        return 'all';
      }
      return 'part';
    }
    // Fix IE/Edge repaint
    // https://github.com/ant-design/ant-design/issues/9697
    // https://stackoverflow.com/q/27947912/3040605
  }, {
    key: "fixIERepaint",
    value: function fixIERepaint() {
      var _this3 = this;
      if (!isIEorEDGE()) {
        return;
      }
      this.fixIERepaintTimer = _setTimeout(function () {
        if (_this3.notFoundNode) {
          // eslint-disable-next-line no-self-assign
          _this3.notFoundNode.className = _this3.notFoundNode.className;
        }
      }, 0);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this,
        _context,
        _context2;
      var _this$props3 = this.props,
        mode = _this$props3.mode,
        direction = _this$props3.direction,
        prefixCls = _this$props3.prefixCls,
        dataSource = _this$props3.dataSource,
        titleText = _this$props3.titleText,
        checkedKeys = _this$props3.checkedKeys,
        lazy = _this$props3.lazy,
        _this$props3$body = _this$props3.body,
        body = _this$props3$body === void 0 ? noop : _this$props3$body,
        _this$props3$footer = _this$props3.footer,
        footer = _this$props3$footer === void 0 ? noop : _this$props3$footer,
        showSearch = _this$props3.showSearch,
        style = _this$props3.style,
        filter = _filterInstanceProperty(_this$props3),
        searchPlaceholder = _this$props3.searchPlaceholder,
        notFoundContent = _this$props3.notFoundContent,
        itemUnit = _this$props3.itemUnit,
        itemsUnit = _this$props3.itemsUnit,
        onScroll = _this$props3.onScroll;
      // Custom Layout
      var footerDom = footer(_Object$assign({}, this.props));
      var bodyDom = body(_Object$assign({}, this.props));
      var listCls = classNames(prefixCls, _defineProperty({}, "".concat(prefixCls, "-with-footer"), !!footerDom));
      var filteredDataSource = [];
      var totalDataSource = [];
      var showItems = _mapInstanceProperty(dataSource).call(dataSource, function (item) {
        var _this4$renderItem = _this4.renderItem(item),
          renderedText = _this4$renderItem.renderedText,
          renderedEl = _this4$renderItem.renderedEl;
        if (filter && _trimInstanceProperty(filter).call(filter) && !_this4.matchFilter(renderedText, item)) {
          return null;
        }
        // all show items
        totalDataSource.push(item);
        if (!item.disabled) {
          // response to checkAll items
          filteredDataSource.push(item);
        }
        var checked = _indexOfInstanceProperty(checkedKeys).call(checkedKeys, item.key) >= 0;
        return /*#__PURE__*/React.createElement(Item, {
          mode: mode,
          direction: direction,
          key: item.key,
          item: item,
          lazy: lazy,
          renderedText: renderedText,
          renderedEl: renderedEl,
          checked: checked,
          prefixCls: prefixCls,
          onClick: _this4.handleSelect,
          onClose: _this4.handleClose
        });
      });
      var unit = dataSource.length > 1 ? itemsUnit : itemUnit;
      var search = showSearch ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-body-search-wrapper")
      }, /*#__PURE__*/React.createElement(Search, {
        prefixCls: "".concat(prefixCls, "-search"),
        onChange: this.handleFilter,
        handleClear: this.handleClear,
        placeholder: searchPlaceholder,
        value: filter
      })) : null;
      var listBody = bodyDom || /*#__PURE__*/React.createElement("div", {
        className: showSearch ? _concatInstanceProperty(_context = "".concat(prefixCls, "-body ")).call(_context, prefixCls, "-body-with-search") : "".concat(prefixCls, "-body")
      }, search, /*#__PURE__*/React.createElement(Animate, {
        component: "ul",
        componentProps: {
          onScroll: onScroll
        },
        className: "".concat(prefixCls, "-content"),
        transitionName: this.state.mounted ? "".concat(prefixCls, "-content-item-highlight") : '',
        transitionLeave: false
      }, showItems), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-body-not-found"),
        ref: this.saveNotFoundRef
      }, notFoundContent));
      var listFooter = footerDom ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-footer")
      }, footerDom) : null;
      var checkStatus = this.getCheckStatus(filteredDataSource);
      var checkedAll = checkStatus === 'all';
      var checkAllCheckbox = /*#__PURE__*/React.createElement(Checkbox, {
        ref: "checkbox",
        checked: checkedAll,
        indeterminate: checkStatus === 'part',
        onChange: function onChange() {
          return _this4.props.handleSelectAll(filteredDataSource, checkedAll);
        }
      });
      return /*#__PURE__*/React.createElement("div", {
        className: listCls,
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-header")
      }, mode === 'multiple' ? checkAllCheckbox : null, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-header-title")
      }, titleText), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-header-selected")
      }, mode === 'multiple' ? _concatInstanceProperty(_context2 = "".concat(checkedKeys.length, "/")).call(_context2, totalDataSource.length) : "".concat(totalDataSource.length), ' ', unit)), listBody, listFooter);
    }
  }]);
  return TransferList;
}(React.Component);
export { TransferList as default };
TransferList.defaultProps = {
  dataSource: [],
  titleText: '',
  showSearch: false,
  render: noop,
  lazy: {}
};