import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import RcTree, { TreeNode } from '../TreeSelect/rcTree';
import DirectoryTree from './DirectoryTree';
import classNames from 'classnames';
import animation from '../../utils/openAnimation';
import Icon from '../Icon';
var Tree = /*#__PURE__*/function (_React$Component) {
  _inherits(Tree, _React$Component);
  var _super = _createSuper(Tree);
  function Tree() {
    var _this;
    _classCallCheck(this, Tree);
    _this = _super.apply(this, arguments);
    _this.renderSwitcherIcon = function (_ref) {
      var isLeaf = _ref.isLeaf,
        expanded = _ref.expanded,
        loading = _ref.loading;
      var _this$props = _this.props,
        prefixCls = _this$props.prefixCls,
        showLine = _this$props.showLine;
      // if (loading) {
      //   return (
      //     <Icon
      //       type="load-line" spin={true}
      //       className={`${prefixCls}-switcher-loading-icon`}
      //     />
      //   );
      // }
      if (showLine) {
        if (isLeaf) {
          return /*#__PURE__*/React.createElement(Icon, {
            type: "file-line",
            className: "".concat(prefixCls, "-switcher-line-icon")
          });
        }
        return /*#__PURE__*/React.createElement(Icon, {
          type: expanded ? 'minus-square' : 'plus-square',
          className: "".concat(prefixCls, "-switcher-line-icon")
        });
      } else {
        if (isLeaf) {
          return null;
        }
        return /*#__PURE__*/React.createElement(Icon, {
          type: "down-fill",
          className: "".concat(prefixCls, "-switcher-icon")
        });
      }
    };
    return _this;
  }
  _createClass(Tree, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var props = this.props;
      var prefixCls = props.prefixCls,
        className = props.className,
        style = props.style,
        showIcon = props.showIcon,
        required = props.required;
      var checkable = props.checkable;
      return /*#__PURE__*/React.createElement(RcTree, _Object$assign({}, props, {
        ref: function ref(node) {
          return _this2.tree = node;
        },
        className: classNames(!showIcon && "".concat(prefixCls, "-icon-hide"), className),
        checkable: checkable ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-checkbox-inner")
        }) : checkable,
        switcherIcon: this.renderSwitcherIcon,
        required: required,
        style: style
      }), this.props.children);
    }
  }]);
  return Tree;
}(React.Component);
export { Tree as default };
Tree.TreeNode = TreeNode;
Tree.DirectoryTree = DirectoryTree;
Tree.defaultProps = {
  autoExpandParent: true,
  checkable: false,
  defaultExpandAll: false,
  defaultExpandParent: true,
  required: false,
  openAnimation: _Object$assign(_Object$assign({}, animation), {
    appear: null
  }),
  prefixCls: 'fishd-tree',
  showIcon: false
};