import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import RcTreeSelect, { TreeNode, SHOW_ALL, SHOW_PARENT, SHOW_CHILD } from './rcTreeSelect';
import classNames from 'classnames';
import warning from 'warning';
import ConfigConsumer from '../Config/Locale/Consumer';
import './style/index.less';
var TreeSelect = /*#__PURE__*/function (_React$Component) {
  _inherits(TreeSelect, _React$Component);
  var _super = _createSuper(TreeSelect);
  function TreeSelect(props) {
    var _this;
    _classCallCheck(this, TreeSelect);
    _this = _super.call(this, props);
    // i18n
    _this.genPropsByLocale = function (Locale) {
      var _this$props = _this.props,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? Locale.placeholder : _this$props$placehold,
        _this$props$searchPla = _this$props.searchPlaceholder,
        searchPlaceholder = _this$props$searchPla === void 0 ? Locale.searchPlaceholder : _this$props$searchPla,
        _this$props$treeNodeR = _this$props.treeNodeResetTitle,
        treeNodeResetTitle = _this$props$treeNodeR === void 0 ? Locale.treeNodeResetTitle : _this$props$treeNodeR;
      return {
        searchPlaceholder: searchPlaceholder,
        placeholder: placeholder,
        treeNodeResetTitle: treeNodeResetTitle
      };
    };
    _this.saveTreeSelect = function (node) {
      _this.rcTreeSelect = node;
    };
    warning(props.multiple !== false || !props.treeCheckable, '`multiple` will alway be `true` when `treeCheckable` is true');
    return _this;
  }
  _createClass(TreeSelect, [{
    key: "focus",
    value: function focus() {
      this.rcTreeSelect.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.rcTreeSelect.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        size = _a.size,
        notFoundContent = _a.notFoundContent,
        dropdownStyle = _a.dropdownStyle,
        dropdownClassName = _a.dropdownClassName,
        treeCheckable = _a.treeCheckable,
        restProps = __rest(_a, ["prefixCls", "className", "size", "notFoundContent", "dropdownStyle", "dropdownClassName", "treeCheckable"]);
      var isEditableMul = (restProps.multiple || treeCheckable) && restProps.editable;
      var cls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-ctner"), true), _defineProperty(_classNames, "".concat(prefixCls, "-scroll"), isEditableMul), _defineProperty(_classNames, "".concat(prefixCls, "-singleline"), !isEditableMul), _defineProperty(_classNames, "".concat(prefixCls, "-lg"), size === 'large'), _defineProperty(_classNames, "".concat(prefixCls, "-sm"), size === 'small'), _classNames), className);
      var checkable = treeCheckable;
      if (checkable) {
        checkable = /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-tree-checkbox-inner")
        });
      }
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "TreeSelect"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement(RcTreeSelect, _Object$assign({}, restProps, _this2.genPropsByLocale(Locale), {
          dropdownClassName: classNames(dropdownClassName, "".concat(prefixCls, "-tree-dropdown")),
          prefixCls: prefixCls,
          className: cls,
          dropdownStyle: _Object$assign({
            maxHeight: '100vh',
            overflow: 'auto'
          }, dropdownStyle),
          treeCheckable: checkable,
          notFoundContent: notFoundContent,
          ref: _this2.saveTreeSelect
        }));
      });
    }
  }]);
  return TreeSelect;
}(React.Component);
export { TreeSelect as default };
TreeSelect.TreeNode = TreeNode;
TreeSelect.SHOW_ALL = SHOW_ALL;
TreeSelect.SHOW_PARENT = SHOW_PARENT;
TreeSelect.SHOW_CHILD = SHOW_CHILD;
TreeSelect.defaultProps = {
  autoClearSearchValue: false,
  autoExpandParent: false,
  choiceTransitionName: 'zoom',
  editable: true,
  esc: true,
  required: false,
  prefixCls: 'fishd-treeselect',
  showCheckedStrategy: SHOW_PARENT,
  showSearch: false,
  tagWidth: 100,
  transitionName: 'slide-up',
  treeCheckStrictly: false,
  placement: 'bottomLeft',
  uniqueTreeNodeByLabel: false,
  getPopupContainer: function getPopupContainer() {
    return document.body;
  }
};