import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import BasePopup from '../Base/BasePopup';
import SearchInput from '../SearchInput';
import { createRef } from '../util';
var SinglePopup = /*#__PURE__*/function (_React$Component) {
  _inherits(SinglePopup, _React$Component);
  var _super = _createSuper(SinglePopup);
  function SinglePopup() {
    var _this;
    _classCallCheck(this, SinglePopup);
    _this = _super.call(this);
    _this.onPlaceholderClick = function () {
      _this.inputRef.current.focus();
    };
    _this.renderPlaceholder = function () {
      var _this$props = _this.props,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        prefixCls = _this$props.prefixCls;
      if (!searchPlaceholder) {
        return null;
      }
      return /*#__PURE__*/React.createElement("span", {
        style: {
          display: searchValue ? 'none' : 'block'
        },
        onClick: _this.onPlaceholderClick,
        className: "".concat(prefixCls, "-search__field__placeholder")
      }, searchPlaceholder);
    };
    _this.renderSearch = function () {
      var _this$props2 = _this.props,
        showSearch = _this$props2.showSearch,
        dropdownPrefixCls = _this$props2.dropdownPrefixCls;
      if (!showSearch) {
        return null;
      }
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(dropdownPrefixCls, "-search")
      }, /*#__PURE__*/React.createElement(SearchInput, _Object$assign({}, _this.props, {
        ref: _this.inputRef,
        renderPlaceholder: _this.renderPlaceholder
      })));
    };
    _this.renderResetItem = function () {
      var _this$props3 = _this.props,
        dropdownPrefixCls = _this$props3.dropdownPrefixCls,
        treeNodeResetTitle = _this$props3.treeNodeResetTitle,
        resetSelect = _this$props3.resetSelect;
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(dropdownPrefixCls, "-reset"),
        onClick: resetSelect
      }, treeNodeResetTitle);
    };
    _this.inputRef = createRef();
    return _this;
  }
  _createClass(SinglePopup, [{
    key: "render",
    value: function render() {
      var required = this.props.required;
      return /*#__PURE__*/React.createElement(BasePopup, _Object$assign({}, this.props, {
        renderSearch: this.renderSearch,
        renderResetItem: required ? null : this.renderResetItem
      }));
    }
  }]);
  return SinglePopup;
}(React.Component);
SinglePopup.propTypes = _Object$assign(_Object$assign({}, BasePopup.propTypes), {
  searchValue: PropTypes.string,
  showSearch: PropTypes.bool,
  dropdownPrefixCls: PropTypes.string,
  disabled: PropTypes.bool,
  required: PropTypes.bool,
  searchPlaceholder: PropTypes.string,
  treeNodeResetTitle: PropTypes.string,
  resetSelect: PropTypes.func
});
export default SinglePopup;