import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Icon from '../../Icon/index';
import Tooltip from '../../Tooltip/index';
import ConfigConsumer from '../../Config/Consumer';
var DownLoad = /*#__PURE__*/function (_Component) {
  _inherits(DownLoad, _Component);
  var _super = _createSuper(DownLoad);
  function DownLoad() {
    _classCallCheck(this, DownLoad);
    return _super.apply(this, arguments);
  }
  _createClass(DownLoad, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        vjsComponent = _this$props.vjsComponent,
        prefixCls = _this$props.prefixCls;
      var src = vjsComponent.options_.playerOptions.downloadSrc;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "VideoViewer"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", {
          className: classnames(prefixCls, 'fishd-video-js-customer-button')
        }, /*#__PURE__*/React.createElement(Tooltip, {
          title: /*#__PURE__*/React.createElement("span", {
            style: {
              wordBreak: 'keep-all'
            }
          }, Locale.download),
          getPopupContainer: function getPopupContainer(e) {
            return e.parentNode;
          }
        }, /*#__PURE__*/React.createElement("a", {
          download: true,
          href: src,
          target: "_blank",
          rel: "noopener noreferrer"
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "sound-download"
        }))));
      });
    }
  }]);
  return DownLoad;
}(Component);
export { DownLoad as default };
DownLoad.propTypes = {
  prefixCls: PropTypes.string,
  vjsComponent: PropTypes.object
};
DownLoad.defaultProps = {
  prefixCls: 'fishd-video-viewer-download'
};