import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Icon from '../../Icon/index';
import { MEDIA_ERROR } from '../constant';
import ConfigConsumer from '../../Config/Consumer';
var ErrorDisplay = /*#__PURE__*/function (_Component) {
  _inherits(ErrorDisplay, _Component);
  var _super = _createSuper(ErrorDisplay);
  function ErrorDisplay(props) {
    var _this;
    _classCallCheck(this, ErrorDisplay);
    _this = _super.call(this, props);
    _this.getMediaError = function () {
      _this.setState({
        mediaError: _this.player.error()
      });
    };
    // 断网重试
    _this.handleRetry = function () {
      var currentTime = _this.player.currentTime();
      _this.player.error(null);
      _this.player.pause();
      _this.player.load();
      _this.player.currentTime(currentTime);
      _this.player.play();
    };
    // 获取播放器实例
    _this.player = props.vjsComponent.player_;
    _this.state = {
      // MediaError对象, 包含了音频/视频的错误状态。http://www.w3school.com.cn/tags/av_prop_error.asp
      mediaError: null
    };
    return _this;
  }
  _createClass(ErrorDisplay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.player.on('error', this.getMediaError);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.player.off('error', this.getMediaError);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        vjsComponent = _this$props.vjsComponent,
        prefixCls = _this$props.prefixCls;
      var mediaError = this.state.mediaError;
      var errorMessage = mediaError !== null ? MEDIA_ERROR[mediaError.code] : '';
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "VideoViewer"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", {
          className: prefixCls
        }, mediaError ? /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-msg")
        }, errorMessage, mediaError.code === 2 ? /*#__PURE__*/React.createElement("a", {
          className: "".concat(prefixCls, "-retry"),
          onClick: _this2.handleRetry
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "picture-rotate"
        }), Locale.retry) : null) : null);
      });
    }
  }]);
  return ErrorDisplay;
}(Component);
export { ErrorDisplay as default };
ErrorDisplay.propTypes = {
  prefixCls: PropTypes.string,
  vjsComponent: PropTypes.object
};
ErrorDisplay.defaultProps = {
  prefixCls: 'fishd-video-error'
};