import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import ReactDOM from 'react-dom';
import videojs from 'video.js';
import Volume from './Volume';
var vjsComponent = videojs.getComponent('Component');
var vjsVolume = /*#__PURE__*/function (_vjsComponent) {
  _inherits(vjsVolume, _vjsComponent);
  var _super = _createSuper(vjsVolume);
  function vjsVolume(player, options) {
    var _context;
    var _this;
    _classCallCheck(this, vjsVolume);
    _this = _super.call(this, player, options);
    /* Bind the current class context to the mount method */
    _this.mount = _bindInstanceProperty(_context = _this.mount).call(_context, _assertThisInitialized(_this));
    /* When player is ready, call method to mount React component */
    player.ready(function () {
      _this.mount();
    });
    /* Remove React root when component is destroyed */
    _this.on("dispose", function () {
      ReactDOM.unmountComponentAtNode(_this.el());
    });
    return _this;
  }
  /**
   * We will render out the React component into the DOM element
   * generated automatically by the VideoJS createEl() method.
   *
   * We fetch that generated element using `this.el()`, a method provided by the
   * vjsComponent class that this class is extending.
   */
  _createClass(vjsVolume, [{
    key: "mount",
    value: function mount() {
      var el = this.el();
      el.className = "vjs-control vjs-button vjs-customer-button vjs-volume";
      ReactDOM.render( /*#__PURE__*/React.createElement(Volume, {
        vjsComponent: this
      }), el);
    }
  }]);
  return vjsVolume;
}(vjsComponent);
/**
 * Make sure to register the vjsComponent so Video JS knows it exists
 */
vjsComponent.registerComponent('vjsVolume', vjsVolume);
export default vjsVolume;