import React from 'react';
import { ColorType } from './QuickPanel';
interface BoardProps {
    color: ColorType;
    onChange: (color: ColorType) => void;
    rootPrefixCls: string;
}
export default class Board extends React.Component<BoardProps> {
    static propTypes: {
        color: any;
        onChange: any;
        rootPrefixCls: any;
    };
    constructor(props: any);
    componentWillUnmount(): void;
    onBoardMouseDown: (e: any) => void;
    onBoardTouchStart: (e: any) => void;
    onBoardTouchMove: (e: any) => void;
    onBoardTouchEnd: () => void;
    onBoardDrag: (e: any) => void;
    onBoardDragEnd: (e: any) => void;
    getPrefixCls: () => string;
    removeTouchListeners: () => void;
    removeListeners: () => void;
    /**
     * 移动光标位置到
     * @param  {object} pos X Y 全局坐标点
     */
    pointMoveTo: (pos: any) => void;
    render(): JSX.Element;
}
export {};
