import React from 'react';
export interface DividerProps {
    prefixCls?: string;
    type?: 'horizontal' | 'split' | 'vertical';
    orientation?: 'left' | 'right' | '' | 'top' | 'bottom';
    className?: string;
    children?: React.ReactNode;
    dashed?: boolean;
    style?: React.CSSProperties;
    textStyle?: React.CSSProperties;
}
export default function Divider({ prefixCls, type, orientation, className, children, dashed, textStyle, ...restProps }: DividerProps): JSX.Element;
