"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _src = _interopRequireDefault(require("./src"));
var _constants = require("./src/common/constants");
var _Modal = _interopRequireDefault(require("../Modal"));
var _Button = _interopRequireDefault(require("../Button"));
require("./style/index.less");
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Guide = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Guide, _Component);
  var _super = _createSuper(Guide);
  function Guide(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Guide);
    _this = _super.call(this, props);
    _this.totalCount = 0;
    _this.driver = null;
    _this.init = function () {
      var _this$props = _this.props,
        steps = _this$props.steps,
        mode = _this$props.mode;
      if (!(steps && steps.length) || mode == 'fixed') return;
      (0, _setTimeout2["default"])(function () {
        if (steps.length == 1) {
          _this.driver.highlight(steps[0]);
        } else {
          _this.driver.defineSteps(_this.props.steps);
          _this.driver.start();
        }
      }, 300);
    };
    _this.handleClose = function () {
      _this.setState({
        visible: false
      }, function () {
        _this.setState({
          currentIndex: 0
        });
      });
      _this.props.onClose && _this.props.onClose();
    };
    _this.handleNext = function () {
      var currentIndex = _this.state.currentIndex,
        nextIndex = 0;
      if (currentIndex >= _this.totalCount - 1) {
        nextIndex = _this.totalCount - 1;
        _this.handleClose();
      } else {
        nextIndex = currentIndex + 1;
      }
      _this.setState({
        currentIndex: nextIndex
      });
    };
    _this.handlePrev = function () {
      var currentIndex = _this.state.currentIndex,
        nextIndex = 0;
      if (currentIndex <= 0) {
        nextIndex = 0;
      } else {
        nextIndex = currentIndex - 1;
      }
      _this.setState({
        currentIndex: nextIndex
      });
    };
    _this.renderTitle = function (curStep) {
      if (!curStep.title) return null;
      if (curStep.subtitle) {
        return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, curStep.title, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(_this.props.prefixCls, "-fixed-subtitle")
        }, curStep.subtitle));
      } else {
        return curStep.title;
      }
    };
    _this.state = {
      visible: props.visible,
      currentIndex: 0
    };
    _this.totalCount = props.steps.length;
    if (props.mode != 'fixed') {
      var opt = {
        counter: props.counter,
        allowClose: props.allowClose,
        keyboardControl: props.keyboardControl,
        onReset: function onReset() {
          _this.handleClose();
        }
      };
      if (!props.mask) {
        opt['opacity'] = 0;
      }
      _this.driver = new _src["default"](opt);
    } else {
      if (props.keyboardControl) {
        var _context;
        window.addEventListener('keyup', (0, _bind["default"])(_context = _this.onKeyUp).call(_context, (0, _assertThisInitialized2["default"])(_this)), false);
      }
    }
    return _this;
  }
  (0, _createClass2["default"])(Guide, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var visible = this.state.visible;
      if (!visible) return;
      this.init();
    }
    // eslint-disable-next-line react/no-deprecated
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var _this2 = this;
      var visible = this.state.visible;
      if (!visible && nextProps.visible) {
        this.setState({
          visible: true
        }, function () {
          _this2.init();
        });
      }
    }
  }, {
    key: "onKeyUp",
    value: function onKeyUp(event) {
      if (!this.props.keyboardControl || this.props.mode != 'fixed') return;
      if (event.keyCode === _constants.ESC_KEY_CODE) {
        this.handleClose();
        return;
      }
      if (event.keyCode === _constants.RIGHT_KEY_CODE) {
        this.handleNext();
      } else if (event.keyCode === _constants.LEFT_KEY_CODE) {
        this.handlePrev();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        allowClose = _this$props2.allowClose,
        mode = _this$props2.mode,
        mask = _this$props2.mask,
        className = _this$props2.className,
        style = _this$props2.style,
        steps = _this$props2.steps,
        _this$state = this.state,
        visible = _this$state.visible,
        currentIndex = _this$state.currentIndex,
        rootCls = (0, _classnames["default"])("".concat(prefixCls, "-fixed"), (0, _defineProperty2["default"])({}, className, className)),
        isFirstStep = currentIndex <= 0,
        isLastStep = currentIndex >= this.totalCount - 1;
      if (mode != 'fixed') {
        return null;
      }
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "Guide"
      }, function (Locale) {
        var _context2;
        var _Locale$prevBtnText = Locale.prevBtnText,
          prevBtnText = _Locale$prevBtnText === void 0 ? '上一步' : _Locale$prevBtnText,
          _Locale$nextBtnText = Locale.nextBtnText,
          nextBtnText = _Locale$nextBtnText === void 0 ? '下一步' : _Locale$nextBtnText,
          _Locale$doneBtnText = Locale.doneBtnText,
          doneBtnText = _Locale$doneBtnText === void 0 ? '知道了' : _Locale$doneBtnText,
          _Locale$skipBtnText = Locale.skipBtnText,
          skipBtnText = _Locale$skipBtnText === void 0 ? '跳过' : _Locale$skipBtnText;
        return /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
          className: rootCls,
          style: (0, _assign["default"])({}, style),
          mask: mask,
          maskClosable: allowClose,
          title: _this3.renderTitle(steps[currentIndex]),
          visible: visible,
          width: 800,
          footer: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
            key: "skip",
            className: "skip",
            onClick: _this3.handleClose
          }, skipBtnText), isFirstStep ? null : /*#__PURE__*/_react["default"].createElement(_Button["default"], {
            key: "prev",
            onClick: _this3.handlePrev
          }, prevBtnText), /*#__PURE__*/_react["default"].createElement(_Button["default"], {
            key: "next",
            type: "primary",
            onClick: _this3.handleNext
          }, isLastStep ? doneBtnText : nextBtnText, (0, _concat["default"])(_context2 = " (".concat(currentIndex + 1, "/")).call(_context2, steps.length, ")"))),
          onCancel: _this3.handleClose
        }, steps[currentIndex].content);
      });
    }
  }]);
  return Guide;
}(_react.Component);
Guide.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  mode: _propTypes["default"].string,
  steps: _propTypes["default"].array.isRequired,
  visible: _propTypes["default"].bool,
  counter: _propTypes["default"].bool,
  mask: _propTypes["default"].bool,
  allowClose: _propTypes["default"].bool,
  keyboardControl: _propTypes["default"].bool,
  onClose: _propTypes["default"].func
};
Guide.defaultProps = {
  prefixCls: 'fishd-guide',
  mode: 'normal',
  allowClose: false,
  keyboardControl: false,
  visible: false,
  counter: true,
  mask: true,
  steps: []
};
var _default = Guide;
exports["default"] = _default;