"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
/**
 * Responsible for validating positions and is used
 * when manipulating positions across the application
 */
var Position = /*#__PURE__*/function () {
  function Position(props) {
    (0, _classCallCheck2["default"])(this, Position);
    this.left = props.left || 0;
    this.right = props.right || 0;
    this.top = props.top || 0;
    this.bottom = props.bottom || 0;
  }
  /**
   * Checks if the position is valid to be highlighted
   * @returns {boolean}
   * @public
   */
  (0, _createClass2["default"])(Position, [{
    key: "canHighlight",
    value: function canHighlight() {
      return this.left < this.right && this.top < this.bottom;
    }
  }]);
  return Position;
}();
exports["default"] = Position;