"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _omit = _interopRequireDefault(require("omit.js"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _TextArea = _interopRequireDefault(require("./TextArea"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function countValue(value) {
  return value.length;
}
var Counter = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Counter, _React$Component);
  var _super = _createSuper(Counter);
  function Counter(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Counter);
    _this = _super.call(this, props);
    _this.saveTextarea = function (node) {
      _this.textarea = node;
    };
    _this.handleClick = function () {
      _this.focus();
    };
    _this.handleTextareaChange = function (e) {
      var onChange = _this.props.onChange;
      var textareaValue = _this.textarea && _this.textarea.textAreaRef.value;
      _this.setState({
        value: textareaValue
      });
      if (onChange) {
        onChange(e);
      }
    };
    _this.getCount = function () {
      var count = _this.props.count;
      var value = _this.state.value;
      if (!value) {
        return 0;
      }
      // 自定义计数方法
      if (count) {
        return count(String(value));
      }
      return countValue(String(value));
    };
    var value = '';
    if ('value' in props) {
      value = props.value;
    } else if ('defaultValue' in props) {
      value = props.defaultValue;
    }
    _this.state = {
      value: value,
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(Counter, [{
    key: "focus",
    value: function focus() {
      this.textarea.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.textarea.blur();
    }
  }, {
    key: "getTextAreaClassName",
    value: function getTextAreaClassName() {
      var _this$props = this.props,
        inputPrefixCls = _this$props.inputPrefixCls,
        className = _this$props.className,
        disabled = _this$props.disabled;
      return (0, _classnames["default"])(inputPrefixCls, className, (0, _defineProperty2["default"])({}, "".concat(inputPrefixCls, "-disabled"), disabled));
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames2;
      var _this$props2 = this.props,
        inputPrefixCls = _this$props2.inputPrefixCls,
        className = _this$props2.className,
        prefixCls = _this$props2.prefixCls,
        disabled = _this$props2.disabled,
        limit = _this$props2.limit;
      var inputClassName = (0, _classnames["default"])(className, (_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls), true), (0, _defineProperty2["default"])(_classNames2, "".concat(inputPrefixCls, "-disabled"), disabled), _classNames2));
      var textareaClassName = (0, _classnames["default"])(inputPrefixCls, className);
      var otherProps = (0, _omit["default"])(this.props, ['inputPrefixCls', 'prefixCls', 'limit', 'count', 'value', 'onChange']);
      var total = this.getCount();
      return /*#__PURE__*/React.createElement("span", {
        className: inputClassName,
        onClick: this.handleClick
      }, /*#__PURE__*/React.createElement(_TextArea["default"], (0, _assign["default"])({}, otherProps, {
        className: textareaClassName,
        maxLength: limit,
        onChange: this.handleTextareaChange,
        value: this.state.value,
        ref: this.saveTextarea
      })), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-footer")
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-indicator")
      }, total, "/", limit)));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      if (prevProps.value !== nextProps.value) {
        newState.value = nextProps.value;
      }
      return newState;
    }
  }]);
  return Counter;
}(React.Component);
Counter.defaultProps = {
  inputPrefixCls: 'fishd-input',
  prefixCls: 'fishd-input-counter'
};
(0, _reactLifecyclesCompat.polyfill)(Counter);
var _default = Counter;
exports["default"] = _default;