"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var LocaleValue = {
  locale: 'en_US',
  AudioPlayer: {
    notSupport: 'Your browser does not support the audio tag'
  },
  AutoComplete: {
    notFoundContent: 'No data'
  },
  Cascader: {
    placeholder: 'Please select',
    notFoundContent: 'No data'
  },
  LoadMore: {
    defaultText: 'Show more',
    loadingText: 'Loading',
    errorText: 'Failed to load. Please try again',
    endText: 'No data'
  },
  Table: {
    filterTitle: 'Filters',
    filterConfirm: 'OK',
    filterReset: 'Reset',
    filterEmptyText: 'No filters',
    emptyText: 'No data',
    selectAll: 'Select current page',
    selectInvert: 'Invert current page',
    selectionAll: 'Select all data',
    sortTitle: 'Sort',
    expand: 'Expand row',
    collapse: 'Collapse row',
    triggerDesc: 'Click to sort descending',
    triggerAsc: 'Click to sort ascending',
    cancelSort: 'Click to cancel sorting',
    modalTitle: 'Select the data item to be displayed',
    defaultOptionTitle: 'Default display data items',
    okText: 'OK',
    cancelText: 'Cancel',
    draggableTitle: 'Field',
    draggableAction: 'Adjust the order'
  },
  DatePicker: {
    now: 'Now',
    today: 'Today',
    cancel: 'Cancel',
    clear: 'Clear',
    confirm: 'Confirm',
    startPlaceholder: 'Start date',
    endPlaceholder: 'End date',
    separator: '~',
    selectDate: 'Select date',
    selectTime: 'Select time',
    startDate: 'Start date',
    startTime: 'Start time',
    endDate: 'End date',
    endTime: 'End time',
    year: '',
    MONTH_ARRAY: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    week: 'Week',
    weeks: {
      sun: 'Sun',
      mon: 'Mon',
      tue: 'Tue',
      wed: 'Wed',
      thu: 'Thu',
      fri: 'Fri',
      sat: 'Sat'
    },
    months: {
      jan: 'Jan',
      feb: 'Feb',
      mar: 'Mar',
      apr: 'Apr',
      may: 'May',
      jun: 'Jun',
      jul: 'Jul',
      aug: 'Aug',
      sep: 'Sep',
      oct: 'Oct',
      nov: 'Nov',
      dec: 'Dec'
    }
  },
  List: {
    emptyText: 'No Data'
  },
  Guide: {
    prevBtnText: 'Prev',
    nextBtnText: 'Next',
    doneBtnText: 'Got it',
    skipBtnText: 'Skip'
  },
  Modal: {
    okText: 'OK',
    cancelText: 'Cancel'
  },
  Pagination: {
    items_per_page: '/ page',
    jump_to: 'Go to',
    jump_to_confirm: 'Confirm',
    page: 'Page',
    // Pagination.jsx
    prev_page: 'Previous page',
    next_page: 'Next page',
    prev_5: 'Previous 5 pages',
    next_5: 'Next 5 pages',
    prev_3: 'Previous 3 pages',
    next_3: 'Next 3 pages'
  },
  RichEditor: {
    // editor
    insertImageTip: 'Support jpg, jpeg, png, gif, bmp format pictures, the best display height does not exceed 400px, width does not exceed 270px.',
    rule1: '1. A single video does not exceed 10M, and supports MP4 and 3GP format video.',
    rule2: '2. The best display height does not exceed 400px',
    PleaseEnterTheVideolinkURL: "Please enter the video link URL",
    selectLocalVideo: 'Select local video',
    videoLink: 'Video link',
    localVideo: "Local video",
    insertVideo: 'Insert the video',
    selectLocalImage: "Select local image",
    insertAttachment: "Insert the attachment",
    selectLocalFile: "Select local files",
    HyperlinkAddress: 'Link address',
    insertPicture: 'Insert the picture',
    noVideoLinkErrorTip: 'Please set the video source address',
    VideoCantPlayTip: "The video cannot be played",
    file: '[File] ',
    noFileInfoTip: 'Failed to read file information',
    noPicSrcTip: 'Please set the picture source address',
    noVideoUrlErrorTip: 'The video link URL cannot be empty',
    videoUrlFormattingError: 'The video link URL format error',
    videoLinkTooLongError: 'The video link cannot exceed 1000 words',
    linkEmptyTip: 'The link address cannot be empty',
    linkToolongError: 'The link address must not exceed 1000 words',
    noSelectionText: 'No selected text',
    insertLink: 'Insert link',
    editLink: 'Edit link',
    //toolbar
    hyperlinks: 'Link',
    backgroundColor: 'Background color',
    textDirection: 'Text direction',
    increaseIndent: 'Increase indent',
    decreaseIndent: 'Decrease indent',
    subScript: 'Sub script',
    superSciprt: 'Super sciprt',
    codeBlock: 'Code block',
    blockquote: 'Blockquote',
    strike: 'Strike',
    brushFormat: 'Brush format',
    clearFormat: 'Clear format',
    fontSize: 'Font size',
    insertEmoji: 'Insert emoji',
    defaultEmoji: 'Default emoji',
    emojiEmoji: 'emoji',
    orderedList: 'Ordered list',
    unOrderedList: 'Unordered list',
    alignJustified: 'Full-justified',
    alignCenter: 'Align center',
    alignRight: 'Align right',
    alignLeft: 'Align left',
    fontColor: 'Font color',
    underline: 'Underline',
    italic: 'Italic',
    bold: 'Bold',
    temporarilyNoData: 'No data',
    enterKeyWordPlease: 'Please enter the keywords',
    placeholder: 'Please enter content',
    justOkText: 'OK',
    accessLink: 'Access the link',
    edit: 'Edit',
    deleteText: 'Delete',
    lineHeight: 'lineHeight',
    fullScreen: 'fullScreen',
    exitFullScreen: 'exitFullScreen',
    undo: 'undo',
    redo: 'redo',
    defaultLineHeight: 'default',
    table: 'Insert table',
    insertColRight: 'Insert column right',
    insertColLeft: 'Insert column left',
    insertRowBelow: 'Insert column below',
    insertRowAbove: 'Insert column above',
    deleteCol: 'Delete column',
    deleteRow: 'Delete row',
    deleteTable: 'Delete table',
    tableDesc: 'Insert a table',
    // find
    findAndReplace: 'Find and replace',
    find: 'find',
    replace: 'replace',
    caseSensitive: 'Case sensitive',
    replaceTo: 'replace with',
    replaceAll: 'Replace all'
  },
  VideoViewer: {
    fullScreen: 'FullScreen',
    cancelFullScreen: 'CancelFullScreen',
    download: 'Download',
    retry: 'Retry'
  },
  Spin: {
    loading: 'Loading...'
  },
  Select: {
    errorMessage: 'Option limit exceeded',
    multipleSelectAllText: 'All select',
    notFoundContent: 'No data',
    placeholder: 'Please select',
    searchPlaceholder: 'Please enter keyword',
    selectAllText: 'Select all',
    confirmText: 'OK',
    cancelText: 'Cancel',
    loading: 'Loading...'
  },
  Transfer: {
    notFoundContent: 'No data',
    sourceNotFoundContent: 'No data',
    targetNotFonudContent: 'No data',
    searchPlaceholder: 'Search here'
  },
  TreeSelect: {
    placeholder: 'Please select',
    searchPlaceholder: 'Search here',
    treeNodeResetTitle: 'Do not select any category',
    notFoundContent: 'No data',
    okText: 'OK',
    cancelText: 'Cancel'
  },
  Upload: {
    uploading: 'Uploading',
    removeFile: 'Remove',
    uploadError: 'Upload error',
    previewFile: 'Preview',
    cancelText: 'Cancel',
    deleteText: 'Delete all',
    uploadedTip: '${length} item uploaded'
  }
};
var _default = LocaleValue;
exports["default"] = _default;