"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var preClass = 'ql-table-popover';
var InsertTable = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(InsertTable, _Component);
  var _super = _createSuper(InsertTable);
  function InsertTable(props) {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, InsertTable);
    _this = _super.call(this, props);
    _this.cellClass = "".concat(preClass, "-cell");
    _this.state = {
      activeRow: 0,
      activeCol: 0
    };
    _this.mouseCallback = function (ev) {
      var target = ev.target;
      if (target.classList.contains(_this.cellClass)) {
        var position = target.dataset.position;
        if (position) {
          var tuple = position.split(',');
          _this.setState({
            activeRow: Number(tuple[0]),
            activeCol: Number(tuple[1])
          });
        }
      }
    };
    _this.mouseoverHandle = function (ev) {
      _this.mouseCallback(ev);
    };
    _this.clickHandle = function (ev) {
      var target = ev.target;
      if (target.classList.contains(_this.cellClass)) {
        var position = target.dataset.position;
        if (position) {
          var tuple = position.split(',');
          _this.props.chooseItemHandle(Number(tuple[0]) + 1, Number(tuple[1]) + 1);
        }
      }
    };
    _this.cellArr = (0, _map["default"])(_context = (0, _toConsumableArray2["default"])(new Array(9))).call(_context, function (item) {
      return (0, _toConsumableArray2["default"])(new Array(9));
    });
    return _this;
  }
  (0, _createClass2["default"])(InsertTable, [{
    key: "render",
    value: function render() {
      var _context2,
        _this2 = this;
      var _this$state = this.state,
        activeCol = _this$state.activeCol,
        activeRow = _this$state.activeRow;
      var locale = this.props.locale;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: preClass
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(preClass, "-header")
      }, /*#__PURE__*/_react["default"].createElement("span", null, locale.tableDesc), /*#__PURE__*/_react["default"].createElement("span", null, activeCol + 1, "\xD7", activeRow + 1)), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(preClass, "-box"),
        onMouseMove: this.mouseoverHandle,
        onClick: this.clickHandle
      }, (0, _map["default"])(_context2 = this.cellArr).call(_context2, function (row, rowIndex) {
        return (0, _map["default"])(row).call(row, function (col, colIndex) {
          var _context3, _context4;
          return /*#__PURE__*/_react["default"].createElement("div", {
            "data-position": (0, _concat["default"])(_context3 = "".concat(rowIndex, ",")).call(_context3, colIndex),
            className: (0, _classnames["default"])(_this2.cellClass, {
              active: rowIndex <= activeRow && colIndex <= activeCol
            }),
            key: (0, _concat["default"])(_context4 = "".concat(rowIndex)).call(_context4, colIndex)
          });
        });
      })));
    }
  }]);
  return InsertTable;
}(_react.Component);
InsertTable.getDerivedStateFromProps = function (nextProps) {
  if (!nextProps.visible) {
    return {
      activeRow: 0,
      activeCol: 0
    };
  }
  return null;
};
var _default = InsertTable;
exports["default"] = _default;