"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _BaseModule2 = _interopRequireDefault(require("./BaseModule"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var DisplaySize = /*#__PURE__*/function (_BaseModule) {
  (0, _inherits2["default"])(DisplaySize, _BaseModule);
  var _super = _createSuper(DisplaySize);
  function DisplaySize() {
    (0, _classCallCheck2["default"])(this, DisplaySize);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(DisplaySize, [{
    key: "onCreate",
    value: function onCreate() {
      // Create the container to hold the size display
      this.display = document.createElement('div');
      // Apply styles
      (0, _assign["default"])(this.display.style, this.options.styles.display);
      // Attach it
      this.overlay.appendChild(this.display);
    }
  }, {
    key: "onUpdate",
    value: function onUpdate() {
      if (!this.display || !this.activeEle) {
        return;
      }
      var size = this.getCurrentSize();
      this.display.innerHTML = size.join(' &times; ');
      if (size[0] > 120 && size[1] > 30) {
        // position on top of image
        (0, _assign["default"])(this.display.style, {
          right: '4px',
          bottom: '4px',
          left: 'auto'
        });
      } else if (this.activeEle.style["float"] === 'right') {
        // position off bottom left
        var displayRect = this.display.getBoundingClientRect();
        (0, _assign["default"])(this.display.style, {
          right: 'auto',
          bottom: "-".concat(displayRect.height + 4, "px"),
          left: "-".concat(displayRect.width + 4, "px")
        });
      } else {
        // position off bottom right
        var _displayRect = this.display.getBoundingClientRect();
        (0, _assign["default"])(this.display.style, {
          right: "-".concat(_displayRect.width + 4, "px"),
          bottom: "-".concat(_displayRect.height + 4, "px"),
          left: 'auto'
        });
      }
    }
  }, {
    key: "getCurrentSize",
    value: function getCurrentSize() {
      return [this.activeEle.offsetWidth, this.activeEle.offsetHeight];
    }
  }]);
  return DisplaySize;
}(_BaseModule2["default"]);
exports["default"] = DisplaySize;