"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ColorStyle = exports.ColorClass = exports.ColorAttributor = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _startsWith = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/starts-with"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _parchment = require("parchment");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ColorAttributor = /*#__PURE__*/function (_StyleAttributor) {
  (0, _inherits2["default"])(ColorAttributor, _StyleAttributor);
  var _super = _createSuper(ColorAttributor);
  function ColorAttributor() {
    (0, _classCallCheck2["default"])(this, ColorAttributor);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(ColorAttributor, [{
    key: "value",
    value: function value(domNode) {
      var _context;
      var value = (0, _get2["default"])((0, _getPrototypeOf2["default"])(ColorAttributor.prototype), "value", this).call(this, domNode);
      if (!(0, _startsWith["default"])(value).call(value, 'rgb(')) return value;
      value = value.replace(/^[^\d]+/, '').replace(/[^\d]+$/, '');
      var hex = (0, _map["default"])(_context = value.split(',')).call(_context, function (component) {
        var _context2;
        return (0, _slice["default"])(_context2 = "00".concat((0, _parseInt2["default"])(component, 10).toString(16))).call(_context2, -2);
      }).join('');
      return "#".concat(hex);
    }
  }]);
  return ColorAttributor;
}(_parchment.StyleAttributor);
exports.ColorAttributor = ColorAttributor;
var ColorClass = new _parchment.ClassAttributor('color', 'ql-color', {
  scope: _parchment.Scope.INLINE
});
exports.ColorClass = ColorClass;
var ColorStyle = new ColorAttributor('color', 'color', {
  scope: _parchment.Scope.INLINE
});
exports.ColorStyle = ColorStyle;