"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _picker = _interopRequireDefault(require("./picker"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ColorPicker = /*#__PURE__*/function (_Picker) {
  (0, _inherits2["default"])(ColorPicker, _Picker);
  var _super = _createSuper(ColorPicker);
  function ColorPicker(select, label) {
    var _context, _context2;
    var _this;
    (0, _classCallCheck2["default"])(this, ColorPicker);
    _this = _super.call(this, select);
    _this.label.innerHTML = label;
    _this.container.classList.add('ql-color-picker');
    (0, _forEach["default"])(_context = (0, _slice["default"])(_context2 = (0, _from["default"])(_this.container.querySelectorAll('.ql-picker-item'))).call(_context2, 0, 7)).call(_context, function (item) {
      item.classList.add('ql-primary');
    });
    return _this;
  }
  (0, _createClass2["default"])(ColorPicker, [{
    key: "buildItem",
    value: function buildItem(option) {
      var item = (0, _get2["default"])((0, _getPrototypeOf2["default"])(ColorPicker.prototype), "buildItem", this).call(this, option);
      item.style.backgroundColor = option.getAttribute('value') || '';
      return item;
    }
  }, {
    key: "selectItem",
    value: function selectItem(item, trigger) {
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(ColorPicker.prototype), "selectItem", this).call(this, item, trigger);
      var colorLabel = this.label.querySelector('.ql-color-label');
      var value = item ? item.getAttribute('data-value') || '' : '';
      if (colorLabel) {
        if (colorLabel.tagName === 'line') {
          colorLabel.style.stroke = value;
        } else {
          colorLabel.style.fill = value;
        }
      }
    }
  }]);
  return ColorPicker;
}(_picker["default"]);
var _default = ColorPicker;
exports["default"] = _default;