"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Option = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Option, _React$Component);
  var _super = _createSuper(Option);
  function Option(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Option);
    _this = _super.call(this, props);
    _this.onOptionClick = function (e, option) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onOptionClick = _this$props.onOptionClick;
      if (!disabled) {
        onOptionClick && onOptionClick(e, option);
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(Option, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        title = _this$props2.title,
        children = _this$props2.children,
        activeKey = _this$props2.activeKey,
        showOptionCheckedIcon = _this$props2.showOptionCheckedIcon,
        value = _this$props2.value,
        disabled = _this$props2.disabled,
        checked = _this$props2.checked,
        prefixCls = _this$props2.prefixCls;
      var label = children && children.length === 1 ? children[0] : children;
      var optionCls = (0, _classnames["default"])((0, _defineProperty2["default"])({}, "".concat(prefixCls, "-item"), true), (0, _defineProperty2["default"])({}, "checked", !!checked), (0, _defineProperty2["default"])({}, "checked-icon", !!checked && showOptionCheckedIcon), (0, _defineProperty2["default"])({}, "active", 'activeKey' in this.props && activeKey === value), (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-item-disabled"), !!disabled));
      return /*#__PURE__*/React.createElement("li", {
        title: title,
        className: optionCls,
        onClick: function onClick(e) {
          return _this2.onOptionClick(e, {
            label: label,
            title: title,
            key: value
          });
        }
      }, children);
    }
  }]);
  return Option;
}(React.Component);
exports["default"] = Option;
Option.isSelectOption = true;
Option.propTypes = {
  activeKey: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  checked: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func]),
  children: _propTypes["default"].node,
  disabled: _propTypes["default"].bool,
  onOptionClick: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string,
  showOptionCheckedIcon: _propTypes["default"].bool,
  title: _propTypes["default"].string,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].node])
};
Option.defaultProps = {
  prefixCls: 'fishd-select-dropdown-option',
  showOptionCheckedIcon: true
};