"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _find = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _domScrollIntoView = _interopRequireDefault(require("dom-scroll-into-view"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _classnames = _interopRequireDefault(require("classnames"));
var _Button = _interopRequireDefault(require("../Button"));
var _Spin = _interopRequireDefault(require("../Spin"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _SelectSearch = _interopRequireDefault(require("./SelectSearch"));
var _placements = _interopRequireDefault(require("./placements"));
var _utils = require("../../utils");
var _isEqual = _interopRequireDefault(require("lodash/isEqual"));
var _Option = _interopRequireDefault(require("./Option"));
var _OptGroup = _interopRequireDefault(require("./OptGroup"));
var _Context = require("../Config/Locale/Context");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var noop = function noop() {};
var Select = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Select, _React$Component);
  var _super = _createSuper(Select);
  function Select(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Select);
    _this = _super.call(this, props);
    //获取面板宽度
    _this.setDropdownWidth = function () {
      if (!_this.props.dropdownMatchSelectWidth) {
        return;
      }
      var width = _reactDom["default"].findDOMNode((0, _assertThisInitialized2["default"])(_this)).offsetWidth;
      if (width !== _this.state.dropdownWidth) {
        _this.setState({
          dropdownWidth: width
        });
      }
    };
    //搜索键入
    _this.updateSearchValue = function (e) {
      var searchValue = e.target.value;
      _this.props.onSearch(searchValue);
      _this.setState({
        searchValue: searchValue
      });
    };
    //清空搜索
    _this.emptySearchValue = function () {
      var searchValue = '';
      _this.props.onSearch(searchValue);
      _this.setState({
        searchValue: searchValue
      });
      _this.focus();
    };
    //全选操作
    _this.selectAllOption = function () {
      _this.setState({
        selectValue: _this.isSelectAll() ? [] : Select.getOptionFromChildren(_this.props.children, [], function (child) {
          return !child.props.disabled;
        })
      });
    };
    //清空数据项,mode='single'
    _this.emptySelectValue = function () {
      _this.changeVisibleState(false);
      _this.props.onChange();
      _this.setState({
        selectValue: []
      });
    };
    //popup显示隐藏
    _this.changeVisibleState = function (visible) {
      _this.props.onVisibleChange(visible);
      var changedState = {
        popupVisible: visible
      };
      var defaultActiveFirstOption = _this.props.defaultActiveFirstOption;
      if (visible) {
        // 打开弹出框时，开启激活第一个选项
        if (defaultActiveFirstOption) {
          var firstOption = Select.getOptionFromChildren(_this.props.children, [], function (child) {
            return !child.props.disabled;
          })[0] || {};
          changedState.activeKey = firstOption.key;
        }
      } else {
        changedState.activeKey = undefined;
      }
      _this.setState(changedState, function () {
        visible && _this.focus();
      });
    };
    //rc-trigger触发visibleChange事件
    _this.visibleChangeFromTrigger = function (visible) {
      var selectValueForMultiplePanel = _this.state.selectValueForMultiplePanel;
      var mode = _this.props.mode;
      if (!visible && mode === 'multiple') {
        _this.setState({
          selectValue: selectValueForMultiplePanel
        });
      }
      _this.changeVisibleState(visible);
    };
    // 焦点操作
    _this.focusEvent = function (event) {
      var _this$props = _this.props,
        showSearch = _this$props.showSearch,
        loading = _this$props.loading;
      if (loading) return;
      var targetElement = showSearch ? _this.selectSearch && _this.selectSearch.searchInput.input : _this.selection;
      if (targetElement) {
        targetElement[event]();
      } else {
        (0, _setTimeout2["default"])(function () {
          var targetElement = showSearch ? _this.selectSearch.searchInput.input : _this.selection;
          targetElement && targetElement[event]();
        });
      }
    };
    //处理 label、option的click操作
    _this.onOptionClick = function (e, obj, clickInLabel) {
      e && e.stopPropagation();
      var _this$props2 = _this.props,
        onChange = _this$props2.onChange,
        mode = _this$props2.mode,
        onSelect = _this$props2.onSelect,
        onDeselect = _this$props2.onDeselect,
        labelInValue = _this$props2.labelInValue;
      var selectValue = _this.state.selectValue;
      var index = (0, _findIndex["default"])(selectValue).call(selectValue, function (selected) {
        return selected.key === obj.key;
      });
      if (mode === 'single') {
        _this.changeVisibleState(false);
        _this.setState({
          selectValue: [obj]
        });
        if (index === -1) {
          if (labelInValue) {
            onChange(obj);
          } else {
            onChange(obj.key);
          }
        }
      } else if (mode === 'multiple') {
        var changedValue,
          changedObj = {};
        //label 点击
        if (clickInLabel) {
          var _context;
          var selectValueForMultiplePanel = _this.state.selectValueForMultiplePanel;
          var indexInMultiple = (0, _findIndex["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, function (selected) {
            return selected.key === obj.key;
          });
          var firstValue = (0, _slice["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, 0, indexInMultiple);
          var restValues = (0, _slice["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, indexInMultiple + 1);
          changedValue = (0, _concat["default"])(_context = []).call(_context, (0, _toConsumableArray2["default"])(firstValue), (0, _toConsumableArray2["default"])(restValues));
          changedObj = {
            selectValue: changedValue,
            selectValueForMultiplePanel: changedValue
          };
        } else {
          var _context2, _context3;
          //option 点击
          changedValue = index === -1 ? (0, _concat["default"])(_context2 = []).call(_context2, (0, _toConsumableArray2["default"])(selectValue), [obj]) : (0, _concat["default"])(_context3 = []).call(_context3, (0, _toConsumableArray2["default"])((0, _slice["default"])(selectValue).call(selectValue, 0, index)), (0, _toConsumableArray2["default"])((0, _slice["default"])(selectValue).call(selectValue, index + 1)));
          changedObj = {
            selectValue: changedValue
          };
        }
        _this.setState(changedObj);
        if (clickInLabel) {
          //click on label will trigger the onchange event.
          if (labelInValue) {
            onChange(changedValue);
          } else {
            onChange((0, _map["default"])(changedValue).call(changedValue, function (selected) {
              return selected.key;
            }));
          }
        }
      }
      //fire onSelect event => option/label click
      if (clickInLabel) {
        onDeselect(obj);
      } else {
        onSelect(obj);
      }
    };
    //获取加料后的children
    _this.getProcessedChildren = function (children, dropdownCls) {
      var _context4;
      return (0, _map["default"])(_context4 = React.Children).call(_context4, children, function (child) {
        var _context5;
        var typeOfChildren = (0, _slice["default"])(_context5 = Object.prototype.toString.call(child)).call(_context5, 8, -1).toLowerCase();
        if (!!child && typeOfChildren === 'object' && child.type && child.type.isSelectOption) {
          var _this$state = _this.state,
            selectValue = _this$state.selectValue,
            activeKey = _this$state.activeKey;
          var showOptionCheckedIcon = _this.props.showOptionCheckedIcon;
          var _value = 'value' in child.props ? child.props.value : child.key;
          //对children中的Option 进行事件绑定、参数补充
          return /*#__PURE__*/React.cloneElement(child, {
            prefixCls: "".concat(dropdownCls, "-option"),
            checked: !!(0, _find["default"])(selectValue).call(selectValue, function (obj) {
              return obj && obj.key === _value;
            }),
            value: _value,
            activeKey: activeKey,
            showOptionCheckedIcon: showOptionCheckedIcon,
            onOptionClick: _this.onOptionClick,
            // NOTICE: onOptionMouseEnter REMOVED (No definition found)
            // onOptionMouseEnter: this.onOptionMouseEnter,
            ref: _value,
            children: _this.getProcessedChildren(child.props.children, dropdownCls)
          });
        } else if (!!child && typeOfChildren === 'object' && child.type && child.type.isSelectOptGroup) {
          return /*#__PURE__*/React.cloneElement(child, {
            prefixCls: "".concat(dropdownCls, "-option-group"),
            children: _this.getProcessedChildren(child.props.children, dropdownCls)
          });
        } else {
          return child;
        }
      });
    };
    //获取筛选后children
    _this.getFilteredChildren = function (children) {
      var _context6, _context7;
      var ChildrenList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var filterOption = _this.props.filterOption;
      var searchValue = _this.state.searchValue;
      var typeOfOption = (0, _slice["default"])(_context6 = Object.prototype.toString.call(filterOption)).call(_context6, 8, -1).toLowerCase();
      (0, _forEach["default"])(_context7 = React.Children).call(_context7, children, function (child) {
        var filterFlag = false;
        if (child && child.type && child.type.isSelectOption) {
          if (typeOfOption === 'function') {
            filterFlag = filterOption(searchValue, child);
          } else if (typeOfOption === 'boolean') {
            filterFlag = filterOption;
          }
          if (filterFlag) {
            ChildrenList.push(child);
          }
        } else if (child && child.type && child.type.isSelectOptGroup) {
          var _children = _this.getFilteredChildren(child.props.children);
          ChildrenList.push( /*#__PURE__*/React.cloneElement(child, {
            children: _children,
            _isShow: !!(_children && _children.length) //搜索后分组下没有东西就隐藏该分组
          }));
        }
      });

      return ChildrenList;
    };
    //多选-取消
    _this.handleCancelSelect = function () {
      var selectValueForMultiplePanel = _this.state.selectValueForMultiplePanel;
      _this.changeVisibleState(false);
      _this.setState({
        selectValue: selectValueForMultiplePanel
      });
    };
    //多选-确定
    _this.handleConfirmSelect = function () {
      var _this$props3 = _this.props,
        onChange = _this$props3.onChange,
        labelInValue = _this$props3.labelInValue;
      var selectValue = _this.state.selectValue;
      _this.changeVisibleState(false);
      _this.setState({
        selectValueForMultiplePanel: selectValue
      });
      var outputSelectedValue = selectValue;
      // 是否过滤失效的选中项
      if (_this.props.filterInactiveOption) {
        var optionList = Select.getOptionFromChildren(_this.props.children, [], function (child) {
          return !child.props.disabled;
        });
        outputSelectedValue = (0, _filter["default"])(selectValue).call(selectValue, function (item) {
          return !!(0, _find["default"])(optionList).call(optionList, function (option) {
            return option.key === item.key;
          });
        });
      }
      if (labelInValue) {
        onChange(outputSelectedValue);
      } else {
        onChange((0, _map["default"])(outputSelectedValue).call(outputSelectedValue, function (selected) {
          return selected.key;
        }));
      }
    };
    //判断是否全选
    _this.isSelectAll = function () {
      var isMultiplePanel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      var _this$state2 = _this.state,
        selectValueForMultiplePanel = _this$state2.selectValueForMultiplePanel,
        selectValue = _this$state2.selectValue;
      var optionList = Select.getOptionFromChildren(_this.props.children, [], function (child) {
        return !child.props.disabled;
      });
      //全选判断逻辑：option中每一项都能在selected中找到（兼容后端搜索的全选判断）
      if (isMultiplePanel) {
        return optionList.length && (0, _every["default"])(optionList).call(optionList, function (selected) {
          return !!(0, _find["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, function (option) {
            return option.key === selected.key;
          });
        });
      } else {
        return (0, _every["default"])(optionList).call(optionList, function (selected) {
          return !!(0, _find["default"])(selectValue).call(selectValue, function (option) {
            return option.key === selected.key;
          });
        });
      }
    };
    //处理键盘事件：ENTER/ESC/UP/DOWN
    _this.handleKeyboardEvent = function (e) {
      var keyCode = e.keyCode;
      if (keyCode === _utils.KeyCode.ESC && _this.props.esc) {
        _this.changeVisibleState(false);
        return;
      }
      if (keyCode === _utils.KeyCode.ENTER || keyCode === _utils.KeyCode.UP || keyCode === _utils.KeyCode.DOWN) {
        e.preventDefault();
        var _this$props4 = _this.props,
          _children2 = _this$props4.children,
          mode = _this$props4.mode,
          _labelInValue = _this$props4.labelInValue,
          onChange = _this$props4.onChange;
        var _this$state3 = _this.state,
          activeKey = _this$state3.activeKey,
          selectValue = _this$state3.selectValue;
        var filteredList = _this.getFilteredChildren(_children2); // 筛选过的数组
        var optionList = Select.getOptionFromChildren(filteredList, [], function (child) {
          return !child.props.disabled;
        }); // 去除 disabled 选项
        var optionListLen = optionList.length;
        if (!optionListLen) return;
        //enter
        if (keyCode === _utils.KeyCode.ENTER) {
          var activeTabIndex = (0, _findIndex["default"])(optionList).call(optionList, function (option) {
            return option.key === activeKey;
          });
          // activeKey不在列表中
          if (activeTabIndex !== -1) {
            if (!(0, _find["default"])(selectValue).call(selectValue, function (selected) {
              return selected.key === activeKey;
            })) {
              if (mode === 'single') {
                _this.changeVisibleState(false);
                _this.setState({
                  selectValue: [optionList[activeTabIndex]],
                  activeKey: undefined
                }, function () {
                  if (_labelInValue) {
                    onChange(_this.state.selectValue[0]);
                  } else {
                    var _context8;
                    onChange((0, _map["default"])(_context8 = _this.state.selectValue).call(_context8, function (selected) {
                      return selected.key;
                    })[0]);
                  }
                });
              } else if (mode === 'multiple') {
                var _context9;
                _this.setState({
                  selectValue: (0, _concat["default"])(_context9 = []).call(_context9, (0, _toConsumableArray2["default"])(selectValue), [optionList[activeTabIndex]])
                });
              }
            }
          }
        }
        //38 up 40 down
        if (keyCode === _utils.KeyCode.UP || keyCode === _utils.KeyCode.DOWN) {
          // 有activeKey
          if (activeKey !== undefined) {
            var _activeTabIndex = (0, _findIndex["default"])(optionList).call(optionList, function (option) {
              return option.key === activeKey;
            });
            // activeKey不在列表中
            if (_activeTabIndex === -1) {
              _this.setState({
                activeKey: optionList[0].key
              }, function () {
                _this.setActiveOptionIntoView(optionList[0].key);
              });
              return;
            }
            // 上按钮
            var nextActiveKey = undefined;
            if (keyCode === _utils.KeyCode.UP) {
              //超出到最后一个
              if (_activeTabIndex === 0) {
                nextActiveKey = optionList[optionListLen - 1].key;
              } else {
                nextActiveKey = optionList[_activeTabIndex - 1].key;
              }
            } else if (keyCode === _utils.KeyCode.DOWN) {
              if (_activeTabIndex + 1 === optionListLen) {
                nextActiveKey = optionList[0].key;
              } else {
                nextActiveKey = optionList[_activeTabIndex + 1].key;
              }
            }
            _this.setState({
              activeKey: nextActiveKey
            }, function () {
              _this.setActiveOptionIntoView(nextActiveKey);
            });
          } else {
            _this.setState({
              activeKey: optionList[0].key
            }, function () {
              _this.setActiveOptionIntoView(optionList[0].key);
            });
          }
        }
      }
    };
    //处理option的激活态
    _this.setActiveOptionIntoView = function (activeKey) {
      (0, _domScrollIntoView["default"])(_reactDom["default"].findDOMNode(_this.refs[activeKey]), _reactDom["default"].findDOMNode(_this.dropdownList), {
        onlyScrollIfNeeded: true
      });
    };
    // selectionChange后重新定位trigger
    _this.resizeTrigger = function () {
      if (_this.trigger && _this.trigger._component && _this.trigger._component.alignInstance) {
        _this.trigger._component.alignInstance.forceAlign();
      }
    };
    var _this$props5 = _this.props,
      value = _this$props5.value,
      defaultValue = _this$props5.defaultValue,
      labelInValue = _this$props5.labelInValue,
      children = _this$props5.children,
      visible = _this$props5.visible;
    var initialValue = [];
    if ('value' in _this.props) {
      initialValue = value;
    } else if ('defaultValue' in _this.props) {
      initialValue = defaultValue;
    }
    var initialSelectValue = Select.getValueFromProps(initialValue, labelInValue, children);
    _this.state = {
      searchValue: '',
      selectValue: initialSelectValue,
      selectValueForMultiplePanel: initialSelectValue,
      popupVisible: visible,
      activeKey: undefined,
      dropdownWidth: null,
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(Select, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setDropdownWidth();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.setDropdownWidth();
    }
    // 聚焦
  }, {
    key: "focus",
    value: function focus() {
      this.focusEvent('focus');
    }
    // 失焦
  }, {
    key: "blur",
    value: function blur() {
      this.focusEvent('blur');
    }
    //下拉框内容
  }, {
    key: "getDropdownPanel",
    value: function getDropdownPanel(Locale) {
      var _this2 = this;
      var _this$props6 = this.props,
        allowClear = _this$props6.allowClear,
        children = _this$props6.children,
        dropdownClassName = _this$props6.dropdownClassName,
        dropdownStyle = _this$props6.dropdownStyle,
        extraOptions = _this$props6.extraOptions,
        loading = _this$props6.loading,
        maxCount = _this$props6.maxCount,
        maxScrollHeight = _this$props6.maxScrollHeight,
        mode = _this$props6.mode,
        onPopupScroll = _this$props6.onPopupScroll,
        prefixCls = _this$props6.prefixCls,
        searchInputProps = _this$props6.searchInputProps,
        showSearch = _this$props6.showSearch,
        showSelectAll = _this$props6.showSelectAll,
        showSingleClear = _this$props6.showSingleClear,
        required = _this$props6.required,
        _this$props6$errorMes = _this$props6.errorMessage,
        errorMessage = _this$props6$errorMes === void 0 ? Locale.errorMessage : _this$props6$errorMes,
        _this$props6$notFound = _this$props6.notFoundContent,
        notFoundContent = _this$props6$notFound === void 0 ? Locale.notFoundContent : _this$props6$notFound,
        _this$props6$placehol = _this$props6.placeholder,
        placeholder = _this$props6$placehol === void 0 ? Locale.placeholder : _this$props6$placehol,
        _this$props6$searchPl = _this$props6.searchPlaceholder,
        searchPlaceholder = _this$props6$searchPl === void 0 ? Locale.searchPlaceholder : _this$props6$searchPl,
        _this$props6$selectAl = _this$props6.selectAllText,
        selectAllText = _this$props6$selectAl === void 0 ? Locale.selectAllText : _this$props6$selectAl;
      var _this$state4 = this.state,
        searchValue = _this$state4.searchValue,
        selectValue = _this$state4.selectValue;
      var dropdownCls = "".concat(prefixCls, "-dropdown");
      //获取筛选后的children
      var optionFilteredList = this.getFilteredChildren(this.getProcessedChildren(children, dropdownCls));
      var showNotFoundContent = !Select.getOptionFromChildren(optionFilteredList).length; // optionList为空判断
      var maxCountError = 'maxCount' in this.props && selectValue.length > maxCount; // maxCount值存在且小于选择数量
      var requiredError = mode === 'multiple' && required && !selectValue.length; // required模式下，必须要有option选择
      var multipleConfirmDisabled = maxCountError || requiredError;
      var dropdownPanelCls = (0, _classnames["default"])(dropdownCls, (0, _defineProperty2["default"])({}, dropdownClassName, !!dropdownClassName));
      return /*#__PURE__*/React.createElement("div", {
        className: dropdownPanelCls,
        onKeyDown: this.handleKeyboardEvent,
        ref: function ref(selection) {
          return _this2.selection = selection;
        },
        style: dropdownStyle,
        tabIndex: 0
      }, loading ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-loading")
      }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_Spin["default"].Container, {
        style: {
          height: 32,
          justifyContent: 'left'
        }
      }, /*#__PURE__*/React.createElement(_Spin["default"], {
        size: "small",
        tip: "\u52A0\u8F7D\u4E2D..."
      }))))) : /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-content")
      }, showSearch && /*#__PURE__*/React.createElement(_SelectSearch["default"], {
        allowClear: allowClear,
        emitEmpty: this.emptySearchValue,
        prefixCls: "".concat(dropdownCls, "-search"),
        ref: function ref(selectSearch) {
          return _this2.selectSearch = selectSearch;
        },
        searchInputProps: searchInputProps,
        searchPlaceholder: searchPlaceholder,
        searchValue: searchValue,
        updateSearchValue: this.updateSearchValue
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-list"),
        onScroll: onPopupScroll,
        ref: function ref(dropdownList) {
          return _this2.dropdownList = dropdownList;
        },
        style: {
          maxHeight: maxScrollHeight
        }
      }, !searchValue && showSelectAll && mode === 'multiple' && /*#__PURE__*/React.createElement("li", {
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({}, "".concat(dropdownCls, "-option-item"), true), (0, _defineProperty2["default"])({}, 'checked checked-icon', this.isSelectAll())),
        onClick: this.selectAllOption
      }, selectAllText), !searchValue && showSingleClear && mode === 'single' && /*#__PURE__*/React.createElement("li", {
        className: "".concat(dropdownCls, "-option-item"),
        onClick: this.emptySelectValue
      }, placeholder),
      //预留置顶项
      extraOptions, showNotFoundContent ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-not-found")
      }, notFoundContent) : /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-filtered-list")
      }, optionFilteredList)), mode === 'multiple' && /*#__PURE__*/React.createElement("div", null, maxCountError && /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-error-panel")
      }, /*#__PURE__*/React.createElement("p", {
        className: "".concat(dropdownCls, "-error-panel-msg")
      }, errorMessage)), /*#__PURE__*/React.createElement("div", {
        className: "".concat(dropdownCls, "-footer")
      }, /*#__PURE__*/React.createElement(_Button["default"], {
        className: "".concat(dropdownCls, "-footer-btn"),
        onClick: this.handleCancelSelect
      }, Locale.cancelText), /*#__PURE__*/React.createElement(_Button["default"], {
        className: "".concat(dropdownCls, "-footer-btn"),
        onClick: this.handleConfirmSelect,
        disabled: multipleConfirmDisabled,
        type: "primary"
      }, Locale.confirmText)))));
    }
    // 获取面板内容
  }, {
    key: "getSelectionPanel",
    value: function getSelectionPanel(Locale) {
      var _this3 = this;
      var _this$props7 = this.props,
        className = _this$props7.className,
        tagWidth = _this$props7.tagWidth,
        disabled = _this$props7.disabled,
        labelClear = _this$props7.labelClear,
        loading = _this$props7.loading,
        maxLabelClearPanelHeight = _this$props7.maxLabelClearPanelHeight,
        mode = _this$props7.mode,
        onMouseEnter = _this$props7.onMouseEnter,
        onMouseLeave = _this$props7.onMouseLeave,
        prefixCls = _this$props7.prefixCls,
        showArrow = _this$props7.showArrow,
        showMultipleSelectAll = _this$props7.showMultipleSelectAll,
        size = _this$props7.size,
        style = _this$props7.style,
        _this$props7$placehol = _this$props7.placeholder,
        placeholder = _this$props7$placehol === void 0 ? Locale.placeholder : _this$props7$placehol,
        _this$props7$multiple = _this$props7.multipleSelectAllText,
        multipleSelectAllText = _this$props7$multiple === void 0 ? Locale.multipleSelectAllText : _this$props7$multiple;
      var _this$state5 = this.state,
        selectValue = _this$state5.selectValue,
        selectValueForMultiplePanel = _this$state5.selectValueForMultiplePanel,
        popupVisible = _this$state5.popupVisible;
      var selectionCls = "".concat(prefixCls);
      var selectionPanelCls = (0, _classnames["default"])((0, _defineProperty2["default"])({}, "".concat(selectionCls), true), (0, _defineProperty2["default"])({}, className, !!className), (0, _defineProperty2["default"])({}, "".concat(selectionCls, "-disabled"), disabled), (0, _defineProperty2["default"])({}, "open", popupVisible), (0, _defineProperty2["default"])({}, "".concat(selectionCls, "-large"), size === 'large'), (0, _defineProperty2["default"])({}, "".concat(selectionCls, "-small"), size === 'small'));
      var panelStyle = (0, _assign["default"])({}, style);
      if (labelClear) {
        panelStyle.paddingRight = 0;
        if (mode === 'multiple' && selectValueForMultiplePanel.length) {
          panelStyle.height = 'auto';
        }
      }
      var multipleTitle = '';
      if (mode === 'multiple' && !labelClear) {
        var titleArray = (0, _map["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, function (panel) {
          return panel.title;
        });
        var isShowTitle = (0, _every["default"])(titleArray).call(titleArray, function (title) {
          return !!title;
        });
        multipleTitle = isShowTitle ? titleArray.join('、') : '';
      }
      return /*#__PURE__*/React.createElement("div", {
        className: selectionPanelCls,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        style: panelStyle
      }, loading ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-loading")
      }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_Spin["default"].Container, {
        style: {
          height: 32,
          justifyContent: 'left'
        }
      }, /*#__PURE__*/React.createElement(_Spin["default"], {
        size: "small",
        tip: "\u52A0\u8F7D\u4E2D..."
      })))) : /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-content")
      }, showArrow && !labelClear && /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-caret")
      }, /*#__PURE__*/React.createElement(_Icon["default"], {
        type: "down-fill",
        className: (0, _classnames["default"])((0, _defineProperty2["default"])({}, 'open', popupVisible))
      })), (!selectValue.length && mode === 'single' || !selectValueForMultiplePanel.length && mode === 'multiple') && /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-placeholder")
      }, placeholder), mode === 'single' && !!selectValue.length && /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-option-single"),
        title: selectValue[0].title
      }, selectValue[0].label),
      // selectValueForMultiplePanel的更新时机：
      // 1.初始化value、defaultValue
      // 2.props.value 更改
      // 3.多选取消、确定按钮点击
      // 4.label.click事件
      mode === 'multiple' && (labelClear ?
      //仅在有选中数据时渲染，fix空状态面板上方高度问题
      selectValueForMultiplePanel && selectValueForMultiplePanel.length ? /*#__PURE__*/React.createElement(_rcAnimate["default"], {
        onEnd: this.resizeTrigger,
        component: "div",
        transitionName: "zoom",
        style: {
          maxHeight: maxLabelClearPanelHeight ? maxLabelClearPanelHeight : null
        },
        className: "".concat(selectionCls, "-option-clearable-list")
      }, (0, _map["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, function (option) {
        return /*#__PURE__*/React.createElement("div", {
          className: "".concat(selectionCls, "-option-clearable-option"),
          style: {
            width: tagWidth
          },
          key: option.key,
          title: option.title
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(selectionCls, "-option-clearable-option-content")
        }, option.label), !disabled && /*#__PURE__*/React.createElement("span", {
          className: "".concat(selectionCls, "-option-clearable-option-close"),
          onClick: function onClick(e) {
            return _this3.onOptionClick(e, option, true);
          }
        }, /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "close-modal-line"
        })));
      })) : null : /*#__PURE__*/React.createElement("div", {
        className: "".concat(selectionCls, "-option-multiple"),
        title: multipleTitle
      }, this.isSelectAll(true) && showMultipleSelectAll ? /*#__PURE__*/React.createElement("span", null, multipleSelectAllText) : (0, _map["default"])(selectValueForMultiplePanel).call(selectValueForMultiplePanel, function (option, index) {
        return /*#__PURE__*/React.createElement("span", {
          key: option.key,
          className: "".concat(selectionCls, "-option-multiple-option")
        }, /*#__PURE__*/React.createElement("span", null, option.label), index + 1 !== selectValueForMultiplePanel.length && '、');
      })))));
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;
      var _this$props8 = this.props,
        disabled = _this$props8.disabled,
        dropdownMatchSelectWidth = _this$props8.dropdownMatchSelectWidth,
        getPopupContainer = _this$props8.getPopupContainer,
        placement = _this$props8.placement,
        prefixCls = _this$props8.prefixCls;
      var _this$state6 = this.state,
        popupVisible = _this$state6.popupVisible,
        dropdownWidth = _this$state6.dropdownWidth;
      var popupStyle = {};
      var widthProp = dropdownMatchSelectWidth ? 'width' : 'minWidth';
      if (dropdownWidth) {
        popupStyle[widthProp] = "".concat(dropdownWidth, "px");
      }
      var LocaleContextValue = this.context;
      var Locale = LocaleContextValue && LocaleContextValue['Select'];
      return /*#__PURE__*/React.createElement(_rcTrigger["default"], {
        action: disabled ? [] : ['click'],
        builtinPlacements: _placements["default"],
        ref: function ref(node) {
          return _this4.trigger = node;
        },
        getPopupContainer: getPopupContainer,
        onPopupVisibleChange: this.visibleChangeFromTrigger,
        popup: this.getDropdownPanel(Locale),
        popupPlacement: placement,
        popupVisible: popupVisible,
        prefixCls: "".concat(prefixCls, "-popup"),
        popupStyle: popupStyle
      }, this.getSelectionPanel(Locale));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('visible' in nextProps && !(0, _isEqual["default"])(nextProps.visible, prevProps.visible)) {
        newState.popupVisible = nextProps.visible;
      }
      if ('value' in nextProps) {
        var changedValue = Select.getValueFromProps(nextProps.value, nextProps.labelInValue, nextProps.children);
        var prevValue = Select.getValueFromProps(prevProps.value, prevProps.labelInValue, prevProps.children);
        if (!(0, _isEqual["default"])(changedValue, prevValue)) {
          newState.selectValue = changedValue;
          if (nextProps.mode === 'multiple') {
            newState.selectValueForMultiplePanel = changedValue;
          }
        }
      }
      return newState;
    }
  }]);
  return Select;
}(React.Component);
Select.Option = _Option["default"];
Select.OptGroup = _OptGroup["default"];
Select.propTypes = {
  allowClear: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  tagWidth: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  defaultActiveFirstOption: _propTypes["default"].bool,
  defaultValue: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].array, _propTypes["default"].object]),
  disabled: _propTypes["default"].bool,
  dropdownClassName: _propTypes["default"].string,
  dropdownMatchSelectWidth: _propTypes["default"].bool,
  dropdownStyle: _propTypes["default"].object,
  errorMessage: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  extraOptions: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]),
  filterOption: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].bool]),
  getPopupContainer: _propTypes["default"].func,
  labelClear: _propTypes["default"].bool,
  labelInValue: _propTypes["default"].bool,
  loading: _propTypes["default"].bool,
  maxCount: _propTypes["default"].number,
  maxLabelClearPanelHeight: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  maxScrollHeight: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  mode: _propTypes["default"].oneOf(['multiple', 'single']),
  multipleSelectAllText: _propTypes["default"].string,
  notFoundContent: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]),
  onChange: _propTypes["default"].func,
  onMouseEnter: _propTypes["default"].func,
  onMouseLeave: _propTypes["default"].func,
  onPopupScroll: _propTypes["default"].func,
  onSearch: _propTypes["default"].func,
  onSelect: _propTypes["default"].func,
  onDeselect: _propTypes["default"].func,
  onVisibleChange: _propTypes["default"].func,
  placeholder: _propTypes["default"].string,
  placement: _propTypes["default"].oneOf(['bottomLeft', 'bottomCenter', 'bottomRight', 'topLeft', 'topCenter', 'topRight']),
  prefixCls: _propTypes["default"].string,
  searchInputProps: _propTypes["default"].object,
  searchPlaceholder: _propTypes["default"].string,
  selectAllText: _propTypes["default"].string,
  showArrow: _propTypes["default"].bool,
  showMultipleSelectAll: _propTypes["default"].bool,
  showOptionCheckedIcon: _propTypes["default"].bool,
  showSearch: _propTypes["default"].bool,
  showSelectAll: _propTypes["default"].bool,
  showSingleClear: _propTypes["default"].bool,
  size: _propTypes["default"].oneOf(['default', 'small', 'large']),
  style: _propTypes["default"].object,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].array, _propTypes["default"].object]),
  visible: _propTypes["default"].bool,
  esc: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  filterInactiveOption: _propTypes["default"].bool // 是否过滤失效的选中项（即不在option列表中）
};

Select.contextType = _Context.LocaleContext;
Select.defaultProps = {
  allowClear: true,
  tagWidth: 'auto',
  defaultActiveFirstOption: false,
  disabled: false,
  dropdownMatchSelectWidth: true,
  filterOption: true,
  labelClear: false,
  labelInValue: false,
  loading: false,
  maxScrollHeight: 250,
  mode: 'single',
  onChange: noop,
  onPopupScroll: noop,
  onSearch: noop,
  onSelect: noop,
  onDeselect: noop,
  onVisibleChange: noop,
  placement: 'bottomLeft',
  prefixCls: 'fishd-select',
  searchInputProps: {},
  showArrow: true,
  showMultipleSelectAll: false,
  showOptionCheckedIcon: true,
  showSearch: false,
  showSelectAll: false,
  showSingleClear: false,
  size: 'default',
  style: {},
  visible: false,
  esc: true,
  required: false,
  filterInactiveOption: false
};
//获取所有option的[{label,key,title}]
Select.getOptionFromChildren = function (children) {
  var _context10;
  var plainOptionList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var filter = arguments.length > 2 ? arguments[2] : undefined;
  (0, _forEach["default"])(_context10 = React.Children).call(_context10, children, function (child) {
    if (child && child.type && child.type.isSelectOption) {
      var selectOption = {
        label: child.props.children,
        key: 'value' in child.props ? child.props.value : child.key,
        title: child.props.title
      };
      if (filter) {
        filter(child) && plainOptionList.push(selectOption);
      } else {
        plainOptionList.push(selectOption);
      }
    } else if (child && child.type && child.type.isSelectOptGroup) {
      Select.getOptionFromChildren(child.props.children, plainOptionList, filter);
    } else {
      //  其余暂时不做处理
    }
  });
  return plainOptionList;
};
//转换传入的value
Select.getValueFromProps = function (value, labelInValue, children) {
  var _context11;
  var valueType = (0, _slice["default"])(_context11 = Object.prototype.toString.call(value)).call(_context11, 8, -1).toLowerCase();
  var optionList = Select.getOptionFromChildren(children, []);
  if (labelInValue) {
    //labelInValue数据从传入数据中取
    if (valueType === 'array') {
      return value && (0, _map["default"])(value).call(value, function (obj) {
        var option = (0, _find["default"])(optionList).call(optionList, function (option) {
          return option.key === obj.key;
        }) || {};
        var label = obj.label || option.label || obj.key;
        var title = obj.title || option.title;
        return {
          key: obj.key,
          label: label,
          title: title
        };
      }) || [];
    } else if (valueType === 'object') {
      var option = (0, _find["default"])(optionList).call(optionList, function (option) {
        return option.key === value.key;
      }) || {};
      var label = value.label || option.label || value.key;
      var title = value.title || option.title;
      return [{
        key: value.key,
        label: label,
        title: title
      }];
    } else {
      // 其余就给空状态
      return [];
    }
  } else {
    // 非labelInValue数据从option里取
    if (valueType === 'string' || valueType === 'number') value = [value];
    return value && (0, _map["default"])(value).call(value, function (key) {
      var option = (0, _find["default"])(optionList).call(optionList, function (option) {
        return option.key === key;
      }) || {};
      var label = option.label || key;
      var title = option.title;
      return {
        key: key,
        label: label,
        title: title
      };
    }) || [];
  }
};
(0, _reactLifecyclesCompat.polyfill)(Select);
var _default = Select;
exports["default"] = _default;