"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _RcSlider = _interopRequireDefault(require("./RcSlider"));
var _RcRange = _interopRequireDefault(require("./RcRange"));
var _RcHandle = _interopRequireDefault(require("./RcHandle"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Slider = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Slider, _React$Component);
  var _super = _createSuper(Slider);
  function Slider(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Slider);
    _this = _super.call(this, props);
    _this.toggleTooltipVisible = function (index, visible) {
      _this.setState(function (_ref) {
        var visibles = _ref.visibles;
        return {
          visibles: (0, _assign["default"])((0, _assign["default"])({}, visibles), (0, _defineProperty2["default"])({}, index, visible))
        };
      });
    };
    _this.sliderHandle = function (_a) {
      var value = _a.value,
        dragging = _a.dragging,
        index = _a.index,
        restProps = __rest(_a, ["value", "dragging", "index"]);
      var _this$props = _this.props,
        tooltipPrefixCls = _this$props.tooltipPrefixCls,
        tipFormatter = _this$props.tipFormatter,
        _this$props$tipMode = _this$props.tipMode,
        tipMode = _this$props$tipMode === void 0 ? 'default' : _this$props$tipMode,
        handle = _this$props.handle;
      var visibles = _this.state.visibles;
      var visible = tipFormatter ? visibles[index] || dragging : false;
      if (tipMode === 'all') {
        return /*#__PURE__*/React.createElement(_RcHandle["default"], (0, _assign["default"])({}, restProps, {
          handle: handle,
          value: value
        }));
      }
      return /*#__PURE__*/React.createElement(_Tooltip["default"], {
        prefixCls: tooltipPrefixCls,
        title: tipFormatter ? tipFormatter(value) : '',
        visible: visible,
        placement: "top",
        transitionName: "zoom-down",
        key: index,
        stretch: "minWidth"
      }, /*#__PURE__*/React.createElement(_RcHandle["default"], (0, _assign["default"])({}, restProps, {
        value: value,
        handle: handle,
        onMouseEnter: function onMouseEnter() {
          return _this.toggleTooltipVisible(index, true);
        },
        onMouseLeave: function onMouseLeave() {
          return _this.toggleTooltipVisible(index, false);
        }
      })));
    };
    _this.saveSlider = function (node) {
      _this.rcSlider = node;
    };
    _this.state = {
      visibles: {}
    };
    return _this;
  }
  (0, _createClass2["default"])(Slider, [{
    key: "focus",
    value: function focus() {
      this.rcSlider.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.rcSlider.focus();
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
        range = _a.range,
        restProps = __rest(_a, ["range"]);
      if (range) {
        return /*#__PURE__*/React.createElement(_RcRange["default"], (0, _assign["default"])({}, restProps, {
          ref: this.saveSlider,
          handle: this.sliderHandle
        }));
      }
      return /*#__PURE__*/React.createElement(_RcSlider["default"], (0, _assign["default"])({}, restProps, {
        ref: this.saveSlider,
        handle: this.sliderHandle
      }));
    }
  }]);
  return Slider;
}(React.Component);
exports["default"] = Slider;
Slider.defaultProps = {
  prefixCls: 'fishd-slider',
  tooltipPrefixCls: 'fishd-tooltip',
  tipFormatter: function tipFormatter(value) {
    return value.toString();
  }
};