import React from 'react';
import { ColumnFiltrateProps, ColumnFiltrateState } from './interface';
declare class ColumnFiltrateDraggableModal<T> extends React.Component<ColumnFiltrateProps<T>, ColumnFiltrateState> {
    static defaultProps: {
        columns: any[];
        defaultColumns: any[];
        hideColumns: any[];
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): any;
    constructor(props: ColumnFiltrateProps<T>);
    componentDidMount(): void;
    showModal: () => void;
    handleOk: () => void;
    handleCancel: () => void;
    onChange: (checkedOption: any) => void;
    getOptions: () => {
        label: JSX.Element;
        value: any;
        disabled: boolean;
    }[];
    getDataSource: () => import("./interface").ColumnProps<T>[];
    render(): JSX.Element;
}
export default ColumnFiltrateDraggableModal;
