"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _reactDom = require("react-dom");
var _index = _interopRequireWildcard(require("./src/index.js"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Icon = _interopRequireDefault(require("../Icon"));
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function isFlexSupported() {
  if (typeof window !== 'undefined' && window.document && window.document.documentElement) {
    var documentElement = window.document.documentElement;
    return 'flex' in documentElement.style || 'webkitFlex' in documentElement.style || 'Flex' in documentElement.style || 'msFlex' in documentElement.style;
  }
  return false;
}
var Tabs = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Tabs, _React$Component);
  var _super = _createSuper(Tabs);
  function Tabs() {
    var _this;
    (0, _classCallCheck2["default"])(this, Tabs);
    _this = _super.apply(this, arguments);
    _this.createNewTab = function (targetKey) {
      var onEdit = _this.props.onEdit;
      if (onEdit) {
        onEdit(targetKey, 'add');
      }
    };
    _this.removeTab = function (targetKey, e) {
      e.stopPropagation();
      if (!targetKey) {
        return;
      }
      var onEdit = _this.props.onEdit;
      if (onEdit) {
        onEdit(targetKey, 'remove');
      }
    };
    _this.handleChange = function (activeKey) {
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(activeKey);
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(Tabs, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _context;
      var NO_FLEX = ' no-flex';
      var tabNode = (0, _reactDom.findDOMNode)(this);
      if (tabNode && !isFlexSupported() && (0, _indexOf["default"])(_context = tabNode.className).call(_context, NO_FLEX) === -1) {
        tabNode.className += NO_FLEX;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _context2,
        _context3,
        _classNames,
        _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        size = _this$props.size,
        type = _this$props.type,
        tabPosition = _this$props.tabPosition,
        children = _this$props.children,
        tabBarExtraContent = _this$props.tabBarExtraContent,
        tabBarStyle = _this$props.tabBarStyle,
        hideAdd = _this$props.hideAdd,
        loading = _this$props.loading,
        onTabClick = _this$props.onTabClick,
        onPrevClick = _this$props.onPrevClick,
        onNextClick = _this$props.onNextClick,
        animated = _this$props.animated,
        tabBarGutter = _this$props.tabBarGutter;
      var _ref = (0, _typeof2["default"])(animated) === 'object' ? {
          inkBarAnimated: animated.inkBar,
          tabPaneAnimated: animated.tabPane
        } : {
          inkBarAnimated: animated,
          tabPaneAnimated: animated
        },
        inkBarAnimated = _ref.inkBarAnimated,
        tabPaneAnimated = _ref.tabPaneAnimated;
      var showInkBar = true;
      // card tabs should not have animation
      if (type !== 'line') {
        showInkBar = false;
        tabPaneAnimated = 'animated' in this.props ? tabPaneAnimated : false;
      }
      var cls = (0, _classnames["default"])(className, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-vertical"), tabPosition === 'left' || tabPosition === 'right'), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context2 = "".concat(prefixCls, "-")).call(_context2, size), !!size), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-card"), (0, _indexOf["default"])(type).call(type, 'card') >= 0), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context3 = "".concat(prefixCls, "-")).call(_context3, type), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-no-animation"), !tabPaneAnimated), _classNames));
      // only card type tabs can be added and closed
      var childrenWithClose = [];
      if (type === 'editable-card') {
        var _context4;
        childrenWithClose = [];
        (0, _forEach["default"])(_context4 = React.Children).call(_context4, children, function (child, index) {
          var closable = child.props.closable;
          closable = typeof closable === 'undefined' ? true : closable;
          var closeIcon = closable ? /*#__PURE__*/React.createElement(_Icon["default"], {
            type: "close-tag-line",
            onClick: function onClick(e) {
              return _this2.removeTab(child.key, e);
            }
          }) : null;
          childrenWithClose.push( /*#__PURE__*/React.cloneElement(child, {
            tab: /*#__PURE__*/React.createElement("div", {
              className: closable ? undefined : "".concat(prefixCls, "-tab-unclosable")
            }, child.props.tab, closeIcon),
            key: child.key || index
          }));
        });
        // Add new tab handler
        if (!hideAdd) {
          tabBarExtraContent = /*#__PURE__*/React.createElement("span", null, /*#__PURE__*/React.createElement(_Icon["default"], {
            type: "upload-plus",
            className: "".concat(prefixCls, "-new-tab"),
            onClick: this.createNewTab
          }), tabBarExtraContent);
        }
      }
      tabBarExtraContent = tabBarExtraContent ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-extra-content")
      }, tabBarExtraContent) : null;
      var renderTabBar = function renderTabBar() {
        return /*#__PURE__*/React.createElement(_index.ScrollableInkTabBar, {
          showInkBar: showInkBar,
          inkBarAnimated: inkBarAnimated,
          extraContent: tabBarExtraContent,
          onTabClick: onTabClick,
          onPrevClick: onPrevClick,
          onNextClick: onNextClick,
          style: tabBarStyle,
          tabBarGutter: tabBarGutter
        });
      };
      return /*#__PURE__*/React.createElement(_index["default"], (0, _assign["default"])({}, this.props, {
        className: cls,
        tabBarPosition: tabPosition,
        renderTabBar: renderTabBar,
        renderTabContent: function renderTabContent() {
          return /*#__PURE__*/React.createElement(_index.TabContent, {
            animated: tabPaneAnimated,
            animatedWithMargin: true,
            loading: loading
          });
        },
        onChange: this.handleChange
      }), childrenWithClose.length > 0 ? childrenWithClose : children);
    }
  }]);
  return Tabs;
}(React.Component);
exports["default"] = Tabs;
Tabs.TabPane = _index.TabPane;
Tabs.defaultProps = {
  prefixCls: 'fishd-tabs',
  hideAdd: false,
  loading: false,
  size: 'default',
  tabPosition: 'top',
  type: 'line'
};