"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _PureRenderMixin = _interopRequireDefault(require("../Checkbox/src/PureRenderMixin"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _reactLazyLoad = _interopRequireDefault(require("react-lazy-load"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Item = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Item, _React$Component);
  var _super = _createSuper(Item);
  function Item() {
    (0, _classCallCheck2["default"])(this, Item);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Item, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return _PureRenderMixin["default"].shouldComponentUpdate.apply(this, args);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        mode = _this$props.mode,
        direction = _this$props.direction,
        renderedText = _this$props.renderedText,
        renderedEl = _this$props.renderedEl,
        item = _this$props.item,
        lazy = _this$props.lazy,
        checked = _this$props.checked,
        prefixCls = _this$props.prefixCls,
        onClick = _this$props.onClick,
        onClose = _this$props.onClose;
      var className = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-content-item"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-content-item-disabled"), item.disabled), _classNames));
      var listItem = /*#__PURE__*/React.createElement("li", {
        className: className,
        title: renderedText
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-content-item-text"),
        onClick: item.disabled ? undefined : function () {
          return onClick(item, direction);
        }
      }, mode === 'multiple' ? /*#__PURE__*/React.createElement(_Checkbox["default"], {
        checked: checked,
        disabled: item.disabled
      }) : null, /*#__PURE__*/React.createElement("span", null, renderedEl)), mode === 'single' && direction === 'right' ? /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-content-item-close"),
        onClick: item.disabled ? undefined : function () {
          return onClose(item);
        }
      }, /*#__PURE__*/React.createElement(_Icon["default"], {
        type: "close-modal-line"
      })) : null);
      var children = null;
      if (lazy) {
        var lazyProps = (0, _assign["default"])({
          height: 32,
          offset: 500,
          throttle: 0,
          debounce: false
        }, lazy);
        children = /*#__PURE__*/React.createElement(_reactLazyLoad["default"], (0, _assign["default"])({}, lazyProps), listItem);
      } else {
        children = listItem;
      }
      return children;
    }
  }]);
  return Item;
}(React.Component);
exports["default"] = Item;