"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _rcTreeSelect = _interopRequireWildcard(require("./rcTreeSelect"));
var _classnames = _interopRequireDefault(require("classnames"));
var _warning = _interopRequireDefault(require("warning"));
var _Consumer = _interopRequireDefault(require("../Config/Locale/Consumer"));
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var TreeSelect = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TreeSelect, _React$Component);
  var _super = _createSuper(TreeSelect);
  function TreeSelect(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TreeSelect);
    _this = _super.call(this, props);
    // i18n
    _this.genPropsByLocale = function (Locale) {
      var _this$props = _this.props,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? Locale.placeholder : _this$props$placehold,
        _this$props$searchPla = _this$props.searchPlaceholder,
        searchPlaceholder = _this$props$searchPla === void 0 ? Locale.searchPlaceholder : _this$props$searchPla,
        _this$props$treeNodeR = _this$props.treeNodeResetTitle,
        treeNodeResetTitle = _this$props$treeNodeR === void 0 ? Locale.treeNodeResetTitle : _this$props$treeNodeR;
      return {
        searchPlaceholder: searchPlaceholder,
        placeholder: placeholder,
        treeNodeResetTitle: treeNodeResetTitle
      };
    };
    _this.saveTreeSelect = function (node) {
      _this.rcTreeSelect = node;
    };
    (0, _warning["default"])(props.multiple !== false || !props.treeCheckable, '`multiple` will alway be `true` when `treeCheckable` is true');
    return _this;
  }
  (0, _createClass2["default"])(TreeSelect, [{
    key: "focus",
    value: function focus() {
      this.rcTreeSelect.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.rcTreeSelect.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        size = _a.size,
        notFoundContent = _a.notFoundContent,
        dropdownStyle = _a.dropdownStyle,
        dropdownClassName = _a.dropdownClassName,
        treeCheckable = _a.treeCheckable,
        restProps = __rest(_a, ["prefixCls", "className", "size", "notFoundContent", "dropdownStyle", "dropdownClassName", "treeCheckable"]);
      var isEditableMul = (restProps.multiple || treeCheckable) && restProps.editable;
      var cls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-ctner"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-scroll"), isEditableMul), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-singleline"), !isEditableMul), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-lg"), size === 'large'), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-sm"), size === 'small'), _classNames), className);
      var checkable = treeCheckable;
      if (checkable) {
        checkable = /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-tree-checkbox-inner")
        });
      }
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "TreeSelect"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement(_rcTreeSelect["default"], (0, _assign["default"])({}, restProps, _this2.genPropsByLocale(Locale), {
          dropdownClassName: (0, _classnames["default"])(dropdownClassName, "".concat(prefixCls, "-tree-dropdown")),
          prefixCls: prefixCls,
          className: cls,
          dropdownStyle: (0, _assign["default"])({
            maxHeight: '100vh',
            overflow: 'auto'
          }, dropdownStyle),
          treeCheckable: checkable,
          notFoundContent: notFoundContent,
          ref: _this2.saveTreeSelect
        }));
      });
    }
  }]);
  return TreeSelect;
}(React.Component);
exports["default"] = TreeSelect;
TreeSelect.TreeNode = _rcTreeSelect.TreeNode;
TreeSelect.SHOW_ALL = _rcTreeSelect.SHOW_ALL;
TreeSelect.SHOW_PARENT = _rcTreeSelect.SHOW_PARENT;
TreeSelect.SHOW_CHILD = _rcTreeSelect.SHOW_CHILD;
TreeSelect.defaultProps = {
  autoClearSearchValue: false,
  autoExpandParent: false,
  choiceTransitionName: 'zoom',
  editable: true,
  esc: true,
  required: false,
  prefixCls: 'fishd-treeselect',
  showCheckedStrategy: _rcTreeSelect.SHOW_PARENT,
  showSearch: false,
  tagWidth: 100,
  transitionName: 'slide-up',
  treeCheckStrictly: false,
  placement: 'bottomLeft',
  uniqueTreeNodeByLabel: false,
  getPopupContainer: function getPopupContainer() {
    return document.body;
  }
};