"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _util = require("../../util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Selection = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Selection, _React$Component);
  var _super = _createSuper(Selection);
  function Selection() {
    var _this;
    (0, _classCallCheck2["default"])(this, Selection);
    _this = _super.apply(this, arguments);
    _this.onRemove = function (event) {
      event.stopPropagation();
      event.preventDefault();
      var _this$props = _this.props,
        onRemove = _this$props.onRemove,
        value = _this$props.value;
      onRemove(event, value);
    };
    return _this;
  }
  (0, _createClass2["default"])(Selection, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        maxTagTextLength = _this$props2.maxTagTextLength,
        label = _this$props2.label,
        value = _this$props2.value,
        tagWidth = _this$props2.tagWidth,
        disableCloseTag = _this$props2.disableCloseTag,
        iconPrefix = _this$props2.iconPrefix;
      var content = label || value;
      if (maxTagTextLength && typeof content === 'string' && content.length > maxTagTextLength) {
        content = "".concat((0, _slice["default"])(content).call(content, 0, maxTagTextLength), "...");
      }
      var tagStyle = (0, _assign["default"])({
        width: tagWidth + 'px'
      }, _util.UNSELECTABLE_STYLE);
      var removeCls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-selection__choice__remove"), true), (0, _defineProperty2["default"])(_classNames, "".concat(iconPrefix, "-close-modal-line"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-selection__choice__remove__disabled"), disableCloseTag), _classNames));
      return /*#__PURE__*/_react["default"].createElement("li", (0, _assign["default"])({
        style: tagStyle
      }, _util.UNSELECTABLE_ATTRIBUTE, {
        role: "menuitem",
        className: "".concat(prefixCls, "-selection__choice"),
        title: (0, _util.toTitle)(label)
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: removeCls,
        onMouseDown: disableCloseTag ? null : this.onRemove
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-selection__choice__content")
      }, content));
    }
  }]);
  return Selection;
}(_react["default"].Component);
Selection.propTypes = {
  disableCloseTag: _propTypes["default"].bool,
  editable: _propTypes["default"].bool,
  prefixCls: _propTypes["default"].string,
  iconPrefix: _propTypes["default"].string,
  maxTagTextLength: _propTypes["default"].number,
  tagWidth: _propTypes["default"].number,
  onRemove: _propTypes["default"].func,
  label: _propTypes["default"].node,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number])
};
var _default = Selection;
exports["default"] = _default;