"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _index = _interopRequireDefault(require("../../Icon/index"));
var _constant = require("../constant");
var _Consumer = _interopRequireDefault(require("../../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ErrorDisplay = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(ErrorDisplay, _Component);
  var _super = _createSuper(ErrorDisplay);
  function ErrorDisplay(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ErrorDisplay);
    _this = _super.call(this, props);
    _this.getMediaError = function () {
      _this.setState({
        mediaError: _this.player.error()
      });
    };
    // 断网重试
    _this.handleRetry = function () {
      var currentTime = _this.player.currentTime();
      _this.player.error(null);
      _this.player.pause();
      _this.player.load();
      _this.player.currentTime(currentTime);
      _this.player.play();
    };
    // 获取播放器实例
    _this.player = props.vjsComponent.player_;
    _this.state = {
      // MediaError对象, 包含了音频/视频的错误状态。http://www.w3school.com.cn/tags/av_prop_error.asp
      mediaError: null
    };
    return _this;
  }
  (0, _createClass2["default"])(ErrorDisplay, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.player.on('error', this.getMediaError);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.player.off('error', this.getMediaError);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        vjsComponent = _this$props.vjsComponent,
        prefixCls = _this$props.prefixCls;
      var mediaError = this.state.mediaError;
      var errorMessage = mediaError !== null ? _constant.MEDIA_ERROR[mediaError.code] : '';
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "VideoViewer"
      }, function (Locale) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: prefixCls
        }, mediaError ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-msg")
        }, errorMessage, mediaError.code === 2 ? /*#__PURE__*/_react["default"].createElement("a", {
          className: "".concat(prefixCls, "-retry"),
          onClick: _this2.handleRetry
        }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
          type: "picture-rotate"
        }), Locale.retry) : null) : null);
      });
    }
  }]);
  return ErrorDisplay;
}(_react.Component);
exports["default"] = ErrorDisplay;
ErrorDisplay.propTypes = {
  prefixCls: _propTypes["default"].string,
  vjsComponent: _propTypes["default"].object
};
ErrorDisplay.defaultProps = {
  prefixCls: 'fishd-video-error'
};