"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _sort = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/sort"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _src = _interopRequireDefault(require("./src"));
var _arrayTreeFilter = _interopRequireDefault(require("array-tree-filter"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _classnames = _interopRequireDefault(require("classnames"));
var _omit = _interopRequireDefault(require("omit.js"));
var _warning = _interopRequireDefault(require("warning"));
var _utils = require("../../utils");
var _Input = _interopRequireDefault(require("../Input"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
// We limit the filtered item count by default
var defaultLimit = 50;
//搜索项高亮-String类型支持
function highlightKeyword(str, keyword, prefixCls) {
  var _context;
  return (0, _map["default"])(_context = str.split(keyword)).call(_context, function (node, index) {
    return index === 0 ? node : [/*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-menu-item-keyword"),
      key: "seperator"
    }, keyword), node];
  });
}
//默认filterOption
function defaultFilterOption(inputValue, path, names) {
  return (0, _some["default"])(path).call(path, function (option) {
    var _context2;
    return (0, _indexOf["default"])(_context2 = option[names.label]).call(_context2, inputValue) > -1;
  });
}
//默认的搜索后的option渲染方法
function defaultRenderFilteredOption(inputValue, path, prefixCls, names) {
  return (0, _map["default"])(path).call(path, function (option, index) {
    var label = option[names.label];
    var node = (0, _indexOf["default"])(label).call(label, inputValue) > -1 ? highlightKeyword(label, inputValue, prefixCls) : label;
    return index === 0 ? node : [' / ', node];
  });
}
//默认搜索后的option排序方案
function defaultSortFilteredOption(a, b, inputValue, names) {
  function callback(elem) {
    var _context3;
    return (0, _indexOf["default"])(_context3 = elem[names.label]).call(_context3, inputValue) > -1;
  }
  return (0, _findIndex["default"])(a).call(a, callback) - (0, _findIndex["default"])(b).call(b, callback);
}
//自定义option参数的名字
function getFilledFieldNames(props) {
  var fieldNames = props.fieldNames || {};
  var names = {
    children: fieldNames.children || 'children',
    label: fieldNames.label || 'label',
    value: fieldNames.value || 'value'
  };
  return names;
}
function flattenTree(options, props) {
  var ancestor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var names = getFilledFieldNames(props);
  var flattenOptions = [];
  var childrenName = names.children;
  (0, _forEach["default"])(options).call(options, function (option) {
    var path = (0, _concat["default"])(ancestor).call(ancestor, option);
    if (props.changeOnSelect || !option[childrenName] || !option[childrenName].length) {
      flattenOptions.push(path);
    }
    if (option[childrenName]) {
      flattenOptions = (0, _concat["default"])(flattenOptions).call(flattenOptions, flattenTree(option[childrenName], props, path));
    }
  });
  return flattenOptions;
}
var defaultDisplayRender = function defaultDisplayRender(label) {
  return label.join(' / ');
};
var Cascader = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Cascader, _React$Component);
  var _super = _createSuper(Cascader);
  function Cascader(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Cascader);
    _this = _super.call(this, props);
    _this.handleChange = function (value, selectedOptions) {
      _this.setState({
        inputValue: ''
      });
      if (selectedOptions[0].__IS_FILTERED_OPTION) {
        var unwrappedValue = value[0];
        var unwrappedSelectedOptions = selectedOptions[0].path;
        _this.setValue(unwrappedValue, unwrappedSelectedOptions);
        return;
      }
      _this.setValue(value, selectedOptions);
    };
    _this.handlePopupVisibleChange = function (popupVisible) {
      if (!('popupVisible' in _this.props)) {
        _this.setState({
          popupVisible: popupVisible,
          inputFocused: popupVisible,
          inputValue: popupVisible ? _this.state.inputValue : ''
        });
      }
      var onVisibleChange = _this.props.onVisibleChange;
      if (onVisibleChange) {
        onVisibleChange(popupVisible);
      }
    };
    _this.handleInputBlur = function () {
      _this.setState({
        inputFocused: false
      });
    };
    _this.handleInputClick = function (e) {
      var _this$state = _this.state,
        inputFocused = _this$state.inputFocused,
        popupVisible = _this$state.popupVisible;
      // Prevent `Trigger` behaviour.
      if (inputFocused || popupVisible) {
        e.stopPropagation();
        if (e.nativeEvent.stopImmediatePropagation) {
          e.nativeEvent.stopImmediatePropagation();
        }
      }
    };
    _this.handleKeyDown = function (e) {
      if (e.keyCode === _utils.KeyCode.BACKSPACE) {
        e.stopPropagation();
      }
    };
    _this.handleInputChange = function (e) {
      var inputValue = e.target.value;
      _this.setState({
        inputValue: inputValue
      });
    };
    _this.setValue = function (value) {
      var selectedOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      if (!('value' in _this.props)) {
        _this.setState({
          value: value
        });
      }
      var onChange = _this.props.onChange;
      if (onChange) {
        onChange(value, selectedOptions);
      }
    };
    _this.clearSelection = function (e) {
      e.preventDefault();
      e.stopPropagation();
      if (!_this.state.inputValue) {
        _this.setValue([]);
        _this.handlePopupVisibleChange(false);
      } else {
        _this.setState({
          inputValue: ''
        });
      }
    };
    _this.saveInput = function (node) {
      _this.input = node;
    };
    _this.state = {
      value: props.value || props.defaultValue || [],
      inputValue: '',
      inputFocused: false,
      popupVisible: props.popupVisible,
      flattenOptions: props.showSearch ? flattenTree(props.options, props) : undefined,
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(Cascader, [{
    key: "getLabel",
    value: function getLabel() {
      var _this$props = this.props,
        options = _this$props.options,
        _this$props$displayRe = _this$props.displayRender,
        displayRender = _this$props$displayRe === void 0 ? defaultDisplayRender : _this$props$displayRe;
      var names = getFilledFieldNames(this.props);
      var value = this.state.value;
      var unwrappedValue = (0, _isArray["default"])(value[0]) ? value[0] : value;
      var selectedOptions = (0, _arrayTreeFilter["default"])(options, function (o, level) {
        return o[names.value] === unwrappedValue[level];
      });
      var label = (0, _map["default"])(selectedOptions).call(selectedOptions, function (o) {
        return o[names.label];
      });
      return displayRender(label, selectedOptions);
    }
  }, {
    key: "generateFilteredOptions",
    value: function generateFilteredOptions(prefixCls, Locale) {
      var _this2 = this,
        _ref2;
      var _this$props2 = this.props,
        showSearch = _this$props2.showSearch,
        _this$props2$notFound = _this$props2.notFoundContent,
        notFoundContent = _this$props2$notFound === void 0 ? Locale.notFoundContent : _this$props2$notFound;
      var names = getFilledFieldNames(this.props);
      var _showSearch$filter = (0, _filter["default"])(showSearch),
        filter = _showSearch$filter === void 0 ? defaultFilterOption : _showSearch$filter,
        _showSearch$render = showSearch.render,
        render = _showSearch$render === void 0 ? defaultRenderFilteredOption : _showSearch$render,
        _showSearch$sort = (0, _sort["default"])(showSearch),
        sort = _showSearch$sort === void 0 ? defaultSortFilteredOption : _showSearch$sort,
        _showSearch$limit = showSearch.limit,
        limit = _showSearch$limit === void 0 ? defaultLimit : _showSearch$limit;
      var _this$state2 = this.state,
        _this$state2$flattenO = _this$state2.flattenOptions,
        flattenOptions = _this$state2$flattenO === void 0 ? [] : _this$state2$flattenO,
        inputValue = _this$state2.inputValue;
      // Limit the filter if needed
      var filtered;
      if (limit > 0) {
        filtered = [];
        var matchCount = 0;
        // Perf optimization to filter items only below the limit
        (0, _some["default"])(flattenOptions).call(flattenOptions, function (path) {
          var match = filter(_this2.state.inputValue, path, names);
          if (match) {
            filtered.push(path);
            matchCount += 1;
          }
          return matchCount >= limit;
        });
      } else {
        (0, _warning["default"])(typeof limit !== 'number', "'limit' of showSearch in Cascader should be positive number or false.");
        filtered = (0, _filter["default"])(flattenOptions).call(flattenOptions, function (path) {
          return filter(_this2.state.inputValue, path, names);
        });
      }
      (0, _sort["default"])(filtered).call(filtered, function (a, b) {
        return sort(a, b, inputValue, names);
      });
      if (filtered.length > 0) {
        return (0, _map["default"])(filtered).call(filtered, function (path) {
          var _ref;
          return _ref = {
            __IS_FILTERED_OPTION: true,
            path: path
          }, (0, _defineProperty2["default"])(_ref, names.label, render(inputValue, path, prefixCls, names)), (0, _defineProperty2["default"])(_ref, names.value, (0, _map["default"])(path).call(path, function (o) {
            return o[names.value];
          })), (0, _defineProperty2["default"])(_ref, "disabled", (0, _some["default"])(path).call(path, function (o) {
            return !!o.disabled;
          })), _ref;
        });
      }
      return [(_ref2 = {}, (0, _defineProperty2["default"])(_ref2, names.label, notFoundContent), (0, _defineProperty2["default"])(_ref2, names.value, 'FISHD_CASCADER_NOT_FOUND'), (0, _defineProperty2["default"])(_ref2, "disabled", true), _ref2)];
    }
  }, {
    key: "focus",
    value: function focus() {
      this.input.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.input.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _classNames2,
        _context4,
        _classNames3,
        _this3 = this;
      var props = this.props,
        state = this.state;
      var prefixCls = props.prefixCls,
        inputPrefixCls = props.inputPrefixCls,
        children = props.children,
        placeholder = props.placeholder,
        notFoundContent = props.notFoundContent,
        size = props.size,
        disabled = props.disabled,
        className = props.className,
        style = props.style,
        allowClear = props.allowClear,
        _props$showSearch = props.showSearch,
        showSearch = _props$showSearch === void 0 ? false : _props$showSearch,
        otherProps = __rest(props, ["prefixCls", "inputPrefixCls", "children", "placeholder", "notFoundContent", "size", "disabled", "className", "style", "allowClear", "showSearch"]);
      var value = state.value,
        inputFocused = state.inputFocused;
      var sizeCls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(inputPrefixCls, "-lg"), size === 'large'), (0, _defineProperty2["default"])(_classNames, "".concat(inputPrefixCls, "-sm"), size === 'small'), _classNames));
      var clearIcon = allowClear && !disabled && value.length > 0 || state.inputValue ? /*#__PURE__*/React.createElement(_Icon["default"], {
        type: "close-circle-fill",
        className: "".concat(prefixCls, "-picker-clear"),
        onClick: this.clearSelection
      }) : null;
      var arrowCls = (0, _classnames["default"])((_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-picker-arrow"), true), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-picker-arrow-expand"), state.popupVisible), _classNames2));
      var pickerCls = (0, _classnames["default"])(className, "".concat(prefixCls, "-picker"), (_classNames3 = {}, (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-picker-with-value"), state.inputValue), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-picker-disabled"), disabled), (0, _defineProperty2["default"])(_classNames3, (0, _concat["default"])(_context4 = "".concat(prefixCls, "-picker-")).call(_context4, size), !!size), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-picker-show-search"), !!showSearch), (0, _defineProperty2["default"])(_classNames3, "".concat(prefixCls, "-picker-focused"), inputFocused), _classNames3));
      // Fix bug of https://github.com/facebook/react/pull/5004
      // and https://fb.me/react-unknown-prop
      var inputProps = (0, _omit["default"])(otherProps, ['onChange', 'options', 'popupPlacement', 'transitionName', 'displayRender', 'onVisibleChange', 'changeOnSelect', 'expandTrigger', 'popupVisible', 'getPopupContainer', 'loadData', 'popupClassName', 'filterOption', 'renderFilteredOption', 'sortFilteredOption', 'notFoundContent', 'fieldNames', 'esc']);
      var getOptionsAndOthers = function getOptionsAndOthers(Locale) {
        var _this3$props = _this3.props,
          _this3$props$notFound = _this3$props.notFoundContent,
          notFoundContent = _this3$props$notFound === void 0 ? Locale.notFoundContent : _this3$props$notFound,
          _this3$props$placehol = _this3$props.placeholder,
          placeholder = _this3$props$placehol === void 0 ? Locale.placeholder : _this3$props$placehol;
        var options = props.options;
        if (state.inputValue) {
          options = _this3.generateFilteredOptions(prefixCls, Locale);
        }
        // Dropdown menu should keep previous status until it is fully closed.
        if (!state.popupVisible) {
          options = _this3.cachedOptions;
        } else {
          _this3.cachedOptions = options;
        }
        var dropdownMenuColumnStyle = {};
        var isNotFound = (options || []).length === 1 && options[0].value === 'FISHD_CASCADER_NOT_FOUND';
        if (isNotFound) {
          dropdownMenuColumnStyle.height = 'auto'; // Height of one row.
        }
        // The default value of `matchInputWidth` is `true`
        var resultListMatchInputWidth = showSearch.matchInputWidth === false ? false : true;
        if (resultListMatchInputWidth && state.inputValue && _this3.input) {
          dropdownMenuColumnStyle.width = _this3.input.input.offsetWidth;
        }
        return {
          options: options,
          dropdownMenuColumnStyle: dropdownMenuColumnStyle,
          notFoundContent: notFoundContent,
          placeholder: placeholder
        };
      };
      var label = this.getLabel();
      var getInput = function getInput(Locale) {
        var _context5;
        var _this3$props$placehol2 = _this3.props.placeholder,
          placeholder = _this3$props$placehol2 === void 0 ? Locale.placeholder : _this3$props$placehol2;
        return children || /*#__PURE__*/React.createElement("span", {
          style: style,
          className: pickerCls
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-picker-label"),
          title: typeof label === 'string' ? label : ''
        }, label), /*#__PURE__*/React.createElement(_Input["default"], (0, _assign["default"])({}, inputProps, {
          ref: _this3.saveInput,
          prefixCls: inputPrefixCls,
          placeholder: value && value.length > 0 ? undefined : placeholder,
          className: (0, _concat["default"])(_context5 = "".concat(prefixCls, "-input ")).call(_context5, sizeCls),
          value: state.inputValue,
          disabled: disabled,
          readOnly: !showSearch,
          autoComplete: "off",
          onClick: showSearch ? _this3.handleInputClick : undefined,
          onBlur: showSearch ? _this3.handleInputBlur : undefined,
          onKeyDown: _this3.handleKeyDown,
          onChange: showSearch ? _this3.handleInputChange : undefined
        })), clearIcon, /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "down-fill",
          className: arrowCls
        }));
      };
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "Cascader"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement(_src["default"], (0, _assign["default"])({}, props, getOptionsAndOthers(Locale), {
          value: value,
          popupVisible: state.popupVisible,
          onPopupVisibleChange: _this3.handlePopupVisibleChange,
          onChange: _this3.handleChange
        }), getInput(Locale));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, _ref3) {
      var prevProps = _ref3.prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('value' in nextProps) {
        newState.value = nextProps.value || [];
      }
      if ('popupVisible' in nextProps) {
        newState.popupVisible = nextProps.popupVisible;
      }
      if (nextProps.showSearch && prevProps.options !== nextProps.options) {
        newState.flattenOptions = flattenTree(nextProps.options, nextProps);
      }
      return newState;
    }
  }]);
  return Cascader;
}(React.Component);
Cascader.defaultProps = {
  prefixCls: 'fishd-cascader',
  inputPrefixCls: 'fishd-input',
  transitionName: 'slide-up',
  popupPlacement: 'bottomLeft',
  options: [],
  disabled: false,
  allowClear: true
};
(0, _reactLifecyclesCompat.polyfill)(Cascader);
var _default = Cascader;
exports["default"] = _default;