"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _PanelContent = _interopRequireDefault(require("./PanelContent"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var CollapsePanel = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(CollapsePanel, _Component);
  var _super = _createSuper(CollapsePanel);
  function CollapsePanel(props) {
    var _context, _context2;
    var _this;
    (0, _classCallCheck2["default"])(this, CollapsePanel);
    _this = _super.call(this, props);
    _this.getHeader = function (status) {
      var header = _this.props.header;
      if (typeof header === 'function') {
        return header(status);
      } else {
        return header;
      }
    };
    _this.handleItemClick = (0, _bind["default"])(_context = _this.handleItemClick).call(_context, (0, _assertThisInitialized2["default"])(_this));
    _this.handleItemClose = (0, _bind["default"])(_context2 = _this.handleItemClose).call(_context2, (0, _assertThisInitialized2["default"])(_this));
    _this.state = {
      isCustom: typeof _this.props.header === 'function' //是否显示箭头,不可关闭时不显示
    };

    return _this;
  }
  (0, _createClass2["default"])(CollapsePanel, [{
    key: "handleItemClick",
    value: function handleItemClick() {
      var _this$props = this.props,
        onItemClick = _this$props.onItemClick,
        disabled = _this$props.disabled;
      if (!disabled) {
        onItemClick();
      }
    }
  }, {
    key: "handleItemClose",
    value: function handleItemClose(e) {
      e.stopPropagation();
      var _this$props2 = this.props,
        onCloseItem = _this$props2.onCloseItem,
        disabled = _this$props2.disabled;
      if (!disabled) {
        onCloseItem();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames, _classNames2;
      var _this$props3 = this.props,
        itemKey = _this$props3.itemKey,
        className = _this$props3.className,
        prefixCls = _this$props3.prefixCls,
        disabled = _this$props3.disabled,
        showClose = _this$props3.showClose,
        style = _this$props3.style,
        children = _this$props3.children,
        isActive = _this$props3.isActive;
      var isCustom = this.state.isCustom;
      var headerCls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-header"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-header-disabled"), disabled), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-header-close"), showClose), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-header-custom"), isCustom), _classNames));
      var itemCls = (0, _classnames["default"])((_classNames2 = {}, (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-item"), true), (0, _defineProperty2["default"])(_classNames2, "".concat(prefixCls, "-item-active"), isActive), (0, _defineProperty2["default"])(_classNames2, className, className), _classNames2));
      var closeCls = (0, _classnames["default"])({
        close: true,
        'z-close-show': showClose
      });
      var getArrowIcon = function getArrowIcon(isActive) {
        if (isActive) {
          return /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
            className: "icon",
            type: "top"
          });
        } else {
          return /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
            className: "icon",
            type: "bottom"
          });
        }
      };
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: itemCls,
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: headerCls,
        onClick: this.handleItemClick,
        role: "tab",
        "aria-expanded": isActive,
        ref: itemKey
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "arrow"
      }, getArrowIcon(isActive)), /*#__PURE__*/_react["default"].createElement("div", {
        className: "title"
      }, this.getHeader(isActive)), /*#__PURE__*/_react["default"].createElement("div", {
        className: closeCls,
        onClick: this.handleItemClose
      }, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
        className: "icon",
        type: "picture-close"
      }))), /*#__PURE__*/_react["default"].createElement(_PanelContent["default"], {
        prefixCls: prefixCls,
        isActive: isActive
      }, children));
    }
  }]);
  return CollapsePanel;
}(_react.Component);
CollapsePanel.propTypes = {
  itemKey: _propTypes["default"].func,
  className: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  style: _propTypes["default"].object,
  children: _propTypes["default"].node,
  openAnimation: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  header: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].func]),
  showClose: _propTypes["default"].bool,
  isActive: _propTypes["default"].bool,
  onItemClick: _propTypes["default"].func,
  onCloseItem: _propTypes["default"].func
};
CollapsePanel.defaultProps = {
  isActive: false,
  disabled: false,
  style: {},
  onItemClick: function onItemClick() {},
  onCloseItem: function onCloseItem() {}
};
var _default = CollapsePanel;
exports["default"] = _default;