import React from 'react';
import { ParamsColor } from './Params';
import Color from './helpers/color';
interface RibbtonProps {
    color?: string | ParamsColor | Color;
    onChange?: (color: ParamsColor) => void;
    rootPrefixCls?: string;
}
export default class Ribbon extends React.Component<RibbtonProps> {
    static propTypes: {
        color: any;
        onChange: any;
        rootPrefixCls: any;
    };
    constructor(props: RibbtonProps);
    componentWillUnmount(): void;
    onMouseDown: (e: any) => void;
    onDrag: (e: any) => void;
    onDragEnd: (e: any) => void;
    getPrefixCls: () => string;
    pointMoveTo: (coords: any) => void;
    removeListeners: () => void;
    render(): JSX.Element;
}
export {};
