"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = LocaleConsumer;
exports.getLocale = getLocale;
var _react = _interopRequireDefault(require("react"));
var _Context = require("./Context");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function getLocale(Locale, componentName) {
  var currentLocale = Locale;
  if (componentName) {
    currentLocale = currentLocale[componentName];
  }
  return currentLocale || {};
}
function LocaleConsumer(_ref) {
  var componentName = _ref.componentName,
    children = _ref.children;
  return /*#__PURE__*/_react["default"].createElement(_Context.Consumer, null, function (Locale) {
    var ComponentLocal = getLocale(Locale, componentName);
    return children(ComponentLocal || {}, Locale.locale);
  });
}