"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BAR_MAP = void 0;
exports.renderThumbStyle = renderThumbStyle;
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var BAR_MAP = {
  vertical: {
    offset: 'offsetHeight',
    scroll: 'scrollTop',
    scrollSize: 'scrollHeight',
    size: 'height',
    key: 'vertical',
    axis: 'Y',
    client: 'clientY',
    direction: 'top'
  },
  horizontal: {
    offset: 'offsetWidth',
    scroll: 'scrollLeft',
    scrollSize: 'scrollWidth',
    size: 'width',
    key: 'horizontal',
    axis: 'X',
    client: 'clientX',
    direction: 'left'
  }
};
exports.BAR_MAP = BAR_MAP;
function renderThumbStyle(_ref) {
  var _context;
  var move = _ref.move,
    size = _ref.size,
    bar = _ref.bar;
  var style = {};
  var translate = (0, _concat["default"])(_context = "translate".concat(bar.axis, "(")).call(_context, move, "%)");
  style[bar.size] = size;
  style.transform = translate;
  style.msTransform = translate;
  style.WebkitTransform = translate;
  return style;
}