import { Component } from 'react';
import { EchartCoreProps } from './core';
declare type EchartProps = Omit<EchartCoreProps, 'echarts'>;
export default class Echart extends Component<EchartProps> {
    static propTypes: {
        prefixCls: any;
        option: any;
        opts: any;
        events: any;
        className: any;
        style: any;
        theme: any;
        notMerge: any;
        lazyUpdate: any;
        onChartReady: any;
        loadingOption: any;
        showLoading: any;
    };
    static defaultProps: {
        prefixCls: string;
        theme: string;
        notMerge: boolean;
        lazyUpdate: boolean;
        style: {
            height: string;
        };
        className: string;
        onChartReady: () => void;
        showLoading: boolean;
        loadingOption: any;
        onEvents: {};
        opts: {};
    };
    constructor(props: EchartProps);
    echarts_react: any;
    getInstance(): any;
    render(): JSX.Element;
}
export {};
