import React from 'react';
interface FooterToolbarProps {
    prefixCls: string;
    className?: string;
    target: () => HTMLElement | Window | null;
    style: React.CSSProperties;
}
interface FooterToolbarState {
    offset: number;
}
declare class FooterToolbar extends React.Component<FooterToolbarProps> {
    static defaultProps: {
        children: any;
        className: string;
        prefixCls: string;
    };
    static propTypes: {
        children: any;
        className: any;
        prefixCls: any;
        target: any;
        style: any;
    };
    private scrollListener;
    private resizeListener;
    private wrapper;
    state: Readonly<FooterToolbarState>;
    constructor(props: FooterToolbarProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    setToolbarPosition: () => void;
    render(): JSX.Element;
}
export default FooterToolbar;
