"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Group: true,
  Button: true
};
Object.defineProperty(exports, "Button", {
  enumerable: true,
  get: function get() {
    return _RadioButton["default"];
  }
});
Object.defineProperty(exports, "Group", {
  enumerable: true,
  get: function get() {
    return _Group["default"];
  }
});
exports["default"] = void 0;
var _Radio = _interopRequireDefault(require("./Radio"));
var _Group = _interopRequireDefault(require("./Group"));
var _RadioButton = _interopRequireDefault(require("./RadioButton"));
require("./style/index.less");
var _interface = require("./interface");
Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _interface[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _interface[key];
    }
  });
});
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
_Radio["default"].Button = _RadioButton["default"];
_Radio["default"].Group = _Group["default"];
var _default = _Radio["default"];
exports["default"] = _default;