"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _quill = _interopRequireDefault(require("./core/quill"));
var _block = _interopRequireWildcard(require("./blots/block"));
var _break = _interopRequireDefault(require("./blots/break"));
var _container = _interopRequireDefault(require("./blots/container"));
var _cursor = _interopRequireDefault(require("./blots/cursor"));
var _embed = _interopRequireDefault(require("./blots/embed"));
var _inline = _interopRequireDefault(require("./blots/inline"));
var _scroll = _interopRequireDefault(require("./blots/scroll"));
var _text = _interopRequireDefault(require("./blots/text"));
var _clipboard = _interopRequireDefault(require("./modules/clipboard"));
var _history = _interopRequireDefault(require("./modules/history"));
var _keyboard = _interopRequireDefault(require("./modules/keyboard"));
var _uploader = _interopRequireDefault(require("./modules/uploader"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
_quill["default"].register({
  'blots/block': _block["default"],
  'blots/block/embed': _block.BlockEmbed,
  'blots/break': _break["default"],
  'blots/container': _container["default"],
  'blots/cursor': _cursor["default"],
  'blots/embed': _embed["default"],
  'blots/inline': _inline["default"],
  'blots/scroll': _scroll["default"],
  'blots/text': _text["default"],
  'modules/clipboard': _clipboard["default"],
  'modules/history': _history["default"],
  'modules/keyboard': _keyboard["default"],
  'modules/uploader': _uploader["default"]
});
var _default = _quill["default"];
exports["default"] = _default;