"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ListContainer = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _block = _interopRequireDefault(require("../blots/block"));
var _container = _interopRequireDefault(require("../blots/container"));
var _quill = _interopRequireDefault(require("../core/quill"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ListContainer = /*#__PURE__*/function (_Container) {
  (0, _inherits2["default"])(ListContainer, _Container);
  var _super = _createSuper(ListContainer);
  function ListContainer() {
    (0, _classCallCheck2["default"])(this, ListContainer);
    return _super.apply(this, arguments);
  }
  return (0, _createClass2["default"])(ListContainer);
}(_container["default"]);
exports.ListContainer = ListContainer;
ListContainer.blotName = 'list-container';
ListContainer.tagName = 'UL';
var ListItem = /*#__PURE__*/function (_Block) {
  (0, _inherits2["default"])(ListItem, _Block);
  var _super2 = _createSuper(ListItem);
  function ListItem(scroll, domNode) {
    (0, _classCallCheck2["default"])(this, ListItem);
    return _super2.call(this, scroll, domNode); // const ui = domNode.ownerDocument.createElement('span');
    // const listEventHandler = e => {
    //   if (!scroll.isEnabled()) return;
    //   const format = this.statics.formats(domNode, scroll);
    //   if (format === 'checked') {
    //     this.format('list', 'unchecked');
    //     e.preventDefault();
    //   } else if (format === 'unchecked') {
    //     this.format('list', 'checked');
    //     e.preventDefault();
    //   }
    // };
    // ui.addEventListener('mousedown', listEventHandler);
    // ui.addEventListener('touchstart', listEventHandler);
    // this.attachUI(ui);
  }

  (0, _createClass2["default"])(ListItem, [{
    key: "format",
    value: function format(name, value) {
      if (name === this.statics.blotName && value) {
        this.domNode.setAttribute('data-list', value);
      } else {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(ListItem.prototype), "format", this).call(this, name, value);
      }
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(ListItem), "create", this).call(this);
      node.setAttribute('data-list', value);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(domNode) {
      return domNode.getAttribute('data-list') || undefined;
    }
  }, {
    key: "register",
    value: function register() {
      _quill["default"].register(ListContainer);
    }
  }]);
  return ListItem;
}(_block["default"]);
exports["default"] = ListItem;
ListItem.blotName = 'list';
ListItem.tagName = 'LI';
ListContainer.allowedChildren = [ListItem];
ListItem.requiredContainer = ListContainer;