"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _merge = _interopRequireDefault(require("lodash/merge"));
var _emitter = _interopRequireDefault(require("../core/emitter"));
var _base = _interopRequireWildcard(require("./base"));
var _link = _interopRequireDefault(require("../formats/link"));
var _selection = require("../core/selection");
var _icons = _interopRequireDefault(require("../ui/icons"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TOOLBAR_CONFIG = [[{
  header: ['1', '2', '3', false]
}], ['bold', 'italic', 'underline', 'link'], [{
  list: 'ordered'
}, {
  list: 'bullet'
}], ['clean']];
var SnowTooltip = /*#__PURE__*/function (_BaseTooltip) {
  (0, _inherits2["default"])(SnowTooltip, _BaseTooltip);
  var _super = _createSuper(SnowTooltip);
  function SnowTooltip(quill, bounds) {
    var _this;
    (0, _classCallCheck2["default"])(this, SnowTooltip);
    _this = _super.call(this, quill, bounds);
    _this.preview = _this.root.querySelector('a.ql-preview');
    return _this;
  }
  (0, _createClass2["default"])(SnowTooltip, [{
    key: "listen",
    value: function listen() {
      var _this2 = this;
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(SnowTooltip.prototype), "listen", this).call(this);
      this.root.querySelector('a.ql-action').addEventListener('click', function (event) {
        if (_this2.root.classList.contains('ql-editing')) {
          _this2.save();
        } else {
          _this2.edit('link', _this2.preview.textContent);
        }
        event.preventDefault();
      });
      this.root.querySelector('a.ql-remove').addEventListener('click', function (event) {
        if (_this2.linkRange != null) {
          var range = _this2.linkRange;
          _this2.restoreFocus();
          _this2.quill.formatText(range, 'link', false, _emitter["default"].sources.USER);
          delete _this2.linkRange;
        }
        event.preventDefault();
        _this2.hide();
      });
      this.quill.on(_emitter["default"].events.SELECTION_CHANGE, function (range, oldRange, source) {
        if (range == null) return;
        if (range.length === 0 && source === _emitter["default"].sources.USER) {
          var _this2$quill$scroll$d = _this2.quill.scroll.descendant(_link["default"], range.index),
            _this2$quill$scroll$d2 = (0, _slicedToArray2["default"])(_this2$quill$scroll$d, 2),
            link = _this2$quill$scroll$d2[0],
            offset = _this2$quill$scroll$d2[1];
          if (link != null) {
            _this2.linkRange = new _selection.Range(range.index - offset, link.length());
            var preview = _link["default"].formats(link.domNode);
            _this2.preview.textContent = preview;
            _this2.preview.setAttribute('href', preview);
            _this2.show();
            _this2.position(_this2.quill.getBounds(_this2.linkRange));
            return;
          }
        } else {
          delete _this2.linkRange;
        }
        _this2.hide();
      });
    }
  }, {
    key: "show",
    value: function show() {
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(SnowTooltip.prototype), "show", this).call(this);
      this.root.removeAttribute('data-mode');
    }
  }]);
  return SnowTooltip;
}(_base.BaseTooltip);
SnowTooltip.TEMPLATE = ['<a class="ql-preview" rel="noopener noreferrer" target="_blank" href="about:blank"></a>', '<input type="text" data-formula="e=mc^2" data-link="https://quilljs.com" data-video="Embed URL">', '<a class="ql-action"></a>', '<a class="ql-remove"></a>'].join('');
var SnowTheme = /*#__PURE__*/function (_BaseTheme) {
  (0, _inherits2["default"])(SnowTheme, _BaseTheme);
  var _super2 = _createSuper(SnowTheme);
  function SnowTheme(quill, options) {
    var _this3;
    (0, _classCallCheck2["default"])(this, SnowTheme);
    if (options.modules.toolbar != null && options.modules.toolbar.container == null) {
      options.modules.toolbar.container = TOOLBAR_CONFIG;
    }
    _this3 = _super2.call(this, quill, options);
    _this3.quill.container.classList.add('ql-snow');
    return _this3;
  }
  (0, _createClass2["default"])(SnowTheme, [{
    key: "extendToolbar",
    value: function extendToolbar(toolbar) {
      toolbar.container.classList.add('ql-snow');
      this.buildButtons(toolbar.container.querySelectorAll('button'), _icons["default"]);
      // this.buildPickers(toolbar.container.querySelectorAll('select'), icons);
      this.tooltip = new SnowTooltip(this.quill, this.options.bounds);
      if (toolbar.container.querySelector('.ql-link')) {
        this.quill.keyboard.addBinding({
          key: 'k',
          shortKey: true
        }, function (range, context) {
          toolbar.handlers.link.call(toolbar, !context.format.link);
        });
      }
    }
  }]);
  return SnowTheme;
}(_base["default"]);
SnowTheme.DEFAULTS = (0, _merge["default"])({}, _base["default"].DEFAULTS, {
  modules: {
    toolbar: {
      handlers: {
        link: function link(value) {
          if (value) {
            var range = this.quill.getSelection();
            if (range == null || range.length === 0) return;
            var preview = this.quill.getText(range);
            if (/^\S+@\S+\.\S+$/.test(preview) && (0, _indexOf["default"])(preview).call(preview, 'mailto:') !== 0) {
              preview = "mailto:".concat(preview);
            }
            var tooltip = this.quill.theme.tooltip;
            tooltip.edit('link', preview);
          } else {
            this.quill.format('link', false);
          }
        }
      }
    }
  }
});
var _default = SnowTheme;
exports["default"] = _default;