"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Input = _interopRequireDefault(require("../Input"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var SelectSearch = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SelectSearch, _React$Component);
  var _super = _createSuper(SelectSearch);
  function SelectSearch(props) {
    (0, _classCallCheck2["default"])(this, SelectSearch);
    return _super.call(this, props);
  }
  (0, _createClass2["default"])(SelectSearch, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _this$props = this.props,
        allowClear = _this$props.allowClear,
        emitEmpty = _this$props.emitEmpty,
        prefixCls = _this$props.prefixCls,
        searchInputProps = _this$props.searchInputProps,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        updateSearchValue = _this$props.updateSearchValue;
      var suffix = searchValue && allowClear && /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
        type: "close-circle-fill",
        className: "".concat(prefixCls, "-clear"),
        onClick: emitEmpty
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement(_Input["default"], (0, _assign["default"])({
        placeholder: searchPlaceholder,
        ref: function ref(searchInput) {
          return _this.searchInput = searchInput;
        },
        value: searchValue,
        onChange: updateSearchValue,
        suffix: suffix
      }, searchInputProps)));
    }
  }]);
  return SelectSearch;
}(_react["default"].Component);
exports["default"] = SelectSearch;
SelectSearch.propTypes = {
  allowClear: _propTypes["default"].bool,
  emitEmpty: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string,
  searchInputProps: _propTypes["default"].object,
  searchPlaceholder: _propTypes["default"].string,
  searchValue: _propTypes["default"].string,
  updateSearchValue: _propTypes["default"].func
};