"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
/* eslint-disable react/prop-types */

var Track = function Track(props) {
  var className = props.className,
    included = props.included,
    vertical = props.vertical,
    offset = props.offset,
    length = props.length,
    style = props.style;
  var positonStyle = vertical ? {
    bottom: "".concat(offset, "%"),
    height: "".concat(length, "%")
  } : {
    left: "".concat(offset, "%"),
    width: "".concat(length, "%")
  };
  var elStyle = (0, _assign["default"])((0, _assign["default"])({}, style), positonStyle);
  return included ? /*#__PURE__*/_react["default"].createElement("div", {
    className: className,
    style: elStyle
  }) : null;
};
var _default = Track;
exports["default"] = _default;