"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var React = _interopRequireWildcard(require("react"));
var PropTypes = _interopRequireWildcard(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _Consumer = _interopRequireDefault(require("../Config/Locale/Consumer"));
var _List = _interopRequireDefault(require("./List"));
var _Operation = _interopRequireDefault(require("./Operation"));
var _Search = _interopRequireDefault(require("./Search"));
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function noop() {}
var Transfer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Transfer, _React$Component);
  var _super = _createSuper(Transfer);
  function Transfer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Transfer);
    _this = _super.call(this, props);
    _this.separatedDataSource = null;
    _this.moveTo = function (direction) {
      var _this$props = _this.props,
        _this$props$targetKey = _this$props.targetKeys,
        targetKeys = _this$props$targetKey === void 0 ? [] : _this$props$targetKey,
        _this$props$dataSourc = _this$props.dataSource,
        dataSource = _this$props$dataSourc === void 0 ? [] : _this$props$dataSourc,
        onChange = _this$props.onChange;
      var _this$state = _this.state,
        sourceSelectedKeys = _this$state.sourceSelectedKeys,
        targetSelectedKeys = _this$state.targetSelectedKeys;
      var moveKeys = direction === 'right' ? sourceSelectedKeys : targetSelectedKeys;
      // filter the disabled options
      var newMoveKeys = (0, _filter["default"])(moveKeys).call(moveKeys, function (key) {
        return !(0, _some["default"])(dataSource).call(dataSource, function (data) {
          return !!(key === data.key && data.disabled);
        });
      });
      // move items to target box
      var newTargetKeys = direction === 'right' ? (0, _concat["default"])(newMoveKeys).call(newMoveKeys, targetKeys) : (0, _filter["default"])(targetKeys).call(targetKeys, function (targetKey) {
        return (0, _indexOf["default"])(newMoveKeys).call(newMoveKeys, targetKey) === -1;
      });
      // empty checked keys
      var oppositeDirection = direction === 'right' ? 'left' : 'right';
      _this.setState((0, _defineProperty2["default"])({}, _this.getSelectedKeysName(oppositeDirection), []));
      _this.handleSelectChange(oppositeDirection, []);
      if (onChange) {
        onChange(newTargetKeys, direction, newMoveKeys);
      }
    };
    _this.moveToLeft = function () {
      return _this.moveTo('left');
    };
    _this.moveToRight = function () {
      return _this.moveTo('right');
    };
    _this.handleSelectAll = function (direction, filteredDataSource, checkAll) {
      var originalSelectedKeys = _this.state[_this.getSelectedKeysName(direction)] || [];
      var currentKeys = (0, _map["default"])(filteredDataSource).call(filteredDataSource, function (item) {
        return item.key;
      });
      // Only operate current keys from original selected keys
      var newKeys1 = (0, _filter["default"])(originalSelectedKeys).call(originalSelectedKeys, function (key) {
        return (0, _indexOf["default"])(currentKeys).call(currentKeys, key) === -1;
      });
      var newKeys2 = (0, _toConsumableArray2["default"])(originalSelectedKeys);
      (0, _forEach["default"])(currentKeys).call(currentKeys, function (key) {
        if ((0, _indexOf["default"])(newKeys2).call(newKeys2, key) === -1) {
          newKeys2.push(key);
        }
      });
      var holder = checkAll ? newKeys1 : newKeys2;
      _this.handleSelectChange(direction, holder);
      if (!_this.props.selectedKeys) {
        _this.setState((0, _defineProperty2["default"])({}, _this.getSelectedKeysName(direction), holder));
      }
    };
    _this.handleLeftSelectAll = function (filteredDataSource, checkAll) {
      return _this.handleSelectAll('left', filteredDataSource, checkAll);
    };
    _this.handleRightSelectAll = function (filteredDataSource, checkAll) {
      return _this.handleSelectAll('right', filteredDataSource, checkAll);
    };
    _this.handleFilter = function (direction, e) {
      _this.setState((0, _defineProperty2["default"])({}, "".concat(direction, "Filter"), e.target.value));
      if (_this.props.onSearchChange) {
        _this.props.onSearchChange(direction, e);
      }
    };
    _this.handleLeftFilter = function (e) {
      return _this.handleFilter('left', e);
    };
    _this.handleRightFilter = function (e) {
      return _this.handleFilter('right', e);
    };
    _this.handleClear = function (direction) {
      _this.setState((0, _defineProperty2["default"])({}, "".concat(direction, "Filter"), ''));
    };
    _this.handleLeftClear = function () {
      return _this.handleClear('left');
    };
    _this.handleRightClear = function () {
      return _this.handleClear('right');
    };
    // 只单选模式下的目标列表
    _this.handleClose = function (selectedItem) {
      if (_this.props.mode === 'single') {
        var _this$props2 = _this.props,
          _this$props2$targetKe = _this$props2.targetKeys,
          _targetKeys = _this$props2$targetKe === void 0 ? [] : _this$props2$targetKe,
          onChange = _this$props2.onChange;
        var newMoveKeys = [selectedItem.key];
        var newTargetKeys = (0, _filter["default"])(_targetKeys).call(_targetKeys, function (key) {
          return key !== selectedItem.key;
        });
        if (onChange) {
          onChange(newTargetKeys, 'left', newMoveKeys);
        }
      }
    };
    _this.handleSelect = function (direction, selectedItem, checked) {
      // 单选模式下，点击直接move
      if (_this.props.mode === 'single') {
        if (direction === 'right') {
          return;
        }
        var _this$props3 = _this.props,
          _this$props3$targetKe = _this$props3.targetKeys,
          _targetKeys2 = _this$props3$targetKe === void 0 ? [] : _this$props3$targetKe,
          onChange = _this$props3.onChange;
        var newMoveKeys = [selectedItem.key];
        var newTargetKeys = (0, _concat["default"])(_targetKeys2).call(_targetKeys2, newMoveKeys);
        if (onChange) {
          onChange(newTargetKeys, 'right', newMoveKeys);
        }
      } else {
        var _this$state2 = _this.state,
          sourceSelectedKeys = _this$state2.sourceSelectedKeys,
          targetSelectedKeys = _this$state2.targetSelectedKeys;
        var holder = direction === 'left' ? (0, _toConsumableArray2["default"])(sourceSelectedKeys) : (0, _toConsumableArray2["default"])(targetSelectedKeys);
        var index = (0, _indexOf["default"])(holder).call(holder, selectedItem.key);
        if (index > -1) {
          (0, _splice["default"])(holder).call(holder, index, 1);
        }
        if (checked) {
          holder.push(selectedItem.key);
        }
        _this.handleSelectChange(direction, holder);
        if (!_this.props.selectedKeys) {
          _this.setState((0, _defineProperty2["default"])({}, _this.getSelectedKeysName(direction), holder));
        }
      }
    };
    _this.handleLeftSelect = function (selectedItem, checked) {
      return _this.handleSelect('left', selectedItem, checked);
    };
    _this.handleRightSelect = function (selectedItem, checked) {
      return _this.handleSelect('right', selectedItem, checked);
    };
    _this.handleScroll = function (direction, e) {
      var onScroll = _this.props.onScroll;
      if (onScroll) {
        onScroll(direction, e);
      }
    };
    _this.handleLeftScroll = function (e) {
      return _this.handleScroll('left', e);
    };
    _this.handleRightScroll = function (e) {
      return _this.handleScroll('right', e);
    };
    _this.getTitles = function (transferLocale) {
      var _assertThisInitialize = (0, _assertThisInitialized2["default"])(_this),
        props = _assertThisInitialize.props;
      if (props.titles) {
        return props.titles;
      }
      return transferLocale.titles;
    };
    _this.getSelectedKeysName = function (direction) {
      return direction === 'left' ? 'sourceSelectedKeys' : 'targetSelectedKeys';
    };
    _this.renderTransfer = function (Locale) {
      var _this$props4 = _this.props,
        _this$props4$prefixCl = _this$props4.prefixCls,
        prefixCls = _this$props4$prefixCl === void 0 ? 'fishd-transfer' : _this$props4$prefixCl,
        className = _this$props4.className,
        mode = _this$props4.mode,
        _this$props4$operatio = _this$props4.operations,
        operations = _this$props4$operatio === void 0 ? [] : _this$props4$operatio,
        operation = _this$props4.operation,
        showSearch = _this$props4.showSearch,
        notFoundContent = _this$props4.notFoundContent,
        searchPlaceholder = _this$props4.searchPlaceholder,
        body = _this$props4.body,
        footer = _this$props4.footer,
        style = _this$props4.style,
        listStyle = _this$props4.listStyle,
        operationStyle = _this$props4.operationStyle,
        filterOption = _this$props4.filterOption,
        render = _this$props4.render,
        lazy = _this$props4.lazy;
      var _this$state3 = _this.state,
        leftFilter = _this$state3.leftFilter,
        rightFilter = _this$state3.rightFilter,
        sourceSelectedKeys = _this$state3.sourceSelectedKeys,
        targetSelectedKeys = _this$state3.targetSelectedKeys;
      var _this$separateDataSou = _this.separateDataSource(_this.props),
        leftDataSource = _this$separateDataSou.leftDataSource,
        rightDataSource = _this$separateDataSou.rightDataSource;
      var leftActive = targetSelectedKeys.length > 0;
      var rightActive = sourceSelectedKeys.length > 0;
      var cls = (0, _classnames["default"])(className, prefixCls);
      var localeDefault = {
        titles: [''],
        notFoundContent: Locale.notFoundContent,
        sourceNotFoundContent: Locale.sourceNotFoundContent,
        targetNotFonudContent: Locale.targetNotFonudContent,
        searchPlaceholder: Locale.searchPlaceholder,
        itemUnit: '',
        itemsUnit: ''
      };
      var titles = _this.getTitles(localeDefault);
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, /*#__PURE__*/React.createElement(_List["default"], {
        mode: mode,
        direction: "left",
        prefixCls: "".concat(prefixCls, "-list"),
        titleText: titles[0],
        dataSource: leftDataSource,
        filter: leftFilter,
        filterOption: filterOption,
        style: listStyle,
        checkedKeys: sourceSelectedKeys,
        handleFilter: _this.handleLeftFilter,
        handleClear: _this.handleLeftClear,
        handleSelect: _this.handleLeftSelect,
        handleSelectAll: _this.handleLeftSelectAll,
        render: render,
        showSearch: showSearch,
        searchPlaceholder: searchPlaceholder || localeDefault.searchPlaceholder,
        notFoundContent: notFoundContent || localeDefault.sourceNotFoundContent,
        itemUnit: localeDefault.itemUnit,
        itemsUnit: localeDefault.itemsUnit,
        body: body,
        footer: footer,
        lazy: lazy,
        onScroll: _this.handleLeftScroll
      }), /*#__PURE__*/React.createElement(_Operation["default"], {
        mode: mode,
        arrowText: operation,
        className: "".concat(prefixCls, "-operation"),
        rightActive: rightActive,
        rightArrowText: operations[0],
        moveToRight: _this.moveToRight,
        leftActive: leftActive,
        leftArrowText: operations[1],
        moveToLeft: _this.moveToLeft,
        style: operationStyle
      }), /*#__PURE__*/React.createElement(_List["default"], {
        mode: mode,
        direction: "right",
        prefixCls: "".concat(prefixCls, "-list"),
        titleText: titles[1],
        dataSource: rightDataSource,
        filter: rightFilter,
        filterOption: filterOption,
        style: listStyle,
        checkedKeys: targetSelectedKeys,
        handleFilter: _this.handleRightFilter,
        handleClear: _this.handleRightClear,
        handleSelect: _this.handleRightSelect,
        handleSelectAll: _this.handleRightSelectAll,
        handleClose: _this.handleClose,
        render: render,
        showSearch: showSearch,
        searchPlaceholder: searchPlaceholder || localeDefault.searchPlaceholder,
        notFoundContent: notFoundContent || localeDefault.targetNotFonudContent,
        itemUnit: localeDefault.itemUnit,
        itemsUnit: localeDefault.itemsUnit,
        body: body,
        footer: footer,
        lazy: lazy,
        onScroll: _this.handleRightScroll
      }));
    };
    var _props$selectedKeys = props.selectedKeys,
      selectedKeys = _props$selectedKeys === void 0 ? [] : _props$selectedKeys,
      _props$targetKeys = props.targetKeys,
      targetKeys = _props$targetKeys === void 0 ? [] : _props$targetKeys;
    _this.state = {
      leftFilter: '',
      rightFilter: '',
      sourceSelectedKeys: (0, _filter["default"])(selectedKeys).call(selectedKeys, function (key) {
        return (0, _indexOf["default"])(targetKeys).call(targetKeys, key) === -1;
      }),
      targetSelectedKeys: (0, _filter["default"])(selectedKeys).call(selectedKeys, function (key) {
        return (0, _indexOf["default"])(targetKeys).call(targetKeys, key) > -1;
      }),
      prevProps: props
    };
    return _this;
  }
  (0, _createClass2["default"])(Transfer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.targetKeys !== this.props.targetKeys || prevProps.dataSource !== this.props.dataSource) {
        // clear cached separated dataSource
        this.separatedDataSource = null;
        this.forceUpdate();
      }
    }
  }, {
    key: "separateDataSource",
    value: function separateDataSource(props) {
      if (this.separatedDataSource) {
        return this.separatedDataSource;
      }
      var dataSource = props.dataSource,
        rowKey = props.rowKey,
        _props$targetKeys2 = props.targetKeys,
        targetKeys = _props$targetKeys2 === void 0 ? [] : _props$targetKeys2;
      var leftDataSource = [];
      var rightDataSource = new Array(targetKeys.length);
      (0, _forEach["default"])(dataSource).call(dataSource, function (record) {
        if (rowKey) {
          record.key = rowKey(record);
        }
        // rightDataSource should be ordered by targetKeys
        // leftDataSource should be ordered by dataSource
        var indexOfKey = (0, _indexOf["default"])(targetKeys).call(targetKeys, record.key);
        if (indexOfKey !== -1) {
          rightDataSource[indexOfKey] = record;
        } else {
          leftDataSource.push(record);
        }
      });
      this.separatedDataSource = {
        leftDataSource: leftDataSource,
        rightDataSource: rightDataSource
      };
      return this.separatedDataSource;
    }
  }, {
    key: "handleSelectChange",
    value: function handleSelectChange(direction, holder) {
      var _this$state4 = this.state,
        sourceSelectedKeys = _this$state4.sourceSelectedKeys,
        targetSelectedKeys = _this$state4.targetSelectedKeys;
      var onSelectChange = this.props.onSelectChange;
      if (!onSelectChange) {
        return;
      }
      if (direction === 'left') {
        onSelectChange(holder, targetSelectedKeys);
      } else {
        onSelectChange(sourceSelectedKeys, holder);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "Transfer"
      }, function (Locale) {
        return _this2.renderTransfer(Locale);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      var sourceSelectedKeys = prevState.sourceSelectedKeys,
        targetSelectedKeys = prevState.targetSelectedKeys;
      if (nextProps.targetKeys !== prevProps.targetKeys || nextProps.dataSource !== prevProps.dataSource) {
        if (!nextProps.selectedKeys || !nextProps.selectedKeys.length) {
          // clear key no longer existed
          // clear checkedKeys according to targetKeys
          var dataSource = nextProps.dataSource,
            _nextProps$targetKeys = nextProps.targetKeys,
            targetKeys = _nextProps$targetKeys === void 0 ? [] : _nextProps$targetKeys;
          var newSourceSelectedKeys = [];
          var newTargetSelectedKeys = [];
          (0, _forEach["default"])(dataSource).call(dataSource, function (_ref) {
            var key = _ref.key;
            if ((0, _includes["default"])(sourceSelectedKeys).call(sourceSelectedKeys, key) && !(0, _includes["default"])(targetKeys).call(targetKeys, key)) {
              newSourceSelectedKeys.push(key);
            }
            if ((0, _includes["default"])(targetSelectedKeys).call(targetSelectedKeys, key) && (0, _includes["default"])(targetKeys).call(targetKeys, key)) {
              newTargetSelectedKeys.push(key);
            }
          });
          newState.sourceSelectedKeys = newSourceSelectedKeys;
          newState.targetSelectedKeys = newTargetSelectedKeys;
        }
      }
      if (nextProps.selectedKeys && nextProps.selectedKeys.length > 0) {
        var _context, _context2;
        var _targetKeys3 = nextProps.targetKeys || [];
        newState.sourceSelectedKeys = (0, _filter["default"])(_context = nextProps.selectedKeys).call(_context, function (key) {
          return !(0, _includes["default"])(_targetKeys3).call(_targetKeys3, key);
        });
        newState.targetSelectedKeys = (0, _filter["default"])(_context2 = nextProps.selectedKeys).call(_context2, function (key) {
          return (0, _includes["default"])(_targetKeys3).call(_targetKeys3, key);
        });
      }
      return newState;
    }
  }]);
  return Transfer;
}(React.Component); // For high-level customized Transfer @dqaria
Transfer.List = _List["default"];
Transfer.Operation = _Operation["default"];
Transfer.Search = _Search["default"];
Transfer.defaultProps = {
  mode: 'multiple',
  dataSource: [],
  render: noop,
  showSearch: false,
  operation: '>'
};
Transfer.propTypes = {
  prefixCls: PropTypes.string,
  dataSource: PropTypes.array,
  render: PropTypes.func,
  targetKeys: PropTypes.array,
  onChange: PropTypes.func,
  height: PropTypes.number,
  style: PropTypes.object,
  listStyle: PropTypes.object,
  operationStyle: PropTypes.object,
  className: PropTypes.string,
  titles: PropTypes.array,
  operations: PropTypes.array,
  operation: PropTypes.string,
  showSearch: PropTypes.bool,
  filterOption: PropTypes.func,
  searchPlaceholder: PropTypes.string,
  notFoundContent: PropTypes.node,
  body: PropTypes.func,
  footer: PropTypes.func,
  rowKey: PropTypes.func,
  lazy: PropTypes.oneOfType([PropTypes.object, PropTypes.bool])
};
(0, _reactLifecyclesCompat.polyfill)(Transfer);
var _default = Transfer;
exports["default"] = _default;