"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _rcTree = _interopRequireWildcard(require("../TreeSelect/rcTree"));
var _DirectoryTree = _interopRequireDefault(require("./DirectoryTree"));
var _classnames = _interopRequireDefault(require("classnames"));
var _openAnimation = _interopRequireDefault(require("../../utils/openAnimation"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Tree = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Tree, _React$Component);
  var _super = _createSuper(Tree);
  function Tree() {
    var _this;
    (0, _classCallCheck2["default"])(this, Tree);
    _this = _super.apply(this, arguments);
    _this.renderSwitcherIcon = function (_ref) {
      var isLeaf = _ref.isLeaf,
        expanded = _ref.expanded,
        loading = _ref.loading;
      var _this$props = _this.props,
        prefixCls = _this$props.prefixCls,
        showLine = _this$props.showLine;
      // if (loading) {
      //   return (
      //     <Icon
      //       type="load-line" spin={true}
      //       className={`${prefixCls}-switcher-loading-icon`}
      //     />
      //   );
      // }
      if (showLine) {
        if (isLeaf) {
          return /*#__PURE__*/React.createElement(_Icon["default"], {
            type: "file-line",
            className: "".concat(prefixCls, "-switcher-line-icon")
          });
        }
        return /*#__PURE__*/React.createElement(_Icon["default"], {
          type: expanded ? 'minus-square' : 'plus-square',
          className: "".concat(prefixCls, "-switcher-line-icon")
        });
      } else {
        if (isLeaf) {
          return null;
        }
        return /*#__PURE__*/React.createElement(_Icon["default"], {
          type: "down-fill",
          className: "".concat(prefixCls, "-switcher-icon")
        });
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(Tree, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var props = this.props;
      var prefixCls = props.prefixCls,
        className = props.className,
        style = props.style,
        showIcon = props.showIcon,
        required = props.required;
      var checkable = props.checkable;
      return /*#__PURE__*/React.createElement(_rcTree["default"], (0, _assign["default"])({}, props, {
        ref: function ref(node) {
          return _this2.tree = node;
        },
        className: (0, _classnames["default"])(!showIcon && "".concat(prefixCls, "-icon-hide"), className),
        checkable: checkable ? /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-checkbox-inner")
        }) : checkable,
        switcherIcon: this.renderSwitcherIcon,
        required: required,
        style: style
      }), this.props.children);
    }
  }]);
  return Tree;
}(React.Component);
exports["default"] = Tree;
Tree.TreeNode = _rcTree.TreeNode;
Tree.DirectoryTree = _DirectoryTree["default"];
Tree.defaultProps = {
  autoExpandParent: true,
  checkable: false,
  defaultExpandAll: false,
  defaultExpandParent: true,
  required: false,
  openAnimation: (0, _assign["default"])((0, _assign["default"])({}, _openAnimation["default"]), {
    appear: null
  }),
  prefixCls: 'fishd-tree',
  showIcon: false
};