"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _index = _interopRequireDefault(require("../../Spin/index"));
var _contextTypes = require("./contextTypes");
var _util = require("./util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var ICON_OPEN = 'open';
var ICON_CLOSE = 'close';
var defaultTitle = '---';
var TreeNode = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TreeNode, _React$Component);
  var _super = _createSuper(TreeNode);
  function TreeNode(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TreeNode);
    _this = _super.call(this, props);
    _this.onSelectorClick = function (e) {
      // Click trigger before select/check operation
      var onNodeClick = _this.context.rcTree.onNodeClick;
      onNodeClick(e, (0, _assertThisInitialized2["default"])(_this));
      if (_this.isSelectable()) {
        _this.onSelect(e);
      } else {
        _this.onCheck(e);
      }
    };
    _this.onSelectorDoubleClick = function (e) {
      var onNodeDoubleClick = _this.context.rcTree.onNodeDoubleClick;
      onNodeDoubleClick(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onSelect = function (e) {
      if (_this.isDisabled()) return;
      var onNodeSelect = _this.context.rcTree.onNodeSelect;
      e.preventDefault();
      onNodeSelect(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onCheck = function (e) {
      if (_this.isDisabled()) return;
      var _this$props = _this.props,
        disableCheckbox = _this$props.disableCheckbox,
        checked = _this$props.checked,
        nodeCheckable = _this$props.checkable;
      var _this$context$rcTree = _this.context.rcTree,
        checkable = _this$context$rcTree.checkable,
        onNodeCheck = _this$context$rcTree.onNodeCheck;
      if (!checkable || disableCheckbox || nodeCheckable === false) return;
      e.preventDefault();
      var targetChecked = !checked;
      onNodeCheck(e, (0, _assertThisInitialized2["default"])(_this), targetChecked);
    };
    _this.onMouseEnter = function (e) {
      var onNodeMouseEnter = _this.context.rcTree.onNodeMouseEnter;
      onNodeMouseEnter(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onMouseLeave = function (e) {
      var onNodeMouseLeave = _this.context.rcTree.onNodeMouseLeave;
      onNodeMouseLeave(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onContextMenu = function (e) {
      var onNodeContextMenu = _this.context.rcTree.onNodeContextMenu;
      onNodeContextMenu(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onDragStart = function (e) {
      var onNodeDragStart = _this.context.rcTree.onNodeDragStart;
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: true
      });
      onNodeDragStart(e, (0, _assertThisInitialized2["default"])(_this));
      try {
        // ie throw error
        // firefox-need-it
        e.dataTransfer.setData('text/plain', '');
      } catch (error) {
        // empty
      }
    };
    _this.onDragEnter = function (e) {
      var onNodeDragEnter = _this.context.rcTree.onNodeDragEnter;
      e.preventDefault();
      e.stopPropagation();
      onNodeDragEnter(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onDragOver = function (e) {
      var onNodeDragOver = _this.context.rcTree.onNodeDragOver;
      e.preventDefault();
      e.stopPropagation();
      onNodeDragOver(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onDragLeave = function (e) {
      var onNodeDragLeave = _this.context.rcTree.onNodeDragLeave;
      e.stopPropagation();
      onNodeDragLeave(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onDragEnd = function (e) {
      var onNodeDragEnd = _this.context.rcTree.onNodeDragEnd;
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: false
      });
      onNodeDragEnd(e, (0, _assertThisInitialized2["default"])(_this));
    };
    _this.onDrop = function (e) {
      var onNodeDrop = _this.context.rcTree.onNodeDrop;
      e.preventDefault();
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: false
      });
      onNodeDrop(e, (0, _assertThisInitialized2["default"])(_this));
    };
    // Disabled item still can be switch
    _this.onExpand = function (e) {
      var onNodeExpand = _this.context.rcTree.onNodeExpand;
      onNodeExpand(e, (0, _assertThisInitialized2["default"])(_this));
    };
    // Drag usage
    _this.setSelectHandle = function (node) {
      _this.selectHandle = node;
    };
    _this.getNodeChildren = function () {
      var _context;
      var children = _this.props.children;
      var originList = (0, _filter["default"])(_context = (0, _util.toArray)(children)).call(_context, function (node) {
        return node;
      });
      var targetList = (0, _util.getNodeChildren)(originList);
      if (originList.length !== targetList.length) {
        (0, _util.warnOnlyTreeNode)();
      }
      return targetList;
    };
    _this.getNodeState = function () {
      var expanded = _this.props.expanded;
      if (_this.isLeaf()) {
        return null;
      }
      return expanded ? ICON_OPEN : ICON_CLOSE;
    };
    _this.isLeaf = function () {
      var _this$props2 = _this.props,
        isLeaf = _this$props2.isLeaf,
        loaded = _this$props2.loaded;
      var loadData = _this.context.rcTree.loadData;
      var hasChildren = _this.getNodeChildren().length !== 0;
      // if (isLeaf === false) {
      //   return false;
      // }
      return isLeaf || !loadData && !hasChildren || loadData && loaded && !hasChildren;
    };
    _this.isDisabled = function () {
      var disabled = _this.props.disabled;
      var treeDisabled = _this.context.rcTree.disabled;
      // Follow the logic of Selectable
      if (disabled === false) {
        return false;
      }
      return !!(treeDisabled || disabled);
    };
    // Load data to avoid default expanded tree without data
    _this.syncLoadData = function (props) {
      var expanded = props.expanded,
        loading = props.loading,
        loaded = props.loaded;
      var _this$context$rcTree2 = _this.context.rcTree,
        loadData = _this$context$rcTree2.loadData,
        onNodeLoad = _this$context$rcTree2.onNodeLoad;
      if (loading) return;
      // read from state to avoid loadData at same time
      if (loadData && expanded && !_this.isLeaf()) {
        // We needn't reload data when has children in sync logic
        // It's only needed in node expanded
        var hasChildren = _this.getNodeChildren().length !== 0;
        if (!hasChildren && !loaded) {
          onNodeLoad((0, _assertThisInitialized2["default"])(_this));
        }
      }
    };
    // Switcher
    _this.renderSwitcher = function () {
      var _context2;
      var _this$props3 = _this.props,
        expanded = _this$props3.expanded,
        switcherIconFromProps = _this$props3.switcherIcon;
      var _this$context$rcTree3 = _this.context.rcTree,
        prefixCls = _this$context$rcTree3.prefixCls,
        switcherIconFromCtx = _this$context$rcTree3.switcherIcon;
      var switcherIcon = switcherIconFromProps || switcherIconFromCtx;
      if (_this.isLeaf()) {
        return /*#__PURE__*/_react["default"].createElement("span", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-switcher"), "".concat(prefixCls, "-switcher-noop"))
        }, typeof switcherIcon === 'function' ? /*#__PURE__*/_react["default"].createElement(switcherIcon, (0, _assign["default"])((0, _assign["default"])({}, _this.props), {
          isLeaf: true
        })) : switcherIcon);
      }
      var switcherCls = (0, _classnames["default"])("".concat(prefixCls, "-switcher"), (0, _concat["default"])(_context2 = "".concat(prefixCls, "-switcher_")).call(_context2, expanded ? ICON_OPEN : ICON_CLOSE));
      return /*#__PURE__*/_react["default"].createElement("span", {
        onClick: _this.onExpand,
        className: switcherCls
      }, typeof switcherIcon === 'function' ? /*#__PURE__*/_react["default"].createElement(switcherIcon, (0, _assign["default"])((0, _assign["default"])({}, _this.props), {
        isLeaf: false
      })) : switcherIcon);
    };
    // Checkbox
    _this.renderCheckbox = function () {
      var _this$props4 = _this.props,
        checked = _this$props4.checked,
        halfChecked = _this$props4.halfChecked,
        disableCheckbox = _this$props4.disableCheckbox,
        nodeCheckable = _this$props4.checkable;
      var _this$context$rcTree4 = _this.context.rcTree,
        prefixCls = _this$context$rcTree4.prefixCls,
        checkable = _this$context$rcTree4.checkable;
      var disabled = _this.isDisabled();
      if (!checkable || nodeCheckable === false) return null;
      // [Legacy] Custom element should be separate with `checkable` in future
      var $custom = typeof checkable !== 'boolean' ? checkable : null;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: (0, _classnames["default"])("".concat(prefixCls, "-checkbox"), checked && "".concat(prefixCls, "-checkbox-checked"), halfChecked && "".concat(prefixCls, "-checkbox-indeterminate"), (disabled || disableCheckbox) && "".concat(prefixCls, "-checkbox-disabled")),
        onClick: _this.onCheck
      }, $custom);
    };
    _this.renderIcon = function () {
      var _this$props5 = _this.props,
        loading = _this$props5.loading,
        icon = _this$props5.icon;
      var _this$context$rcTree5 = _this.context.rcTree,
        prefixCls = _this$context$rcTree5.prefixCls,
        showIcon = _this$context$rcTree5.showIcon,
        treeIcon = _this$context$rcTree5.icon,
        loadData = _this$context$rcTree5.loadData;
      var currentIcon = icon || treeIcon;
      var customIcon = null,
        loadingIcon = null;
      if (showIcon && currentIcon) {
        customIcon = /*#__PURE__*/_react["default"].createElement("span", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-iconEle"), "".concat(prefixCls, "-icon__customize"))
        }, typeof currentIcon === 'function' ? /*#__PURE__*/_react["default"].createElement(currentIcon, (0, _assign["default"])({}, _this.props)) : currentIcon);
      }
      if (loadData && loading) {
        loadingIcon = /*#__PURE__*/_react["default"].createElement(_index["default"], {
          className: prefixCls + '-spinning',
          size: "small"
        });
      }
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-iconCtner")
      }, loadingIcon, customIcon);
      /* 废弃的 loading icon
      return (
        <span
          className={classNames(
            `${prefixCls}-iconEle`,
            `${prefixCls}-icon__${this.getNodeState() || 'docu'}`,
            loading && `${prefixCls}-icon_loading`,
          )}
        />
      );
      */
    };
    // Icon + Title
    _this.renderSelector = function () {
      var _context3;
      var dragNodeHighlight = _this.state.dragNodeHighlight;
      var _this$props6 = _this.props,
        title = _this$props6.title,
        selected = _this$props6.selected;
      var _this$context$rcTree6 = _this.context.rcTree,
        prefixCls = _this$context$rcTree6.prefixCls,
        draggable = _this$context$rcTree6.draggable;
      var disabled = _this.isDisabled();
      var wrapClass = "".concat(prefixCls, "-node-content-wrapper");
      var $icon = _this.renderIcon();
      var $title = /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(prefixCls, "-title")
      }, title);
      return /*#__PURE__*/_react["default"].createElement("span", {
        ref: _this.setSelectHandle,
        title: typeof title === 'string' ? title : '',
        className: (0, _classnames["default"])("".concat(wrapClass), (0, _concat["default"])(_context3 = "".concat(wrapClass, "-")).call(_context3, _this.getNodeState() || 'normal'), !disabled && (selected || dragNodeHighlight) && "".concat(prefixCls, "-node-selected"), !disabled && draggable && 'draggable'),
        draggable: !disabled && draggable || undefined,
        "aria-grabbed": !disabled && draggable || undefined,
        onMouseEnter: _this.onMouseEnter,
        onMouseLeave: _this.onMouseLeave,
        onContextMenu: _this.onContextMenu,
        onClick: _this.onSelectorClick,
        onDoubleClick: _this.onSelectorDoubleClick,
        onDragStart: draggable ? _this.onDragStart : undefined
      }, $icon, $title);
    };
    // Children list wrapped with `Animation`
    _this.renderChildren = function () {
      var _this$props7 = _this.props,
        expanded = _this$props7.expanded,
        pos = _this$props7.pos;
      var _this$context$rcTree7 = _this.context.rcTree,
        prefixCls = _this$context$rcTree7.prefixCls,
        openTransitionName = _this$context$rcTree7.openTransitionName,
        openAnimation = _this$context$rcTree7.openAnimation,
        renderTreeNode = _this$context$rcTree7.renderTreeNode;
      var animProps = {};
      if (openTransitionName) {
        animProps.transitionName = openTransitionName;
      } else if ((0, _typeof2["default"])(openAnimation) === 'object') {
        animProps.animation = (0, _assign["default"])({}, openAnimation);
      }
      // Children TreeNode
      var nodeList = _this.getNodeChildren();
      if (nodeList.length === 0) {
        return null;
      }
      var $children;
      if (expanded) {
        $children = /*#__PURE__*/_react["default"].createElement("ul", {
          className: (0, _classnames["default"])("".concat(prefixCls, "-child-tree"), expanded && "".concat(prefixCls, "-child-tree-open")),
          "data-expanded": expanded,
          role: "group"
        }, (0, _util.mapChildren)(nodeList, function (node, index) {
          return renderTreeNode(node, index, pos);
        }));
      }
      return /*#__PURE__*/_react["default"].createElement(_rcAnimate["default"], (0, _assign["default"])({}, animProps, {
        showProp: "data-expanded",
        component: ""
      }), $children);
    };
    _this.state = {
      dragNodeHighlight: false
    };
    return _this;
  }
  (0, _createClass2["default"])(TreeNode, [{
    key: "getChildContext",
    value: function getChildContext() {
      return (0, _assign["default"])((0, _assign["default"])({}, this.context), {
        rcTreeNode: {
          // onUpCheckConduct: this.onUpCheckConduct,
        }
      });
    }
    // Isomorphic needn't load data in server side
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.syncLoadData(this.props);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.syncLoadData(this.props);
    }
  }, {
    key: "isSelectable",
    value: function isSelectable() {
      var selectable = this.props.selectable;
      var treeSelectable = this.context.rcTree.selectable;
      // Ignore when selectable is undefined or null
      if (typeof selectable === 'boolean') {
        return selectable;
      }
      return treeSelectable;
    }
  }, {
    key: "render",
    value: function render() {
      var _context4, _classNames;
      var loading = this.props.loading;
      var _a = this.props,
        className = _a.className,
        style = _a.style,
        dragOver = _a.dragOver,
        dragOverGapTop = _a.dragOverGapTop,
        dragOverGapBottom = _a.dragOverGapBottom,
        isLeaf = _a.isLeaf,
        expanded = _a.expanded,
        selected = _a.selected,
        checked = _a.checked,
        halfChecked = _a.halfChecked,
        otherProps = __rest(_a, ["className", "style", "dragOver", "dragOverGapTop", "dragOverGapBottom", "isLeaf", "expanded", "selected", "checked", "halfChecked"]);
      var _this$context$rcTree8 = this.context.rcTree,
        prefixCls = _this$context$rcTree8.prefixCls,
        filterTreeNode = _this$context$rcTree8.filterTreeNode,
        draggable = _this$context$rcTree8.draggable;
      var disabled = this.isDisabled();
      var dataOrAriaAttributeProps = (0, _util.getDataAndAria)(otherProps);
      return /*#__PURE__*/_react["default"].createElement("li", (0, _assign["default"])({
        className: (0, _classnames["default"])(className, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-treenode-disabled"), disabled), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context4 = "".concat(prefixCls, "-treenode-switcher-")).call(_context4, expanded ? 'open' : 'close'), !isLeaf), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-treenode-checkbox-checked"), checked), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-treenode-checkbox-indeterminate"), halfChecked), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-treenode-selected"), selected), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-treenode-loading"), loading), (0, _defineProperty2["default"])(_classNames, 'drag-over', !disabled && dragOver), (0, _defineProperty2["default"])(_classNames, 'drag-over-gap-top', !disabled && dragOverGapTop), (0, _defineProperty2["default"])(_classNames, 'drag-over-gap-bottom', !disabled && dragOverGapBottom), (0, _defineProperty2["default"])(_classNames, 'filter-node', filterTreeNode && filterTreeNode(this)), _classNames)),
        style: style,
        role: "treeitem",
        onDragEnter: draggable ? this.onDragEnter : undefined,
        onDragOver: draggable ? this.onDragOver : undefined,
        onDragLeave: draggable ? this.onDragLeave : undefined,
        onDrop: draggable ? this.onDrop : undefined,
        onDragEnd: draggable ? this.onDragEnd : undefined
      }, dataOrAriaAttributeProps), this.renderSwitcher(), this.renderCheckbox(), this.renderSelector(), this.renderChildren());
    }
  }]);
  return TreeNode;
}(_react["default"].Component);
TreeNode.propTypes = {
  eventKey: _propTypes["default"].string,
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  root: _propTypes["default"].object,
  onSelect: _propTypes["default"].func,
  // By parent
  expanded: _propTypes["default"].bool,
  selected: _propTypes["default"].bool,
  checked: _propTypes["default"].bool,
  loaded: _propTypes["default"].bool,
  loading: _propTypes["default"].bool,
  halfChecked: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  title: _propTypes["default"].node,
  pos: _propTypes["default"].string,
  dragOver: _propTypes["default"].bool,
  dragOverGapTop: _propTypes["default"].bool,
  dragOverGapBottom: _propTypes["default"].bool,
  // By user
  isLeaf: _propTypes["default"].bool,
  selectable: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  checkable: _propTypes["default"].bool,
  disableCheckbox: _propTypes["default"].bool,
  icon: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  switcherIcon: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func])
};
TreeNode.contextTypes = _contextTypes.nodeContextTypes;
TreeNode.childContextTypes = _contextTypes.nodeContextTypes;
TreeNode.defaultProps = {
  title: defaultTitle
};
TreeNode.isTreeNode = 1;
(0, _reactLifecyclesCompat.polyfill)(TreeNode);
var _default = TreeNode;
exports["default"] = _default;