"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.multipleSelectorContextTypes = exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _set = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _BaseSelector = _interopRequireWildcard(require("../../Base/BaseSelector"));
var _Selection = _interopRequireDefault(require("./Selection"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TREE_SELECT_EMPTY_VALUE_KEY = 'RC_TREE_SELECT_EMPTY_VALUE_KEY';
var Selector = (0, _BaseSelector["default"])('multiple');
var multipleSelectorContextTypes = {
  onMultipleSelectorRemove: _propTypes["default"].func.isRequired
};
exports.multipleSelectorContextTypes = multipleSelectorContextTypes;
var MultipleSelector = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(MultipleSelector, _React$Component);
  var _super = _createSuper(MultipleSelector);
  function MultipleSelector() {
    var _this;
    (0, _classCallCheck2["default"])(this, MultipleSelector);
    _this = _super.call(this);
    // onPlaceholderClick = () => {
    //   this.inputRef.current.focus();
    // };
    // focus = () => {
    //   this.inputRef.current.focus();
    // };
    // blur = () => {
    //   this.inputRef.current.blur();
    // };
    _this.renderPlaceholder = function () {
      var _this$props = _this.props,
        prefixCls = _this$props.prefixCls,
        placeholder = _this$props.placeholder,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        selectorValueList = _this$props.selectorValueList;
      var currentPlaceholder = placeholder || searchPlaceholder;
      if (!currentPlaceholder) return null;
      // const hidden = searchValue || selectorValueList.length;
      var hidden = selectorValueList.length;
      // [Legacy] Not remove the placeholder
      return /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          display: hidden ? 'none' : 'block'
        },
        onClick: _this.onPlaceholderClick,
        className: "".concat(prefixCls, "-search__field__placeholder")
      }, currentPlaceholder);
    };
    _this.renderSelection = function () {
      var _classNames;
      var _this$props2 = _this.props,
        selectorValueList = _this$props2.selectorValueList,
        choiceTransitionName = _this$props2.choiceTransitionName,
        prefixCls = _this$props2.prefixCls,
        onChoiceAnimationLeave = _this$props2.onChoiceAnimationLeave,
        labelInValue = _this$props2.labelInValue,
        maxTagCount = _this$props2.maxTagCount,
        maxTagPlaceholder = _this$props2.maxTagPlaceholder,
        editable = _this$props2.editable,
        uniqueTreeNodeByLabel = _this$props2.uniqueTreeNodeByLabel;
      var onMultipleSelectorRemove = _this.context.rcTreeSelect.onMultipleSelectorRemove;
      // Check if `maxTagCount` is set
      var myValueList = selectorValueList;
      if (maxTagCount >= 0) {
        myValueList = (0, _slice["default"])(selectorValueList).call(selectorValueList, 0, maxTagCount);
      }
      // Selector node list
      var selectedValueNodes = (0, _map["default"])(myValueList).call(myValueList, function (_ref) {
        var label = _ref.label,
          value = _ref.value;
        return /*#__PURE__*/_react["default"].createElement(_Selection["default"], (0, _assign["default"])({}, _this.props, {
          key: value || TREE_SELECT_EMPTY_VALUE_KEY,
          label: label,
          value: value,
          onRemove: onMultipleSelectorRemove
        }));
      });
      // Rest node count
      if (maxTagCount >= 0 && maxTagCount < selectorValueList.length) {
        var content = "+ ".concat(selectorValueList.length - maxTagCount, " ...");
        if (typeof maxTagPlaceholder === 'string') {
          content = maxTagPlaceholder;
        } else if (typeof maxTagPlaceholder === 'function') {
          var restValueList = (0, _slice["default"])(selectorValueList).call(selectorValueList, maxTagCount);
          content = maxTagPlaceholder(labelInValue ? restValueList : (0, _map["default"])(restValueList).call(restValueList, function (_ref2) {
            var value = _ref2.value;
            return value;
          }));
        }
        var restNodeSelect = /*#__PURE__*/_react["default"].createElement(_Selection["default"], (0, _assign["default"])({}, _this.props, {
          key: "rc-tree-select-internal-max-tag-counter",
          label: content,
          value: null
        }));
        selectedValueNodes.push(restNodeSelect);
      }
      // selectedValueNodes.push(
      //   <li className={`${prefixCls}-search ${prefixCls}-search--inline`} key="__input">
      //     <SearchInput {...this.props} ref={this.inputRef} needAlign />
      //   </li>
      // );
      // 处理不可编辑的多选
      if (!editable) {
        var labelList = (0, _map["default"])(selectedValueNodes).call(selectedValueNodes, function (item) {
          return item.props.label;
        });
        // 相同 label 去重
        uniqueTreeNodeByLabel && (labelList = (0, _toConsumableArray2["default"])(new _set["default"](labelList)));
        selectedValueNodes = (0, _filter["default"])(labelList).call(labelList, function (item) {
          return item != undefined;
        }).join('、');
      }
      // const className = `${prefixCls}-selection__rendered`;
      var className = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-selection__rendered"), true), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-multiple-readonly"), !editable), _classNames), className);
      if (choiceTransitionName && editable) {
        return /*#__PURE__*/_react["default"].createElement(_rcAnimate["default"], {
          className: className,
          component: "ul",
          transitionName: choiceTransitionName,
          onLeave: onChoiceAnimationLeave
        }, selectedValueNodes);
      }
      return /*#__PURE__*/_react["default"].createElement("ul", {
        className: className,
        role: "menubar",
        title: !editable ? selectedValueNodes : null
      }, selectedValueNodes);
    };
    // this.inputRef = createRef();
    return _this;
  }
  (0, _createClass2["default"])(MultipleSelector, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement(Selector, (0, _assign["default"])({}, this.props, {
        tabIndex: -1,
        showArrow: !this.props.editable,
        renderSelection: this.renderSelection,
        renderPlaceholder: this.renderPlaceholder
      }));
    }
  }]);
  return MultipleSelector;
}(_react["default"].Component);
MultipleSelector.propTypes = (0, _assign["default"])((0, _assign["default"])({}, _BaseSelector.selectorPropTypes), {
  selectorValueList: _propTypes["default"].array,
  disabled: _propTypes["default"].bool,
  disableCloseTag: _propTypes["default"].bool,
  editable: _propTypes["default"].bool,
  searchValue: _propTypes["default"].string,
  labelInValue: _propTypes["default"].bool,
  maxTagCount: _propTypes["default"].number,
  maxTagPlaceholder: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]),
  tagWidth: _propTypes["default"].number,
  onChoiceAnimationLeave: _propTypes["default"].func
});
MultipleSelector.contextTypes = {
  rcTreeSelect: _propTypes["default"].shape((0, _assign["default"])((0, _assign["default"])({}, multipleSelectorContextTypes), {
    onSearchInputChange: _propTypes["default"].func
  }))
};
var _default = MultipleSelector;
exports["default"] = _default;