"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _video = _interopRequireDefault(require("video.js"));
require("./component/vjsDownLoad");
require("./component/vjsFullScreen");
require("./component/vjsVolume");
require("./component/vjsPlay");
require("./component/vjsErrorDisplay");
var _zhCN = require("./lang/zh-CN");
var _KeyCode = _interopRequireDefault(require("../../utils/KeyCode"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
_video["default"].addLanguage('zh-CN', _zhCN.zh_CN);
var VideoViewer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(VideoViewer, _React$Component);
  var _super = _createSuper(VideoViewer);
  function VideoViewer(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, VideoViewer);
    _this = _super.call(this, props);
    _this.getVideoPlayer = function () {
      return _this.player;
    };
    // 空格键控制 暂停、播放
    _this.handleSpaceKeyDown = function (e) {
      if (e.which === _KeyCode["default"].SPACE) {
        e.preventDefault();
        if (_this.player) {
          if (_this.player.paused()) {
            _this.player.play();
          } else {
            _this.player.pause();
          }
        }
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(VideoViewer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _a = this.props,
        download = _a.download,
        bigPlayButton = _a.bigPlayButton,
        otherProps = __rest(_a, ["download", "bigPlayButton"]);
      var initOptions = {
        //aspectRatio: '16:9',
        //autoSetup: false,
        //fluid: true,
        //inactivityTimeout: 3000,
        //liveui: true,
        //notSupportedMessage: '',
        //responsive: true,
        loadingSpinner: true,
        bigPlayButton: bigPlayButton,
        controlBar: {
          children: [{
            name: 'progressControl'
          }, {
            name: 'vjsPlay'
          }, {
            name: 'currentTimeDisplay'
          }, {
            name: 'timeDivider'
          }, {
            name: 'durationDisplay'
          }, {
            name: 'vjsFullScreen'
          }, {
            name: download ? 'vjsDownLoad' : ''
          }, {
            name: 'vjsVolume'
          }]
        },
        errorDisplay: {
          children: [{
            name: 'vjsErrorDisplay'
          }]
        }
      };
      var option = (0, _assign["default"])({}, initOptions, otherProps);
      // instantiate video.js
      this.player = (0, _video["default"])(this.videoNode, option, function () {
        _this2.player.on('timeupdate', function (e) {
          // 控制焦点
          _this2.videoPlayerRef.focus();
        });
      });
    }
    // destroy player on unmount
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.player) {
        this.player.dispose();
      }
    }
    // wrap the player in a div with a `data-vjs-player` attribute
    // so videojs won't create additional wrapper in the DOM
    // see https://github.com/videojs/ video.js /pull/3856
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className;
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-wrap")
      }, /*#__PURE__*/React.createElement("div", {
        "data-vjs-player": true,
        ref: function ref(node) {
          return _this3.videoPlayerRef = node;
        },
        onKeyDown: this.handleSpaceKeyDown
      }, /*#__PURE__*/React.createElement("video", {
        ref: function ref(node) {
          return _this3.videoNode = node;
        },
        className: className
      })));
    }
  }]);
  return VideoViewer;
}(React.Component);
exports["default"] = VideoViewer;
VideoViewer.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  height: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  poster: _propTypes["default"].string,
  sources: _propTypes["default"].array,
  autoplay: _propTypes["default"].bool,
  loop: _propTypes["default"].bool,
  muted: _propTypes["default"].bool,
  preload: _propTypes["default"].oneOf(['auto', 'none', 'metadata']),
  controls: _propTypes["default"].bool,
  download: _propTypes["default"].bool,
  bigPlayButton: _propTypes["default"].bool
};
VideoViewer.defaultProps = {
  prefixCls: 'fishd-video-js',
  className: 'video-js',
  width: 640,
  height: 360,
  poster: '',
  sources: [],
  autoplay: false,
  loop: false,
  muted: false,
  preload: 'auto',
  controls: true,
  download: false,
  bigPlayButton: true // 是否显示大按钮
};