import * as React from 'react';
import { FishdAnchor } from './Anchor';
export interface AnchorLinkProps {
    prefixCls?: string;
    href: string;
    title: React.ReactNode;
    children?: any;
}
export default class AnchorLink extends React.Component<AnchorLinkProps, any> {
    static defaultProps: {
        prefixCls: string;
        href: string;
    };
    static contextTypes: {
        fishdAnchor: any;
    };
    context: {
        fishdAnchor: FishdAnchor;
    };
    componentDidMount(): void;
    componentDidUpdate(prevProps: AnchorLinkProps): void;
    componentWillUnmount(): void;
    handleClick: (e: React.MouseEvent<HTMLElement>) => void;
    render(): JSX.Element;
}
