import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import { Option, OptGroup } from './src/index.js';
import Select from './Select';
import classNames from 'classnames';
import Input from '../Input';
import InputElement from './InputElement';
import './style/index.less';
function isSelectOptionOrSelectOptGroup(child) {
  return child && child.type && (child.type.isSelectOption || child.type.isSelectOptGroup);
}
var AutoComplete = /*#__PURE__*/function (_React$Component) {
  _inherits(AutoComplete, _React$Component);
  var _super = _createSuper(AutoComplete);
  function AutoComplete() {
    var _this;
    _classCallCheck(this, AutoComplete);
    _this = _super.apply(this, arguments);
    _this.getInputElement = function () {
      var children = _this.props.children;
      var element = children && /*#__PURE__*/React.isValidElement(children) && children.type !== Option ? React.Children.only(_this.props.children) : /*#__PURE__*/React.createElement(Input, null);
      var elementProps = _Object$assign({}, element.props);
      // https://github.com/ant-design/ant-design/pull/7742
      delete elementProps.children;
      return /*#__PURE__*/React.createElement(InputElement, _Object$assign({}, elementProps), element);
    };
    _this.saveSelect = function (node) {
      _this.select = node;
    };
    return _this;
  }
  _createClass(AutoComplete, [{
    key: "focus",
    value: function focus() {
      this.select.focus();
    }
  }, {
    key: "blur",
    value: function blur() {
      this.select.blur();
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props = this.props,
        size = _this$props.size,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        notFoundContent = _this$props.notFoundContent,
        prefixCls = _this$props.prefixCls,
        optionLabelProp = _this$props.optionLabelProp,
        dataSource = _this$props.dataSource,
        children = _this$props.children,
        highlightSelected = _this$props.highlightSelected;
      var cls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-lg"), size === 'large'), _defineProperty(_classNames, "".concat(prefixCls, "-sm"), size === 'small'), _defineProperty(_classNames, className, !!className), _defineProperty(_classNames, "".concat(prefixCls, "-show-search"), true), _defineProperty(_classNames, "".concat(prefixCls, "-auto-complete"), true), _classNames));
      var options;
      var childArray = React.Children.toArray(children);
      if (childArray.length && isSelectOptionOrSelectOptGroup(childArray[0])) {
        options = children;
      } else {
        options = dataSource ? _mapInstanceProperty(dataSource).call(dataSource, function (item) {
          if ( /*#__PURE__*/React.isValidElement(item)) {
            return item;
          }
          switch (_typeof(item)) {
            case 'string':
              return /*#__PURE__*/React.createElement(Option, {
                key: item
              }, item);
            case 'object':
              return /*#__PURE__*/React.createElement(Option, {
                key: item.value
              }, item.text);
            default:
              throw new Error('AutoComplete[dataSource] only supports type `string[] | Object[]`.');
          }
        }) : [];
      }
      return /*#__PURE__*/React.createElement(Select, _Object$assign({}, this.props, {
        className: cls,
        dropdownClassName: highlightSelected ? null : "".concat(prefixCls, "-nohighlight"),
        mode: Select.SECRET_COMBOBOX_MODE_DO_NOT_USE,
        optionLabelProp: optionLabelProp,
        getInputElement: this.getInputElement,
        notFoundContent: notFoundContent,
        ref: this.saveSelect
      }), options);
    }
  }]);
  return AutoComplete;
}(React.Component);
export { AutoComplete as default };
AutoComplete.Option = Option;
AutoComplete.OptGroup = OptGroup;
AutoComplete.defaultProps = {
  prefixCls: 'fishd-autocomplete-select',
  transitionName: 'slide-up',
  optionLabelProp: 'children',
  choiceTransitionName: 'zoom',
  showSearch: false,
  filterOption: false,
  highlightSelected: true
};