import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import Animate from 'rc-animate';
import ScrollNumber from './ScrollNumber';
import classNames from 'classnames';
var Badge = /*#__PURE__*/function (_React$Component) {
  _inherits(Badge, _React$Component);
  var _super = _createSuper(Badge);
  function Badge() {
    _classCallCheck(this, Badge);
    return _super.apply(this, arguments);
  }
  _createClass(Badge, [{
    key: "render",
    value: function render() {
      var _context, _classNames, _context2, _classNames2, _classNames3;
      var _a = this.props,
        count = _a.count,
        showZero = _a.showZero,
        prefixCls = _a.prefixCls,
        scrollNumberPrefixCls = _a.scrollNumberPrefixCls,
        overflowCount = _a.overflowCount,
        overflowType = _a.overflowType,
        className = _a.className,
        style = _a.style,
        children = _a.children,
        dot = _a.dot,
        status = _a.status,
        text = _a.text,
        offset = _a.offset,
        title = _a.title,
        restProps = __rest(_a, ["count", "showZero", "prefixCls", "scrollNumberPrefixCls", "overflowCount", "overflowType", "className", "style", "children", "dot", "status", "text", "offset", "title"]);
      var displayCount = count > overflowCount ? overflowType === 'plus' ? "".concat(overflowCount, "+") : '...' : count;
      var isZero = displayCount === '0' || displayCount === 0;
      var isDot = dot && !isZero || status;
      // dot mode don't need count
      if (isDot) {
        displayCount = '';
      }
      var isEmpty = displayCount === null || displayCount === undefined || displayCount === '';
      var hidden = (isEmpty || isZero && !showZero) && !isDot;
      var statusCls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-status-dot"), !!status), _defineProperty(_classNames, _concatInstanceProperty(_context = "".concat(prefixCls, "-status-")).call(_context, status), !!status), _classNames));
      var scrollNumberCls = classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-dot"), isDot), _defineProperty(_classNames2, "".concat(prefixCls, "-count"), !isDot), _defineProperty(_classNames2, "".concat(prefixCls, "-multiple-words"), !isDot && count && count.toString && count.toString().length > 1), _defineProperty(_classNames2, _concatInstanceProperty(_context2 = "".concat(prefixCls, "-status-")).call(_context2, status), !!status), _classNames2));
      var badgeCls = classNames(className, prefixCls, (_classNames3 = {}, _defineProperty(_classNames3, "".concat(prefixCls, "-status"), !!status), _defineProperty(_classNames3, "".concat(prefixCls, "-not-a-wrapper"), !children), _classNames3));
      var styleWithOffset = offset ? _Object$assign({
        marginLeft: offset[0],
        marginTop: offset[1]
      }, style) : style;
      // <Badge status="success" />
      if (!children && status) {
        return /*#__PURE__*/React.createElement("span", _Object$assign({}, restProps, {
          className: badgeCls,
          style: styleWithOffset
        }), /*#__PURE__*/React.createElement("span", {
          className: statusCls
        }), /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-status-text")
        }, text));
      }
      var scrollNumber = hidden ? null : /*#__PURE__*/React.createElement(ScrollNumber, {
        prefixCls: scrollNumberPrefixCls,
        "data-show": !hidden,
        className: scrollNumberCls,
        count: displayCount,
        title: title || count,
        style: styleWithOffset,
        key: "scrollNumber"
      });
      var statusText = hidden || !text ? null : /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-status-text")
      }, text);
      return /*#__PURE__*/React.createElement("span", _Object$assign({}, restProps, {
        className: badgeCls
      }), children, /*#__PURE__*/React.createElement(Animate, {
        component: "",
        showProp: "data-show",
        transitionName: children ? "".concat(prefixCls, "-zoom") : '',
        transitionAppear: true
      }, scrollNumber), statusText);
    }
  }]);
  return Badge;
}(React.Component);
export { Badge as default };
Badge.defaultProps = {
  prefixCls: 'fishd-badge',
  scrollNumberPrefixCls: 'fishd-scroll-number',
  count: null,
  showZero: false,
  dot: false,
  overflowCount: 99,
  overflowType: 'plus'
};
Badge.propTypes = {
  count: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  showZero: PropTypes.bool,
  dot: PropTypes.bool,
  overflowCount: PropTypes.number
};