import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _reverseInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reverse";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import { createElement, Component } from 'react';
import omit from 'omit.js';
import { polyfill } from 'react-lifecycles-compat';
import classNames from 'classnames';
function getNumberArray(num) {
  var _context, _context2;
  return num ? _mapInstanceProperty(_context = _reverseInstanceProperty(_context2 = num.toString().split('')).call(_context2)).call(_context, function (i) {
    return Number(i);
  }) : [];
}
var ScrollNumber = /*#__PURE__*/function (_Component) {
  _inherits(ScrollNumber, _Component);
  var _super = _createSuper(ScrollNumber);
  function ScrollNumber(props) {
    var _this;
    _classCallCheck(this, ScrollNumber);
    _this = _super.call(this, props);
    _this.state = {
      prevProps: props,
      animateStarted: false,
      count: props.count,
      lastCount: props.count,
      nextCount: undefined
    };
    return _this;
  }
  _createClass(ScrollNumber, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;
      if ('count' in this.props) {
        if (prevState.animateStarted === false && this.state.animateStarted === true) {
          _setTimeout(function () {
            _this2.setState({
              animateStarted: false,
              count: _this2.state.nextCount
            }, function () {
              var onAnimated = _this2.props.onAnimated;
              if (onAnimated) {
                onAnimated();
              }
            });
          }, 5);
        }
      }
    }
  }, {
    key: "getPositionByNum",
    value: function getPositionByNum(num, i) {
      if (this.state.animateStarted) {
        return 10 + num;
      }
      var currentDigit = getNumberArray(this.state.count)[i];
      var lastDigit = getNumberArray(this.state.lastCount)[i];
      // 同方向则在同一侧切换数字
      if (this.state.count > this.state.lastCount) {
        if (currentDigit >= lastDigit) {
          return 10 + num;
        }
        return 20 + num;
      }
      if (currentDigit <= lastDigit) {
        return 10 + num;
      }
      return num;
    }
  }, {
    key: "renderNumberList",
    value: function renderNumberList(position) {
      var childrenToReturn = [];
      for (var i = 0; i < 30; i++) {
        var currentClassName = position === i ? 'current' : '';
        childrenToReturn.push( /*#__PURE__*/React.createElement("p", {
          key: i.toString(),
          className: currentClassName
        }, i % 10));
      }
      return childrenToReturn;
    }
  }, {
    key: "renderCurrentNumber",
    value: function renderCurrentNumber(num, i) {
      var position = this.getPositionByNum(num, i);
      var removeTransition = this.state.animateStarted || getNumberArray(this.state.lastCount)[i] === undefined;
      return /*#__PURE__*/createElement('span', {
        className: "".concat(this.props.prefixCls, "-only"),
        style: {
          transition: removeTransition ? 'none' : undefined,
          msTransform: "translateY(".concat(-position * 100, "%)"),
          WebkitTransform: "translateY(".concat(-position * 100, "%)"),
          transform: "translateY(".concat(-position * 100, "%)")
        },
        key: i
      }, this.renderNumberList(position));
    }
  }, {
    key: "renderNumberElement",
    value: function renderNumberElement() {
      var _context3,
        _context4,
        _this3 = this;
      var state = this.state;
      if (!state.count || isNaN(state.count)) {
        return state.count;
      }
      return _reverseInstanceProperty(_context3 = _mapInstanceProperty(_context4 = getNumberArray(state.count)).call(_context4, function (num, i) {
        return _this3.renderCurrentNumber(num, i);
      })).call(_context3);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        style = _this$props.style,
        title = _this$props.title,
        _this$props$component = _this$props.component,
        component = _this$props$component === void 0 ? 'sup' : _this$props$component;
      // fix https://fb.me/react-unknown-prop
      var restProps = omit(this.props, ['count', 'onAnimated', 'component', 'prefixCls']);
      var newProps = _Object$assign(_Object$assign({}, restProps), {
        className: classNames(prefixCls, className),
        title: title
      });
      // allow specify the border
      // mock border-color by box-shadow for compatible with old usage:
      // <Badge count={4} style={{ backgroundColor: '#fff', color: '#999', borderColor: '#d9d9d9' }} />
      if (style && style.borderColor) {
        newProps.style.boxShadow = "0 0 0 1px ".concat(style.borderColor, " inset");
      }
      return /*#__PURE__*/createElement(component, newProps, this.renderNumberElement());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {
        prevProps: nextProps
      };
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      if ('count' in nextProps) {
        if (prevProps.count === nextProps.count) {
          return newState;
        }
        return _Object$assign(_Object$assign({}, newState), {
          animateStarted: true,
          lastCount: prevProps.count,
          nextCount: nextProps.count
        });
      }
    }
  }]);
  return ScrollNumber;
}(Component);
ScrollNumber.defaultProps = {
  prefixCls: 'fishd-scroll-number',
  count: null,
  onAnimated: function onAnimated() {}
};
polyfill(ScrollNumber);
export default ScrollNumber;