import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import PropTypes from 'prop-types';
var BreadcrumbItem = /*#__PURE__*/function (_React$Component) {
  _inherits(BreadcrumbItem, _React$Component);
  var _super = _createSuper(BreadcrumbItem);
  function BreadcrumbItem() {
    _classCallCheck(this, BreadcrumbItem);
    return _super.apply(this, arguments);
  }
  _createClass(BreadcrumbItem, [{
    key: "render",
    value: function render() {
      var _a = this.props,
        prefixCls = _a.prefixCls,
        separator = _a.separator,
        children = _a.children,
        maxWidth = _a.maxWidth,
        restProps = __rest(_a, ["prefixCls", "separator", "children", "maxWidth"]);
      var link = null;
      if ('href' in this.props) {
        link = /*#__PURE__*/React.createElement("a", _Object$assign({
          className: "".concat(prefixCls, "-link"),
          style: maxWidth != undefined ? {
            maxWidth: maxWidth
          } : null
        }, restProps), children);
      } else {
        link = /*#__PURE__*/React.createElement("span", _Object$assign({
          className: "".concat(prefixCls, "-link"),
          style: maxWidth != undefined ? {
            maxWidth: maxWidth
          } : null
        }, restProps), children);
      }
      if (children) {
        return /*#__PURE__*/React.createElement("span", null, link, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-separator")
        }, separator));
      }
      return null;
    }
  }]);
  return BreadcrumbItem;
}(React.Component);
export { BreadcrumbItem as default };
BreadcrumbItem.__FISHD_BREADCRUMB_ITEM = true;
BreadcrumbItem.defaultProps = {
  prefixCls: 'fishd-breadcrumb',
  separator: '/'
};
BreadcrumbItem.propTypes = {
  prefixCls: PropTypes.string,
  separator: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),
  href: PropTypes.string,
  maxWidth: PropTypes.number
};