import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/* eslint-disable @typescript-eslint/no-var-requires */
import * as React from 'react';
import { findDOMNode } from 'react-dom';
import debounce from 'lodash/debounce';
import classNames from 'classnames';
// matchMedia polyfill for
// https://github.com/WickyNilliams/enquire.js/issues/82
if (typeof window !== 'undefined') {
  var matchMediaPolyfill = function matchMediaPolyfill(mediaQuery) {
    return {
      media: mediaQuery,
      matches: false,
      addListener: function addListener() {},
      removeListener: function removeListener() {}
    };
  };
  window.matchMedia = window.matchMedia || matchMediaPolyfill;
}
// Use require over import (will be lifted up)
// make sure matchMedia polyfill run before require('react-slick')
// Fix https://github.com/ant-design/ant-design/issues/6560
// Fix https://github.com/ant-design/ant-design/issues/3308
var SlickCarousel = require('react-slick')["default"];
function CustomArrow(props) {
  var className = props.className,
    style = props.style,
    onClick = props.onClick;
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    style: _Object$assign(_Object$assign({}, style), {
      display: 'flex'
    }),
    onClick: onClick
  });
}
var Carousel = /*#__PURE__*/function (_React$Component) {
  _inherits(Carousel, _React$Component);
  var _super = _createSuper(Carousel);
  function Carousel(props) {
    var _this;
    _classCallCheck(this, Carousel);
    _this = _super.call(this, props);
    _this.onWindowResized = function () {
      // Fix https://github.com/ant-design/ant-design/issues/2550
      var autoplay = _this.props.autoplay;
      if (autoplay && _this.slick && _this.slick.innerSlider && _this.slick.innerSlider.autoPlay) {
        _this.slick.innerSlider.autoPlay();
      }
    };
    _this.saveSlick = function (node) {
      _this.slick = node;
    };
    _this.onWindowResized = debounce(_this.onWindowResized, 500, {
      leading: false
    });
    return _this;
  }
  _createClass(Carousel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props = this.props,
        autoplay = _this$props.autoplay,
        autoplaySpeed = _this$props.autoplaySpeed,
        dotsPosition = _this$props.dotsPosition,
        dotsTimer = _this$props.dotsTimer;
      if (autoplay) {
        window.addEventListener('resize', this.onWindowResized);
      }
      // https://github.com/ant-design/ant-design/issues/7191
      this.innerSlider = this.slick && this.slick.innerSlider;
      this.slickDOM = findDOMNode(this.slick);
      if (autoplay && dotsTimer) {
        var _context;
        var aniName = dotsPosition == 'left' || dotsPosition == 'right' ? 'dotsAniVertical' : 'dotsAni',
          timerEl = this.slickDOM.querySelector('.timer');
        !!timerEl && timerEl.style.setProperty('--dots-ani', _concatInstanceProperty(_context = "".concat(aniName, " ")).call(_context, autoplaySpeed / 1000, "s infinite"));
        this.slickDOM.addEventListener('mouseover', function () {
          var timerEl = _this2.slickDOM.querySelector('.timer');
          !!timerEl && timerEl.style.setProperty('--dots-ani', 'none');
        });
        this.slickDOM.addEventListener('mouseout', function () {
          var _context2;
          var timerEl = _this2.slickDOM.querySelector('.timer');
          !!timerEl && timerEl.style.setProperty('--dots-ani', _concatInstanceProperty(_context2 = "".concat(aniName, " ")).call(_context2, autoplaySpeed / 1000, "s infinite"));
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var autoplay = this.props.autoplay;
      if (autoplay) {
        window.removeEventListener('resize', this.onWindowResized);
        this.onWindowResized.cancel();
      }
    }
  }, {
    key: "next",
    value: function next() {
      this.slick.slickNext();
    }
  }, {
    key: "prev",
    value: function prev() {
      this.slick.slickPrev();
    }
  }, {
    key: "goTo",
    value: function goTo(slide) {
      this.slick.slickGoTo(slide);
    }
  }, {
    key: "render",
    value: function render() {
      var _context3;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        style = _a.style,
        dotsPosition = _a.dotsPosition,
        dotsTimer = _a.dotsTimer,
        nextArrow = _a.nextArrow,
        prevArrow = _a.prevArrow,
        centerMode = _a.centerMode,
        centerPadding = _a.centerPadding,
        slidesToShow = _a.slidesToShow,
        restProps = __rest(_a, ["prefixCls", "className", "style", "dotsPosition", "dotsTimer", "nextArrow", "prevArrow", "centerMode", "centerPadding", "slidesToShow"]);
      var cls = classNames(prefixCls, _concatInstanceProperty(_context3 = "".concat(prefixCls, "-")).call(_context3, dotsPosition), className);
      var dotsCls = classNames('slick-dots', {
        'slick-dots-vertical': dotsPosition == 'left' || dotsPosition == 'right',
        timer: restProps.autoplay && dotsTimer
      });
      if (restProps.effect === 'fade') {
        restProps.fade = true;
      }
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, /*#__PURE__*/React.createElement(SlickCarousel, _Object$assign({}, restProps, {
        ref: this.saveSlick,
        nextArrow: nextArrow ? nextArrow : /*#__PURE__*/React.createElement(CustomArrow, {
          className: "slick-next",
          onClick: this.next
        }),
        prevArrow: prevArrow ? prevArrow : /*#__PURE__*/React.createElement(CustomArrow, {
          className: "slick-prev",
          onClick: this.prev
        }),
        centerMode: centerMode,
        centerPadding: centerPadding,
        slidesToShow: slidesToShow,
        dotsClass: dotsCls
      })));
    }
  }]);
  return Carousel;
}(React.Component);
export { Carousel as default };
Carousel.defaultProps = {
  dots: true,
  arrows: false,
  prefixCls: 'fishd-carousel',
  draggable: false,
  dotsTimer: false,
  autoplaySpeed: 3000,
  dotsPosition: 'bottom',
  centerMode: false,
  centerPadding: '50px',
  slidesToShow: 1
};