import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _fillInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/fill";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import React, { Component, Children } from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import CollapsePanel from './Panel';
function toArray(activeKey) {
  var currentActiveKey = activeKey;
  if (!_Array$isArray(currentActiveKey)) {
    currentActiveKey = currentActiveKey ? [currentActiveKey] : [];
  }
  return currentActiveKey;
}
var Collapse = /*#__PURE__*/function (_Component) {
  _inherits(Collapse, _Component);
  var _super = _createSuper(Collapse);
  function Collapse(props) {
    var _context;
    var _this;
    _classCallCheck(this, Collapse);
    _this = _super.call(this, props);
    // class fields
    _this.collapse = null;
    // class fields
    _this.currentKey = null;
    var activeKey = props.activeKey,
      defaultActiveKey = props.defaultActiveKey,
      statusList = props.statusList;
    var currentActiveKey = defaultActiveKey;
    if ('activeKey' in props) {
      currentActiveKey = activeKey;
    }
    _this.state = {
      // 已激活面板的key
      activeKey: toArray(currentActiveKey),
      statusList: statusList || _fillInstanceProperty(_context = new Array(_this.props.children.length)).call(_context, true),
      prevProps: props
    };
    // 当前点击的key
    _this.currentKey = null;
    return _this;
  }
  _createClass(Collapse, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      this.scrollToHeader();
    }
  }, {
    key: "onClickItem",
    value: function onClickItem(key) {
      var _this2 = this;
      return function () {
        var activeKey = _this2.state.activeKey;
        // 手风琴效果,只展开一项,收起其他项
        if (_this2.props.accordion) {
          activeKey = activeKey[0] === key ? [] : [key];
        } else {
          // @ts-ignore
          activeKey = _toConsumableArray(activeKey);
          var index = _indexOfInstanceProperty(activeKey).call(activeKey, key);
          var isActive = index > -1;
          if (isActive) {
            // remove active state
            _spliceInstanceProperty(activeKey).call(activeKey, index, 1);
          } else {
            activeKey.push(key);
          }
        }
        // 当前点击的key
        _this2.currentKey = key;
        _this2.setActiveKey(activeKey);
      };
    }
  }, {
    key: "onCloseItem",
    value: function onCloseItem(key) {
      var _this3 = this;
      return function () {
        var _this3$props = _this3.props,
          children = _this3$props.children,
          statusList = _this3$props.statusList;
        var keyList = _mapInstanceProperty(Children).call(Children, children, function (child, index) {
          return child.key || String(index);
        });
        var index = _findIndexInstanceProperty(keyList).call(keyList, function (item) {
          return key == item;
        });
        statusList[index] = false;
        _this3.props.close(statusList);
      };
    }
  }, {
    key: "getItems",
    value: function getItems() {
      var _this4 = this;
      var activeKey = this.state.activeKey;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        accordion = _this$props.accordion,
        showClose = _this$props.showClose;
      return _mapInstanceProperty(Children).call(Children, this.props.children, function (child, index) {
        var _context2, _context3;
        if (!_this4.state.statusList[index]) {
          return null;
        }
        // If there is no key provide, use the panel order as default key
        var key = child.key || String(index);
        var header = child.props.header;
        var isActive = false;
        if (accordion) {
          isActive = activeKey[0] === key;
        } else {
          isActive = _indexOfInstanceProperty(activeKey).call(activeKey, key) > -1;
        }
        var props = {
          itemKey: function itemKey(el) {
            return _this4[key] = el;
          },
          header: header,
          showClose: showClose,
          isActive: isActive,
          prefixCls: prefixCls,
          children: child.props.children,
          onItemClick: _bindInstanceProperty(_context2 = _this4.onClickItem(key)).call(_context2, _this4),
          onCloseItem: _bindInstanceProperty(_context3 = _this4.onCloseItem(key)).call(_context3, _this4)
        };
        return /*#__PURE__*/React.cloneElement(child, props);
      });
    }
  }, {
    key: "setActiveKey",
    value: function setActiveKey(activeKey) {
      if (!('activeKey' in this.props)) {
        this.setState({
          activeKey: activeKey
        });
      }
      this.props.onChange(this.props.accordion ? activeKey[0] : activeKey);
    }
  }, {
    key: "scrollToHeader",
    value: function scrollToHeader() {
      var activeKey = this.state.activeKey;
      var isScrollToHeader = this.props.isScrollToHeader;
      var currentKey = this.currentKey;
      var collapse = this.collapse;
      if (!isScrollToHeader || !currentKey || !_includesInstanceProperty(activeKey).call(activeKey, currentKey)) {
        return;
      }
      var el = this[currentKey];
      var collapseRect = collapse && collapse.getBoundingClientRect();
      var elRect = el && el.getBoundingClientRect();
      var diff = collapse.scrollHeight - collapse.clientHeight;
      if (collapseRect && elRect) {
        var toTop = collapse.scrollTop + elRect.top - collapseRect.top;
        if (toTop < diff) {
          collapse.scrollTop = toTop;
        }
      }
      this.currentKey = null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        isScrollToHeader = _this$props2.isScrollToHeader,
        bordered = _this$props2.bordered;
      var clsObj = {};
      var style = null;
      clsObj[prefixCls] = true;
      if (className) {
        clsObj[className] = true;
      }
      if (!bordered) {
        clsObj["".concat(prefixCls, "-borderless")] = true;
      }
      if (isScrollToHeader) {
        style = {
          overflowY: 'auto',
          overflowX: 'hidden'
        };
      }
      return /*#__PURE__*/React.createElement("div", {
        className: classNames(clsObj),
        ref: function ref(node) {
          return _this5.collapse = node;
        },
        style: style
      }, this.getItems());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var prevProps = prevState.prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('activeKey' in nextProps) {
        newState.activeKey = toArray(nextProps.activeKey);
      }
      if (nextProps.statusList !== prevProps.statusList) {
        newState.statusList = nextProps.statusList;
      }
      return newState;
    }
  }]);
  return Collapse;
}(Component);
Collapse.propTypes = {
  children: PropTypes.node,
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  defaultActiveKey: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
  activeKey: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
  // 是否开启功能：点击header后将header置顶
  isScrollToHeader: PropTypes.bool,
  // 是否开启功能：手风琴效果，既每次点击header只展开一项
  accordion: PropTypes.bool,
  // 是否开启删除功能
  showClose: PropTypes.bool,
  // 是否显示边框
  bordered: PropTypes.bool,
  // 是否显示面板的状态数组
  statusList: PropTypes.array,
  onChange: PropTypes.func,
  close: PropTypes.func
};
Collapse.defaultProps = {
  prefixCls: 'fishd-collapse',
  isScrollToHeader: false,
  accordion: false,
  showClose: false,
  bordered: true,
  onChange: function onChange(value) {},
  close: function close(e) {}
};
Collapse.Panel = CollapsePanel;
polyfill(Collapse);
export default Collapse;