import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import { findDOMNode } from 'react-dom';
import PropTypes from 'prop-types';
function rgbaColor(r, g, b, a) {
  return "rgba(".concat([r, g, b, a / 100].join(','), ")");
}
var Alpha = /*#__PURE__*/function (_React$Component) {
  _inherits(Alpha, _React$Component);
  var _super = _createSuper(Alpha);
  function Alpha(props) {
    var _this;
    _classCallCheck(this, Alpha);
    _this = _super.call(this, props);
    _this.onMouseDown = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      window.addEventListener('mousemove', _this.onDrag);
      window.addEventListener('mouseup', _this.onDragEnd);
    };
    _this.onDrag = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
    };
    _this.onDragEnd = function (e) {
      var x = e.clientX;
      var y = e.clientY;
      _this.pointMoveTo({
        x: x,
        y: y
      });
      _this.removeListeners();
    };
    _this.getBackground = function () {
      var _context;
      var _this$props$color = _this.props.color,
        red = _this$props$color.red,
        green = _this$props$color.green,
        blue = _this$props$color.blue;
      var opacityGradient = _concatInstanceProperty(_context = "linear-gradient(to right, ".concat(rgbaColor(red, green, blue, 0), " , ")).call(_context, rgbaColor(red, green, blue, 100), ")");
      return opacityGradient;
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-alpha");
    };
    _this.pointMoveTo = function (coords) {
      var rect = findDOMNode(_assertThisInitialized(_this)).getBoundingClientRect();
      var width = rect.width;
      var left = coords.x - rect.left;
      left = Math.max(0, left);
      left = Math.min(left, width);
      var alpha = Math.round(left / width * 100);
      _this.props.onChange(alpha);
    };
    _this.removeListeners = function () {
      window.removeEventListener('mousemove', _this.onDrag);
      window.removeEventListener('mouseup', _this.onDragEnd);
    };
    return _this;
  }
  _createClass(Alpha, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.removeListeners();
    }
  }, {
    key: "render",
    value: function render() {
      var prefixCls = this.getPrefixCls();
      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/React.createElement("div", {
        ref: "bg",
        className: "".concat(prefixCls, "-bg"),
        style: {
          background: this.getBackground()
        }
      }), /*#__PURE__*/React.createElement("span", {
        style: {
          left: "".concat(this.props.alpha, "%")
        }
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-handler"),
        onMouseDown: this.onMouseDown
      }));
    }
  }]);
  return Alpha;
}(React.Component);
export { Alpha as default };
Alpha.propTypes = {
  alpha: PropTypes.number,
  color: PropTypes.object,
  onChange: PropTypes.func,
  rootPrefixCls: PropTypes.string
};