import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _slicedToArray from "@babel/runtime-corejs3/helpers/slicedToArray";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
// @ts-nocheck
import React from 'react';
import PropTypes from 'prop-types';
import Trigger from 'rc-trigger';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import { KeyCode } from '../../utils';
import typeColor from './utils/validationColor';
import ColorPickerPanel from './Panel';
import placements from './placements';
import Color from './helpers/color';
import Icon from '../Icon/index';
function noop() {}
var QuickPanel = /*#__PURE__*/function (_React$Component) {
  _inherits(QuickPanel, _React$Component);
  var _super = _createSuper(QuickPanel);
  function QuickPanel(props) {
    var _this;
    _classCallCheck(this, QuickPanel);
    _this = _super.call(this, props);
    _this.onFocus = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
        _this._blurTimer = null;
      } else {
        _this.props.onFocus();
      }
    };
    _this.onBlur = function () {
      if (_this._blurTimer) {
        clearTimeout(_this._blurTimer);
      }
      _this._blurTimer = _setTimeout(function () {
        // if is system color picker open, then stop run blur
        if (_this.systemColorPickerOpen) {
          _this.systemColorPickerOpen = false;
          return;
        }
        _this.props.onBlur();
      }, 100);
    };
    _this.handleChange = function (color, alpha) {
      var fireChange = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onChange = _this$props.onChange,
        onVisibleChange = _this$props.onVisibleChange,
        __useInComponent = _this$props.__useInComponent;
      if (disabled) return;
      _this.setState({
        color: color
      });
      onChange({
        color: color,
        alpha: alpha
      });
      // colorPicker弹层中使用，点击时触发visibleChange
      if (__useInComponent && fireChange) {
        onVisibleChange(false);
      }
    };
    _this.onChange = function (colors) {
      _this.setState(_Object$assign({}, colors));
    };
    _this.onVisibleChangeFromTrigger = function (visible) {
      _this.setVisible(visible);
      //自定义选择颜色弹层关闭时才颜色改变确认
      if (!visible) {
        _this.props.onChange(_this.state);
      }
    };
    _this.onPanelMount = function (panelDOMRef) {
      if (_this.state.visible) {
        _setTimeout(function () {
          panelDOMRef.focus();
        }, 0);
      }
    };
    _this.handleKeyDown = function (e) {
      var keyCode = e.keyCode;
      if (keyCode === KeyCode.ESC && _this.props.esc || keyCode === KeyCode.ENTER) {
        _this.setVisible(false, function () {
          _this.props.onChange(_this.state);
        });
      }
    };
    _this.handleSpnKeyDown = function (e) {
      var keyCode = e.keyCode;
      var colorMap = _this.props.colorMap;
      var _this$state = _this.state,
        color = _this$state.color,
        visible = _this$state.visible;
      var activeIndex = _indexOfInstanceProperty(colorMap).call(colorMap, color);
      if (activeIndex === -1 || visible) return;
      // LEFT/RIGHT触发选择
      if (keyCode === KeyCode.LEFT) {
        _this.handleChange(colorMap[activeIndex - 1 === -1 ? colorMap.length - 1 : activeIndex - 1], 100, false);
      }
      if (keyCode === KeyCode.RIGHT) {
        _this.handleChange(colorMap[activeIndex + 1 === colorMap.length ? 0 : activeIndex + 1], 100, false);
      }
    };
    _this.setVisible = function (visible, callback) {
      if (_this.state.visible !== visible) {
        _this.setState({
          visible: visible
        }, function () {
          if (typeof callback === 'function') callback();
          var _this$props2 = _this.props,
            onVisibleChange = _this$props2.onVisibleChange,
            enableHistory = _this$props2.enableHistory,
            maxHistory = _this$props2.maxHistory;
          onVisibleChange(_this.state.visible);
          //关闭时记录历史记录
          if (!_this.state.visible && enableHistory) {
            var _context, _context2;
            var _this$state2 = _this.state,
              color = _this$state2.color,
              _alpha = _this$state2.alpha,
              colorHistory = _this$state2.colorHistory;
            if (colorHistory.length && color === colorHistory[0].color && _alpha === colorHistory[0].alpha) return;
            _this.setState({
              colorHistory: colorHistory.length >= maxHistory ? _concatInstanceProperty(_context = [{
                color: color,
                alpha: _alpha
              }]).call(_context, _toConsumableArray(_sliceInstanceProperty(colorHistory).call(colorHistory, 0, -1))) : _concatInstanceProperty(_context2 = [{
                color: color,
                alpha: _alpha
              }]).call(_context2, _toConsumableArray(colorHistory))
            });
          }
        });
      }
    };
    _this.getPickerElement = function () {
      var _this$props3 = _this.props,
        mode = _this$props3.mode,
        className = _this$props3.className,
        enableAlpha = _this$props3.enableAlpha,
        enableHistory = _this$props3.enableHistory,
        maxHistory = _this$props3.maxHistory;
      return /*#__PURE__*/React.createElement(ColorPickerPanel, {
        onMount: _this.onPanelMount,
        defaultColor: _this.state.color,
        alpha: _this.state.alpha,
        enableAlpha: enableAlpha,
        prefixCls: "fishd-color-picker-panel",
        onChange: _this.onChange,
        onBlur: _this.onBlur,
        mode: mode,
        className: className,
        colorHistory: _this.state.colorHistory,
        enableHistory: enableHistory,
        maxHistory: maxHistory
      });
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    _this.state = {
      color: props.color || props.defaultColor,
      alpha: alpha,
      visible: false,
      colorHistory: props.colorHistory
    };
    return _this;
  }
  _createClass(QuickPanel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onMount(this.ref);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        colorMap = _this$props4.colorMap,
        userSelectColor = _this$props4.userSelectColor,
        getPopupContainer = _this$props4.getPopupContainer,
        disabled = _this$props4.disabled,
        __useInComponent = _this$props4.__useInComponent,
        popupStyle = _this$props4.popupStyle;
      var _Color$RGB = _slicedToArray(new Color(this.state.color).RGB, 3),
        r = _Color$RGB[0],
        g = _Color$RGB[1],
        b = _Color$RGB[2];
      var RGBA = [r, g, b];
      var customChecked = !_includesInstanceProperty(colorMap).call(colorMap, this.state.color);
      RGBA.push(this.state.alpha / 100);
      return /*#__PURE__*/React.createElement("div", {
        ref: function ref(_ref) {
          return _this2.ref = _ref;
        },
        className: [prefixCls, this.props.className].join(' '),
        style: this.props.style,
        onFocus: this.onFocus,
        onKeyDown: this.handleSpnKeyDown,
        onBlur: this.onBlur,
        tabIndex: 0
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, _mapInstanceProperty(colorMap).call(colorMap, function (color, i) {
        var _classNames;
        var spnClasses = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-color-spn"), true), _defineProperty(_classNames, "".concat(prefixCls, "-color-spn-active"), _this2.state.color === color), _classNames));
        return /*#__PURE__*/React.createElement("span", {
          key: i,
          className: spnClasses,
          style: {
            background: color
          },
          onClick: function onClick() {
            return _this2.handleChange(color, 100);
          }
        });
      }), userSelectColor && !__useInComponent && /*#__PURE__*/React.createElement(Trigger, {
        popup: /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-content"),
          onKeyDown: this.handleKeyDown
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-arrow")
        }), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-inner")
        }, this.getPickerElement())),
        builtinPlacements: placements,
        popupPlacement: 'topCenter',
        action: disabled ? [] : ['click'],
        destroyPopupOnHide: true,
        popupStyle: popupStyle,
        getPopupContainer: getPopupContainer,
        popupVisible: this.state.visible,
        onPopupVisibleChange: this.onVisibleChangeFromTrigger,
        prefixCls: "fishd-color-picker-panel"
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-custom-btn")
      }, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-custom-btn-text"),
        style: customChecked ? {
          backgroundColor: "rgba(".concat(RGBA.join(','), ")"),
          color: '#fff',
          textShadow: '0 0.5px 0.5px rgba(0,0,0,50%)'
        } : {}
      }, customChecked && /*#__PURE__*/React.createElement(Icon, {
        type: "check-line-bold"
      }), "\u81EA\u5B9A\u4E49")))));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return QuickPanel;
}(React.Component);
QuickPanel.propTypes = {
  __useInComponent: PropTypes.bool,
  alpha: PropTypes.number,
  className: PropTypes.string,
  color: typeColor,
  colorHistory: PropTypes.array,
  colorMap: PropTypes.array,
  defaultAlpha: PropTypes.number,
  defaultColor: typeColor,
  disabled: PropTypes.bool,
  enableAlpha: PropTypes.bool,
  enableHistory: PropTypes.bool,
  getPopupContainer: PropTypes.func,
  maxHistory: PropTypes.number,
  mode: PropTypes.oneOf(['RGB', 'HSL', 'HSB']),
  onBlur: PropTypes.func,
  onChange: PropTypes.func,
  onFocus: PropTypes.func,
  onMount: PropTypes.func,
  onVisibleChange: PropTypes.func,
  prefixCls: PropTypes.string,
  userSelectColor: PropTypes.bool,
  style: PropTypes.object,
  popupStyle: PropTypes.object,
  esc: PropTypes.bool
};
QuickPanel.defaultProps = {
  __useInComponent: false,
  className: '',
  colorHistory: [],
  colorMap: ['#33bbff', '#337eff', '#8a73ff', '#bb67e6', '#f290b6', '#f24957', '#cc613d', '#faa702', '#ffe500', '#aacc00', '#26bf40', '#3dd9af', '#333333', '#666666', '#999999', '#cccccc'],
  defaultAlpha: 100,
  defaultColor: '#33bbff',
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  mode: 'RGB',
  onBlur: noop,
  onChange: noop,
  onFocus: noop,
  onMount: noop,
  onVisibleChange: noop,
  prefixCls: 'fishd-color-picker-quick-panel',
  userSelectColor: true,
  style: {},
  popupStyle: {},
  esc: true
};
polyfill(QuickPanel);
export default QuickPanel;