import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import BasePicker from './BasePicker';
import DatePanel from './panel/DatePanel';
import TimeSelectPanel from './panel/TimeSelectPanel';
import TimePanel from './panel/TimePanel';
import { converSelectRange } from './TimePicker';
import { SELECTION_MODES } from '../../utils/date';
import DateRangePicker from './DateRangePicker';
var DatePicker = /*#__PURE__*/function (_BasePicker) {
  _inherits(DatePicker, _BasePicker);
  var _super = _createSuper(DatePicker);
  function DatePicker(props) {
    _classCallCheck(this, DatePicker);
    var type = props.showTime ? 'datetime' : 'date';
    switch (props.mode) {
      // case SELECTION_MODES.YEAR:
      //   type = 'year'; break;
      // case SELECTION_MODES.MONTH:
      //   type = 'month'; break;
      case SELECTION_MODES.WEEK:
        type = 'week';
        break;
    }
    return _super.call(this, props, type, {});
  }
  _createClass(DatePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      // 带时间的日期面板，需要检查时间的合法性
      var dateValid = _get(_getPrototypeOf(DatePicker.prototype), "isDateValid", this).call(this, value) && DatePanel.isValid(value, this.props.disabledDate);
      if (this.props.showTime) {
        var timeSelectValid = this.props.timeSelectMode === 'TimeSelect' && TimeSelectPanel.isValid(this.dateToStr(value).split(' ')[1], this.props.timeSelectModeProps);
        var timePickerValid = this.props.timeSelectMode === 'TimePicker' && TimePanel.isValid(value, converSelectRange({
          selectableRange: this.props.timeSelectableRange
        }));
        return dateValid && (timeSelectValid || timePickerValid);
      } else {
        return dateValid;
      }
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(DatePanel, _Object$assign({}, this.props, {
        value: value,
        onPick: this.onPicked,
        onCancelPicked: this.onCancelPicked
      }));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      var _context;
      return _Object$assign({}, {
        placeholder: PropTypes.string,
        value: PropTypes.instanceOf(Date),
        mode: PropTypes.oneOf(_mapInstanceProperty(_context = _Object$keys(SELECTION_MODES)).call(_context, function (e) {
          return SELECTION_MODES[e];
        }))
      }, BasePicker.propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return _Object$assign({}, DatePanel.defaultProps, BasePicker.defaultProps);
    }
  }]);
  return DatePicker;
}(BasePicker);
export { DatePicker as default };
DatePicker.DateRangePicker = DateRangePicker;