import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import DateRangeBasePicker from './DateRangeBasePicker';
import DateRangePanel from './panel/DateRangePanel';
import TimeSelectPanel from './panel/TimeSelectPanel';
import TimePanel from './panel/TimePanel';
import { converSelectRange } from './TimePicker';
import ConfigConsumer from '../Config/Consumer';
var DateRangePicker = /*#__PURE__*/function (_DateRangeBasePicker) {
  _inherits(DateRangePicker, _DateRangeBasePicker);
  var _super = _createSuper(DateRangePicker);
  // FIXME: props typing
  function DateRangePicker(props) {
    var _this;
    _classCallCheck(this, DateRangePicker);
    _this = _super.call(this, props, props.showTime ? 'datetimerange' : 'daterange', {});
    _this.getFormatSeparator = function () {
      return _this.props.separator;
    };
    _this.onError = function (value) {
      return _this.props.onError && typeof _this.props.onError === 'function' ? _this.props.onError(value) : undefined;
    };
    return _this;
  }
  _createClass(DateRangePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      var dateValid = _get(_getPrototypeOf(DateRangePicker.prototype), "isDateValid", this).call(this, value) && DateRangePanel.isValid(value, this.props.disabledDate);
      // 带时间的日期范围面板，需要检查时间的合法性
      if (this.props.showTime) {
        var startTime = value && value.length >= 2 ? value[0] : null;
        var endTime = value && value.length >= 2 ? value[1] : null;
        var startTimeSelectValid = startTime && this.props.startTimeSelectMode === 'TimeSelect' && TimeSelectPanel.isValid(this.dateToStr(startTime).split(' ')[1], this.props.startTimeSelectModeProps);
        var startTimePickerValid = startTime && this.props.startTimeSelectMode === 'TimePicker' && TimePanel.isValid(startTime, converSelectRange({
          selectableRange: this.props.startTimeSelectableRange
        }));
        var endTimeSelectValid = endTime && this.props.endTimeSelectMode === 'TimeSelect' && TimeSelectPanel.isValid(this.dateToStr(endTime).split(' ')[1], this.props.endTimeSelectModeProps);
        var endTimePickerValid = endTime && this.props.endTimeSelectMode === 'TimePicker' && TimePanel.isValid(endTime, converSelectRange({
          selectableRange: this.props.endTimeSelectableRange
        }));
        return dateValid && (startTimeSelectValid || startTimePickerValid) && (endTimeSelectValid || endTimePickerValid);
      } else {
        return dateValid;
      }
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this2 = this;
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales) {
        return (
          /*#__PURE__*/
          // @ts-ignore to much unmatched props
          React.createElement(DateRangePanel, _Object$assign({}, _this2.props, {
            value: value,
            onPick: _this2.onPicked,
            onCancelPicked: _this2.onCancelPicked,
            dateToStr: _this2.dateToStr
          }))
        );
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return _Object$assign({}, {
        separator: PropTypes.string,
        yearCount: PropTypes.number,
        shortcuts: PropTypes.arrayOf(PropTypes.shape({
          text: PropTypes.string.isRequired,
          onClick: PropTypes.func.isRequired
        })),
        disabledDate: PropTypes.func,
        firstDayOfWeek: PropTypes.number,
        footer: PropTypes.func,
        onError: PropTypes.func
      }, DateRangeBasePicker.propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return _Object$assign({}, DateRangePanel.defaultProps, DateRangeBasePicker.defaultProps);
    }
  }]);
  return DateRangePicker;
}(DateRangeBasePicker);
export { DateRangePicker as default };