import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import PropTypes from 'prop-types';
import BasePicker from './BasePicker';
import TimePanel from './panel/TimePanel';
import { TYPE_VALUE_RESOLVER_MAP, DEFAULT_FORMATS } from './constants';
import debounce from 'lodash/debounce';
import TimeSelect from './TimeSelect';
import ConfigConsumer from '../Config/Consumer';
export var converSelectRange = function converSelectRange(props) {
  var selectableRange = [];
  if (props.selectableRange) {
    var ranges = props.selectableRange;
    var parser = TYPE_VALUE_RESOLVER_MAP.datetimerange.parser;
    var format = DEFAULT_FORMATS.timerange;
    ranges = _Array$isArray(ranges) ? ranges : [ranges];
    selectableRange = _mapInstanceProperty(ranges).call(ranges, function (range) {
      return parser(range, format);
    });
  }
  return selectableRange;
};
var TimePicker = /*#__PURE__*/function (_BasePicker) {
  _inherits(TimePicker, _BasePicker);
  var _super = _createSuper(TimePicker);
  function TimePicker(props) {
    var _this;
    _classCallCheck(this, TimePicker);
    //props, type, state
    _this = _super.call(this, props, 'time', {});
    _this.onSelectionChange = function (start, end) {
      _this.refInputRoot.input && _this.refInputRoot.input.setSelectionRange(start, end);
      _this.refInputRoot.input && _this.refInputRoot.input.focus();
    };
    _this._onSelectionChange = debounce(_this.onSelectionChange, 200);
    return _this;
  }
  _createClass(TimePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      return _get(_getPrototypeOf(TimePicker.prototype), "isDateValid", this).call(this, value) && TimePanel.isValid(value, converSelectRange(this.props));
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this2 = this;
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(TimePanel, _Object$assign({}, _this2.props, {
          selectableRange: converSelectRange(_this2.props),
          ONSELECTRANGECHANGE: _this2._onSelectionChange,
          value: value,
          onPicked: _this2.onPicked,
          onCancelPicked: _this2.onCancelPicked,
          Locales: Locales
        }));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return _Object$assign({}, {
        // '18:30:00 - 20:30:00' or ['09:30:00 - 12:00:00', '14:30:00 - 18:30:00']
        selectableRange: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
        isShowCurrent: PropTypes.bool,
        footer: PropTypes.func,
        onValueChange: PropTypes.func
      }, BasePicker.propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return _Object$assign({}, {
        isShowCurrent: false
      }, BasePicker.defaultProps);
    }
  }]);
  return TimePicker;
}(BasePicker);
export { TimePicker as default };
TimePicker.TimeSelect = TimeSelect;