import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _Array$from from "@babel/runtime-corejs3/core-js-stable/array/from";
import _Symbol from "@babel/runtime-corejs3/core-js-stable/symbol";
import _getIteratorMethod from "@babel/runtime-corejs3/core-js/get-iterator-method";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof _Symbol !== "undefined" && _getIteratorMethod(o) || o["@@iterator"]; if (!it) { if (_Array$isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { var _context32; if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = _sliceInstanceProperty(_context32 = Object.prototype.toString.call(o)).call(_context32, 8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return _Array$from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { DateTable } from '../basic';
import Input from '../../Input/index';
import Icon from '../../Icon/index';
import Button from '../../Button/index';
import TimePicker from '../../TimePicker/index';
import { converSelectRange } from '../TimePicker';
import TimePanel from './TimePanel.js';
import TimeSelectPanel from './TimeSelectPanel.js';
import YearAndMonthPopover from './YearAndMonthPopover.js';
import isEqual from 'lodash/isEqual';
import { SELECTION_MODES, toDate, prevYear as _prevYear, nextYear as _nextYear, prevMonth as _prevMonth, nextMonth as _nextMonth, timeFormat, dateFormat, formatDate, parseDate, YEARS_ARRAY, isValidValue, isValidValueArr, setTime, equalYearAndMonth, diffDate } from '../../../utils/date';
import { TYPE_VALUE_RESOLVER_MAP, DEFAULT_FORMATS } from '../constants';
import ConfigConsumer from '../../Config/Consumer';
var TimeSelect = TimePicker.TimeSelect;
var isInputValid = function isInputValid(text, date, disabledDate) {
  if (_trimInstanceProperty(text).call(text) === '' || !isValidValueArr(date) || !DateRangePanel.isValid(date, disabledDate)) return false;
  return true;
};
var dateToStr = function dateToStr(date) {
  if (!date || !isValidValue(date)) return '';
  var tdate = date;
  var formatter = TYPE_VALUE_RESOLVER_MAP['timeselect'].formatter;
  var result = formatter(tdate, DEFAULT_FORMATS['timeselect']);
  return result;
};
var DateRangePanel = /*#__PURE__*/function (_React$Component) {
  _inherits(DateRangePanel, _React$Component);
  var _super = _createSuper(DateRangePanel);
  function DateRangePanel(props) {
    var _this;
    _classCallCheck(this, DateRangePanel);
    _this = _super.call(this, props);
    // 日期时间都选择，确定按钮才可点击
    _this.confirmBtnDisabled = function () {
      var _this$state = _this.state,
        minDate = _this$state.minDate,
        maxDate = _this$state.maxDate,
        minTime = _this$state.minTime,
        maxTime = _this$state.maxTime,
        minDateInputText = _this$state.minDateInputText,
        maxDateInputText = _this$state.maxDateInputText;
      return !(minDate && maxDate && minTime && maxTime && minDateInputText && maxDateInputText);
    };
    // 未选择日期时，时间不可选
    _this.timePickerDisable = function () {
      var _this$state2 = _this.state,
        minDate = _this$state2.minDate,
        maxDate = _this$state2.maxDate,
        minDateInputText = _this$state2.minDateInputText,
        maxDateInputText = _this$state2.maxDateInputText;
      return !(minDate && maxDate && minDateInputText && maxDateInputText);
    };
    // 计算结束时间的可选范围
    _this.getEndTimeSelectableRange = function (minTime) {
      var _this$props = _this.props,
        endTimeSelectableRange = _this$props.endTimeSelectableRange,
        endTimeSelectMode = _this$props.endTimeSelectMode,
        endTimeSelectModeProps = _this$props.endTimeSelectModeProps;
      //TimePicker模式下返回endTimeSelectableRange
      return DateRangePanel.getEndTimeSelectableRange({
        minTime: minTime,
        endTimeSelectMode: endTimeSelectMode,
        endTimeSelectModeProps: endTimeSelectModeProps,
        endTimeSelectableRange: endTimeSelectableRange
      });
    };
    // 计算最大时间
    _this.getMaxTime = function (maxTime, minTime) {
      var endTimeSelectMode = _this.props.endTimeSelectMode;
      if (endTimeSelectMode === 'TimePicker') {
        return maxTime && TimePanel.isValid(maxTime, converSelectRange({
          selectableRange: _this.getEndTimeSelectableRange(minTime)
        })) ? maxTime : null;
      } else {
        var _context;
        return maxTime && TimeSelectPanel.isValid(_concatInstanceProperty(_context = "".concat(maxTime.getHours(), ":")).call(_context, maxTime.getMinutes()), _this.getEndTimeSelectableRange(minTime)) ? maxTime : null;
      }
    };
    // 当开始日期和结束日期为同一天时，需要控制结束时间的可选范围
    _this.setEndTimeRange = function () {
      var _this$state3 = _this.state,
        minDate = _this$state3.minDate,
        maxDate = _this$state3.maxDate,
        minTime = _this$state3.minTime,
        maxTime = _this$state3.maxTime;
      var _this$props2 = _this.props,
        endTimeSelectableRange = _this$props2.endTimeSelectableRange,
        endTimeSelectMode = _this$props2.endTimeSelectMode,
        endTimeSelectModeProps = _this$props2.endTimeSelectModeProps;
      var isSameDate = minDate && maxDate && diffDate(minDate, maxDate) === 0;
      _this.setState({
        maxTime: isSameDate && minTime ? _this.getMaxTime(maxTime, minTime) : maxTime,
        endTimeSelectableRange: endTimeSelectMode === 'TimePicker' && isSameDate && minTime ? _this.getEndTimeSelectableRange(minTime) : endTimeSelectableRange,
        endTimeSelectModeProps: endTimeSelectMode === 'TimeSelect' && isSameDate && minTime ? _this.getEndTimeSelectableRange(minTime) : endTimeSelectModeProps
      });
    };
    // 日期输入框失焦时，重置入合法值
    _this.handleDateInputBlur = function (e, type) {
      var _this$state4 = _this.state,
        minDate = _this$state4.minDate,
        maxDate = _this$state4.maxDate;
      if (type === 'min') {
        _this.setState({
          minDateInputText: formatDate(minDate, dateFormat(_this.props.format))
        });
      } else {
        _this.setState({
          maxDateInputText: formatDate(maxDate, dateFormat(_this.props.format))
        });
      }
    };
    // 左边日历的next year btn特殊处理: 左边日历的下一年面板日期大于右边日历，右边日历的年份+1
    _this.handleLeftNextYear = function () {
      var _this$state5 = _this.state,
        leftDate = _this$state5.leftDate,
        rightDate = _this$state5.rightDate;
      if (leftDate >= rightDate) {
        _this.nextYear('rightDate', rightDate);
      }
    };
    // 左边日历的next month btn特殊处理: 左边日历的下一月等于右边日历，右边日历月份+1
    _this.handleLeftNextMonth = function () {
      var _this$state6 = _this.state,
        leftDate = _this$state6.leftDate,
        rightDate = _this$state6.rightDate;
      if (rightDate.getFullYear() === leftDate.getFullYear() && rightDate.getMonth() === leftDate.getMonth()) {
        _this.nextMonth('rightDate', rightDate);
      }
    };
    // 右边日历的prev year btn特殊处理: 右边日历的上一年面板小于左边日历，左边日历年份-1
    _this.handleRightPrevYear = function () {
      var _this$state7 = _this.state,
        leftDate = _this$state7.leftDate,
        rightDate = _this$state7.rightDate;
      if (rightDate <= leftDate) {
        _this.prevYear('leftDate', leftDate);
      }
    };
    // 右边日历的prev month btn特殊处理： 右边日历的上一月等于左边日历，左边日历的月份-1
    _this.handleRightPrevMonth = function () {
      var _this$state8 = _this.state,
        leftDate = _this$state8.leftDate,
        rightDate = _this$state8.rightDate;
      if (rightDate.getFullYear() === leftDate.getFullYear() && rightDate.getMonth() === leftDate.getMonth()) {
        _this.prevMonth('leftDate', leftDate);
      }
    };
    // 点击确定按钮
    _this.handleConfirm = function () {
      var onError = _this.props.onError;
      var _this$state9 = _this.state,
        minDate = _this$state9.minDate,
        maxDate = _this$state9.maxDate,
        minTime = _this$state9.minTime,
        maxTime = _this$state9.maxTime;
      var pickedMinTime = setTime(new Date(minDate), minTime);
      var pickedMaxTime = setTime(new Date(maxDate), maxTime);
      if (pickedMinTime && pickedMaxTime && onError && onError([pickedMinTime, pickedMaxTime])) {
        return;
      }
      _this.props.onPick([pickedMinTime, pickedMaxTime], false, true);
    };
    // 点击取消按钮
    _this.handleCancel = function () {
      _this.props.onCancelPicked();
    };
    _this.state = _Object$assign({}, {
      rangeState: {
        firstSelectedValue: null,
        endDate: null,
        selecting: false
      }
    }, DateRangePanel.propsToState(props));
    return _this;
  }
  _createClass(DateRangePanel, [{
    key: "handleChangeRange",
    value:
    // 鼠标移动选择结束时间的回调
    function handleChangeRange(rangeState) {
      this.setState({
        minDate: new Date(Math.min(rangeState.firstSelectedValue, rangeState.endDate)),
        maxDate: new Date(Math.max(rangeState.firstSelectedValue, rangeState.endDate))
      });
    }
    // 开始日期或结束日期发生改变
  }, {
    key: "handleDateInputChange",
    value: function handleDateInputChange(e, type) {
      var _this2 = this;
      var _this$props3 = this.props,
        disabledDate = _this$props3.disabledDate,
        format = _this$props3.format;
      var _this$state10 = this.state,
        minDate = _this$state10.minDate,
        maxDate = _this$state10.maxDate,
        minTime = _this$state10.minTime,
        maxTime = _this$state10.maxTime;
      var text = type === 'min' ? 'minDateInputText' : 'maxDateInputText';
      var value = type === 'min' ? 'minDate' : 'maxDate';
      var inputText = e.target.value;
      var ndate = parseDate(inputText, dateFormat(format));
      var getDate = function getDate() {
        var ndateMin = [minTime ? setTime(new Date(ndate), minTime) : new Date(ndate), maxDate];
        var ndateMax = [minDate, maxTime ? setTime(new Date(ndate), maxTime) : new Date(ndate)];
        return type === 'min' ? ndateMin : ndateMax;
      };
      if (!isInputValid(inputText, getDate(), disabledDate)) {
        this.setState(_defineProperty({}, text, inputText));
      } else {
        var _this$setState2;
        this.setState((_this$setState2 = {}, _defineProperty(_this$setState2, text, inputText), _defineProperty(_this$setState2, value, new Date(ndate)), _this$setState2), function () {
          //当开始日期和结束日期为同一天时，控制结束时间的可选范围
          _this2.setEndTimeRange();
        });
      }
    }
    // 开始时间或结束时间发生改变
  }, {
    key: "handleTimeInputChange",
    value: function handleTimeInputChange(value, type) {
      var _this3 = this;
      if (value) {
        if (type === 'min') {
          this.setState({
            minTime: new Date(value)
          }, function () {
            //当开始日期和结束日期为同一天时，控制结束时间的可选范围
            _this3.setEndTimeRange();
          });
        } else {
          this.setState({
            maxTime: new Date(value)
          });
        }
      }
    }
    // 点击快捷选项
  }, {
    key: "handleShortcutClick",
    value: function handleShortcutClick(shortcut) {
      shortcut.onClick();
    }
    // 上一年
  }, {
    key: "prevYear",
    value: function prevYear(type, date) {
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      this.setState(_defineProperty({}, type, _prevYear(date)), callback);
    }
    // 下一年
  }, {
    key: "nextYear",
    value: function nextYear(type, date) {
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      this.setState(_defineProperty({}, type, _nextYear(date)), callback);
    }
    // 上个月
  }, {
    key: "prevMonth",
    value: function prevMonth(type, date) {
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      this.setState(_defineProperty({}, type, _prevMonth(date)), callback);
    }
    // 下个月
  }, {
    key: "nextMonth",
    value: function nextMonth(type, date) {
      var callback = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      this.setState(_defineProperty({}, type, _nextMonth(date)), callback);
    }
    // 切换年份
  }, {
    key: "handleChangeYear",
    value: function handleChangeYear(type, date, year) {
      var _this4 = this;
      this.setState(_defineProperty({}, type, new Date(new Date(date).setFullYear(year))), function () {
        // 切换完年份，若左边日历小于等于右边日历，保持右边日历是左边日历的下一年
        var _this4$state = _this4.state,
          leftDate = _this4$state.leftDate,
          rightDate = _this4$state.rightDate;
        if (type === 'leftDate') {
          if (leftDate >= rightDate) {
            _this4.setState({
              rightDate: new Date(new Date(rightDate).setFullYear(leftDate.getFullYear() + 1))
            });
          }
        } else if (type === 'rightDate') {
          if (leftDate >= rightDate) {
            _this4.setState({
              leftDate: new Date(new Date(leftDate).setFullYear(rightDate.getFullYear() - 1))
            });
          }
        }
      });
    }
    // 切换月份
  }, {
    key: "handleChangeMonth",
    value: function handleChangeMonth(type, date, month, locales) {
      var _context2,
        _this5 = this;
      var monthNumber = _indexOfInstanceProperty(_context2 = locales.MONTH_ARRAY).call(_context2, month);
      this.setState(_defineProperty({}, type, new Date(new Date(date).setMonth(monthNumber))), function () {
        // 切换完月份，若左边日历小于等于右边日历，保持右边日历是左边日历的下一月
        var _this5$state = _this5.state,
          leftDate = _this5$state.leftDate,
          rightDate = _this5$state.rightDate;
        if (type === 'leftDate') {
          if (leftDate >= rightDate) {
            _this5.setState({
              rightDate: _nextMonth(leftDate)
            });
          }
        } else if (type === 'rightDate') {
          if (leftDate >= rightDate) {
            _this5.setState({
              leftDate: _prevMonth(rightDate)
            });
          }
        }
      });
    }
    // 点击日期
  }, {
    key: "handleRangePick",
    value: function handleRangePick(_ref, isClose) {
      var _this6 = this;
      var minDate = _ref.minDate,
        maxDate = _ref.maxDate;
      var _this$props4 = this.props,
        showTime = _this$props4.showTime,
        onPick = _this$props4.onPick,
        format = _this$props4.format,
        onError = _this$props4.onError;
      var _this$state11 = this.state,
        minTime = _this$state11.minTime,
        maxTime = _this$state11.maxTime;
      var pickedMinTime = minTime ? setTime(new Date(minDate), minTime) : minDate;
      var pickedMaxTime = maxTime ? setTime(new Date(maxDate), maxTime) : maxDate;
      if (minDate && maxDate && onError && onError([pickedMinTime, pickedMaxTime])) {
        return;
      }
      this.setState({
        minDate: minDate ? new Date(minDate) : null,
        maxDate: maxDate ? new Date(maxDate) : null,
        minDateInputText: formatDate(minDate, dateFormat(format)),
        maxDateInputText: formatDate(maxDate, dateFormat(format))
      }, function () {
        //当开始日期和结束日期为同一天时，控制结束时间的可选范围
        _this6.setEndTimeRange();
      });
      if (!isClose) return;
      if (!showTime) {
        //日期范围选择的开始时间为 00：00 结束时间为 23：59
        var _pickedMinTime = setTime(new Date(minDate), new Date(new Date().setHours(0, 0, 0, 0)));
        var _pickedMaxTime = setTime(new Date(maxDate), new Date(new Date().setHours(23, 59, 59, 999)));
        onPick([_pickedMinTime, _pickedMaxTime], false, true);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this7 = this;
      var _this$props5 = this.props,
        shortcuts = _this$props5.shortcuts,
        disabledDate = _this$props5.disabledDate,
        firstDayOfWeek = _this$props5.firstDayOfWeek,
        format = _this$props5.format,
        yearCount = _this$props5.yearCount,
        showTime = _this$props5.showTime,
        showTimeCurrent = _this$props5.showTimeCurrent,
        footer = _this$props5.footer,
        prefixCls = _this$props5.prefixCls,
        startTimeSelectMode = _this$props5.startTimeSelectMode,
        startTimeSelectModeProps = _this$props5.startTimeSelectModeProps,
        endTimeSelectMode = _this$props5.endTimeSelectMode;
      var _this$state12 = this.state,
        rangeState = _this$state12.rangeState,
        leftDate = _this$state12.leftDate,
        rightDate = _this$state12.rightDate,
        minDate = _this$state12.minDate,
        maxDate = _this$state12.maxDate,
        minDateInputText = _this$state12.minDateInputText,
        maxDateInputText = _this$state12.maxDateInputText,
        minTime = _this$state12.minTime,
        maxTime = _this$state12.maxTime,
        startTimeSelectableRange = _this$state12.startTimeSelectableRange,
        endTimeSelectableRange = _this$state12.endTimeSelectableRange,
        endTimeSelectModeProps = _this$state12.endTimeSelectModeProps;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "DatePicker"
      }, function (Locales, lang) {
        var _context3, _context4, _context5, _context6, _context7, _context8, _context9, _context10, _context11, _context12, _context13, _context14, _context15, _context16, _context17, _context18, _context19, _context20, _context21, _context22, _context23, _context24, _context25, _context26, _context27, _context28;
        return /*#__PURE__*/React.createElement("div", {
          className: classNames("".concat(prefixCls, "-picker-panel"), "".concat(prefixCls, "-date-range-picker"), {
            'has-sidebar': shortcuts,
            'has-time': showTime
          })
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body-wrapper")
        }, _Array$isArray(shortcuts) && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__sidebar")
        }, _mapInstanceProperty(shortcuts).call(shortcuts, function (e, idx) {
          return /*#__PURE__*/React.createElement("button", {
            key: idx,
            type: "button",
            className: "".concat(prefixCls, "-picker-panel__shortcut"),
            onClick: function onClick() {
              return _this7.handleShortcutClick(e);
            }
          }, e.text);
        })), /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__body")
        }, showTime && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-date-range-picker__time-header")
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__editors-wrap is-left")
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__time-picker-wrap")
        }, /*#__PURE__*/React.createElement(Input, {
          placeholder: Locales.startDate,
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          value: minDateInputText,
          onChange: function onChange(value) {
            return _this7.handleDateInputChange(value, 'min');
          },
          onBlur: function onBlur(value) {
            return _this7.handleDateInputBlur(value, 'min');
          }
        })), /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__time-picker-wrap")
        }, startTimeSelectMode === 'TimePicker' ? /*#__PURE__*/React.createElement(TimePicker, {
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          placeholder: Locales.startTime,
          format: timeFormat(format),
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this7.timePickerDisable(),
          value: minTime,
          onChange: function onChange(value) {
            return _this7.handleTimeInputChange(value, 'min');
          },
          isShowCurrent: showTimeCurrent,
          selectableRange: startTimeSelectableRange
        }) : /*#__PURE__*/React.createElement(TimePicker.TimeSelect, {
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          placeholder: Locales.startTime,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this7.timePickerDisable(),
          value: minTime,
          onChange: function onChange(value) {
            return _this7.handleTimeInputChange(value, 'min');
          },
          start: startTimeSelectModeProps.start,
          step: startTimeSelectModeProps.step,
          end: startTimeSelectModeProps.end,
          maxTime: startTimeSelectModeProps.maxTime,
          minTime: startTimeSelectModeProps.minTime
        }))), /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__editors-wrap is-right")
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__time-picker-wrap")
        }, /*#__PURE__*/React.createElement(Input, {
          placeholder: Locales.endDate,
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          value: maxDateInputText,
          readOnly: !minDate,
          onChange: function onChange(value) {
            return _this7.handleDateInputChange(value, 'max');
          },
          onBlur: function onBlur(value) {
            return _this7.handleDateInputBlur(value, 'max');
          }
        })), /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__time-picker-wrap")
        }, endTimeSelectMode === 'TimePicker' ? /*#__PURE__*/React.createElement(TimePicker, {
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          placeholder: Locales.endTime,
          format: timeFormat(format),
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this7.timePickerDisable(),
          value: maxTime,
          onChange: function onChange(value) {
            return _this7.handleTimeInputChange(value, 'max');
          },
          isShowCurrent: showTimeCurrent,
          selectableRange: endTimeSelectableRange
        }) : /*#__PURE__*/React.createElement(TimePicker.TimeSelect, {
          className: "".concat(prefixCls, "-date-range-picker__editor"),
          placeholder: Locales.endTime,
          getPopupContainer: function getPopupContainer(node) {
            return node.parentNode;
          },
          showTrigger: false,
          allowClear: false,
          disabled: _this7.timePickerDisable(),
          value: maxTime,
          onChange: function onChange(value) {
            return _this7.handleTimeInputChange(value, 'max');
          },
          start: endTimeSelectModeProps.start,
          step: endTimeSelectModeProps.step,
          end: endTimeSelectModeProps.end,
          maxTime: endTimeSelectModeProps.maxTime,
          minTime: endTimeSelectModeProps.minTime
        })))), /*#__PURE__*/React.createElement("div", {
          className: _concatInstanceProperty(_context3 = "".concat(prefixCls, "-picker-panel__content ")).call(_context3, prefixCls, "-date-range-picker__content is-left")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-date-range-picker__header")
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "left-double",
          onClick: _bindInstanceProperty(_context4 = _this7.prevYear).call(_context4, _this7, 'leftDate', leftDate, function () {}),
          className: _concatInstanceProperty(_context5 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context5, prefixCls, "-date-range-picker__prev-btn")
        }), /*#__PURE__*/React.createElement(Icon, {
          type: "left",
          onClick: _bindInstanceProperty(_context6 = _this7.prevMonth).call(_context6, _this7, 'leftDate', leftDate, function () {}),
          className: _concatInstanceProperty(_context7 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context7, prefixCls, "-date-range-picker__prev-btn")
        }), /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          value: leftDate.getFullYear(),
          sourceData: YEARS_ARRAY(yearCount),
          onChange: _bindInstanceProperty(_context8 = _this7.handleChangeYear).call(_context8, _this7, 'leftDate', leftDate)
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__header-label")
        }, _concatInstanceProperty(_context9 = "".concat(leftDate.getFullYear())).call(_context9, Locales.year))), /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          value: leftDate.getMonth() + 1,
          sourceData: Locales.MONTH_ARRAY,
          onChange: function onChange(month) {
            return _this7.handleChangeMonth.call(_this7, 'leftDate', leftDate, month, Locales);
          }
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__header-label")
        }, Locales.MONTH_ARRAY[leftDate.getMonth()])), /*#__PURE__*/React.createElement(Icon, {
          type: "right-double",
          onClick: _bindInstanceProperty(_context10 = _this7.nextYear).call(_context10, _this7, 'leftDate', leftDate, _this7.handleLeftNextYear),
          className: _concatInstanceProperty(_context11 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context11, prefixCls, "-date-range-picker__next-btn")
        }), /*#__PURE__*/React.createElement(Icon, {
          type: "right",
          onClick: _bindInstanceProperty(_context12 = _this7.nextMonth).call(_context12, _this7, 'leftDate', leftDate, _this7.handleLeftNextMonth),
          className: _concatInstanceProperty(_context13 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context13, prefixCls, "-date-range-picker__next-btn")
        })), /*#__PURE__*/React.createElement(DateTable, {
          mode: SELECTION_MODES.RANGE,
          date: leftDate,
          value: minDate,
          minDate: minDate,
          maxDate: maxDate,
          rangeState: rangeState,
          disabledDate: disabledDate,
          onChangeRange: _bindInstanceProperty(_context14 = _this7.handleChangeRange).call(_context14, _this7),
          onPick: _bindInstanceProperty(_context15 = _this7.handleRangePick).call(_context15, _this7),
          firstDayOfWeek: firstDayOfWeek
        })), /*#__PURE__*/React.createElement("div", {
          className: _concatInstanceProperty(_context16 = "".concat(prefixCls, "-picker-panel__content ")).call(_context16, prefixCls, "-date-range-picker__content is-right")
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-date-range-picker__header")
        }, /*#__PURE__*/React.createElement(Icon, {
          type: "left-double",
          onClick: _bindInstanceProperty(_context17 = _this7.prevYear).call(_context17, _this7, 'rightDate', rightDate, _this7.handleRightPrevYear),
          className: _concatInstanceProperty(_context18 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context18, prefixCls, "-date-range-picker__prev-btn")
        }), /*#__PURE__*/React.createElement(Icon, {
          type: "left",
          onClick: _bindInstanceProperty(_context19 = _this7.prevMonth).call(_context19, _this7, 'rightDate', rightDate, _this7.handleRightPrevMonth),
          className: _concatInstanceProperty(_context20 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context20, prefixCls, "-date-range-picker__prev-btn")
        }), /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          value: rightDate.getFullYear(),
          sourceData: YEARS_ARRAY(yearCount),
          onChange: _bindInstanceProperty(_context21 = _this7.handleChangeYear).call(_context21, _this7, 'rightDate', rightDate)
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__header-label")
        }, _concatInstanceProperty(_context22 = "".concat(rightDate.getFullYear())).call(_context22, Locales.year))), /*#__PURE__*/React.createElement(YearAndMonthPopover, {
          value: rightDate.getMonth() + 1,
          sourceData: Locales.MONTH_ARRAY,
          onChange: function onChange(month) {
            return _this7.handleChangeMonth.call(_this7, 'rightDate', rightDate, month, Locales);
          }
        }, /*#__PURE__*/React.createElement("span", {
          className: "".concat(prefixCls, "-date-range-picker__header-label")
        }, Locales.MONTH_ARRAY[rightDate.getMonth()])), /*#__PURE__*/React.createElement(Icon, {
          type: "right-double",
          onClick: _bindInstanceProperty(_context23 = _this7.nextYear).call(_context23, _this7, 'rightDate', rightDate, function () {}),
          className: _concatInstanceProperty(_context24 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context24, prefixCls, "-date-range-picker__next-btn")
        }), /*#__PURE__*/React.createElement(Icon, {
          type: "right",
          onClick: _bindInstanceProperty(_context25 = _this7.nextMonth).call(_context25, _this7, 'rightDate', rightDate, function () {}),
          className: _concatInstanceProperty(_context26 = "".concat(prefixCls, "-picker-panel__icon-btn ")).call(_context26, prefixCls, "-date-range-picker__next-btn")
        })), /*#__PURE__*/React.createElement(DateTable, {
          mode: SELECTION_MODES.RANGE,
          date: rightDate,
          value: maxDate,
          minDate: minDate,
          maxDate: maxDate,
          rangeState: rangeState,
          disabledDate: disabledDate,
          onChangeRange: _bindInstanceProperty(_context27 = _this7.handleChangeRange).call(_context27, _this7),
          onPick: _bindInstanceProperty(_context28 = _this7.handleRangePick).call(_context28, _this7),
          firstDayOfWeek: firstDayOfWeek
        })))), typeof footer === 'function' && footer() && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__extra-footer")
        }, footer()), showTime && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-picker-panel__footer")
        }, /*#__PURE__*/React.createElement(Button, {
          className: "".concat(prefixCls, "-picker-panel__btn cancel"),
          onClick: _this7.handleCancel
        }, Locales.cancel), /*#__PURE__*/React.createElement(Button, {
          type: "primary",
          className: classNames("".concat(prefixCls, "-picker-panel__btn confirm"), {
            disabled: _this7.confirmBtnDisabled()
          }),
          onClick: _this7.handleConfirm,
          disabled: _this7.confirmBtnDisabled()
        }, Locales.confirm)));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return {
        prefixCls: PropTypes.string,
        format: PropTypes.string,
        value: PropTypes.array,
        onPick: PropTypes.func.isRequired,
        onCancelPicked: PropTypes.func.isRequired,
        yearCount: PropTypes.number,
        shortcuts: PropTypes.arrayOf(PropTypes.shape({
          text: PropTypes.string.isRequired,
          onClick: PropTypes.func.isRequired
        })),
        disabledDate: PropTypes.func,
        firstDayOfWeek: PropTypes.number,
        footer: PropTypes.func,
        onError: PropTypes.func,
        defaultPanelMonth: PropTypes.instanceOf(Date),
        scene: PropTypes.oneOf(['past', 'future']),
        // 时间面板
        showTime: PropTypes.bool,
        showTimeCurrent: PropTypes.bool,
        startTimeSelectableRange: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
        endTimeSelectableRange: PropTypes.oneOfType([PropTypes.string, PropTypes.arrayOf(PropTypes.string)]),
        defaultStartTimeValue: PropTypes.instanceOf(Date),
        defaultEndTimeValue: PropTypes.instanceOf(Date),
        startTimeSelectMode: PropTypes.oneOf(['TimePicker', 'TimeSelect']),
        startTimeSelectModeProps: PropTypes.object,
        endTimeSelectMode: PropTypes.oneOf(['TimePicker', 'TimeSelect']),
        endTimeSelectModeProps: PropTypes.object
      };
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return {
        prefixCls: 'fishd',
        yearCount: 50,
        firstDayOfWeek: 0,
        onError: function onError() {},
        defaultPanelMonth: new Date(new Date().setHours(0, 0, 0, 0)),
        scene: 'future',
        showTime: false,
        showTimeCurrent: false,
        defaultStartTimeValue: null,
        defaultEndTimeValue: null,
        startTimeSelectMode: 'TimePicker',
        startTimeSelectModeProps: {
          start: '09:00',
          end: '18:00',
          step: '00:30',
          minTime: '',
          maxTime: ''
        },
        endTimeSelectMode: 'TimePicker',
        endTimeSelectModeProps: {
          start: '09:00',
          end: '18:00',
          step: '00:30',
          minTime: '',
          maxTime: ''
        }
      };
    }
  }, {
    key: "propsToState",
    value: function propsToState(props) {
      var setDate = function setDate(start, end) {
        var result = {
          left: start,
          right: end
        };
        // 当开始日期和结束日期在同一个月，根据不同的业务场景设置左右日历
        if (equalYearAndMonth(start, end)) {
          if (props.scene === 'past') {
            result = {
              left: _prevMonth(end),
              right: end
            };
          } else {
            result = {
              left: start,
              right: _nextMonth(start)
            };
          }
        }
        return result;
      };
      var setDefaultDate = function setDefaultDate(defaultPanelMonth) {
        var result = {};
        if (props.scene === 'past') {
          result = {
            left: _prevMonth(defaultPanelMonth),
            right: defaultPanelMonth
          };
        } else {
          result = {
            left: defaultPanelMonth,
            right: _nextMonth(defaultPanelMonth)
          };
        }
        return result;
      };
      var minTime = isValidValueArr(props.value) ? toDate(props.value[0]) : toDate(props.defaultStartTimeValue);
      var maxTime = isValidValueArr(props.value) ? toDate(props.value[1]) : toDate(props.defaultEndTimeValue);
      var minDate = isValidValueArr(props.value) ? toDate(props.value[0]) : null;
      var maxDate = isValidValueArr(props.value) ? toDate(props.value[1]) : null;
      var isSameDate = minDate && maxDate && diffDate(minDate, maxDate) === 0;
      var getTimeRangeOption = {
        minTime: minTime,
        endTimeSelectableRange: props.endTimeSelectableRange,
        endTimeSelectMode: props.endTimeSelectMode,
        endTimeSelectModeProps: props.endTimeSelectModeProps
      };
      var state = {};
      // 左侧日历月份
      state.leftDate = isValidValueArr(props.value) ? setDate(props.value[0], props.value[1])['left'] : setDefaultDate(props.defaultPanelMonth)['left'];
      // 右侧日历月份
      state.rightDate = isValidValueArr(props.value) ? setDate(props.value[0], props.value[1])['right'] : setDefaultDate(props.defaultPanelMonth)['right'];
      // 开始日期
      state.minDate = minDate;
      // 结束日期
      state.maxDate = maxDate;
      // 开始日期输入框中的值
      state.minDateInputText = isValidValueArr(props.value) ? formatDate(props.value[0], dateFormat(props.format)) : '';
      // 结束日期输入框中的值
      state.maxDateInputText = isValidValueArr(props.value) ? formatDate(props.value[1], dateFormat(props.format)) : '';
      // 开始时间
      state.minTime = minTime;
      // 结束时间
      state.maxTime = maxTime;
      // 开始时间可选范围
      state.startTimeSelectableRange = props.startTimeSelectableRange;
      // 结束时间可选范围
      state.endTimeSelectableRange = props.endTimeSelectMode === 'TimePicker' && isSameDate ? DateRangePanel.getEndTimeSelectableRange(getTimeRangeOption) : props.endTimeSelectableRange;
      state.endTimeSelectModeProps = props.endTimeSelectMode === 'TimeSelect' && isSameDate ? DateRangePanel.getEndTimeSelectableRange(getTimeRangeOption) : props.endTimeSelectModeProps;
      return state;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      // 只 value 受控
      if ('value' in nextProps && !isEqual(prevState.prevPropValue, nextProps.value)) {
        var state = DateRangePanel.propsToState(nextProps);
        state.prevPropValue = nextProps.value;
        return state;
      }
      return null;
    }
  }]);
  return DateRangePanel;
}(React.Component); // 计算结束时间的可选范围
DateRangePanel.getEndTimeSelectableRange = function (_ref2) {
  var minTime = _ref2.minTime,
    endTimeSelectableRange = _ref2.endTimeSelectableRange,
    endTimeSelectMode = _ref2.endTimeSelectMode,
    endTimeSelectModeProps = _ref2.endTimeSelectModeProps;
  //TimePicker模式下返回endTimeSelectableRange
  if (endTimeSelectMode === 'TimePicker') {
    var propsTimeRangeArr = converSelectRange({
      selectableRange: endTimeSelectableRange
    });
    if (!minTime) return endTimeSelectableRange;
    var getTimeString = function getTimeString(date) {
      var _context29, _context30;
      return _concatInstanceProperty(_context29 = _concatInstanceProperty(_context30 = "".concat(date.getHours(), ":")).call(_context30, date.getMinutes(), ":")).call(_context29, date.getSeconds());
    };
    var rangeResult = [];
    if (propsTimeRangeArr && propsTimeRangeArr.length > 0) {
      var min = minTime;
      var max = setTime(new Date(minTime), new Date(new Date().setHours(23, 59, 59)));
      var _iterator = _createForOfIteratorHelper(propsTimeRangeArr),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _context31;
          var range = _step.value;
          min = Math.max(min, range[0]);
          max = Math.min(max, range[1]);
          rangeResult.push(_concatInstanceProperty(_context31 = "".concat(getTimeString(new Date(min)), " - ")).call(_context31, getTimeString(new Date(max))));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    } else {
      rangeResult = ["".concat(getTimeString(minTime), " - 23:59:59")];
    }
    return rangeResult;
    //TimeSelect模式下返回endTimeSelectModeProps
  } else {
    // let propsResult = endTimeSelectModeProps;
    // propsResult.minTime = dateToStr(minTime);
    var propsResult = _Object$assign({}, endTimeSelectModeProps, {
      minTime: dateToStr(minTime)
    });
    return propsResult;
  }
};
DateRangePanel.isValid = function (value, disabledDate) {
  if (value && value.length >= 2 && value[0] > value[1]) return false;
  return typeof disabledDate === 'function' && value && value.length >= 2 ? !(disabledDate(value[0]) || disabledDate(value[1])) : true;
};
export default DateRangePanel;