import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as PropTypes from 'prop-types';
import RcDrawer from './src';
var Drawer = /*#__PURE__*/function (_React$Component) {
  _inherits(Drawer, _React$Component);
  var _super = _createSuper(Drawer);
  function Drawer(props) {
    _classCallCheck(this, Drawer);
    return _super.call(this, props);
  }
  _createClass(Drawer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        className = _this$props.className,
        wrapperClassName = _this$props.wrapperClassName,
        width = _this$props.width,
        height = _this$props.height,
        visible = _this$props.visible,
        placement = _this$props.placement,
        getContainer = _this$props.getContainer,
        style = _this$props.style,
        mask = _this$props.mask,
        maskStyle = _this$props.maskStyle,
        handler = _this$props.handler,
        level = _this$props.level,
        ease = _this$props.ease,
        duration = _this$props.duration,
        closed = _this$props.closed,
        onMaskClick = _this$props.onMaskClick,
        onChange = _this$props.onChange,
        onHandleClick = _this$props.onHandleClick,
        onCloseClick = _this$props.onCloseClick;
      return /*#__PURE__*/React.createElement(RcDrawer, {
        className: className,
        wrapperClassName: wrapperClassName,
        width: width,
        height: height,
        open: visible,
        closed: closed,
        placement: placement,
        getContainer: getContainer,
        showMask: mask,
        level: level,
        ease: ease,
        duration: duration,
        maskStyle: maskStyle,
        style: style,
        handler: handler,
        onMaskClick: onMaskClick,
        onHandleClick: onHandleClick,
        onChange: onChange,
        onCloseClick: onCloseClick
      }, this.props.children);
    }
  }]);
  return Drawer;
}(React.Component);
export { Drawer as default };
Drawer.propTypes = {
  // prefixCls: PropTypes.string,
  className: PropTypes.string,
  wrapperClassName: PropTypes.string,
  width: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  height: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  visible: PropTypes.bool,
  closed: PropTypes.bool,
  placement: PropTypes.oneOf(['left', 'right', 'bottom', 'top']),
  getContainer: PropTypes.oneOfType([PropTypes.string, PropTypes.object, PropTypes.func, PropTypes.bool]),
  style: PropTypes.object,
  mask: PropTypes.bool,
  maskStyle: PropTypes.object,
  children: PropTypes.node,
  handler: PropTypes.oneOfType([PropTypes.bool, PropTypes.node]),
  level: PropTypes.oneOfType([PropTypes.string, PropTypes.array]),
  ease: PropTypes.string,
  duration: PropTypes.string,
  onChange: PropTypes.func,
  onMaskClick: PropTypes.func,
  onHandleClick: PropTypes.func,
  onCloseClick: PropTypes.func
};
Drawer.defaultProps = {
  // prefixCls: "fishd-drawer",
  placement: 'right',
  onChange: function onChange() {},
  onMaskClick: function onMaskClick() {},
  onHandleClick: function onHandleClick() {}
};