import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import classNames from 'classnames';
import omit from 'omit.js';
var Icon = function Icon(props) {
  var type = props.type,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    spinning = props.spinning;
  var classString = classNames(_defineProperty({
    fishdicon: true,
    'fishdicon-spin': spinning || type === 'loading'
  }, "fishdicon-".concat(type), true), className);
  return /*#__PURE__*/React.createElement("i", _Object$assign({}, omit(props, ['type', 'spinning']), {
    className: classString
  }));
};
export default Icon;