import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
var BasicLayout = /*#__PURE__*/function (_React$Component) {
  _inherits(BasicLayout, _React$Component);
  var _super = _createSuper(BasicLayout);
  function BasicLayout() {
    var _this;
    _classCallCheck(this, BasicLayout);
    _this = _super.apply(this, arguments);
    _this.state = {
      siders: []
    };
    return _this;
  }
  _createClass(BasicLayout, [{
    key: "getChildContext",
    value: function getChildContext() {
      var _this2 = this;
      return {
        siderHook: {
          addSider: function addSider(id) {
            var _context;
            _this2.setState({
              siders: _concatInstanceProperty(_context = []).call(_context, _toConsumableArray(_this2.state.siders), [id])
            });
          },
          removeSider: function removeSider(id) {
            var _context2;
            _this2.setState({
              siders: _filterInstanceProperty(_context2 = _this2.state.siders).call(_context2, function (currentId) {
                return currentId !== id;
              })
            });
          }
        }
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        children = _a.children,
        hasSider = _a.hasSider,
        others = __rest(_a, ["prefixCls", "className", "children", "hasSider"]);
      var divCls = classNames(className, prefixCls, _defineProperty({}, "".concat(prefixCls, "-has-sider"), hasSider || this.state.siders.length > 0));
      return /*#__PURE__*/React.createElement("div", _Object$assign({
        className: divCls
      }, others), children);
    }
  }]);
  return BasicLayout;
}(React.Component);
export { BasicLayout as default };
BasicLayout.childContextTypes = {
  siderHook: PropTypes.object
};