import React from 'react';
import './style/index.less';
interface LoadMoreProps {
    buttonSize: 'small' | 'default' | 'large';
    className?: string;
    defaultText: string | React.ReactNode;
    onLoadMore: () => void;
    endText: string | React.ReactNode;
    errorText: string | React.ReactNode;
    loadingText: string | React.ReactNode;
    status: string;
    extraCls?: string;
}
export default class LoadMore extends React.Component<LoadMoreProps> {
    static propTypes: {
        onLoadMore: any;
        className: any;
        status: any;
        defaultText: any;
        loadingText: any;
        errorText: any;
        endText: any;
        extraCls: any;
        buttonSize: any;
    };
    static defaultProps: {
        onLoadMore: () => void;
        status: string;
        defaultText: string;
        loadingText: string;
        errorText: string;
        endText: string;
        buttonSize: string;
    };
    constructor(props: LoadMoreProps);
    render(): JSX.Element;
}
export {};
