import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Button from '../Button';
import './style/index.less';
import ConfigConsumer from '../Config/Consumer';
var noop = function noop() {};
var LoadMore = /*#__PURE__*/function (_React$Component) {
  _inherits(LoadMore, _React$Component);
  var _super = _createSuper(LoadMore);
  function LoadMore(props) {
    _classCallCheck(this, LoadMore);
    return _super.call(this, props);
  }
  _createClass(LoadMore, [{
    key: "render",
    value: function render() {
      var _a = this.props,
        defaultText = _a.defaultText,
        onLoadMore = _a.onLoadMore,
        status = _a.status,
        buttonSize = _a.buttonSize,
        loadingText = _a.loadingText,
        errorText = _a.errorText,
        endText = _a.endText,
        extraCls = _a.extraCls,
        otherProps = __rest(_a, ["defaultText", "onLoadMore", "status", "buttonSize", "loadingText", "errorText", "endText", "extraCls"]);
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "LoadMore"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", {
          className: classNames('fishd-loadmore', _defineProperty({}, "".concat(extraCls), !!extraCls))
        }, status === 'end' ? /*#__PURE__*/React.createElement("span", {
          className: "z-load-end"
        }, Locale.endText) : /*#__PURE__*/React.createElement(Button, _Object$assign({
          size: buttonSize,
          onClick: onLoadMore,
          loading: status === 'loading'
        }, otherProps), function () {
          switch (status) {
            case 'default':
              return Locale.defaultText;
              break;
            case 'loading':
              return Locale.loadingText;
              break;
            case 'error':
              return Locale.errorText;
              break;
            case 'end':
              return Locale.endText;
          }
        }()));
      });
    }
  }]);
  return LoadMore;
}(React.Component);
export { LoadMore as default };
LoadMore.propTypes = {
  onLoadMore: PropTypes.func,
  className: PropTypes.string,
  status: PropTypes.string,
  defaultText: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  loadingText: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  errorText: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  endText: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  extraCls: PropTypes.string,
  buttonSize: PropTypes.string
};
LoadMore.defaultProps = {
  onLoadMore: noop,
  status: 'default',
  defaultText: '查看更多',
  loadingText: '加载中',
  errorText: '加载失败，请重试',
  endText: '没有更多了',
  buttonSize: 'default'
};