var localeValues = {
  locale: 'zh_TW',
  AudioPlayer: {
    notSupport: '您的瀏覽器不支持 audio 標籤。'
  },
  AutoComplete: {
    notFoundContent: '無匹配結果'
  },
  Cascader: {
    placeholder: '請選擇',
    notFoundContent: '無匹配結果'
  },
  Table: {
    filterTitle: '篩選',
    filterConfirm: '確定',
    filterReset: '重置',
    filterEmptyText: '無篩選項',
    emptyText: '暫無數據',
    selectAll: '全選當頁',
    selectInvert: '反選當頁',
    selectionAll: '全選所有',
    sortTitle: '排序',
    expand: '展開行',
    collapse: '關閉行',
    triggerDesc: '點擊降序',
    triggerAsc: '點擊升序',
    cancelSort: '取消排序',
    modalTitle: '選擇需要展示的數據項',
    defaultOptionTitle: '默認展示數據項',
    okText: '確定',
    cancelText: '取消',
    draggableTitle: '字段',
    draggableAction: '拖拽排序'
  },
  Modal: {
    okText: '確定',
    cancelText: '取消'
  },
  Pagination: {
    items_per_page: '條/頁',
    jump_to: '跳至',
    jump_to_confirm: '確定',
    page: '頁',
    // Pagination.js
    prev_page: '上一頁',
    next_page: '下一頁',
    prev_5: '向前 5 頁',
    next_5: '向後 5 頁',
    prev_3: '向前 3 頁',
    next_3: '向後 3 頁'
  },
  RichEditor: {
    // editor
    insertImageTip: '支持jpg、jpeg、png、gif、bmp格式的圖片，最佳顯示高度不超過400px，寬度不超過270px。',
    rule1: '1、單個視頻不超過10M，支持MP4、3GP格式視頻。',
    rule2: '2、最佳顯示高度不超過400px',
    PleaseEnterTheVideolinkURL: "請輸入視頻鏈接URL",
    selectLocalVideo: '選擇本地視頻',
    videoLink: '視頻鏈接',
    localVideo: "本地視頻",
    insertVideo: '插入視頻',
    selectLocalImage: "選擇本地圖片",
    insertAttachment: "插入附件",
    selectLocalFile: "選擇本地文件",
    HyperlinkAddress: '超鏈接地址',
    insertPicture: '插入圖片',
    noVideoLinkErrorTip: '請設置視頻源地址',
    VideoCantPlayTip: '視頻無法播放',
    file: '[文件] ',
    noFileInfoTip: '文件信息讀取失敗',
    noPicSrcTip: '請設置圖片源地址',
    noVideoUrlErrorTip: '視頻鏈接URL不得為空',
    videoUrlFormattingError: '視頻鏈接URL格式錯誤',
    videoLinkTooLongError: '視頻鏈接不得超過1000個字',
    linkEmptyTip: '鏈接地址不得為空',
    linkToolongError: '鏈接地址不得超過1000個字',
    noSelectionText: '沒有選中文本',
    insertLink: '插入超鏈接',
    editLink: '編輯超鏈接',
    //toolbar
    hyperlinks: '超鏈接',
    backgroundColor: '背景色',
    textDirection: '文字方向',
    increaseIndent: '增加縮進',
    decreaseIndent: '減少縮進',
    subScript: '下腳標',
    superSciprt: '上腳標',
    codeBlock: '代碼塊',
    blockquote: '塊引用',
    strike: '刪除線',
    brushFormat: '格式刷',
    clearFormat: '清除格式',
    fontSize: '文字大小',
    insertEmoji: '插入表情',
    defaultEmoji: '默認表情',
    emojiEmoji: 'emoji表情',
    orderedList: '有序列表',
    unOrderedList: '無序列表',
    alignJustified: '兩端對齊',
    alignCenter: '居中',
    alignRight: '居右',
    alignLeft: '居左',
    fontColor: '文字顏色',
    underline: '下劃線',
    italic: '斜體',
    bold: '粗體',
    temporarilyNoData: '暫無數據',
    enterKeyWordPlease: '請輸入關鍵字',
    placeholder: '請輸入內容',
    justOkText: '知道了',
    accessLink: '訪問鏈接',
    edit: '編輯',
    deleteText: '删除',
    lineHeight: '行距',
    fullScreen: '全屏',
    exitFullScreen: '退出全屏',
    undo: '撤銷',
    redo: '恢復',
    defaultLineHeight: '默認',
    table: '插入表格',
    insertColRight: '右側插入列',
    insertColLeft: '左側插入列',
    insertRowBelow: '下方插入行',
    insertRowAbove: '上方插入行',
    deleteCol: '刪除列',
    deleteRow: '刪除行',
    deleteTable: '刪除表格',
    tableDesc: '插入支持富文本的表格',
    // find
    findAndReplace: '查找與替換',
    find: '查找',
    replace: '替換',
    caseSensitive: '區分大小寫',
    replaceTo: '替換為',
    replaceAll: '全部替換'
  },
  Spin: {
    loading: '加載中'
  },
  Select: {
    errorMessage: '超過選項上限',
    multipleSelectAllText: '所有選項',
    notFoundContent: '無匹配結果',
    placeholder: '請選擇',
    searchPlaceholder: '請輸入關鍵字',
    selectAllText: '選擇所有',
    confirmText: '確定',
    cancelText: '取消',
    loading: '加載中…'
  },
  Transfer: {
    notFoundContent: '無匹配結果',
    sourceNotFoundContent: '暫無相關信息',
    targetNotFonudContent: '請從左側選擇添加',
    searchPlaceholder: '請輸入關鍵字'
  },
  TreeSelect: {
    placeholder: '請選擇',
    searchPlaceholder: '請輸入關鍵字',
    treeNodeResetTitle: '不選擇任何分類',
    notFoundContent: '無匹配結果',
    okText: '確定',
    cancelText: '取消'
  },
  Upload: {
    uploading: '上傳中',
    removeFile: '移除文件',
    uploadError: '上傳錯誤',
    previewFile: '預覽文件',
    cancelText: '取消',
    deleteText: '全部刪除',
    uploadedTip: '已上傳 ${length} 項'
  },
  List: {
    emptyText: '暫無數據'
  },
  Guide: {
    prevBtnText: '上一步',
    nextBtnText: '下一步',
    doneBtnText: '知道了',
    skipBtnText: '跳過'
  },
  LoadMore: {
    defaultText: '查看更多',
    loadingText: '加載中',
    errorText: '加載失敗，請重試',
    endText: '沒有更多了'
  },
  DatePicker: {
    now: '現在',
    today: '今天',
    cancel: '取消',
    clear: '清空',
    confirm: '確定',
    startPlaceholder: '開始日期',
    endPlaceholder: '結束日期',
    separator: '至',
    selectDate: '下方選擇日期',
    selectTime: '請選擇時間',
    startDate: '開始日期',
    startTime: '開始時間',
    endDate: '結束日期',
    endTime: '結束時間',
    year: '年',
    MONTH_ARRAY: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
    week: '週次',
    weeks: {
      sun: '日',
      mon: '一',
      tue: '二',
      wed: '三',
      thu: '四',
      fri: '五',
      sat: '六'
    },
    months: {
      jan: '一月',
      feb: '二月',
      mar: '三月',
      apr: '四月',
      may: '五月',
      jun: '六月',
      jul: '七月',
      aug: '八月',
      sep: '九月',
      oct: '十月',
      nov: '十一月',
      dec: '十二月'
    }
  },
  VideoViewer: {
    fullScreen: '全屏',
    cancelFullScreen: '取消全屏',
    download: '下載',
    retry: '重試'
  }
};
export default localeValues;