import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Dialog from './Dialog';
import { ContainerRender, Portal } from '../../utils';
import './style/index.less';
var IS_REACT_16 = ('createPortal' in ReactDOM);
var DialogWrap = /*#__PURE__*/function (_React$Component) {
  _inherits(DialogWrap, _React$Component);
  var _super = _createSuper(DialogWrap);
  function DialogWrap() {
    var _this;
    _classCallCheck(this, DialogWrap);
    _this = _super.apply(this, arguments);
    _this.saveDialog = function (node) {
      _this._component = node;
    };
    _this.getComponent = function () {
      var extra = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      return /*#__PURE__*/React.createElement(Dialog, _Object$assign({
        ref: _this.saveDialog
      }, _this.props, extra, {
        key: "dialog"
      }));
    };
    // fix issue #10656
    /*
     * Custom container should not be return, because in the Portal component, it will remove the
     * return container element here, if the custom container is the only child of it's component,
     * like issue #10656, It will has a conflict with removeChild method in react-dom.
     * So here should add a child (div element) to custom container.
     * */
    _this.getContainer = function () {
      var container = document.createElement('div');
      if (_this.props.getContainer) {
        _this.props.getContainer().appendChild(container);
      } else {
        document.body.appendChild(container);
      }
      return container;
    };
    return _this;
  }
  _createClass(DialogWrap, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(_ref) {
      var visible = _ref.visible;
      return !!(this.props.visible || visible);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (IS_REACT_16) {
        return;
      }
      if (this.props.visible) {
        this.renderComponent({
          afterClose: this.removeContainer,
          onClose: function onClose() {},
          visible: false
        });
      } else {
        this.removeContainer();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var visible = this.props.visible;
      var portal = null;
      if (!IS_REACT_16) {
        return /*#__PURE__*/React.createElement(ContainerRender, {
          parent: this,
          visible: visible,
          autoDestroy: false,
          getComponent: this.getComponent,
          getContainer: this.getContainer
        }, function (_ref2) {
          var renderComponent = _ref2.renderComponent,
            removeContainer = _ref2.removeContainer;
          _this2.renderComponent = renderComponent;
          _this2.removeContainer = removeContainer;
          return null;
        });
      }
      if (visible || this._component) {
        portal = /*#__PURE__*/React.createElement(Portal, {
          getContainer: this.getContainer
        }, this.getComponent());
      }
      return portal;
    }
  }]);
  return DialogWrap;
}(React.Component);
DialogWrap.defaultProps = {
  visible: false
};
export default DialogWrap;