import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import Modal from './Modal';
import confirm from './confirm';
import './style/index.less';
Modal.info = function (props) {
  var config = _Object$assign({
    type: 'info',
    iconType: 'hints-notification',
    okCancel: false
  }, props);
  return confirm(config);
};
Modal.success = function (props) {
  var config = _Object$assign({
    type: 'success',
    iconType: 'hints-success',
    okCancel: false
  }, props);
  return confirm(config);
};
Modal.error = function (props) {
  var config = _Object$assign({
    type: 'error',
    iconType: 'hints-error',
    okCancel: false
  }, props);
  return confirm(config);
};
Modal.warning = Modal.warn = function (props) {
  var config = _Object$assign({
    type: 'warning',
    iconType: 'hints-warning',
    okCancel: false
  }, props);
  return confirm(config);
};
Modal.confirm = function (props) {
  var config = _Object$assign({
    type: 'confirm',
    okCancel: true
  }, props);
  return confirm(config);
};
export default Modal;