import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import React from 'react';
import PropTypes from 'prop-types';
var Pager = function Pager(props) {
  var _context, _context2;
  var prefixCls = "".concat(props.rootPrefixCls, "-item");
  var cls = _concatInstanceProperty(_context = _concatInstanceProperty(_context2 = "".concat(prefixCls, " ")).call(_context2, prefixCls, "-")).call(_context, props.page);
  if (props.active) {
    var _context3;
    cls = _concatInstanceProperty(_context3 = "".concat(cls, " ")).call(_context3, prefixCls, "-active");
  }
  if (props.className) {
    var _context4;
    cls = _concatInstanceProperty(_context4 = "".concat(cls, " ")).call(_context4, props.className);
  }
  var handleClick = function handleClick() {
    props.onClick(props.page);
  };
  var handleKeyPress = function handleKeyPress(e) {
    props.onKeyPress(e, props.onClick, props.page);
  };
  return /*#__PURE__*/React.createElement("li", {
    title: props.showTitle ? props.page : null,
    className: cls,
    onClick: handleClick,
    onKeyPress: handleKeyPress,
    tabIndex: "0"
  }, props.itemRender(props.page, 'page', /*#__PURE__*/React.createElement("a", null, props.page)));
};
Pager.propTypes = {
  page: PropTypes.number,
  active: PropTypes.bool,
  last: PropTypes.bool,
  locale: PropTypes.object,
  className: PropTypes.string,
  showTitle: PropTypes.bool,
  rootPrefixCls: PropTypes.string,
  onClick: PropTypes.func,
  onKeyPress: PropTypes.func,
  itemRender: PropTypes.func
};
export default Pager;