import * as React from 'react';
import { RadioGroupProps, RadioGroupState, RadioChangeEvent } from './interface';
declare class RadioGroup extends React.Component<RadioGroupProps, RadioGroupState> {
    static defaultProps: {
        disabled: boolean;
        prefixCls: string;
        buttonStyle: string;
    };
    static childContextTypes: {
        radioGroup: any;
    };
    static getDerivedStateFromProps(nextProps: RadioGroupProps): {
        value: any;
    };
    constructor(props: RadioGroupProps);
    getChildContext(): {
        radioGroup: {
            onChange: (ev: RadioChangeEvent) => void;
            value: any;
            disabled: boolean;
            name: string;
        };
    };
    shouldComponentUpdate(nextProps: RadioGroupProps, nextState: RadioGroupState): boolean;
    onRadioChange: (ev: RadioChangeEvent) => void;
    render(): JSX.Element;
}
export default RadioGroup;
