import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from '../quill';
var Embed = Quill["import"]('blots/embed');
var Attach = /*#__PURE__*/function (_Embed) {
  _inherits(Attach, _Embed);
  var _super = _createSuper(Attach);
  function Attach() {
    _classCallCheck(this, Attach);
    return _super.apply(this, arguments);
  }
  _createClass(Attach, [{
    key: "format",
    value: function format(name, data) {
      this.statics.formatCursor = true;
      if (data) {
        this.domNode.setAttribute(name, data && data.toString());
        var label = this.domNode.querySelector('a');
        if (name === 'data-iconUrl') {
          var img = this.domNode.querySelector('img');
          img.src = data;
        } else if (name === 'data-href') {
          label.setAttribute('href', data && data.toString());
        } else if (name === 'data-title') {
          label.innerText = data;
          label.setAttribute('download', data || '');
        }
      }
      _get(_getPrototypeOf(Attach.prototype), "format", this).call(this, name, data);
    }
  }], [{
    key: "create",
    value: function create(data) {
      this.formatCursor = false;
      var node = _get(_getPrototypeOf(Attach), "create", this).call(this, data);
      var defaultImage = data.iconUrl;
      var img = document.createElement('img');
      img.src = defaultImage;
      img.setAttribute('class', 'attach_icon');
      img.style.cssText = 'width: 25px;height: 25px;';
      node.appendChild(img);
      var ALabel = document.createElement('a');
      ALabel.innerText = data.name;
      ALabel.href = data.url;
      ALabel.target = '_blank';
      ALabel.style.cssText = "\n      margin-left: 4px;\n      vertical-align: middle;\n      text-decoration: none;\n      display: inline;\n    ";
      ALabel.setAttribute('download', data.name || '');
      node.appendChild(ALabel);
      node.style.cssText = "display:inline-block;border:1px solid #ddd;padding:4px;margin: 4px;user-select: text;";
      node.setAttribute('contenteditable', 'false');
      node.setAttribute('data-title', data.name);
      node.setAttribute('data-href', data.url);
      node.setAttribute('data-iconUrl', defaultImage);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      return {
        'data-href': node.getAttribute('data-href') || node.getAttribute('href'),
        'data-title': node.getAttribute('data-title') || node.getAttribute('title'),
        'data-iconUrl': node.getAttribute('data-iconUrl') || node.getAttribute('iconUrl')
      };
    }
  }]);
  return Attach;
}(Embed);
Attach.blotName = 'attach';
Attach.tagName = 'div';
Attach.className = 'attach_file';
export { Attach as default };