import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from '../quill';
var Embed = Quill["import"]('blots/embed');
export var getAttrs = function getAttrs(node) {
  var value = {};
  if (node.hasAttributes()) {
    var attrs = node.attributes;
    for (var i = attrs.length - 1; i >= 0; i--) {
      value[attrs[i].name] = attrs[i].value;
    }
  }
  return value;
};
var ImageBlot = /*#__PURE__*/function (_Embed) {
  _inherits(ImageBlot, _Embed);
  var _super = _createSuper(ImageBlot);
  function ImageBlot() {
    _classCallCheck(this, ImageBlot);
    return _super.apply(this, arguments);
  }
  _createClass(ImageBlot, [{
    key: "format",
    value: function format(name, value) {
      _get(_getPrototypeOf(ImageBlot.prototype), "format", this).call(this, name, value);
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = _get(_getPrototypeOf(ImageBlot), "create", this).call(this);
      if (Object.prototype.toString.call(value) == '[object Object]') {
        var _context;
        _forEachInstanceProperty(_context = _Object$keys(value)).call(_context, function (key) {
          try {
            node.setAttribute(key, value[key]);
          } catch (e) {
            console.error(e); // eslint-disable-line
          }
        });
      } else if (typeof value == 'string') {
        node.setAttribute('src', value);
      }
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      return getAttrs(node);
    }
  }, {
    key: "value",
    value: function value(node) {
      return getAttrs(node);
    }
  }]);
  return ImageBlot;
}(Embed);
ImageBlot.blotName = 'image';
ImageBlot.tagName = 'img';
export default ImageBlot;