import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from '../quill';
var Inline = Quill["import"]('blots/inline');
var Link = /*#__PURE__*/function (_Inline) {
  _inherits(Link, _Inline);
  var _super = _createSuper(Link);
  function Link() {
    _classCallCheck(this, Link);
    return _super.apply(this, arguments);
  }
  _createClass(Link, [{
    key: "format",
    value:
    // static sanitize(url) {
    //   return sanitize(url, this.PROTOCOL_WHITELIST) ? url : this.SANITIZED_URL;
    // }
    function format(name, data) {
      if (name !== this.statics.blotName || !data) {
        _get(_getPrototypeOf(Link.prototype), "format", this).call(this, name, data);
      } else {
        // 在超链接内输入回车时需要为光标添加超链接
        this.statics.formatCursor = true;
        if (data) {
          this.domNode.setAttribute('href', data.url);
          if (data.type != null) {
            this.domNode.setAttribute('data-ql-link-type', data.type);
            if (data.type == 'attachment') {
              this.domNode.setAttribute('contenteditable', 'false');
              this.domNode.setAttribute('download', data.name || '');
            }
          }
        }
      }
    }
  }], [{
    key: "create",
    value: function create(data) {
      this.formatCursor = false;
      var node = _get(_getPrototypeOf(Link), "create", this).call(this, data);
      if (data) {
        node.setAttribute('target', '_blank');
        node.setAttribute('href', data.url);
        if (data.type != null) {
          node.setAttribute('data-ql-link-type', data.type);
          if (data.type == 'attachment') {
            node.setAttribute('download', data.name || '');
            node.setAttribute('contenteditable', 'false');
          }
        }
      }
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      // 修复在超链接后输入回车光标被异常添加超链接的问题
      var domChildren = node.children;
      // let containsCursor = /<\s*span\s*class\s*=\s*['"]\s*ql-cursor\s*['"]\s*>\s*\ufeff\s*<\s*\/\s*span\s*>/gi;
      if (!this.formatCursor && domChildren && domChildren.length == 1 && domChildren[0].innerText == "\uFEFF") {
        return {};
      }
      return {
        url: node.getAttribute('href'),
        type: node.getAttribute('data-ql-link-type'),
        name: node.getAttribute('download')
      };
    }
  }]);
  return Link;
}(Inline);
Link.blotName = 'link';
Link.tagName = 'A';
Link.formatCursor = false; // 是否为光标添加超链接
// Link.SANITIZED_URL = 'about:blank';
// Link.PROTOCOL_WHITELIST = ['http', 'https', 'mailto', 'tel'];
function sanitize(url, protocols) {
  var _context, _context2;
  var anchor = document.createElement('a');
  anchor.href = url;
  var protocol = _sliceInstanceProperty(_context = anchor.href).call(_context, 0, _indexOfInstanceProperty(_context2 = anchor.href).call(_context2, ':'));
  return _indexOfInstanceProperty(protocols).call(protocols, protocol) > -1;
}
export { Link as default, sanitize };