import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _get from "@babel/runtime-corejs3/helpers/get";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { Quill } from '../quill';
var Clipboard = Quill["import"]('modules/clipboard');
var Delta = Quill["import"]('delta');
var CustomClipboard = /*#__PURE__*/function (_Clipboard) {
  _inherits(CustomClipboard, _Clipboard);
  var _super = _createSuper(CustomClipboard);
  function CustomClipboard(quill, options) {
    _classCallCheck(this, CustomClipboard);
    return _super.call(this, quill, options);
  }
  _createClass(CustomClipboard, [{
    key: "onPaste",
    value: function onPaste(range, _ref) {
      var text = _ref.text,
        html = _ref.html;
      if (this.options) {
        var _this$options = this.options,
          pastePlainText = _this$options.pastePlainText,
          pasteFormater = _this$options.pasteFormater;
        var newText = text;
        var newHtml = html ? html : text; // fix: empty html string on Windows
        if (pastePlainText) {
          newHtml = text;
          if (pasteFormater) {
            newHtml = pasteFormater(newHtml);
          }
          newText = newHtml.innerText ? newHtml.innerText() : newHtml;
          var delta = new Delta().retain(range.index)["delete"](range.length).insert(newText),
            index = newText.length + range.index,
            length = 0;
          this.quill.updateContents(delta, 'silent');
          this.quill.setSelection(index, length, 'silent');
          this.quill.scrollIntoView();
        } else if (pasteFormater) {
          newHtml = pasteFormater(newHtml);
          newText = newHtml.innerText ? newHtml.innerText() : newHtml;
          _get(_getPrototypeOf(CustomClipboard.prototype), "onPaste", this).call(this, range, {
            text: newText,
            html: newHtml
          });
        } else {
          _get(_getPrototypeOf(CustomClipboard.prototype), "onPaste", this).call(this, range, {
            text: text,
            html: html
          });
        }
      } else {
        _get(_getPrototypeOf(CustomClipboard.prototype), "onPaste", this).call(this, range, {
          text: text,
          html: html
        });
      }
    }
  }]);
  return CustomClipboard;
}(Clipboard);
export default CustomClipboard;