import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import BaseModule from './BaseModule';
var DisplaySize = /*#__PURE__*/function (_BaseModule) {
  _inherits(DisplaySize, _BaseModule);
  var _super = _createSuper(DisplaySize);
  function DisplaySize() {
    _classCallCheck(this, DisplaySize);
    return _super.apply(this, arguments);
  }
  _createClass(DisplaySize, [{
    key: "onCreate",
    value: function onCreate() {
      // Create the container to hold the size display
      this.display = document.createElement('div');
      // Apply styles
      _Object$assign(this.display.style, this.options.styles.display);
      // Attach it
      this.overlay.appendChild(this.display);
    }
  }, {
    key: "onUpdate",
    value: function onUpdate() {
      if (!this.display || !this.activeEle) {
        return;
      }
      var size = this.getCurrentSize();
      this.display.innerHTML = size.join(' &times; ');
      if (size[0] > 120 && size[1] > 30) {
        // position on top of image
        _Object$assign(this.display.style, {
          right: '4px',
          bottom: '4px',
          left: 'auto'
        });
      } else if (this.activeEle.style["float"] === 'right') {
        // position off bottom left
        var displayRect = this.display.getBoundingClientRect();
        _Object$assign(this.display.style, {
          right: 'auto',
          bottom: "-".concat(displayRect.height + 4, "px"),
          left: "-".concat(displayRect.width + 4, "px")
        });
      } else {
        // position off bottom right
        var _displayRect = this.display.getBoundingClientRect();
        _Object$assign(this.display.style, {
          right: "-".concat(_displayRect.width + 4, "px"),
          bottom: "-".concat(_displayRect.height + 4, "px"),
          left: 'auto'
        });
      }
    }
  }, {
    key: "getCurrentSize",
    value: function getCurrentSize() {
      return [this.activeEle.offsetWidth, this.activeEle.offsetHeight];
    }
  }]);
  return DisplaySize;
}(BaseModule);
export { DisplaySize as default };