import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import BaseModule from './BaseModule';
import { Quill } from "../../../quill";
var Parchment = Quill["import"]('parchment');
// Quill.js 2.x support
var ClassAttributor = Parchment.ClassAttributor ? Parchment.ClassAttributor : Parchment.Attributor.Class;
var ImageFormatClass = new ClassAttributor('imagestyle', 'ql-resize-style');
var Toolbar = /*#__PURE__*/function (_BaseModule) {
  _inherits(Toolbar, _BaseModule);
  var _super = _createSuper(Toolbar);
  function Toolbar() {
    _classCallCheck(this, Toolbar);
    return _super.apply(this, arguments);
  }
  _createClass(Toolbar, [{
    key: "onCreate",
    value: function onCreate() {
      // Setup Toolbar
      this.toolbar = document.createElement('div');
      _Object$assign(this.toolbar.style, this.options.styles.toolbar);
      this.overlay.appendChild(this.toolbar);
      // Setup Buttons
      this._defineAlignments();
      this._addToolbarButtons();
    }
  }, {
    key: "_defineAlignments",
    value: function _defineAlignments() {
      var _this = this;
      this.alignments = [{
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-lef\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'left');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'left';
        }
      }, {
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-mid\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'center');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'center';
        }
      }, {
        icon: "<i class=\"fishdicon fishdicon-richeditor-align-rig\"></i>",
        apply: function apply() {
          ImageFormatClass.add(_this.activeEle, 'right');
        },
        isApplied: function isApplied() {
          return ImageFormatClass.value(_this.activeEle) === 'right';
        }
      }
      // {
      //   icon:`<i class="fishdicon fishdicon-richeditor-align-all"></i>`,
      //   apply: () => {
      //     ImageFormatClass.add(this.activeEle, 'full');
      //   },
      //   isApplied: () => ImageFormatClass.value(this.activeEle) === 'full'
      // }
      ];
    }
  }, {
    key: "_addToolbarButtons",
    value: function _addToolbarButtons() {
      var _context,
        _this2 = this;
      var buttons = [];
      _forEachInstanceProperty(_context = this.alignments).call(_context, function (alignment, idx) {
        var button = document.createElement('span');
        buttons.push(button);
        button.innerHTML = alignment.icon;
        button.addEventListener('click', function () {
          // deselect all buttons
          _forEachInstanceProperty(buttons).call(buttons, function (button) {
            return button.style.filter = '';
          });
          if (alignment.isApplied()) {
            // If applied, unapply
            ImageFormatClass.remove(_this2.activeEle);
          } else {
            // otherwise, select button and apply
            _this2._selectButton(button);
            alignment.apply();
          }
          // image may change position; redraw drag handles
          _this2.requestUpdate();
        });
        _Object$assign(button.style, _this2.options.styles.toolbarButton);
        if (idx > 0) {
          button.style.borderLeftWidth = '0';
        }
        // console.log(button)
        _Object$assign(button.children[0].style, _this2.options.styles.toolbarButtonSvg);
        if (alignment.isApplied()) {
          // select button if previously applied
          _this2._selectButton(button);
        }
        _this2.toolbar.appendChild(button);
      });
      // Edit button
      // const button = document.createElement('span')
      // button.innerHTML = IconPencil
      // Object.assign(button.style, this.options.styles.toolbarButton)
      // button.style.borderLeftWidth = '0'
      // button.addEventListener('click', () => {
      //   this.quill.emitter.emit('resize-edit', this.activeEle, this.blot)
      // })
      // this.toolbar.appendChild(button)
    }
  }, {
    key: "_selectButton",
    value: function _selectButton(button) {
      button.style.filter = 'invert(20%)';
    }
  }]);
  return Toolbar;
}(BaseModule);
export { Toolbar as default };