import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _bindInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/bind";
var levels = ['error', 'warn', 'log', 'info'];
var level = 'warn';
function debug(method) {
  if (_indexOfInstanceProperty(levels).call(levels, method) <= _indexOfInstanceProperty(levels).call(levels, level)) {
    var _console;
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    (_console = console)[method].apply(_console, args); // eslint-disable-line no-console
  }
}

function namespace(ns) {
  return _reduceInstanceProperty(levels).call(levels, function (logger, method) {
    logger[method] = _bindInstanceProperty(debug).call(debug, console, method, ns);
    return logger;
  }, {});
}
namespace.level = function (newLevel) {
  level = newLevel;
};
debug.level = namespace.level;
export default namespace;