import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _parseInt from "@babel/runtime-corejs3/core-js-stable/parse-int";
import _JSON$stringify from "@babel/runtime-corejs3/core-js-stable/json/stringify";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/trim";
import * as React from 'react';
import { PureComponent } from 'react';
import classNames from 'classnames';
import emojiList from './emojiList';
import Tooltip from '../../Tooltip/index';
import Popover from '../../Popover/index';
import Tabs from '../../Tabs/index';
import Input from '../../Input/index';
import Icon from '../../Icon/index';
import popoEmojiList from './popoEmojiList';
import ConfigConsumer from '../../Config/Consumer';
import InsertTable from './insertTable';
var TabPane = Tabs.TabPane;
var COLORS = ['#E53333', '#E56600', '#FF9900', '#64451D', '#DFC5A4', '#FFE500', '#009900', '#006600', '#99BB00', '#B8D100', '#60D978', '#00D5FF', '#337FE5', '#003399', '#4C33E5', '#9933E5', '#CC33E5', '#EE33EE', '#ffffff', '#cccccc', '#999999', '#666666', '#333333', '#000000'];
var defaultBackgrounds = [];
var defaultColors = [];
_forEachInstanceProperty(COLORS).call(COLORS, function (color, index) {
  defaultBackgrounds.push( /*#__PURE__*/React.createElement("button", {
    className: "background-item",
    key: 'default_background_' + index,
    value: color,
    title: color,
    style: {
      backgroundColor: color
    }
  }));
  defaultColors.push( /*#__PURE__*/React.createElement("button", {
    className: "color-item",
    key: 'default_color_' + index,
    value: color,
    title: color,
    style: {
      backgroundColor: color
    }
  }));
});
var EMOJI_DEFAULT_WIDTH = 24;
var EMOJI_DEFAULT_HEIGHT = 24;
var EMOJI_COSTOM_WIDTH = 74;
var EMOJI_COSTOM_HEIGHT = 74;
var genEmoji = function genEmoji(data) {
  var _context;
  var colSize = 10,
    resPath = '//qiyukf.com/sdk/res/portrait/emoji/',
    tmpObj = {},
    result = [];
  _forEachInstanceProperty(data).call(data, function (item, index) {
    var grpIndex = _parseInt((item.id / colSize).toString(), 10);
    if (typeof tmpObj[grpIndex] == 'undefined') {
      tmpObj[grpIndex] = [];
    }
    tmpObj[grpIndex].push( /*#__PURE__*/React.createElement("div", {
      className: "emoji-item-ctner",
      key: 'emoji_' + grpIndex + '_' + index
    }, /*#__PURE__*/React.createElement("button", {
      className: 'emoji-item ' + item.className,
      value: _JSON$stringify({
        type: 'defaultEmoji',
        alt: item.title,
        src: resPath + item.imgName + '.png',
        width: EMOJI_DEFAULT_WIDTH,
        height: EMOJI_DEFAULT_HEIGHT,
        id: 'emoticon_' + item.className.replace('-', '_')
      }),
      title: item.title
    })));
  });
  _forEachInstanceProperty(_context = _Object$keys(tmpObj)).call(_context, function (key) {
    result.push( /*#__PURE__*/React.createElement("div", {
      className: "emoji-row",
      key: 'emoji_row_' + key
    }, tmpObj[key]));
  });
  return result;
};
var genPoPoEmoji = function genPoPoEmoji(data) {
  var _context2;
  var colSize = 10,
    tmpObj = {},
    result = [];
  _forEachInstanceProperty(data).call(data, function (item, index) {
    // 这里从 1 开始
    var grpIndex = _parseInt(((item.id - 1) / colSize).toString(), 10);
    if (typeof tmpObj[grpIndex] == 'undefined') {
      tmpObj[grpIndex] = [];
    }
    tmpObj[grpIndex].push( /*#__PURE__*/React.createElement("div", {
      className: "emoji-item-ctner",
      key: 'popo-emoji_' + grpIndex + '_' + index
    }, /*#__PURE__*/React.createElement("button", {
      className: 'popo-emoji-item ' + item.className,
      value: _JSON$stringify({
        type: 'defaultEmoji',
        alt: item.title,
        src: item.url,
        width: EMOJI_DEFAULT_WIDTH,
        height: EMOJI_DEFAULT_HEIGHT,
        id: 'emoticon_' + item.className.replace('-', '_')
      }),
      title: item.title
    })));
  });
  _forEachInstanceProperty(_context2 = _Object$keys(tmpObj)).call(_context2, function (key) {
    result.push( /*#__PURE__*/React.createElement("div", {
      className: "emoji-row",
      key: 'emoji_row_' + key
    }, tmpObj[key]));
  });
  return result;
};
var defaultEmojis = genEmoji(emojiList);
var popoEmojis = genPoPoEmoji(popoEmojiList);
var genCustomEmoji = function genCustomEmoji(data) {
  if (!(data && data.length)) return;
  var sortedData = _sortInstanceProperty(data).call(data, function (a, b) {
    if (typeof a.id != 'number' || typeof b.id != 'number') {
      return 0;
    } else {
      return a.id - b.id;
    }
  });
  return _mapInstanceProperty(sortedData).call(sortedData, function (item, index) {
    return /*#__PURE__*/React.createElement("img", {
      key: 'emoji_extend_' + index,
      className: 'emoji-extend-item ' + item.className,
      value: _JSON$stringify({
        type: 'customEmoji',
        alt: item.title,
        src: item.url,
        width: EMOJI_DEFAULT_WIDTH,
        height: EMOJI_DEFAULT_HEIGHT
      }),
      title: item.title,
      src: item.url,
      width: EMOJI_COSTOM_WIDTH,
      height: EMOJI_COSTOM_HEIGHT,
      alt: item.title
    });
  });
};
var CustomToolbar = /*#__PURE__*/function (_PureComponent) {
  _inherits(CustomToolbar, _PureComponent);
  var _super = _createSuper(CustomToolbar);
  function CustomToolbar(props) {
    var _this;
    _classCallCheck(this, CustomToolbar);
    _this = _super.call(this, props);
    _this.handleIVSearchChange = function (e) {
      var value = e.target.value;
      _this.setState({
        curIVSearchValue: value ? value : ''
      });
    };
    _this.handleClearIVSearch = function () {
      _this.setState({
        curIVSearchValue: ''
      });
    };
    _this.getModuleHTML = function (mType, key) {
      var _this$props = _this.props,
        iconPrefix = _this$props.iconPrefix,
        handleInsertEmoji = _this$props.handleInsertEmoji,
        handleFormatBackground = _this$props.handleFormatBackground,
        handleFormatColor = _this$props.handleFormatColor,
        handleInsertValue = _this$props.handleInsertValue,
        prefixCls = _this$props.prefixCls,
        customEmoji = _this$props.customEmoji,
        customLink = _this$props.customLink,
        customInsertValue = _this$props.customInsertValue,
        popoverPlacement = _this$props.popoverPlacement,
        tooltipPlacement = _this$props.tooltipPlacement,
        getPopupContainer = _this$props.getPopupContainer,
        fullScreen = _this$props.fullScreen;
      // 兼容全屏时向上显示看不见的问题
      popoverPlacement = fullScreen ? 'bottom' : popoverPlacement;
      var mValue = null,
        value = null,
        tooltip = null;
      var _assertThisInitialize = _assertThisInitialized(_this),
        Locale = _assertThisInitialize.Locale;
      // mType 对象格式：
      // {'align': 'right'}
      // {size: ['32px', '24px', '18px', '16px', '13px', '12px']}
      if (_typeof(mType) === 'object') {
        var obj = mType;
        mType = _Object$keys(obj)[0];
        mValue = obj[mType];
      }
      // 处理定制的链接模块
      if (mType in customLink) {
        var _classNames;
        var customModule = customLink[mType] || {},
          cls = classNames('action custom-entry', (_classNames = {}, _defineProperty(_classNames, "ql-".concat(mType, "Entry"), true), _defineProperty(_classNames, "".concat(iconPrefix), true), _defineProperty(_classNames, "".concat(iconPrefix, "-richeditor-transfer"), true), _defineProperty(_classNames, "".concat(customModule.className), !!customModule.className), _classNames));
        value = /*#__PURE__*/React.createElement("button", {
          className: cls,
          key: key
        });
        if (customModule.title) {
          tooltip = customModule.title;
        }
      } else if (mType in customInsertValue) {
        // 处理定制的插入值
        var _customModule = customInsertValue[mType] || {},
          _cls = classNames('action custom-insert-value ql-customInsertValue', _defineProperty({}, "".concat(_customModule.className), !!_customModule.className)),
          _mValue = _customModule.option || [],
          editable = true;
        if (_customModule.editable != undefined) {
          editable = _customModule.editable;
        }
        if (_Array$isArray(_mValue) && _mValue.length) {
          _this.curInsertValueList = _mValue;
        }
        var filteredValueList = _this.curInsertValueList || [];
        if (_customModule.showSearch && _this.curInsertValueList && _this.curInsertValueList.length) {
          var _context3;
          filteredValueList = _filterInstanceProperty(_context3 = _this.curInsertValueList).call(_context3, function (item) {
            var _context4;
            return item.title && _indexOfInstanceProperty(_context4 = item.title.toLowerCase()).call(_context4, _this.state.curIVSearchValue.toLowerCase()) > -1;
          });
        }
        var content = /*#__PURE__*/React.createElement("div", {
          className: "insert-value-con",
          onClick: handleInsertValue
        }, _customModule.showSearch ? /*#__PURE__*/React.createElement("div", {
          className: "insert-value-search"
        }, /*#__PURE__*/React.createElement(Input, {
          placeholder: _customModule.searchPlaceholder ? _customModule.searchPlaceholder : Locale.enterKeyWordPlease,
          suffix: _this.state.curIVSearchValue ? /*#__PURE__*/React.createElement(Icon, {
            className: "insert-value-icon-clear",
            type: "close-circle-fill",
            onClick: _this.handleClearIVSearch
          }) : null,
          value: _this.state.curIVSearchValue,
          onChange: _this.handleIVSearchChange
        })) : null, filteredValueList.length ? _mapInstanceProperty(filteredValueList).call(filteredValueList, function (item, index) {
          return /*#__PURE__*/React.createElement("button", {
            className: "insert-value-item",
            key: 'insert_value_' + index,
            title: item.title,
            value: _JSON$stringify({
              value: item.value,
              editable: item.editable != undefined ? item.editable : editable
            })
          }, item.title);
        }) : /*#__PURE__*/React.createElement("div", {
          className: "insert-value-empty"
        }, Locale.temporarilyNoData));
        value = /*#__PURE__*/React.createElement(Popover, {
          trigger: "click",
          overlayClassName: "".concat(prefixCls, "-insert-value-popover"),
          content: content,
          title: null,
          key: key,
          placement: popoverPlacement,
          getPopupContainer: getPopupContainer
        }, /*#__PURE__*/React.createElement(Tooltip, {
          trigger: "hover",
          placement: tooltipPlacement,
          title: customInsertValue[mType].title ? customInsertValue[mType].title : null,
          mouseEnterDelay: 0.3
        }, /*#__PURE__*/React.createElement("div", {
          className: "item"
        }, /*#__PURE__*/React.createElement("div", {
          className: _cls
        }, /*#__PURE__*/React.createElement("button", {
          type: "button",
          "data-role": "customInsertValue",
          value: "",
          className: "ql-customInsertValue hide"
        })))));
        tooltip = customInsertValue[mType].title || '';
      } else {
        switch (mType) {
          case 'link':
            {
              var _classNames3;
              var linkCls = classNames('action ql-link', (_classNames3 = {}, _defineProperty(_classNames3, "".concat(iconPrefix), true), _defineProperty(_classNames3, "".concat(iconPrefix, "-richeditor-link"), true), _classNames3));
              value = /*#__PURE__*/React.createElement("button", {
                className: linkCls,
                key: key
              });
              tooltip = Locale.hyperlinks;
              break;
            }
          case 'bold':
            {
              var _classNames4;
              var boldCls = classNames('action ql-bold', (_classNames4 = {}, _defineProperty(_classNames4, "".concat(iconPrefix), true), _defineProperty(_classNames4, "".concat(iconPrefix, "-richeditor-bold"), true), _classNames4));
              value = /*#__PURE__*/React.createElement("button", {
                className: boldCls,
                key: key
              });
              tooltip = Locale.bold;
              break;
            }
          case 'italic':
            {
              var _classNames5;
              var italicCls = classNames('action ql-italic', (_classNames5 = {}, _defineProperty(_classNames5, "".concat(iconPrefix), true), _defineProperty(_classNames5, "".concat(iconPrefix, "-richeditor-tilt"), true), _classNames5));
              value = /*#__PURE__*/React.createElement("button", {
                className: italicCls,
                key: key
              });
              tooltip = Locale.italic;
              break;
            }
          case 'underline':
            {
              var _classNames6;
              var underlineCls = classNames('action ql-underline', (_classNames6 = {}, _defineProperty(_classNames6, "".concat(iconPrefix), true), _defineProperty(_classNames6, "".concat(iconPrefix, "-richeditor-underline"), true), _classNames6));
              value = /*#__PURE__*/React.createElement("button", {
                className: underlineCls,
                key: key
              });
              tooltip = Locale.underline;
              break;
            }
          case 'color':
            {
              var _classNames7;
              var colorCls = classNames('action custom-color', (_classNames7 = {}, _defineProperty(_classNames7, "".concat(iconPrefix), true), _defineProperty(_classNames7, "".concat(iconPrefix, "-richeditor-color"), true), _classNames7));
              var colorHTML = defaultColors;
              if (_Array$isArray(mValue) && mValue.length) {
                colorHTML = _mapInstanceProperty(mValue).call(mValue, function (color, index) {
                  return /*#__PURE__*/React.createElement("button", {
                    className: "color-item",
                    key: 'custom_color_' + index,
                    value: color,
                    title: color,
                    style: {
                      backgroundColor: color
                    }
                  });
                });
              }
              var _content = /*#__PURE__*/React.createElement("div", {
                className: "color-con",
                onClick: handleFormatColor
              }, colorHTML);
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                overlayClassName: "".concat(prefixCls, "-color-popover"),
                content: _content,
                title: null,
                key: key,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.fontColor,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("div", {
                className: colorCls
              }, /*#__PURE__*/React.createElement("button", {
                type: "button",
                "data-role": "color",
                value: "",
                className: "ql-color hide"
              })))));
              tooltip = Locale.fontColor;
              break;
            }
          case 'align':
            {
              if (typeof mValue === 'string') {
                var _context5, _classNames8;
                var alignIconType = 'richeditor-align-lef';
                tooltip = Locale.alignLeft;
                if (mValue == 'right') {
                  alignIconType = 'richeditor-align-rig';
                  tooltip = Locale.alignRight;
                } else if (mValue == 'center') {
                  alignIconType = 'richeditor-align-mid';
                  tooltip = Locale.alignCenter;
                } else if (mValue == 'justify') {
                  alignIconType = 'richeditor-align-all';
                  tooltip = Locale.alignJustified;
                }
                var alignCls = classNames('action ql-align', (_classNames8 = {}, _defineProperty(_classNames8, "".concat(iconPrefix), true), _defineProperty(_classNames8, _concatInstanceProperty(_context5 = "".concat(iconPrefix, "-")).call(_context5, alignIconType), true), _classNames8));
                value = /*#__PURE__*/React.createElement("button", {
                  type: "button",
                  className: alignCls,
                  value: mValue,
                  key: key
                });
              }
              break;
            }
          case 'list':
            {
              var _context6, _classNames9;
              var listIconType = 'richeditor-list';
              tooltip = Locale.unOrderedList;
              if (mValue == 'ordered') {
                listIconType = 'richeditor-numberlis';
                tooltip = Locale.orderedList;
              }
              var listCls = classNames('action ql-list', (_classNames9 = {}, _defineProperty(_classNames9, "".concat(iconPrefix), true), _defineProperty(_classNames9, _concatInstanceProperty(_context6 = "".concat(iconPrefix, "-")).call(_context6, listIconType), true), _classNames9));
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: listCls,
                value: mValue,
                key: key
              });
              break;
            }
          case 'emoji':
            {
              var _classNames10;
              var emojiCls = classNames('action custom-emoji', (_classNames10 = {}, _defineProperty(_classNames10, "".concat(iconPrefix), true), _defineProperty(_classNames10, "".concat(iconPrefix, "-richeditor-expressio"), true), _classNames10));
              var tabPanes = [/*#__PURE__*/React.createElement(TabPane, {
                tab: Locale.defaultEmoji,
                key: "default"
              }, /*#__PURE__*/React.createElement("div", {
                className: "emoji-ctner"
              }, /*#__PURE__*/React.createElement("div", {
                className: "emoji-con",
                onClick: handleInsertEmoji
              }, popoEmojis))), /*#__PURE__*/React.createElement(TabPane, {
                tab: Locale.emojiEmoji,
                key: "emoji"
              }, /*#__PURE__*/React.createElement("div", {
                className: "emoji-ctner"
              }, /*#__PURE__*/React.createElement("div", {
                className: "emoji-con",
                onClick: handleInsertEmoji
              }, defaultEmojis)))];
              mValue = mValue || ['emoji'];
              if (_Array$isArray(mValue)) {
                tabPanes = _filterInstanceProperty(tabPanes).call(tabPanes, function (tab) {
                  return _includesInstanceProperty(mValue).call(mValue, tab.key);
                });
              }
              if (customEmoji && customEmoji.length) {
                _forEachInstanceProperty(customEmoji).call(customEmoji, function (item, index) {
                  tabPanes.push( /*#__PURE__*/React.createElement(TabPane, {
                    tab: item.name,
                    key: 'custom_emoji_' + index
                  }, /*#__PURE__*/React.createElement("div", {
                    className: "emoji-ctner"
                  }, /*#__PURE__*/React.createElement("div", {
                    className: "emoji-con",
                    onClick: handleInsertEmoji
                  }, genCustomEmoji(item.data)))));
                });
              }
              var _content2 = /*#__PURE__*/React.createElement(Tabs, {
                defaultActiveKey: "emoji_default"
              }, tabPanes);
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                overlayClassName: "".concat(prefixCls, "-emoji-popover"),
                content: _content2,
                title: null,
                key: key,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.insertEmoji,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("div", {
                className: emojiCls
              }, /*#__PURE__*/React.createElement("button", {
                type: "button",
                "data-role": "emoji",
                value: "",
                className: "ql-emoji hide"
              })))));
              tooltip = Locale.insertEmoji;
              break;
            }
          case 'image':
            {
              var _classNames11;
              var imageCls = classNames('action ql-image', (_classNames11 = {}, _defineProperty(_classNames11, "".concat(iconPrefix), true), _defineProperty(_classNames11, "".concat(iconPrefix, "-richeditor-picture"), true), _classNames11));
              value = /*#__PURE__*/React.createElement("button", {
                className: imageCls,
                key: key
              });
              tooltip = Locale.insertPicture;
              break;
            }
          case 'attachment':
            {
              var _classNames12;
              var _cls2 = classNames('action ql-attachment', (_classNames12 = {}, _defineProperty(_classNames12, "".concat(iconPrefix), true), _defineProperty(_classNames12, "".concat(iconPrefix, "-richeditor-annexx"), true), _classNames12));
              value = /*#__PURE__*/React.createElement("button", {
                className: _cls2,
                key: key
              });
              tooltip = Locale.insertAttachment;
              break;
            }
          case 'size':
            {
              var _classNames13, _context7;
              var sizeCls = classNames('action custom-size', (_classNames13 = {}, _defineProperty(_classNames13, "".concat(iconPrefix), true), _defineProperty(_classNames13, "".concat(iconPrefix, "-richeditor-size"), true), _classNames13));
              _this.curSizeList = _this.defaultSizes;
              if (_Array$isArray(mValue) && mValue.length) {
                _this.curSizeList = mValue;
              }
              var _content3 = /*#__PURE__*/React.createElement("div", {
                className: "size-con",
                key: "custom_size_content",
                onClick: _this.handleSizeItemClick
              }, _this.curSizeList && _mapInstanceProperty(_context7 = _this.curSizeList).call(_context7, function (size, index) {
                var sizeItemCls = classNames('size-item', {
                  active: size && _this.state.curSize == _trimInstanceProperty(size).call(size)
                });
                return /*#__PURE__*/React.createElement("button", {
                  className: sizeItemCls,
                  key: 'custom_size_' + index,
                  value: size,
                  style: {
                    fontSize: size
                  }
                }, size);
              }));
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                overlayClassName: "".concat(prefixCls, "-size-popover"),
                content: _content3,
                title: null,
                key: key,
                visible: _this.state.sizePopoverVisible,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer,
                onVisibleChange: _this.handleSizePopoverVisibleChange
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.fontSize,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("div", {
                className: sizeCls
              }))));
              tooltip = Locale.fontSize;
              break;
            }
          case 'table':
            {
              var _classNames14;
              var insertTableDisabled = _this.props.insertTableDisabled;
              var tableCls = classNames('action ql-customTable', (_classNames14 = {}, _defineProperty(_classNames14, "".concat(iconPrefix), true), _defineProperty(_classNames14, "".concat(iconPrefix, "-biaoge"), true), _defineProperty(_classNames14, 'ql-btn-disabled', insertTableDisabled), _classNames14));
              var tablePopoverVisible = _this.state.tablePopoverVisible;
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                overlayClassName: "".concat(prefixCls, "-size-popover"),
                content: /*#__PURE__*/React.createElement(InsertTable, {
                  locale: _this.Locale,
                  visible: tablePopoverVisible,
                  chooseItemHandle: _this.handleTableInsertPopover
                }),
                title: null,
                key: key,
                visible: tablePopoverVisible,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer,
                onVisibleChange: _this.handleTablePopoverVisibleChange
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.table,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("button", {
                className: tableCls,
                key: key
              }))));
              tooltip = Locale.table;
              break;
            }
          case 'clean':
            {
              var _classNames15;
              var cleanCls = classNames('action ql-clean', (_classNames15 = {}, _defineProperty(_classNames15, "".concat(iconPrefix), true), _defineProperty(_classNames15, "".concat(iconPrefix, "-richeditor-clear"), true), _classNames15));
              value = /*#__PURE__*/React.createElement("button", {
                className: cleanCls,
                key: key
              });
              tooltip = Locale.clearFormat;
              break;
            }
          case 'formatPainter':
            {
              var _classNames16;
              var _cls3 = classNames('action ql-formatPainter', (_classNames16 = {}, _defineProperty(_classNames16, "".concat(iconPrefix), true), _defineProperty(_classNames16, 'ql-active', _this.props.formatPainterActive), _defineProperty(_classNames16, "".concat(iconPrefix, "-richeditor-brushx"), true), _classNames16));
              value = /*#__PURE__*/React.createElement("button", {
                className: _cls3,
                key: key,
                onClick: _this.handleFormatPainterClick
              });
              tooltip = Locale.brushFormat;
              break;
            }
          case 'strike':
            {
              value = /*#__PURE__*/React.createElement("button", {
                className: "action ql-strike",
                key: key
              });
              tooltip = Locale.strike;
              break;
            }
          case 'blockquote':
            {
              value = /*#__PURE__*/React.createElement("button", {
                className: "action ql-blockquote",
                key: key
              });
              tooltip = Locale.blockquote;
              break;
            }
          case 'code-block':
            {
              value = /*#__PURE__*/React.createElement("button", {
                className: "action ql-code-block",
                key: key
              });
              tooltip = Locale.codeBlock;
              break;
            }
          case 'script':
            {
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: "action ql-script",
                value: mValue,
                key: key
              });
              if (mValue == 'super') {
                tooltip = Locale.superSciprt;
              } else {
                tooltip = Locale.subScript;
              }
              break;
            }
          case 'indent':
            {
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: "action ql-indent",
                value: mValue,
                key: key
              });
              if (mValue == '-1') {
                tooltip = Locale.decreaseIndent;
              } else {
                tooltip = Locale.increaseIndent;
              }
              break;
            }
          case 'direction':
            {
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: "action ql-direction",
                value: mValue,
                key: key
              });
              tooltip = Locale.textDirection;
              break;
            }
          case 'background':
            {
              var _classNames17;
              var backgroundCls = classNames('action custom-background', (_classNames17 = {}, _defineProperty(_classNames17, "".concat(iconPrefix), true), _defineProperty(_classNames17, "".concat(iconPrefix, "-richeditor-fontbkcol"), true), _classNames17));
              var backgroundHTML = defaultBackgrounds;
              if (_Array$isArray(mValue) && mValue.length) {
                backgroundHTML = _mapInstanceProperty(mValue).call(mValue, function (color, index) {
                  return /*#__PURE__*/React.createElement("button", {
                    className: "background-item",
                    key: 'custom_background_' + index,
                    value: color,
                    title: color,
                    style: {
                      backgroundColor: color
                    }
                  });
                });
              }
              var _content4 = /*#__PURE__*/React.createElement("div", {
                className: "background-con",
                onClick: handleFormatBackground
              }, backgroundHTML);
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                overlayClassName: "".concat(prefixCls, "-background-popover"),
                content: _content4,
                title: null,
                key: key,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.backgroundColor,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("div", {
                className: backgroundCls
              }, /*#__PURE__*/React.createElement("button", {
                type: "button",
                "data-role": "background",
                value: "",
                className: "ql-background hide"
              })))));
              tooltip = Locale.backgroundColor;
              break;
            }
          case 'video':
            {
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: "action ql-video",
                value: mValue,
                key: key
              });
              tooltip = Locale.insertVideo;
              break;
            }
          case 'fullscreen':
            {
              var _classNames18;
              var fullScreenCls = classNames('action ql-fullscreen', (_classNames18 = {}, _defineProperty(_classNames18, "".concat(iconPrefix), true), _defineProperty(_classNames18, "".concat(iconPrefix, "-video-shrink"), fullScreen), _defineProperty(_classNames18, "".concat(iconPrefix, "-video-fullscreen"), !fullScreen), _classNames18));
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: fullScreenCls,
                value: mValue,
                key: 'fullScreen'
              });
              tooltip = fullScreen ? Locale.exitFullScreen : Locale.fullScreen;
              break;
            }
          case 'findAndReplace':
            {
              var _classNames19;
              var findAndReplaceCls = classNames('action ql-findAndReplace', (_classNames19 = {}, _defineProperty(_classNames19, "".concat(iconPrefix), true), _defineProperty(_classNames19, "".concat(iconPrefix, "-search-line"), true), _classNames19));
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: findAndReplaceCls,
                value: mValue,
                key: 'findAndReplace'
              });
              tooltip = Locale.findAndReplace;
              break;
            }
          // case 'header': {
          //  // 使用原生quill的样式, 弹窗可能会有些不一样, 先不开放此功能, 还有一点是多语言比较麻烦
          //   // [{ header: [ 1,2, 3, 4 ,5, 6, false] }]
          //   if (typeof mValue === 'string' || typeof mValue === 'number') {
          //     value = <button type="button" className="ql-header" value={mValue} key={key}/>;
          //   } else if (mValue instanceof Array && mValue.length){
          //     value = (
          //       <div className="item toolbar-header-item" key={key} >
          //         <select className="ql-header" defaultValue="false">
          //           {
          //             mValue.map((val, idx) => <option key={key+'_option_'+idx} value={val} />)
          //           }
          //         </select>
          //       </div>
          //     );
          //   }
          //   tooltip = '标题';
          //   break;
          // }
          case 'undo':
            {
              var _context8;
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: _concatInstanceProperty(_context8 = "action ql-undo ".concat(iconPrefix, " ")).call(_context8, iconPrefix, "-richeditor-undo"),
                value: 'undo',
                key: key
              });
              tooltip = Locale.undo;
              break;
            }
          case 'redo':
            {
              var _context9;
              value = /*#__PURE__*/React.createElement("button", {
                type: "button",
                className: _concatInstanceProperty(_context9 = "action ql-redo ".concat(iconPrefix, " ")).call(_context9, iconPrefix, "-richeditor-redo"),
                value: 'redo',
                key: key
              });
              tooltip = Locale.redo;
              break;
            }
          case 'lineHeight':
            {
              var _classNames20, _context10;
              var lineHeightCls = classNames('action custom-lineHeight', (_classNames20 = {}, _defineProperty(_classNames20, "".concat(iconPrefix), true), _defineProperty(_classNames20, "".concat(iconPrefix, "-richeditor-line-height"), true), _classNames20));
              if (_Array$isArray(mValue)) {
                _this.defaultLineHeight = mValue || _this.defaultLineHeight;
              }
              var _content5 = /*#__PURE__*/React.createElement("div", {
                className: "line-height-con",
                key: "line-height_content",
                onClick: _this.handleLineHeightItemClick
              }, _this.defaultLineHeight && _mapInstanceProperty(_context10 = _this.defaultLineHeight).call(_context10, function (height, index) {
                var sizeItemCls = classNames('line-height-item', {
                  active: height && Number(_this.state.curLineHeight) == Number(height)
                });
                return /*#__PURE__*/React.createElement("button", {
                  className: sizeItemCls,
                  key: 'line-height_' + index,
                  value: height
                }, height == '1.42' ? Locale.defaultLineHeight : height);
              }));
              value = /*#__PURE__*/React.createElement(Popover, {
                trigger: "click",
                visible: _this.state.lineHeightPopoverVisible,
                overlayClassName: "".concat(prefixCls, "-line-height-popover"),
                content: _content5,
                title: null,
                key: key,
                placement: popoverPlacement,
                getPopupContainer: getPopupContainer,
                onVisibleChange: _this.handleLineHeightPopoverVisibleChange
              }, /*#__PURE__*/React.createElement(Tooltip, {
                trigger: "hover",
                placement: tooltipPlacement,
                title: Locale.lineHeight,
                mouseEnterDelay: 0.3
              }, /*#__PURE__*/React.createElement("div", {
                className: "item"
              }, /*#__PURE__*/React.createElement("div", {
                className: lineHeightCls
              }))));
              break;
            }
          default:
            {
              break;
            }
        }
      }
      var mTypesHasPopover = ['background', 'color', 'emoji', 'size', 'header', 'lineHeight', 'table'];
      if (value && _indexOfInstanceProperty(mTypesHasPopover).call(mTypesHasPopover, mType) < 0 && !(mType in customInsertValue)) {
        value = /*#__PURE__*/React.createElement(Tooltip, {
          key: key,
          trigger: "hover",
          placement: tooltipPlacement,
          title: tooltip,
          mouseEnterDelay: 0.3
        }, /*#__PURE__*/React.createElement("div", {
          className: "item"
        }, value));
      }
      return value;
    };
    _this.handleLineHeightItemClick = function (e) {
      var _context11;
      var handleFormatLineHeight = _this.props.handleFormatLineHeight,
        target = e.target;
      if (_indexOfInstanceProperty(_context11 = target.classList.value).call(_context11, 'line-height-item') > -1 && target.hasAttribute('value')) {
        handleFormatLineHeight && handleFormatLineHeight(target.getAttribute('value'));
        _this.setState({
          lineHeightPopoverVisible: false
        });
      }
    };
    _this.handleFormatPainterClick = function () {
      var _this$props2 = _this.props,
        formatPainterActive = _this$props2.formatPainterActive,
        saveSelectionFormat = _this$props2.saveSelectionFormat,
        unsaveSelectionFormat = _this$props2.unsaveSelectionFormat;
      if (formatPainterActive) {
        unsaveSelectionFormat && unsaveSelectionFormat();
      } else {
        saveSelectionFormat && saveSelectionFormat();
      }
    };
    _this.handleSizeItemClick = function (e) {
      var _context12;
      var handleFormatSize = _this.props.handleFormatSize,
        target = e.target;
      if (_indexOfInstanceProperty(_context12 = target.classList.value).call(_context12, 'size-item') > -1 && target.hasAttribute('value')) {
        handleFormatSize && handleFormatSize(target.getAttribute('value'));
        _this.setState({
          sizePopoverVisible: false
        });
      }
    };
    _this.genToolbar = function (toolbar) {
      var result = [];
      _forEachInstanceProperty(toolbar).call(toolbar, function (item, index) {
        // 分组展示的项目
        if (item instanceof Array) {
          var grpItems = _mapInstanceProperty(item).call(item, function (mType, subindex) {
            return _this.getModuleHTML(mType, 'toolbar_' + index + '_sub_' + subindex);
          });
          result.push( /*#__PURE__*/React.createElement("div", {
            className: "toolbar-grp",
            key: 'toolbar_' + index
          }, grpItems));
        } else {
          // 单个展示的项目
          result.push(_this.getModuleHTML(item, 'toolbar_' + index));
        }
      });
      return result;
    };
    _this.handleSizePopoverVisibleChange = function (visible) {
      _this.setState({
        sizePopoverVisible: visible
      });
      if (!visible) return;
      var getCurrentSize = _this.props.getCurrentSize,
        curSize = getCurrentSize && getCurrentSize();
      if (curSize != _this.state.curSize) {
        _this.setState({
          curSize: curSize
        });
      }
    };
    _this.handleTablePopoverVisibleChange = function (visible) {
      var insertTableDisabled = _this.props.insertTableDisabled;
      _this.setState({
        tablePopoverVisible: insertTableDisabled ? false : visible
      });
    };
    _this.handleTableInsertPopover = function (row, col) {
      var _this$props3 = _this.props,
        handleInsertTable = _this$props3.handleInsertTable,
        insertTableDisabled = _this$props3.insertTableDisabled;
      if (insertTableDisabled) return;
      handleInsertTable && handleInsertTable(row, col);
      _this.setState({
        tablePopoverVisible: false
      });
    };
    _this.handleLineHeightPopoverVisibleChange = function (visible) {
      _this.setState({
        lineHeightPopoverVisible: visible
      });
      if (!visible) return;
      var getCurrentLineHeight = _this.props.getCurrentLineHeight,
        curLineHeight = getCurrentLineHeight && getCurrentLineHeight();
      if (curLineHeight != _this.state.curLineHeight) {
        _this.setState({
          curLineHeight: curLineHeight
        });
      }
    };
    _this.defaultSizes = ['32px', '24px', '20px', '18px', '16px', '14px', '13px', '12px'];
    _this.defaultLineHeight = ['1', '1.15', '1.42', '1.5', '2.0', '2.5', '3.0'];
    _this.curInsertValueList = [];
    _this.state = {
      curSize: null,
      sizePopoverVisible: false,
      tablePopoverVisible: false,
      curLineHeight: '',
      lineHeightPopoverVisible: false,
      curIVSearchValue: ''
    };
    return _this;
  }
  _createClass(CustomToolbar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var emojiImg = new Image(); // emoji 表情
      emojiImg.src = '//ysf.qiyukf.net/wwfttuqcqzrxhhyjacexkgalzzkwqagy';
      var popoEmojiImg = new Image(); // popo 表情
      popoEmojiImg.src = '//res.qiyukf.net/popoEmoji/b6e8603537419833078b79ebc7513fd7';
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        className = _this$props4.className,
        style = _this$props4.style,
        toolbar = _this$props4.toolbar;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "RichEditor"
      }, function (Locale) {
        _this2.Locale = Locale;
        return /*#__PURE__*/React.createElement("div", {
          className: className,
          ref: function ref(node) {
            return _this2.toolbarCtner = node;
          },
          style: style
        }, _this2.genToolbar(toolbar));
      });
    }
  }]);
  return CustomToolbar;
}(PureComponent);
CustomToolbar.defaultProps = {
  className: '',
  iconPrefix: 'fishdicon',
  toolbar: [],
  customEmoji: [],
  customLink: {},
  customInsertValue: {},
  prefixCls: 'fishd-richeditor',
  popoverPlacement: 'top',
  tooltipPlacement: 'bottom',
  formatPainterActive: false,
  insertTableDisabled: false,
  getPopupContainer: function getPopupContainer() {
    return document.body;
  }
};
export default CustomToolbar;