import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import Input from '../Input';
import Icon from '../Icon';
var SelectSearch = /*#__PURE__*/function (_React$Component) {
  _inherits(SelectSearch, _React$Component);
  var _super = _createSuper(SelectSearch);
  function SelectSearch(props) {
    _classCallCheck(this, SelectSearch);
    return _super.call(this, props);
  }
  _createClass(SelectSearch, [{
    key: "render",
    value: function render() {
      var _this = this;
      var _this$props = this.props,
        allowClear = _this$props.allowClear,
        emitEmpty = _this$props.emitEmpty,
        prefixCls = _this$props.prefixCls,
        searchInputProps = _this$props.searchInputProps,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        updateSearchValue = _this$props.updateSearchValue;
      var suffix = searchValue && allowClear && /*#__PURE__*/React.createElement(Icon, {
        type: "close-circle-fill",
        className: "".concat(prefixCls, "-clear"),
        onClick: emitEmpty
      });
      return /*#__PURE__*/React.createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/React.createElement(Input, _Object$assign({
        placeholder: searchPlaceholder,
        ref: function ref(searchInput) {
          return _this.searchInput = searchInput;
        },
        value: searchValue,
        onChange: updateSearchValue,
        suffix: suffix
      }, searchInputProps)));
    }
  }]);
  return SelectSearch;
}(React.Component);
export { SelectSearch as default };
SelectSearch.propTypes = {
  allowClear: PropTypes.bool,
  emitEmpty: PropTypes.func,
  prefixCls: PropTypes.string,
  searchInputProps: PropTypes.object,
  searchPlaceholder: PropTypes.string,
  searchValue: PropTypes.string,
  updateSearchValue: PropTypes.func
};