import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import Tooltip from '../../Tooltip/index';
var Tip = /*#__PURE__*/function (_React$Component) {
  _inherits(Tip, _React$Component);
  var _super = _createSuper(Tip);
  function Tip() {
    _classCallCheck(this, Tip);
    return _super.apply(this, arguments);
  }
  _createClass(Tip, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        visible = _this$props.visible,
        position = _this$props.position,
        vertical = _this$props.vertical,
        title = _this$props.title,
        prefixCls = _this$props.prefixCls;
      var tipStyle = {
        position: 'absolute'
      };
      if (position) {
        if (vertical) {
          tipStyle.top = position;
          tipStyle.height = 10;
          tipStyle.width = 5;
        } else {
          tipStyle.left = position - 5;
          tipStyle.width = 10;
          tipStyle.height = 5;
        }
      }
      return /*#__PURE__*/React.createElement(Tooltip, {
        title: title,
        visible: visible
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-all-handle"),
        style: tipStyle
      }));
    }
  }]);
  return Tip;
}(React.Component);
export { Tip as default };
Tip.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  disabled: PropTypes.bool,
  position: PropTypes.number,
  vertical: PropTypes.bool,
  visible: PropTypes.bool,
  title: PropTypes.oneOfType([PropTypes.node, PropTypes.string])
};