import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import * as React from 'react';
import classNames from 'classnames';
import omit from 'omit.js';
var Container = function Container(props) {
  var children = props.children,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$prefixCls = props.prefixCls,
    prefixCls = _props$prefixCls === void 0 ? 'fishd-spin' : _props$prefixCls;
  var otherProps = omit(props, ['className', 'prefixCls']);
  var classString = classNames("".concat(prefixCls, "-container"), className);
  return /*#__PURE__*/React.createElement("div", _Object$assign({}, otherProps, {
    className: classString
  }), children);
};
export default Container;