import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _setTimeout from "@babel/runtime-corejs3/core-js-stable/set-timeout";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import Animate from 'rc-animate';
import omit from 'omit.js';
import { polyfill } from 'react-lifecycles-compat';
// Render indicator
var defaultIndicator = null;
function renderIndicator(props) {
  var prefixCls = props.prefixCls,
    indicator = props.indicator;
  var dotClassName = "".concat(prefixCls, "-dot");
  if ( /*#__PURE__*/React.isValidElement(indicator)) {
    return /*#__PURE__*/React.cloneElement(indicator, {
      className: classNames(indicator.props.className, dotClassName)
    });
  }
  if ( /*#__PURE__*/React.isValidElement(defaultIndicator)) {
    return /*#__PURE__*/React.cloneElement(defaultIndicator, {
      className: classNames(defaultIndicator.props.className, dotClassName)
    });
  }
  return /*#__PURE__*/React.createElement("span", {
    className: classNames(dotClassName, "".concat(prefixCls, "-dot-spin"))
  }, /*#__PURE__*/React.createElement("i", null), /*#__PURE__*/React.createElement("i", null), /*#__PURE__*/React.createElement("i", null), /*#__PURE__*/React.createElement("i", null));
}
var Spin = /*#__PURE__*/function (_React$Component) {
  _inherits(Spin, _React$Component);
  var _super = _createSuper(Spin);
  function Spin(props) {
    var _this;
    _classCallCheck(this, Spin);
    _this = _super.call(this, props);
    var spinning = props.spinning;
    _this.state = {
      spinning: spinning
    };
    return _this;
  }
  _createClass(Spin, [{
    key: "isNestedPattern",
    value: function isNestedPattern() {
      return !!(this.props && this.props.children);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props = this.props,
        spinning = _this$props.spinning,
        delay = _this$props.delay;
      if (spinning && delay && !isNaN(Number(delay))) {
        this.setState({
          spinning: false
        });
        this.delayTimeout = _setTimeout(function () {
          return _this2.setState({
            spinning: spinning
          });
        }, delay);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.debounceTimeout) {
        clearTimeout(this.debounceTimeout);
      }
      if (this.delayTimeout) {
        clearTimeout(this.delayTimeout);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this3 = this;
      var spinning = this.props.spinning;
      var prevSpinning = prevProps.spinning;
      var delay = this.props.delay;
      if (this.debounceTimeout) {
        clearTimeout(this.debounceTimeout);
      }
      if (prevSpinning && !spinning) {
        this.debounceTimeout = _setTimeout(function () {
          return _this3.setState({
            spinning: spinning
          });
        }, 200);
        if (this.delayTimeout) {
          clearTimeout(this.delayTimeout);
        }
      } else {
        if (spinning && delay && !isNaN(Number(delay))) {
          if (this.delayTimeout) {
            clearTimeout(this.delayTimeout);
          }
          this.delayTimeout = _setTimeout(function () {
            return _this3.setState({
              spinning: spinning
            });
          }, delay);
        } else if (spinning !== this.state.spinning) {
          this.setState({
            spinning: spinning
          });
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;
      var _a = this.props,
        className = _a.className,
        size = _a.size,
        prefixCls = _a.prefixCls,
        tip = _a.tip,
        wrapperClassName = _a.wrapperClassName,
        restProps = __rest(_a, ["className", "size", "prefixCls", "tip", "wrapperClassName"]);
      var spinning = this.state.spinning;
      var spinClassName = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-sm"), size === 'small'), _defineProperty(_classNames, "".concat(prefixCls, "-lg"), size === 'large'), _defineProperty(_classNames, "".concat(prefixCls, "-spinning"), spinning), _defineProperty(_classNames, "".concat(prefixCls, "-show-text"), !!tip), _classNames), className);
      // fix https://fb.me/react-unknown-prop
      var divProps = omit(restProps, ['spinning', 'delay', 'indicator']);
      var spinElement = /*#__PURE__*/React.createElement("div", _Object$assign({}, divProps, {
        className: spinClassName
      }), renderIndicator(this.props), tip ? /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-text")
      }, tip) : null);
      if (this.isNestedPattern()) {
        var _classNames2;
        var animateClassName = prefixCls + '-nested-loading';
        if (wrapperClassName) {
          animateClassName += ' ' + wrapperClassName;
        }
        var nestedClassName = classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-nested"), true), _defineProperty(_classNames2, "".concat(prefixCls, "-blur"), spinning), _classNames2));
        return /*#__PURE__*/React.createElement(Animate, _Object$assign({}, divProps, {
          component: "div",
          className: animateClassName,
          style: null,
          transitionName: "fade"
        }), spinning && /*#__PURE__*/React.createElement("div", {
          key: "loading"
        }, spinElement), /*#__PURE__*/React.createElement("div", {
          className: nestedClassName,
          key: "nested"
        }, this.props.children));
      }
      return spinElement;
    }
  }], [{
    key: "setDefaultIndicator",
    value: function setDefaultIndicator(indicator) {
      defaultIndicator = indicator;
    }
  }, {
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var spinning = nextProps.spinning,
        delay = nextProps.delay;
      if (prevState.spinning !== spinning) {
        if (spinning == false || isNaN(Number(delay)) || delay === 0) {
          // spinning -> false
          // spinning -> true && delay -> falsy
          return _Object$assign(_Object$assign({}, prevState), {
            spinning: spinning
          });
        }
      }
      return null;
    }
  }]);
  return Spin;
}(React.Component);
Spin.defaultProps = {
  prefixCls: 'fishd-spin',
  spinning: true,
  size: 'default',
  wrapperClassName: ''
};
Spin.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  spinning: PropTypes.bool,
  size: PropTypes.oneOf(['small', 'default', 'large']),
  wrapperClassName: PropTypes.string,
  indicator: PropTypes.node
};
polyfill(Spin);
export default Spin;