import * as React from 'react';
export interface StepProps {
    description?: string | React.ReactNode;
    icon?: React.ReactNode;
    status?: string;
    title?: string | React.ReactNode;
    className?: string;
    prefixCls?: string;
    style?: React.CSSProperties;
    wrapperStyle?: React.CSSProperties;
    itemWidth?: number | string;
    iconPrefix?: string;
    adjustMarginRight?: number | string;
    stepNumber?: number;
    progressDot?: boolean | ((content: React.ReactNode, options: object) => React.ReactNode);
    tailContent?: string | React.ReactNode;
    icons?: {
        finish: React.ReactNode;
        error: React.ReactNode;
    };
}
export default class Step extends React.Component<StepProps> {
    static propTypes: {
        className: any;
        prefixCls: any;
        style: any;
        wrapperStyle: any;
        itemWidth: any;
        status: any;
        iconPrefix: any;
        icon: any;
        adjustMarginRight: any;
        stepNumber: any;
        description: any;
        title: any;
        progressDot: any;
        tailContent: any;
        icons: any;
    };
    renderIconNode(): {} | React.ReactElement<any>;
    render(): JSX.Element;
}
