import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _reduceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reduce";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _findIndexInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/find-index";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _JSON$stringify from "@babel/runtime-corejs3/core-js-stable/json/stringify";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/sort";
import React from 'react';
import { polyfill } from 'react-lifecycles-compat';
import Modal from '../Modal';
import Icon from '../Icon';
import Checkbox from '../Checkbox';
import ToolTip from '../Tooltip';
import ConfigConsumer from '../Config/Consumer';
var CheckboxGroup = Checkbox.Group;
var getColumnKey = function getColumnKey(column) {
  if ('colSpan' in column) {
    return column.filtrateTitle || column.title;
  } else {
    return column.key || column.dataIndex || column.filtrateTitle || column.title;
  }
};
var flatten = function flatten(arr) {
  return _reduceInstanceProperty(arr).call(arr, function (prev, next) {
    return _concatInstanceProperty(prev).call(prev, _Array$isArray(next) ? flatten(next) : next);
  }, []);
};
var getCheckedOptions = function getCheckedOptions(columns, hideColumns) {
  var _context, _context2;
  return _mapInstanceProperty(_context = _filterInstanceProperty(_context2 = _filterInstanceProperty(columns
  // 去除表头合并不显示的列
  ).call(columns
  // 去除表头合并不显示的列
  , function (column) {
    return column.colSpan !== 0;
  })
  // 去除初始化就被隐藏的列
  ).call(_context2, function (column) {
    return _findIndexInstanceProperty(hideColumns).call(hideColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 只留uniqueId
  ).call(_context, function (column) {
    return getColumnKey(column);
  });
};
var getColSpanOption = function getColSpanOption(columns) {
  var colSpanOption = [];
  _forEachInstanceProperty(columns).call(columns, function (column, index) {
    if ('colSpan' in column && column.colSpan !== 0) {
      var _context3;
      colSpanOption.push({
        key: column.filtrateTitle || column.title,
        value: _mapInstanceProperty(_context3 = _sliceInstanceProperty(columns).call(columns, index, index + column.colSpan)).call(_context3, function (column) {
          return column.key || column.dataIndex;
        })
      });
    }
  });
  return colSpanOption;
};
var ColumnFiltrateModal = /*#__PURE__*/function (_React$Component) {
  _inherits(ColumnFiltrateModal, _React$Component);
  var _super = _createSuper(ColumnFiltrateModal);
  function ColumnFiltrateModal(props) {
    var _this;
    _classCallCheck(this, ColumnFiltrateModal);
    _this = _super.call(this, props);
    _this.showModal = function () {
      _this.setState({
        visible: true
      });
    };
    _this.handleOk = function () {
      _this.setState({
        visible: false,
        checkedOptionConfirm: _this.state.checkedOption,
        okButtonDisabled: true
      }, function () {
        var _context4, _context5;
        // 被隐藏的列表key
        _this.props.onChange(flatten(_mapInstanceProperty(_context4 = _filterInstanceProperty(_context5 = _this.getOptions()).call(_context5, function (column) {
          var _context6;
          return _indexOfInstanceProperty(_context6 = _this.state.checkedOptionConfirm).call(_context6, column.value) === -1;
        })).call(_context4, function (column) {
          var _context7;
          var indexOfColSpan = _findIndexInstanceProperty(_context7 = _this.state.colSpanOption).call(_context7, function (option) {
            return option.key === column.value;
          });
          if (indexOfColSpan !== -1) {
            return _this.state.colSpanOption[indexOfColSpan].value;
          } else {
            return column.value;
          }
        })));
      });
    };
    _this.handleCancel = function () {
      _this.setState({
        visible: false,
        checkedOption: _this.state.checkedOptionConfirm,
        okButtonDisabled: true
      });
    };
    _this.onChange = function (checkedOption) {
      var checkedOptionConfirm = _this.state.checkedOptionConfirm;
      _this.setState({
        checkedOption: checkedOption,
        okButtonDisabled: _JSON$stringify(checkedOption && _sortInstanceProperty(checkedOption).call(checkedOption)) == _JSON$stringify(checkedOptionConfirm && _sortInstanceProperty(checkedOptionConfirm).call(checkedOptionConfirm))
      });
    };
    _this.getOptions = function () {
      var _context8, _context9;
      var _this$props = _this.props,
        columns = _this$props.columns,
        defaultColumns = _this$props.defaultColumns;
      return _filterInstanceProperty(_context8 = _mapInstanceProperty(_context9 = _filterInstanceProperty(columns
      // 去除表头合并的不显示的
      ).call(columns
      // 去除表头合并的不显示的
      , function (column) {
        return column.colSpan !== 0;
      })
      // 获取他们的label、value、disabled
      ).call(_context9, function (column) {
        var uniqKey = getColumnKey(column);
        //fixed /分组不能控制显示隐藏
        var disabled = !!column.fixed || !!column.children || !!column.filtrateDefault;
        var title = column.filtrateTitle || column.title;
        return {
          label: /*#__PURE__*/React.createElement(ToolTip, {
            title: title
          }, title),
          value: uniqKey,
          disabled: disabled
        };
      })
      // 去除默认展示数据项
      ).call(_context8, function (column) {
        return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
          return key === column.value;
        }) === -1;
      });
    };
    //默认一直显示的选项
    _this.getDefaultOption = function () {
      var _context10;
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        _this$props2$defaultC = _this$props2.defaultColumns,
        defaultColumns = _this$props2$defaultC === void 0 ? [] : _this$props2$defaultC;
      return _mapInstanceProperty(_context10 = _filterInstanceProperty(columns).call(columns, function (column) {
        return _findIndexInstanceProperty(defaultColumns).call(defaultColumns, function (key) {
          return key === getColumnKey(column);
        }) !== -1;
      })).call(_context10, function (column) {
        return {
          label: /*#__PURE__*/React.createElement(ToolTip, {
            title: column.filtrateTitle || column.title
          }, column.filtrateTitle || column.title),
          value: getColumnKey(column),
          disabled: true
        };
      });
    };
    var _this$props3 = _this.props,
      columns = _this$props3.columns,
      hideColumns = _this$props3.hideColumns;
    var option = getCheckedOptions(columns, hideColumns);
    _this.state = {
      visible: false,
      checkedOption: option,
      checkedOptionConfirm: option,
      okButtonDisabled: true,
      prevProps: props,
      colSpanOption: getColSpanOption(columns)
    };
    return _this;
  }
  _createClass(ColumnFiltrateModal, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var _this$state = this.state,
        visible = _this$state.visible,
        checkedOption = _this$state.checkedOption,
        okButtonDisabled = _this$state.okButtonDisabled;
      var options = this.getOptions();
      var defaultOption = this.getDefaultOption();
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Table"
      }, function (Locale) {
        return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Icon, {
          className: "".concat(prefixCls, "-filtrate-icon"),
          type: "Settingx",
          onClick: _this2.showModal
        }), /*#__PURE__*/React.createElement(Modal, {
          title: Locale.modalTitle,
          wrapClassName: "".concat(prefixCls, "-filtrate-modal"),
          visible: visible,
          width: 680,
          okButtonDisabled: okButtonDisabled,
          onOk: _this2.handleOk,
          onCancel: _this2.handleCancel,
          okText: Locale.okText,
          cancelText: Locale.cancelText
        }, /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-filtrate-modal-enable-list")
        }, /*#__PURE__*/React.createElement(CheckboxGroup, {
          value: checkedOption,
          options: options,
          onChange: _this2.onChange
        })), defaultOption && !!defaultOption.length && /*#__PURE__*/React.createElement("div", {
          className: "".concat(prefixCls, "-filtrate-modal-disabled-list")
        }, /*#__PURE__*/React.createElement("p", {
          className: "title"
        }, Locale.defaultOptionTitle), /*#__PURE__*/React.createElement(CheckboxGroup, {
          options: defaultOption,
          defaultValue: _mapInstanceProperty(defaultOption).call(defaultOption, function (option) {
            return option.value;
          })
        }))));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      //监听column个数变化，重新初始化checkedOption
      if ('columns' in nextProps && nextProps.columns.length !== prevProps.columns.length) {
        var columns = nextProps.columns,
          hideColumns = nextProps.hideColumns;
        var option = getCheckedOptions(columns, hideColumns);
        newState.checkedOption = option;
        newState.checkedOptionConfirm = option;
        newState.colSpanOption = getColSpanOption(columns);
      }
      return newState;
    }
  }]);
  return ColumnFiltrateModal;
}(React.Component);
ColumnFiltrateModal.defaultProps = {
  defaultColumns: [],
  hideColumns: []
};
polyfill(ColumnFiltrateModal);
export default ColumnFiltrateModal;