import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import { shallowEqual } from '../../../utils';
var ExpandIcon = /*#__PURE__*/function (_React$Component) {
  _inherits(ExpandIcon, _React$Component);
  var _super = _createSuper(ExpandIcon);
  function ExpandIcon() {
    _classCallCheck(this, ExpandIcon);
    return _super.apply(this, arguments);
  }
  _createClass(ExpandIcon, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !shallowEqual(nextProps, this.props);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        expandable = _this$props.expandable,
        prefixCls = _this$props.prefixCls,
        onExpand = _this$props.onExpand,
        needIndentSpaced = _this$props.needIndentSpaced,
        expanded = _this$props.expanded,
        record = _this$props.record;
      if (expandable) {
        var _context, _context2;
        var expandClassName = expanded ? 'expanded' : 'collapsed';
        return /*#__PURE__*/React.createElement("span", {
          className: _concatInstanceProperty(_context = _concatInstanceProperty(_context2 = "".concat(prefixCls, "-expand-icon ")).call(_context2, prefixCls, "-")).call(_context, expandClassName),
          onClick: function onClick(e) {
            return onExpand(record, e);
          }
        });
      } else if (needIndentSpaced) {
        var _context3;
        return /*#__PURE__*/React.createElement("span", {
          className: _concatInstanceProperty(_context3 = "".concat(prefixCls, "-expand-icon ")).call(_context3, prefixCls, "-spaced")
        });
      }
      return null;
    }
  }]);
  return ExpandIcon;
}(React.Component);
export { ExpandIcon as default };
ExpandIcon.propTypes = {
  record: PropTypes.object,
  prefixCls: PropTypes.string,
  expandable: PropTypes.bool,
  expanded: PropTypes.bool,
  needIndentSpaced: PropTypes.bool,
  onExpand: PropTypes.func
};