import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _reverseInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/reverse";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { cloneElement } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { getDataAttr } from './utils';
var TabBarRootNode = /*#__PURE__*/function (_React$Component) {
  _inherits(TabBarRootNode, _React$Component);
  var _super = _createSuper(TabBarRootNode);
  function TabBarRootNode() {
    _classCallCheck(this, TabBarRootNode);
    return _super.apply(this, arguments);
  }
  _createClass(TabBarRootNode, [{
    key: "render",
    value: function render() {
      var _a = this.props,
        prefixCls = _a.prefixCls,
        onKeyDown = _a.onKeyDown,
        className = _a.className,
        extraContent = _a.extraContent,
        style = _a.style,
        tabBarPosition = _a.tabBarPosition,
        children = _a.children,
        restProps = __rest(_a, ["prefixCls", "onKeyDown", "className", "extraContent", "style", "tabBarPosition", "children"]);
      var cls = classnames("".concat(prefixCls, "-bar"), _defineProperty({}, className, !!className));
      var topOrBottom = tabBarPosition === 'top' || tabBarPosition === 'bottom';
      var tabBarExtraContentStyle = topOrBottom ? {
        "float": 'right'
      } : {};
      var extraContentStyle = extraContent && extraContent.props ? extraContent.props.style : {};
      var newChildren = children;
      if (extraContent) {
        newChildren = [/*#__PURE__*/cloneElement(extraContent, {
          key: 'extra',
          style: _Object$assign(_Object$assign({}, tabBarExtraContentStyle), extraContentStyle)
        }), /*#__PURE__*/cloneElement(children, {
          key: 'content'
        })];
        newChildren = topOrBottom ? newChildren : _reverseInstanceProperty(newChildren).call(newChildren);
      }
      return /*#__PURE__*/React.createElement("div", _Object$assign({
        role: "tablist",
        className: cls,
        tabIndex: "0",
        ref: this.props.saveRef('root'),
        onKeyDown: onKeyDown,
        style: style
      }, getDataAttr(restProps)), newChildren);
    }
  }]);
  return TabBarRootNode;
}(React.Component);
export { TabBarRootNode as default };
TabBarRootNode.propTypes = {
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  tabBarPosition: PropTypes.oneOf(['left', 'right', 'top', 'bottom']),
  children: PropTypes.node,
  extraContent: PropTypes.node,
  onKeyDown: PropTypes.func,
  saveRef: PropTypes.func
};
TabBarRootNode.defaultProps = {
  prefixCls: '',
  className: '',
  style: {},
  tabBarPosition: 'top',
  extraContent: null,
  children: null,
  onKeyDown: function onKeyDown() {},
  saveRef: function saveRef() {}
};