import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import Animate from 'rc-animate';
import classNames from 'classnames';
import omit from 'omit.js';
import { polyfill } from 'react-lifecycles-compat';
import Icon from '../Icon/index';
import CheckableTag from './CheckableTag';
import './style/index.less';
var Tag = /*#__PURE__*/function (_React$Component) {
  _inherits(Tag, _React$Component);
  var _super = _createSuper(Tag);
  function Tag() {
    var _this;
    _classCallCheck(this, Tag);
    _this = _super.apply(this, arguments);
    _this.state = {
      closing: false,
      closed: false,
      visible: true
    };
    _this.handleIconClick = function (e) {
      var onClose = _this.props.onClose;
      if (onClose) {
        onClose(e);
      }
      if (e.defaultPrevented || 'visible' in _this.props) {
        return;
      }
      _this.setState({
        visible: false
      });
    };
    _this.close = function () {
      if (_this.state.closing || _this.state.closed) {
        return;
      }
      var dom = ReactDOM.findDOMNode(_assertThisInitialized(_this));
      dom.style.width = "".concat(dom.getBoundingClientRect().width, "px");
      // It's Magic Code, don't know why
      dom.style.width = "".concat(dom.getBoundingClientRect().width, "px");
      _this.setState({
        closing: true
      });
    };
    _this.show = function () {
      _this.setState({
        closed: false
      });
    };
    _this.animationEnd = function (_, existed) {
      if (!existed && !_this.state.closed) {
        _this.setState({
          closed: true,
          closing: false
        });
        var afterClose = _this.props.afterClose;
        if (afterClose) {
          afterClose();
        }
      } else {
        _this.setState({
          closed: false
        });
      }
    };
    return _this;
  }
  _createClass(Tag, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(_prevProps, prevState) {
      if (prevState.visible && !this.state.visible) {
        this.close();
      } else if (!prevState.visible && this.state.visible) {
        this.show();
      }
    }
  }, {
    key: "isPresetColor",
    value: function isPresetColor(color) {
      return false;
      // if (!color) { return false; }
      // return (
      //   /^(pink|red|yellow|orange|cyan|green|blue|purple|geekblue|magenta|volcano|gold|lime)(-inverse)?$/
      //   .test(color)
      // );
    }
  }, {
    key: "render",
    value: function render() {
      var _context, _classNames;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        closable = _a.closable,
        color = _a.color,
        className = _a.className,
        children = _a.children,
        style = _a.style,
        autoShowClose = _a.autoShowClose,
        otherProps = __rest(_a, ["prefixCls", "closable", "color", "className", "children", "style", "autoShowClose"]);
      var isPresetColor = this.isPresetColor(color);
      var classString = classNames(prefixCls, (_classNames = {}, _defineProperty(_classNames, _concatInstanceProperty(_context = "".concat(prefixCls, "-")).call(_context, color), isPresetColor), _defineProperty(_classNames, "".concat(prefixCls, "-has-color"), color && !isPresetColor), _defineProperty(_classNames, "".concat(prefixCls, "-close"), this.state.closing), _classNames), className);
      // fix https://fb.me/react-unknown-prop
      var divProps = omit(otherProps, ['onClose', 'afterClose', 'visible']);
      var tagStyle = _Object$assign({
        backgroundColor: color && !isPresetColor ? color : null
      }, style);
      var closeIcon = null;
      if (closable) {
        if (autoShowClose) {
          closeIcon = /*#__PURE__*/React.createElement(Icon, {
            type: "close-modal-line",
            onClick: this.handleIconClick
          });
        } else {
          closeIcon = /*#__PURE__*/React.createElement(Icon, {
            type: "close-modal-line",
            onClick: this.handleIconClick,
            className: "invisible"
          });
        }
      }
      var tag = this.state.closed ? null : /*#__PURE__*/React.createElement("div", _Object$assign({
        "data-show": !this.state.closing
      }, divProps, {
        className: classString,
        style: tagStyle
      }), children, closeIcon);
      return /*#__PURE__*/React.createElement(Animate, {
        component: "",
        showProp: "data-show",
        transitionName: "".concat(prefixCls, "-zoom"),
        transitionAppear: true,
        onEnd: this.animationEnd
      }, tag);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      return 'visible' in nextProps ? {
        visible: nextProps.visible
      } : null;
    }
  }]);
  return Tag;
}(React.Component);
Tag.CheckableTag = CheckableTag;
Tag.defaultProps = {
  prefixCls: 'fishd-tag',
  closable: false,
  autoShowClose: true
};
polyfill(Tag);
export default Tag;