import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import * as React from 'react';
import classNames from 'classnames';
var TimelineItem = /*#__PURE__*/function (_React$Component) {
  _inherits(TimelineItem, _React$Component);
  var _super = _createSuper(TimelineItem);
  function TimelineItem() {
    _classCallCheck(this, TimelineItem);
    return _super.apply(this, arguments);
  }
  _createClass(TimelineItem, [{
    key: "render",
    value: function render() {
      var _classNames, _context, _classNames2;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        _a$color = _a.color,
        color = _a$color === void 0 ? '' : _a$color,
        children = _a.children,
        pending = _a.pending,
        dot = _a.dot,
        restProps = __rest(_a, ["prefixCls", "className", "color", "children", "pending", "dot"]);
      var itemClassName = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-item"), true), _defineProperty(_classNames, "".concat(prefixCls, "-item-pending"), pending), _classNames), className);
      var dotClassName = classNames((_classNames2 = {}, _defineProperty(_classNames2, "".concat(prefixCls, "-item-head"), true), _defineProperty(_classNames2, "".concat(prefixCls, "-item-head-custom"), dot), _defineProperty(_classNames2, _concatInstanceProperty(_context = "".concat(prefixCls, "-item-head-")).call(_context, color), true), _classNames2));
      return /*#__PURE__*/React.createElement("li", _Object$assign({}, restProps, {
        className: itemClassName
      }), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-item-tail")
      }), /*#__PURE__*/React.createElement("div", {
        className: dotClassName,
        style: {
          borderColor: /blue|red|green/.test(color) ? undefined : color
        }
      }, dot), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-item-content")
      }, children));
    }
  }]);
  return TimelineItem;
}(React.Component);
export { TimelineItem as default };
TimelineItem.defaultProps = {
  prefixCls: 'fishd-timeline',
  color: 'blue',
  pending: false
};