import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _someInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/some";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _forEachInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/for-each";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/splice";
import _includesInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/includes";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import * as PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import ConfigConsumer from '../Config/Locale/Consumer';
import List from './List';
import Operation from './Operation';
import Search from './Search';
import './style/index.less';
function noop() {}
var Transfer = /*#__PURE__*/function (_React$Component) {
  _inherits(Transfer, _React$Component);
  var _super = _createSuper(Transfer);
  function Transfer(props) {
    var _this;
    _classCallCheck(this, Transfer);
    _this = _super.call(this, props);
    _this.separatedDataSource = null;
    _this.moveTo = function (direction) {
      var _this$props = _this.props,
        _this$props$targetKey = _this$props.targetKeys,
        targetKeys = _this$props$targetKey === void 0 ? [] : _this$props$targetKey,
        _this$props$dataSourc = _this$props.dataSource,
        dataSource = _this$props$dataSourc === void 0 ? [] : _this$props$dataSourc,
        onChange = _this$props.onChange;
      var _this$state = _this.state,
        sourceSelectedKeys = _this$state.sourceSelectedKeys,
        targetSelectedKeys = _this$state.targetSelectedKeys;
      var moveKeys = direction === 'right' ? sourceSelectedKeys : targetSelectedKeys;
      // filter the disabled options
      var newMoveKeys = _filterInstanceProperty(moveKeys).call(moveKeys, function (key) {
        return !_someInstanceProperty(dataSource).call(dataSource, function (data) {
          return !!(key === data.key && data.disabled);
        });
      });
      // move items to target box
      var newTargetKeys = direction === 'right' ? _concatInstanceProperty(newMoveKeys).call(newMoveKeys, targetKeys) : _filterInstanceProperty(targetKeys).call(targetKeys, function (targetKey) {
        return _indexOfInstanceProperty(newMoveKeys).call(newMoveKeys, targetKey) === -1;
      });
      // empty checked keys
      var oppositeDirection = direction === 'right' ? 'left' : 'right';
      _this.setState(_defineProperty({}, _this.getSelectedKeysName(oppositeDirection), []));
      _this.handleSelectChange(oppositeDirection, []);
      if (onChange) {
        onChange(newTargetKeys, direction, newMoveKeys);
      }
    };
    _this.moveToLeft = function () {
      return _this.moveTo('left');
    };
    _this.moveToRight = function () {
      return _this.moveTo('right');
    };
    _this.handleSelectAll = function (direction, filteredDataSource, checkAll) {
      var originalSelectedKeys = _this.state[_this.getSelectedKeysName(direction)] || [];
      var currentKeys = _mapInstanceProperty(filteredDataSource).call(filteredDataSource, function (item) {
        return item.key;
      });
      // Only operate current keys from original selected keys
      var newKeys1 = _filterInstanceProperty(originalSelectedKeys).call(originalSelectedKeys, function (key) {
        return _indexOfInstanceProperty(currentKeys).call(currentKeys, key) === -1;
      });
      var newKeys2 = _toConsumableArray(originalSelectedKeys);
      _forEachInstanceProperty(currentKeys).call(currentKeys, function (key) {
        if (_indexOfInstanceProperty(newKeys2).call(newKeys2, key) === -1) {
          newKeys2.push(key);
        }
      });
      var holder = checkAll ? newKeys1 : newKeys2;
      _this.handleSelectChange(direction, holder);
      if (!_this.props.selectedKeys) {
        _this.setState(_defineProperty({}, _this.getSelectedKeysName(direction), holder));
      }
    };
    _this.handleLeftSelectAll = function (filteredDataSource, checkAll) {
      return _this.handleSelectAll('left', filteredDataSource, checkAll);
    };
    _this.handleRightSelectAll = function (filteredDataSource, checkAll) {
      return _this.handleSelectAll('right', filteredDataSource, checkAll);
    };
    _this.handleFilter = function (direction, e) {
      _this.setState(_defineProperty({}, "".concat(direction, "Filter"), e.target.value));
      if (_this.props.onSearchChange) {
        _this.props.onSearchChange(direction, e);
      }
    };
    _this.handleLeftFilter = function (e) {
      return _this.handleFilter('left', e);
    };
    _this.handleRightFilter = function (e) {
      return _this.handleFilter('right', e);
    };
    _this.handleClear = function (direction) {
      _this.setState(_defineProperty({}, "".concat(direction, "Filter"), ''));
    };
    _this.handleLeftClear = function () {
      return _this.handleClear('left');
    };
    _this.handleRightClear = function () {
      return _this.handleClear('right');
    };
    // 只单选模式下的目标列表
    _this.handleClose = function (selectedItem) {
      if (_this.props.mode === 'single') {
        var _this$props2 = _this.props,
          _this$props2$targetKe = _this$props2.targetKeys,
          _targetKeys = _this$props2$targetKe === void 0 ? [] : _this$props2$targetKe,
          onChange = _this$props2.onChange;
        var newMoveKeys = [selectedItem.key];
        var newTargetKeys = _filterInstanceProperty(_targetKeys).call(_targetKeys, function (key) {
          return key !== selectedItem.key;
        });
        if (onChange) {
          onChange(newTargetKeys, 'left', newMoveKeys);
        }
      }
    };
    _this.handleSelect = function (direction, selectedItem, checked) {
      // 单选模式下，点击直接move
      if (_this.props.mode === 'single') {
        if (direction === 'right') {
          return;
        }
        var _this$props3 = _this.props,
          _this$props3$targetKe = _this$props3.targetKeys,
          _targetKeys2 = _this$props3$targetKe === void 0 ? [] : _this$props3$targetKe,
          onChange = _this$props3.onChange;
        var newMoveKeys = [selectedItem.key];
        var newTargetKeys = _concatInstanceProperty(_targetKeys2).call(_targetKeys2, newMoveKeys);
        if (onChange) {
          onChange(newTargetKeys, 'right', newMoveKeys);
        }
      } else {
        var _this$state2 = _this.state,
          sourceSelectedKeys = _this$state2.sourceSelectedKeys,
          targetSelectedKeys = _this$state2.targetSelectedKeys;
        var holder = direction === 'left' ? _toConsumableArray(sourceSelectedKeys) : _toConsumableArray(targetSelectedKeys);
        var index = _indexOfInstanceProperty(holder).call(holder, selectedItem.key);
        if (index > -1) {
          _spliceInstanceProperty(holder).call(holder, index, 1);
        }
        if (checked) {
          holder.push(selectedItem.key);
        }
        _this.handleSelectChange(direction, holder);
        if (!_this.props.selectedKeys) {
          _this.setState(_defineProperty({}, _this.getSelectedKeysName(direction), holder));
        }
      }
    };
    _this.handleLeftSelect = function (selectedItem, checked) {
      return _this.handleSelect('left', selectedItem, checked);
    };
    _this.handleRightSelect = function (selectedItem, checked) {
      return _this.handleSelect('right', selectedItem, checked);
    };
    _this.handleScroll = function (direction, e) {
      var onScroll = _this.props.onScroll;
      if (onScroll) {
        onScroll(direction, e);
      }
    };
    _this.handleLeftScroll = function (e) {
      return _this.handleScroll('left', e);
    };
    _this.handleRightScroll = function (e) {
      return _this.handleScroll('right', e);
    };
    _this.getTitles = function (transferLocale) {
      var _assertThisInitialize = _assertThisInitialized(_this),
        props = _assertThisInitialize.props;
      if (props.titles) {
        return props.titles;
      }
      return transferLocale.titles;
    };
    _this.getSelectedKeysName = function (direction) {
      return direction === 'left' ? 'sourceSelectedKeys' : 'targetSelectedKeys';
    };
    _this.renderTransfer = function (Locale) {
      var _this$props4 = _this.props,
        _this$props4$prefixCl = _this$props4.prefixCls,
        prefixCls = _this$props4$prefixCl === void 0 ? 'fishd-transfer' : _this$props4$prefixCl,
        className = _this$props4.className,
        mode = _this$props4.mode,
        _this$props4$operatio = _this$props4.operations,
        operations = _this$props4$operatio === void 0 ? [] : _this$props4$operatio,
        operation = _this$props4.operation,
        showSearch = _this$props4.showSearch,
        notFoundContent = _this$props4.notFoundContent,
        searchPlaceholder = _this$props4.searchPlaceholder,
        body = _this$props4.body,
        footer = _this$props4.footer,
        style = _this$props4.style,
        listStyle = _this$props4.listStyle,
        operationStyle = _this$props4.operationStyle,
        filterOption = _this$props4.filterOption,
        render = _this$props4.render,
        lazy = _this$props4.lazy;
      var _this$state3 = _this.state,
        leftFilter = _this$state3.leftFilter,
        rightFilter = _this$state3.rightFilter,
        sourceSelectedKeys = _this$state3.sourceSelectedKeys,
        targetSelectedKeys = _this$state3.targetSelectedKeys;
      var _this$separateDataSou = _this.separateDataSource(_this.props),
        leftDataSource = _this$separateDataSou.leftDataSource,
        rightDataSource = _this$separateDataSou.rightDataSource;
      var leftActive = targetSelectedKeys.length > 0;
      var rightActive = sourceSelectedKeys.length > 0;
      var cls = classNames(className, prefixCls);
      var localeDefault = {
        titles: [''],
        notFoundContent: Locale.notFoundContent,
        sourceNotFoundContent: Locale.sourceNotFoundContent,
        targetNotFonudContent: Locale.targetNotFonudContent,
        searchPlaceholder: Locale.searchPlaceholder,
        itemUnit: '',
        itemsUnit: ''
      };
      var titles = _this.getTitles(localeDefault);
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, /*#__PURE__*/React.createElement(List, {
        mode: mode,
        direction: "left",
        prefixCls: "".concat(prefixCls, "-list"),
        titleText: titles[0],
        dataSource: leftDataSource,
        filter: leftFilter,
        filterOption: filterOption,
        style: listStyle,
        checkedKeys: sourceSelectedKeys,
        handleFilter: _this.handleLeftFilter,
        handleClear: _this.handleLeftClear,
        handleSelect: _this.handleLeftSelect,
        handleSelectAll: _this.handleLeftSelectAll,
        render: render,
        showSearch: showSearch,
        searchPlaceholder: searchPlaceholder || localeDefault.searchPlaceholder,
        notFoundContent: notFoundContent || localeDefault.sourceNotFoundContent,
        itemUnit: localeDefault.itemUnit,
        itemsUnit: localeDefault.itemsUnit,
        body: body,
        footer: footer,
        lazy: lazy,
        onScroll: _this.handleLeftScroll
      }), /*#__PURE__*/React.createElement(Operation, {
        mode: mode,
        arrowText: operation,
        className: "".concat(prefixCls, "-operation"),
        rightActive: rightActive,
        rightArrowText: operations[0],
        moveToRight: _this.moveToRight,
        leftActive: leftActive,
        leftArrowText: operations[1],
        moveToLeft: _this.moveToLeft,
        style: operationStyle
      }), /*#__PURE__*/React.createElement(List, {
        mode: mode,
        direction: "right",
        prefixCls: "".concat(prefixCls, "-list"),
        titleText: titles[1],
        dataSource: rightDataSource,
        filter: rightFilter,
        filterOption: filterOption,
        style: listStyle,
        checkedKeys: targetSelectedKeys,
        handleFilter: _this.handleRightFilter,
        handleClear: _this.handleRightClear,
        handleSelect: _this.handleRightSelect,
        handleSelectAll: _this.handleRightSelectAll,
        handleClose: _this.handleClose,
        render: render,
        showSearch: showSearch,
        searchPlaceholder: searchPlaceholder || localeDefault.searchPlaceholder,
        notFoundContent: notFoundContent || localeDefault.targetNotFonudContent,
        itemUnit: localeDefault.itemUnit,
        itemsUnit: localeDefault.itemsUnit,
        body: body,
        footer: footer,
        lazy: lazy,
        onScroll: _this.handleRightScroll
      }));
    };
    var _props$selectedKeys = props.selectedKeys,
      selectedKeys = _props$selectedKeys === void 0 ? [] : _props$selectedKeys,
      _props$targetKeys = props.targetKeys,
      targetKeys = _props$targetKeys === void 0 ? [] : _props$targetKeys;
    _this.state = {
      leftFilter: '',
      rightFilter: '',
      sourceSelectedKeys: _filterInstanceProperty(selectedKeys).call(selectedKeys, function (key) {
        return _indexOfInstanceProperty(targetKeys).call(targetKeys, key) === -1;
      }),
      targetSelectedKeys: _filterInstanceProperty(selectedKeys).call(selectedKeys, function (key) {
        return _indexOfInstanceProperty(targetKeys).call(targetKeys, key) > -1;
      }),
      prevProps: props
    };
    return _this;
  }
  _createClass(Transfer, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.targetKeys !== this.props.targetKeys || prevProps.dataSource !== this.props.dataSource) {
        // clear cached separated dataSource
        this.separatedDataSource = null;
        this.forceUpdate();
      }
    }
  }, {
    key: "separateDataSource",
    value: function separateDataSource(props) {
      if (this.separatedDataSource) {
        return this.separatedDataSource;
      }
      var dataSource = props.dataSource,
        rowKey = props.rowKey,
        _props$targetKeys2 = props.targetKeys,
        targetKeys = _props$targetKeys2 === void 0 ? [] : _props$targetKeys2;
      var leftDataSource = [];
      var rightDataSource = new Array(targetKeys.length);
      _forEachInstanceProperty(dataSource).call(dataSource, function (record) {
        if (rowKey) {
          record.key = rowKey(record);
        }
        // rightDataSource should be ordered by targetKeys
        // leftDataSource should be ordered by dataSource
        var indexOfKey = _indexOfInstanceProperty(targetKeys).call(targetKeys, record.key);
        if (indexOfKey !== -1) {
          rightDataSource[indexOfKey] = record;
        } else {
          leftDataSource.push(record);
        }
      });
      this.separatedDataSource = {
        leftDataSource: leftDataSource,
        rightDataSource: rightDataSource
      };
      return this.separatedDataSource;
    }
  }, {
    key: "handleSelectChange",
    value: function handleSelectChange(direction, holder) {
      var _this$state4 = this.state,
        sourceSelectedKeys = _this$state4.sourceSelectedKeys,
        targetSelectedKeys = _this$state4.targetSelectedKeys;
      var onSelectChange = this.props.onSelectChange;
      if (!onSelectChange) {
        return;
      }
      if (direction === 'left') {
        onSelectChange(holder, targetSelectedKeys);
      } else {
        onSelectChange(sourceSelectedKeys, holder);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "Transfer"
      }, function (Locale) {
        return _this2.renderTransfer(Locale);
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      var sourceSelectedKeys = prevState.sourceSelectedKeys,
        targetSelectedKeys = prevState.targetSelectedKeys;
      if (nextProps.targetKeys !== prevProps.targetKeys || nextProps.dataSource !== prevProps.dataSource) {
        if (!nextProps.selectedKeys || !nextProps.selectedKeys.length) {
          // clear key no longer existed
          // clear checkedKeys according to targetKeys
          var dataSource = nextProps.dataSource,
            _nextProps$targetKeys = nextProps.targetKeys,
            targetKeys = _nextProps$targetKeys === void 0 ? [] : _nextProps$targetKeys;
          var newSourceSelectedKeys = [];
          var newTargetSelectedKeys = [];
          _forEachInstanceProperty(dataSource).call(dataSource, function (_ref) {
            var key = _ref.key;
            if (_includesInstanceProperty(sourceSelectedKeys).call(sourceSelectedKeys, key) && !_includesInstanceProperty(targetKeys).call(targetKeys, key)) {
              newSourceSelectedKeys.push(key);
            }
            if (_includesInstanceProperty(targetSelectedKeys).call(targetSelectedKeys, key) && _includesInstanceProperty(targetKeys).call(targetKeys, key)) {
              newTargetSelectedKeys.push(key);
            }
          });
          newState.sourceSelectedKeys = newSourceSelectedKeys;
          newState.targetSelectedKeys = newTargetSelectedKeys;
        }
      }
      if (nextProps.selectedKeys && nextProps.selectedKeys.length > 0) {
        var _context, _context2;
        var _targetKeys3 = nextProps.targetKeys || [];
        newState.sourceSelectedKeys = _filterInstanceProperty(_context = nextProps.selectedKeys).call(_context, function (key) {
          return !_includesInstanceProperty(_targetKeys3).call(_targetKeys3, key);
        });
        newState.targetSelectedKeys = _filterInstanceProperty(_context2 = nextProps.selectedKeys).call(_context2, function (key) {
          return _includesInstanceProperty(_targetKeys3).call(_targetKeys3, key);
        });
      }
      return newState;
    }
  }]);
  return Transfer;
}(React.Component); // For high-level customized Transfer @dqaria
Transfer.List = List;
Transfer.Operation = Operation;
Transfer.Search = Search;
Transfer.defaultProps = {
  mode: 'multiple',
  dataSource: [],
  render: noop,
  showSearch: false,
  operation: '>'
};
Transfer.propTypes = {
  prefixCls: PropTypes.string,
  dataSource: PropTypes.array,
  render: PropTypes.func,
  targetKeys: PropTypes.array,
  onChange: PropTypes.func,
  height: PropTypes.number,
  style: PropTypes.object,
  listStyle: PropTypes.object,
  operationStyle: PropTypes.object,
  className: PropTypes.string,
  titles: PropTypes.array,
  operations: PropTypes.array,
  operation: PropTypes.string,
  showSearch: PropTypes.bool,
  filterOption: PropTypes.func,
  searchPlaceholder: PropTypes.string,
  notFoundContent: PropTypes.node,
  body: PropTypes.func,
  footer: PropTypes.func,
  rowKey: PropTypes.func,
  lazy: PropTypes.oneOfType([PropTypes.object, PropTypes.bool])
};
polyfill(Transfer);
export default Transfer;