import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _typeof from "@babel/runtime-corejs3/helpers/typeof";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _assertThisInitialized from "@babel/runtime-corejs3/helpers/assertThisInitialized";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$getOwnPropertySymbols from "@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && _indexOfInstanceProperty(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _Object$getOwnPropertySymbols === "function") for (var i = 0, p = _Object$getOwnPropertySymbols(s); i < p.length; i++) {
    if (_indexOfInstanceProperty(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import Animate from 'rc-animate';
import { polyfill } from 'react-lifecycles-compat';
import Spin from '../../Spin/index';
import { nodeContextTypes } from './contextTypes';
import { toArray, getNodeChildren, getDataAndAria, mapChildren, warnOnlyTreeNode } from './util';
var ICON_OPEN = 'open';
var ICON_CLOSE = 'close';
var defaultTitle = '---';
var TreeNode = /*#__PURE__*/function (_React$Component) {
  _inherits(TreeNode, _React$Component);
  var _super = _createSuper(TreeNode);
  function TreeNode(props) {
    var _this;
    _classCallCheck(this, TreeNode);
    _this = _super.call(this, props);
    _this.onSelectorClick = function (e) {
      // Click trigger before select/check operation
      var onNodeClick = _this.context.rcTree.onNodeClick;
      onNodeClick(e, _assertThisInitialized(_this));
      if (_this.isSelectable()) {
        _this.onSelect(e);
      } else {
        _this.onCheck(e);
      }
    };
    _this.onSelectorDoubleClick = function (e) {
      var onNodeDoubleClick = _this.context.rcTree.onNodeDoubleClick;
      onNodeDoubleClick(e, _assertThisInitialized(_this));
    };
    _this.onSelect = function (e) {
      if (_this.isDisabled()) return;
      var onNodeSelect = _this.context.rcTree.onNodeSelect;
      e.preventDefault();
      onNodeSelect(e, _assertThisInitialized(_this));
    };
    _this.onCheck = function (e) {
      if (_this.isDisabled()) return;
      var _this$props = _this.props,
        disableCheckbox = _this$props.disableCheckbox,
        checked = _this$props.checked,
        nodeCheckable = _this$props.checkable;
      var _this$context$rcTree = _this.context.rcTree,
        checkable = _this$context$rcTree.checkable,
        onNodeCheck = _this$context$rcTree.onNodeCheck;
      if (!checkable || disableCheckbox || nodeCheckable === false) return;
      e.preventDefault();
      var targetChecked = !checked;
      onNodeCheck(e, _assertThisInitialized(_this), targetChecked);
    };
    _this.onMouseEnter = function (e) {
      var onNodeMouseEnter = _this.context.rcTree.onNodeMouseEnter;
      onNodeMouseEnter(e, _assertThisInitialized(_this));
    };
    _this.onMouseLeave = function (e) {
      var onNodeMouseLeave = _this.context.rcTree.onNodeMouseLeave;
      onNodeMouseLeave(e, _assertThisInitialized(_this));
    };
    _this.onContextMenu = function (e) {
      var onNodeContextMenu = _this.context.rcTree.onNodeContextMenu;
      onNodeContextMenu(e, _assertThisInitialized(_this));
    };
    _this.onDragStart = function (e) {
      var onNodeDragStart = _this.context.rcTree.onNodeDragStart;
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: true
      });
      onNodeDragStart(e, _assertThisInitialized(_this));
      try {
        // ie throw error
        // firefox-need-it
        e.dataTransfer.setData('text/plain', '');
      } catch (error) {
        // empty
      }
    };
    _this.onDragEnter = function (e) {
      var onNodeDragEnter = _this.context.rcTree.onNodeDragEnter;
      e.preventDefault();
      e.stopPropagation();
      onNodeDragEnter(e, _assertThisInitialized(_this));
    };
    _this.onDragOver = function (e) {
      var onNodeDragOver = _this.context.rcTree.onNodeDragOver;
      e.preventDefault();
      e.stopPropagation();
      onNodeDragOver(e, _assertThisInitialized(_this));
    };
    _this.onDragLeave = function (e) {
      var onNodeDragLeave = _this.context.rcTree.onNodeDragLeave;
      e.stopPropagation();
      onNodeDragLeave(e, _assertThisInitialized(_this));
    };
    _this.onDragEnd = function (e) {
      var onNodeDragEnd = _this.context.rcTree.onNodeDragEnd;
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: false
      });
      onNodeDragEnd(e, _assertThisInitialized(_this));
    };
    _this.onDrop = function (e) {
      var onNodeDrop = _this.context.rcTree.onNodeDrop;
      e.preventDefault();
      e.stopPropagation();
      _this.setState({
        dragNodeHighlight: false
      });
      onNodeDrop(e, _assertThisInitialized(_this));
    };
    // Disabled item still can be switch
    _this.onExpand = function (e) {
      var onNodeExpand = _this.context.rcTree.onNodeExpand;
      onNodeExpand(e, _assertThisInitialized(_this));
    };
    // Drag usage
    _this.setSelectHandle = function (node) {
      _this.selectHandle = node;
    };
    _this.getNodeChildren = function () {
      var _context;
      var children = _this.props.children;
      var originList = _filterInstanceProperty(_context = toArray(children)).call(_context, function (node) {
        return node;
      });
      var targetList = getNodeChildren(originList);
      if (originList.length !== targetList.length) {
        warnOnlyTreeNode();
      }
      return targetList;
    };
    _this.getNodeState = function () {
      var expanded = _this.props.expanded;
      if (_this.isLeaf()) {
        return null;
      }
      return expanded ? ICON_OPEN : ICON_CLOSE;
    };
    _this.isLeaf = function () {
      var _this$props2 = _this.props,
        isLeaf = _this$props2.isLeaf,
        loaded = _this$props2.loaded;
      var loadData = _this.context.rcTree.loadData;
      var hasChildren = _this.getNodeChildren().length !== 0;
      // if (isLeaf === false) {
      //   return false;
      // }
      return isLeaf || !loadData && !hasChildren || loadData && loaded && !hasChildren;
    };
    _this.isDisabled = function () {
      var disabled = _this.props.disabled;
      var treeDisabled = _this.context.rcTree.disabled;
      // Follow the logic of Selectable
      if (disabled === false) {
        return false;
      }
      return !!(treeDisabled || disabled);
    };
    // Load data to avoid default expanded tree without data
    _this.syncLoadData = function (props) {
      var expanded = props.expanded,
        loading = props.loading,
        loaded = props.loaded;
      var _this$context$rcTree2 = _this.context.rcTree,
        loadData = _this$context$rcTree2.loadData,
        onNodeLoad = _this$context$rcTree2.onNodeLoad;
      if (loading) return;
      // read from state to avoid loadData at same time
      if (loadData && expanded && !_this.isLeaf()) {
        // We needn't reload data when has children in sync logic
        // It's only needed in node expanded
        var hasChildren = _this.getNodeChildren().length !== 0;
        if (!hasChildren && !loaded) {
          onNodeLoad(_assertThisInitialized(_this));
        }
      }
    };
    // Switcher
    _this.renderSwitcher = function () {
      var _context2;
      var _this$props3 = _this.props,
        expanded = _this$props3.expanded,
        switcherIconFromProps = _this$props3.switcherIcon;
      var _this$context$rcTree3 = _this.context.rcTree,
        prefixCls = _this$context$rcTree3.prefixCls,
        switcherIconFromCtx = _this$context$rcTree3.switcherIcon;
      var switcherIcon = switcherIconFromProps || switcherIconFromCtx;
      if (_this.isLeaf()) {
        return /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-switcher"), "".concat(prefixCls, "-switcher-noop"))
        }, typeof switcherIcon === 'function' ? /*#__PURE__*/React.createElement(switcherIcon, _Object$assign(_Object$assign({}, _this.props), {
          isLeaf: true
        })) : switcherIcon);
      }
      var switcherCls = classNames("".concat(prefixCls, "-switcher"), _concatInstanceProperty(_context2 = "".concat(prefixCls, "-switcher_")).call(_context2, expanded ? ICON_OPEN : ICON_CLOSE));
      return /*#__PURE__*/React.createElement("span", {
        onClick: _this.onExpand,
        className: switcherCls
      }, typeof switcherIcon === 'function' ? /*#__PURE__*/React.createElement(switcherIcon, _Object$assign(_Object$assign({}, _this.props), {
        isLeaf: false
      })) : switcherIcon);
    };
    // Checkbox
    _this.renderCheckbox = function () {
      var _this$props4 = _this.props,
        checked = _this$props4.checked,
        halfChecked = _this$props4.halfChecked,
        disableCheckbox = _this$props4.disableCheckbox,
        nodeCheckable = _this$props4.checkable;
      var _this$context$rcTree4 = _this.context.rcTree,
        prefixCls = _this$context$rcTree4.prefixCls,
        checkable = _this$context$rcTree4.checkable;
      var disabled = _this.isDisabled();
      if (!checkable || nodeCheckable === false) return null;
      // [Legacy] Custom element should be separate with `checkable` in future
      var $custom = typeof checkable !== 'boolean' ? checkable : null;
      return /*#__PURE__*/React.createElement("span", {
        className: classNames("".concat(prefixCls, "-checkbox"), checked && "".concat(prefixCls, "-checkbox-checked"), halfChecked && "".concat(prefixCls, "-checkbox-indeterminate"), (disabled || disableCheckbox) && "".concat(prefixCls, "-checkbox-disabled")),
        onClick: _this.onCheck
      }, $custom);
    };
    _this.renderIcon = function () {
      var _this$props5 = _this.props,
        loading = _this$props5.loading,
        icon = _this$props5.icon;
      var _this$context$rcTree5 = _this.context.rcTree,
        prefixCls = _this$context$rcTree5.prefixCls,
        showIcon = _this$context$rcTree5.showIcon,
        treeIcon = _this$context$rcTree5.icon,
        loadData = _this$context$rcTree5.loadData;
      var currentIcon = icon || treeIcon;
      var customIcon = null,
        loadingIcon = null;
      if (showIcon && currentIcon) {
        customIcon = /*#__PURE__*/React.createElement("span", {
          className: classNames("".concat(prefixCls, "-iconEle"), "".concat(prefixCls, "-icon__customize"))
        }, typeof currentIcon === 'function' ? /*#__PURE__*/React.createElement(currentIcon, _Object$assign({}, _this.props)) : currentIcon);
      }
      if (loadData && loading) {
        loadingIcon = /*#__PURE__*/React.createElement(Spin, {
          className: prefixCls + '-spinning',
          size: "small"
        });
      }
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-iconCtner")
      }, loadingIcon, customIcon);
      /* 废弃的 loading icon
      return (
        <span
          className={classNames(
            `${prefixCls}-iconEle`,
            `${prefixCls}-icon__${this.getNodeState() || 'docu'}`,
            loading && `${prefixCls}-icon_loading`,
          )}
        />
      );
      */
    };
    // Icon + Title
    _this.renderSelector = function () {
      var _context3;
      var dragNodeHighlight = _this.state.dragNodeHighlight;
      var _this$props6 = _this.props,
        title = _this$props6.title,
        selected = _this$props6.selected;
      var _this$context$rcTree6 = _this.context.rcTree,
        prefixCls = _this$context$rcTree6.prefixCls,
        draggable = _this$context$rcTree6.draggable;
      var disabled = _this.isDisabled();
      var wrapClass = "".concat(prefixCls, "-node-content-wrapper");
      var $icon = _this.renderIcon();
      var $title = /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-title")
      }, title);
      return /*#__PURE__*/React.createElement("span", {
        ref: _this.setSelectHandle,
        title: typeof title === 'string' ? title : '',
        className: classNames("".concat(wrapClass), _concatInstanceProperty(_context3 = "".concat(wrapClass, "-")).call(_context3, _this.getNodeState() || 'normal'), !disabled && (selected || dragNodeHighlight) && "".concat(prefixCls, "-node-selected"), !disabled && draggable && 'draggable'),
        draggable: !disabled && draggable || undefined,
        "aria-grabbed": !disabled && draggable || undefined,
        onMouseEnter: _this.onMouseEnter,
        onMouseLeave: _this.onMouseLeave,
        onContextMenu: _this.onContextMenu,
        onClick: _this.onSelectorClick,
        onDoubleClick: _this.onSelectorDoubleClick,
        onDragStart: draggable ? _this.onDragStart : undefined
      }, $icon, $title);
    };
    // Children list wrapped with `Animation`
    _this.renderChildren = function () {
      var _this$props7 = _this.props,
        expanded = _this$props7.expanded,
        pos = _this$props7.pos;
      var _this$context$rcTree7 = _this.context.rcTree,
        prefixCls = _this$context$rcTree7.prefixCls,
        openTransitionName = _this$context$rcTree7.openTransitionName,
        openAnimation = _this$context$rcTree7.openAnimation,
        renderTreeNode = _this$context$rcTree7.renderTreeNode;
      var animProps = {};
      if (openTransitionName) {
        animProps.transitionName = openTransitionName;
      } else if (_typeof(openAnimation) === 'object') {
        animProps.animation = _Object$assign({}, openAnimation);
      }
      // Children TreeNode
      var nodeList = _this.getNodeChildren();
      if (nodeList.length === 0) {
        return null;
      }
      var $children;
      if (expanded) {
        $children = /*#__PURE__*/React.createElement("ul", {
          className: classNames("".concat(prefixCls, "-child-tree"), expanded && "".concat(prefixCls, "-child-tree-open")),
          "data-expanded": expanded,
          role: "group"
        }, mapChildren(nodeList, function (node, index) {
          return renderTreeNode(node, index, pos);
        }));
      }
      return /*#__PURE__*/React.createElement(Animate, _Object$assign({}, animProps, {
        showProp: "data-expanded",
        component: ""
      }), $children);
    };
    _this.state = {
      dragNodeHighlight: false
    };
    return _this;
  }
  _createClass(TreeNode, [{
    key: "getChildContext",
    value: function getChildContext() {
      return _Object$assign(_Object$assign({}, this.context), {
        rcTreeNode: {
          // onUpCheckConduct: this.onUpCheckConduct,
        }
      });
    }
    // Isomorphic needn't load data in server side
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.syncLoadData(this.props);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.syncLoadData(this.props);
    }
  }, {
    key: "isSelectable",
    value: function isSelectable() {
      var selectable = this.props.selectable;
      var treeSelectable = this.context.rcTree.selectable;
      // Ignore when selectable is undefined or null
      if (typeof selectable === 'boolean') {
        return selectable;
      }
      return treeSelectable;
    }
  }, {
    key: "render",
    value: function render() {
      var _context4, _classNames;
      var loading = this.props.loading;
      var _a = this.props,
        className = _a.className,
        style = _a.style,
        dragOver = _a.dragOver,
        dragOverGapTop = _a.dragOverGapTop,
        dragOverGapBottom = _a.dragOverGapBottom,
        isLeaf = _a.isLeaf,
        expanded = _a.expanded,
        selected = _a.selected,
        checked = _a.checked,
        halfChecked = _a.halfChecked,
        otherProps = __rest(_a, ["className", "style", "dragOver", "dragOverGapTop", "dragOverGapBottom", "isLeaf", "expanded", "selected", "checked", "halfChecked"]);
      var _this$context$rcTree8 = this.context.rcTree,
        prefixCls = _this$context$rcTree8.prefixCls,
        filterTreeNode = _this$context$rcTree8.filterTreeNode,
        draggable = _this$context$rcTree8.draggable;
      var disabled = this.isDisabled();
      var dataOrAriaAttributeProps = getDataAndAria(otherProps);
      return /*#__PURE__*/React.createElement("li", _Object$assign({
        className: classNames(className, (_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-treenode-disabled"), disabled), _defineProperty(_classNames, _concatInstanceProperty(_context4 = "".concat(prefixCls, "-treenode-switcher-")).call(_context4, expanded ? 'open' : 'close'), !isLeaf), _defineProperty(_classNames, "".concat(prefixCls, "-treenode-checkbox-checked"), checked), _defineProperty(_classNames, "".concat(prefixCls, "-treenode-checkbox-indeterminate"), halfChecked), _defineProperty(_classNames, "".concat(prefixCls, "-treenode-selected"), selected), _defineProperty(_classNames, "".concat(prefixCls, "-treenode-loading"), loading), _defineProperty(_classNames, 'drag-over', !disabled && dragOver), _defineProperty(_classNames, 'drag-over-gap-top', !disabled && dragOverGapTop), _defineProperty(_classNames, 'drag-over-gap-bottom', !disabled && dragOverGapBottom), _defineProperty(_classNames, 'filter-node', filterTreeNode && filterTreeNode(this)), _classNames)),
        style: style,
        role: "treeitem",
        onDragEnter: draggable ? this.onDragEnter : undefined,
        onDragOver: draggable ? this.onDragOver : undefined,
        onDragLeave: draggable ? this.onDragLeave : undefined,
        onDrop: draggable ? this.onDrop : undefined,
        onDragEnd: draggable ? this.onDragEnd : undefined
      }, dataOrAriaAttributeProps), this.renderSwitcher(), this.renderCheckbox(), this.renderSelector(), this.renderChildren());
    }
  }]);
  return TreeNode;
}(React.Component);
TreeNode.propTypes = {
  eventKey: PropTypes.string,
  prefixCls: PropTypes.string,
  className: PropTypes.string,
  style: PropTypes.object,
  root: PropTypes.object,
  onSelect: PropTypes.func,
  // By parent
  expanded: PropTypes.bool,
  selected: PropTypes.bool,
  checked: PropTypes.bool,
  loaded: PropTypes.bool,
  loading: PropTypes.bool,
  halfChecked: PropTypes.bool,
  children: PropTypes.node,
  title: PropTypes.node,
  pos: PropTypes.string,
  dragOver: PropTypes.bool,
  dragOverGapTop: PropTypes.bool,
  dragOverGapBottom: PropTypes.bool,
  // By user
  isLeaf: PropTypes.bool,
  selectable: PropTypes.bool,
  disabled: PropTypes.bool,
  checkable: PropTypes.bool,
  disableCheckbox: PropTypes.bool,
  icon: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  switcherIcon: PropTypes.oneOfType([PropTypes.node, PropTypes.func])
};
TreeNode.contextTypes = nodeContextTypes;
TreeNode.childContextTypes = nodeContextTypes;
TreeNode.defaultProps = {
  title: defaultTitle
};
TreeNode.isTreeNode = 1;
polyfill(TreeNode);
export default TreeNode;