import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _indexOfInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/index-of";
import _Object$keys from "@babel/runtime-corejs3/core-js-stable/object/keys";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
import _Array$isArray from "@babel/runtime-corejs3/core-js-stable/array/is-array";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { polyfill } from 'react-lifecycles-compat';
import Tree from '../../rcTree';
import Spin from '../../../Spin/index';
export var popupContextTypes = {
  onPopupKeyDown: PropTypes.func.isRequired,
  onTreeNodeSelect: PropTypes.func.isRequired,
  onTreeNodeCheck: PropTypes.func.isRequired
};
var BasePopup = /*#__PURE__*/function (_React$Component) {
  _inherits(BasePopup, _React$Component);
  var _super = _createSuper(BasePopup);
  function BasePopup(props) {
    var _this;
    _classCallCheck(this, BasePopup);
    _this = _super.call(this);
    _this.onTreeExpand = function (expandedKeyList, extra) {
      var _this$props = _this.props,
        onTreeExpanded = _this$props.onTreeExpanded,
        onExpand = _this$props.onExpand;
      _this.setState({
        expandedKeyList: expandedKeyList
      }, onTreeExpanded);
      onExpand && onExpand(expandedKeyList, extra);
    };
    _this.onLoad = function (loadedKeys) {
      _this.setState({
        loadedKeys: loadedKeys
      });
    };
    /**
     * This method pass to Tree component which is used for add filtered class
     * in TreeNode > li
     */
    _this.filterTreeNode = function (treeNode) {
      var _this$props2 = _this.props,
        upperSearchValue = _this$props2.upperSearchValue,
        treeNodeFilterProp = _this$props2.treeNodeFilterProp;
      var filterVal = treeNode.props[treeNodeFilterProp];
      if (typeof filterVal === 'string') {
        var _context;
        return upperSearchValue && _indexOfInstanceProperty(_context = filterVal.toUpperCase()).call(_context, upperSearchValue) !== -1;
      }
      return false;
    };
    _this.renderNotFound = function () {
      var _this$props3 = _this.props,
        prefixCls = _this$props3.prefixCls,
        notFoundContent = _this$props3.notFoundContent,
        loading = _this$props3.loading;
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-not-found")
      }, loading ? /*#__PURE__*/React.createElement(Spin, {
        size: "small"
      }) : notFoundContent);
    };
    var treeDefaultExpandAll = props.treeDefaultExpandAll,
      treeDefaultExpandedKeys = props.treeDefaultExpandedKeys,
      keyEntities = props.keyEntities;
    // TODO: make `expandedKeyList` control
    var expandedKeyList = treeDefaultExpandedKeys;
    if (treeDefaultExpandAll) {
      expandedKeyList = _Object$keys(keyEntities);
    }
    _this.state = {
      keyList: [],
      expandedKeyList: expandedKeyList,
      loadedKeys: []
    };
    return _this;
  }
  _createClass(BasePopup, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
        keyList = _this$state.keyList,
        expandedKeyList = _this$state.expandedKeyList,
        loadedKeys = _this$state.loadedKeys;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        treeNodes = _this$props4.treeNodes,
        filteredTreeNodes = _this$props4.filteredTreeNodes,
        showIcon = _this$props4.showIcon,
        treeLine = _this$props4.treeLine,
        treeCheckable = _this$props4.treeCheckable,
        treeCheckStrictly = _this$props4.treeCheckStrictly,
        treeCheckType = _this$props4.treeCheckType,
        multiple = _this$props4.multiple,
        loadData = _this$props4.loadData,
        loading = _this$props4.loading,
        ariaId = _this$props4.ariaId,
        renderSearch = _this$props4.renderSearch,
        renderResetItem = _this$props4.renderResetItem,
        autoExpandParent = _this$props4.autoExpandParent,
        icon = _this$props4.icon,
        doCheckChildInSearch = _this$props4.doCheckChildInSearch;
      var _this$context$rcTreeS = this.context.rcTreeSelect,
        onPopupKeyDown = _this$context$rcTreeS.onPopupKeyDown,
        onTreeNodeSelect = _this$context$rcTreeS.onTreeNodeSelect,
        onTreeNodeCheck = _this$context$rcTreeS.onTreeNodeCheck;
      var treeProps = {};
      if (treeCheckable) {
        treeProps.checkedKeys = keyList;
      } else {
        treeProps.selectedKeys = keyList;
      }
      var $notFound;
      var $treeNodes;
      if (!treeNodes || !treeNodes.length || loading) {
        $notFound = this.renderNotFound();
      } else if (filteredTreeNodes) {
        if (filteredTreeNodes.length) {
          treeProps.checkStrictly = true;
          $treeNodes = filteredTreeNodes;
        } else {
          $notFound = this.renderNotFound();
        }
      } else {
        $treeNodes = treeNodes;
      }
      var $tree;
      var isNotFound = false;
      if ($notFound) {
        $tree = $notFound;
        isNotFound = true;
      } else {
        $tree = /*#__PURE__*/React.createElement(Tree, _Object$assign({
          doCheckChildInSearch: doCheckChildInSearch,
          autoExpandParent: autoExpandParent,
          prefixCls: "".concat(prefixCls, "-tree"),
          className: classNames(!showIcon && "".concat(prefixCls, "-tree-icon-hide")),
          icon: icon,
          showIcon: showIcon,
          showLine: treeLine,
          selectable: !treeCheckable,
          checkable: treeCheckable,
          checkStrictly: treeCheckStrictly,
          checkType: treeCheckType,
          multiple: multiple,
          loadData: loadData,
          loadedKeys: loadedKeys,
          expandedKeys: expandedKeyList,
          filterTreeNode: this.filterTreeNode,
          onSelect: onTreeNodeSelect,
          onCheck: onTreeNodeCheck,
          onExpand: this.onTreeExpand,
          onLoad: this.onLoad
        }, treeProps), $treeNodes);
      }
      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-base-popup"),
        role: "listbox",
        id: ariaId,
        onKeyDown: onPopupKeyDown,
        tabIndex: -1
      }, renderSearch ? renderSearch() : null, renderResetItem && !isNotFound ? renderResetItem() : null, $tree);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _ref = prevState || {},
        _ref$prevProps = _ref.prevProps,
        prevProps = _ref$prevProps === void 0 ? {} : _ref$prevProps,
        loadedKeys = _ref.loadedKeys;
      var valueList = nextProps.valueList,
        valueEntities = nextProps.valueEntities,
        keyEntities = nextProps.keyEntities,
        filteredTreeNodes = nextProps.filteredTreeNodes,
        upperSearchValue = nextProps.upperSearchValue;
      var newState = {
        prevProps: nextProps
      };
      // Check value update
      if (valueList !== prevProps.valueList) {
        var _context2, _context3;
        newState.keyList = _mapInstanceProperty(_context2 = _filterInstanceProperty(_context3 = _mapInstanceProperty(valueList).call(valueList, function (_ref2) {
          var value = _ref2.value;
          return valueEntities[value];
        })).call(_context3, function (entity) {
          return entity;
        })).call(_context2, function (_ref3) {
          var key = _ref3.key;
          return key;
        });
      }
      // 清空搜索内容后恢复搜索前的展开状态
      if (upperSearchValue && !prevState.savedExpandedKeyList) {
        // 保存搜索前展开的节点
        newState.prevExpandedKeyList = _Array$isArray(prevState.expandedKeyList) ? _toConsumableArray(prevState.expandedKeyList) : [];
        newState.savedExpandedKeyList = true;
      } else if (!upperSearchValue && prevState.savedExpandedKeyList) {
        // 恢复搜索前展开的节点
        newState.expandedKeyList = _Array$isArray(prevState.prevExpandedKeyList) ? _toConsumableArray(prevState.prevExpandedKeyList) : [];
        newState.savedExpandedKeyList = false;
      }
      // Show all when tree is in filter mode
      if (filteredTreeNodes && filteredTreeNodes.length && filteredTreeNodes !== prevProps.filteredTreeNodes) {
        newState.expandedKeyList = _Object$keys(keyEntities);
      }
      // Clean loadedKeys if key not exist in keyEntities anymore
      if (nextProps.loadData) {
        newState.loadedKeys = _filterInstanceProperty(loadedKeys).call(loadedKeys, function (key) {
          return key in keyEntities;
        });
      }
      return newState;
    }
  }]);
  return BasePopup;
}(React.Component);
BasePopup.propTypes = {
  prefixCls: PropTypes.string,
  upperSearchValue: PropTypes.string,
  valueList: PropTypes.array,
  valueEntities: PropTypes.object,
  keyEntities: PropTypes.object,
  showIcon: PropTypes.bool,
  icon: PropTypes.oneOfType([PropTypes.func, PropTypes.node]),
  treeLine: PropTypes.bool,
  treeNodeFilterProp: PropTypes.string,
  treeCheckable: PropTypes.oneOfType([PropTypes.bool, PropTypes.node]),
  doCheckChildInSearch: PropTypes.bool,
  treeCheckStrictly: PropTypes.bool,
  treeCheckType: PropTypes.string,
  treeDefaultExpandAll: PropTypes.bool,
  treeDefaultExpandedKeys: PropTypes.array,
  loadData: PropTypes.func,
  loading: PropTypes.bool,
  multiple: PropTypes.bool,
  autoExpandParent: PropTypes.bool,
  treeNodes: PropTypes.node,
  filteredTreeNodes: PropTypes.node,
  notFoundContent: PropTypes.oneOfType([PropTypes.string, PropTypes.node]),
  ariaId: PropTypes.string,
  // HOC
  renderSearch: PropTypes.func,
  renderResetItem: PropTypes.func,
  onTreeExpanded: PropTypes.func,
  // 确定或取消选择
  onCancel: PropTypes.func,
  onConfirm: PropTypes.func,
  onExpand: PropTypes.func // 节点展开时的回调
};

BasePopup.contextTypes = {
  rcTreeSelect: PropTypes.shape(_Object$assign({}, popupContextTypes))
};
polyfill(BasePopup);
export default BasePopup;