import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import React from 'react';
import PropTypes from 'prop-types';
import { TreeNode } from '../rcTree';
/**
 * SelectNode wrapped the tree node.
 * Let's use SelectNode instead of TreeNode
 * since TreeNode is so confuse here.
 */
var SelectNode = function SelectNode(props) {
  return /*#__PURE__*/React.createElement(TreeNode, _Object$assign({}, props));
};
SelectNode.propTypes = _Object$assign(_Object$assign({}, TreeNode.propTypes), {
  value: PropTypes.string
});
// Let Tree trade as TreeNode to reuse this for performance saving.
SelectNode.isTreeNode = 1;
export default SelectNode;