import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { toTitle, UNSELECTABLE_ATTRIBUTE, UNSELECTABLE_STYLE } from '../../util';
var Selection = /*#__PURE__*/function (_React$Component) {
  _inherits(Selection, _React$Component);
  var _super = _createSuper(Selection);
  function Selection() {
    var _this;
    _classCallCheck(this, Selection);
    _this = _super.apply(this, arguments);
    _this.onRemove = function (event) {
      event.stopPropagation();
      event.preventDefault();
      var _this$props = _this.props,
        onRemove = _this$props.onRemove,
        value = _this$props.value;
      onRemove(event, value);
    };
    return _this;
  }
  _createClass(Selection, [{
    key: "render",
    value: function render() {
      var _classNames;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        maxTagTextLength = _this$props2.maxTagTextLength,
        label = _this$props2.label,
        value = _this$props2.value,
        tagWidth = _this$props2.tagWidth,
        disableCloseTag = _this$props2.disableCloseTag,
        iconPrefix = _this$props2.iconPrefix;
      var content = label || value;
      if (maxTagTextLength && typeof content === 'string' && content.length > maxTagTextLength) {
        content = "".concat(_sliceInstanceProperty(content).call(content, 0, maxTagTextLength), "...");
      }
      var tagStyle = _Object$assign({
        width: tagWidth + 'px'
      }, UNSELECTABLE_STYLE);
      var removeCls = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-selection__choice__remove"), true), _defineProperty(_classNames, "".concat(iconPrefix, "-close-modal-line"), true), _defineProperty(_classNames, "".concat(prefixCls, "-selection__choice__remove__disabled"), disableCloseTag), _classNames));
      return /*#__PURE__*/React.createElement("li", _Object$assign({
        style: tagStyle
      }, UNSELECTABLE_ATTRIBUTE, {
        role: "menuitem",
        className: "".concat(prefixCls, "-selection__choice"),
        title: toTitle(label)
      }), /*#__PURE__*/React.createElement("span", {
        className: removeCls,
        onMouseDown: disableCloseTag ? null : this.onRemove
      }), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-selection__choice__content")
      }, content));
    }
  }]);
  return Selection;
}(React.Component);
Selection.propTypes = {
  disableCloseTag: PropTypes.bool,
  editable: PropTypes.bool,
  prefixCls: PropTypes.string,
  iconPrefix: PropTypes.string,
  maxTagTextLength: PropTypes.number,
  tagWidth: PropTypes.number,
  onRemove: PropTypes.func,
  label: PropTypes.node,
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};
export default Selection;