import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _defineProperty from "@babel/runtime-corejs3/helpers/defineProperty";
import _toConsumableArray from "@babel/runtime-corejs3/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/slice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/map";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _Set from "@babel/runtime-corejs3/core-js-stable/set";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/filter";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import PropTypes from 'prop-types';
import Animate from 'rc-animate';
import generateSelector, { selectorPropTypes } from '../../Base/BaseSelector';
import Selection from './Selection';
import classNames from 'classnames';
var TREE_SELECT_EMPTY_VALUE_KEY = 'RC_TREE_SELECT_EMPTY_VALUE_KEY';
var Selector = generateSelector('multiple');
export var multipleSelectorContextTypes = {
  onMultipleSelectorRemove: PropTypes.func.isRequired
};
var MultipleSelector = /*#__PURE__*/function (_React$Component) {
  _inherits(MultipleSelector, _React$Component);
  var _super = _createSuper(MultipleSelector);
  function MultipleSelector() {
    var _this;
    _classCallCheck(this, MultipleSelector);
    _this = _super.call(this);
    // onPlaceholderClick = () => {
    //   this.inputRef.current.focus();
    // };
    // focus = () => {
    //   this.inputRef.current.focus();
    // };
    // blur = () => {
    //   this.inputRef.current.blur();
    // };
    _this.renderPlaceholder = function () {
      var _this$props = _this.props,
        prefixCls = _this$props.prefixCls,
        placeholder = _this$props.placeholder,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        selectorValueList = _this$props.selectorValueList;
      var currentPlaceholder = placeholder || searchPlaceholder;
      if (!currentPlaceholder) return null;
      // const hidden = searchValue || selectorValueList.length;
      var hidden = selectorValueList.length;
      // [Legacy] Not remove the placeholder
      return /*#__PURE__*/React.createElement("span", {
        style: {
          display: hidden ? 'none' : 'block'
        },
        onClick: _this.onPlaceholderClick,
        className: "".concat(prefixCls, "-search__field__placeholder")
      }, currentPlaceholder);
    };
    _this.renderSelection = function () {
      var _classNames;
      var _this$props2 = _this.props,
        selectorValueList = _this$props2.selectorValueList,
        choiceTransitionName = _this$props2.choiceTransitionName,
        prefixCls = _this$props2.prefixCls,
        onChoiceAnimationLeave = _this$props2.onChoiceAnimationLeave,
        labelInValue = _this$props2.labelInValue,
        maxTagCount = _this$props2.maxTagCount,
        maxTagPlaceholder = _this$props2.maxTagPlaceholder,
        editable = _this$props2.editable,
        uniqueTreeNodeByLabel = _this$props2.uniqueTreeNodeByLabel;
      var onMultipleSelectorRemove = _this.context.rcTreeSelect.onMultipleSelectorRemove;
      // Check if `maxTagCount` is set
      var myValueList = selectorValueList;
      if (maxTagCount >= 0) {
        myValueList = _sliceInstanceProperty(selectorValueList).call(selectorValueList, 0, maxTagCount);
      }
      // Selector node list
      var selectedValueNodes = _mapInstanceProperty(myValueList).call(myValueList, function (_ref) {
        var label = _ref.label,
          value = _ref.value;
        return /*#__PURE__*/React.createElement(Selection, _Object$assign({}, _this.props, {
          key: value || TREE_SELECT_EMPTY_VALUE_KEY,
          label: label,
          value: value,
          onRemove: onMultipleSelectorRemove
        }));
      });
      // Rest node count
      if (maxTagCount >= 0 && maxTagCount < selectorValueList.length) {
        var content = "+ ".concat(selectorValueList.length - maxTagCount, " ...");
        if (typeof maxTagPlaceholder === 'string') {
          content = maxTagPlaceholder;
        } else if (typeof maxTagPlaceholder === 'function') {
          var restValueList = _sliceInstanceProperty(selectorValueList).call(selectorValueList, maxTagCount);
          content = maxTagPlaceholder(labelInValue ? restValueList : _mapInstanceProperty(restValueList).call(restValueList, function (_ref2) {
            var value = _ref2.value;
            return value;
          }));
        }
        var restNodeSelect = /*#__PURE__*/React.createElement(Selection, _Object$assign({}, _this.props, {
          key: "rc-tree-select-internal-max-tag-counter",
          label: content,
          value: null
        }));
        selectedValueNodes.push(restNodeSelect);
      }
      // selectedValueNodes.push(
      //   <li className={`${prefixCls}-search ${prefixCls}-search--inline`} key="__input">
      //     <SearchInput {...this.props} ref={this.inputRef} needAlign />
      //   </li>
      // );
      // 处理不可编辑的多选
      if (!editable) {
        var labelList = _mapInstanceProperty(selectedValueNodes).call(selectedValueNodes, function (item) {
          return item.props.label;
        });
        // 相同 label 去重
        uniqueTreeNodeByLabel && (labelList = _toConsumableArray(new _Set(labelList)));
        selectedValueNodes = _filterInstanceProperty(labelList).call(labelList, function (item) {
          return item != undefined;
        }).join('、');
      }
      // const className = `${prefixCls}-selection__rendered`;
      var className = classNames((_classNames = {}, _defineProperty(_classNames, "".concat(prefixCls, "-selection__rendered"), true), _defineProperty(_classNames, "".concat(prefixCls, "-multiple-readonly"), !editable), _classNames), className);
      if (choiceTransitionName && editable) {
        return /*#__PURE__*/React.createElement(Animate, {
          className: className,
          component: "ul",
          transitionName: choiceTransitionName,
          onLeave: onChoiceAnimationLeave
        }, selectedValueNodes);
      }
      return /*#__PURE__*/React.createElement("ul", {
        className: className,
        role: "menubar",
        title: !editable ? selectedValueNodes : null
      }, selectedValueNodes);
    };
    // this.inputRef = createRef();
    return _this;
  }
  _createClass(MultipleSelector, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(Selector, _Object$assign({}, this.props, {
        tabIndex: -1,
        showArrow: !this.props.editable,
        renderSelection: this.renderSelection,
        renderPlaceholder: this.renderPlaceholder
      }));
    }
  }]);
  return MultipleSelector;
}(React.Component);
MultipleSelector.propTypes = _Object$assign(_Object$assign({}, selectorPropTypes), {
  selectorValueList: PropTypes.array,
  disabled: PropTypes.bool,
  disableCloseTag: PropTypes.bool,
  editable: PropTypes.bool,
  searchValue: PropTypes.string,
  labelInValue: PropTypes.bool,
  maxTagCount: PropTypes.number,
  maxTagPlaceholder: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
  tagWidth: PropTypes.number,
  onChoiceAnimationLeave: PropTypes.func
});
MultipleSelector.contextTypes = {
  rcTreeSelect: PropTypes.shape(_Object$assign(_Object$assign({}, multipleSelectorContextTypes), {
    onSearchInputChange: PropTypes.func
  }))
};
export default MultipleSelector;