import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React from 'react';
import generateSelector, { selectorPropTypes } from '../Base/BaseSelector';
import { toTitle, createRef } from '../util';
var Selector = generateSelector('single');
var SingleSelector = /*#__PURE__*/function (_React$Component) {
  _inherits(SingleSelector, _React$Component);
  var _super = _createSuper(SingleSelector);
  function SingleSelector() {
    var _this;
    _classCallCheck(this, SingleSelector);
    _this = _super.call(this);
    _this.focus = function () {
      _this.selectorRef.current.focus();
    };
    _this.blur = function () {
      _this.selectorRef.current.blur();
    };
    _this.renderSelection = function () {
      var _this$props = _this.props,
        selectorValueList = _this$props.selectorValueList,
        placeholder = _this$props.placeholder,
        prefixCls = _this$props.prefixCls;
      var innerNode;
      if (selectorValueList.length) {
        var _selectorValueList$ = selectorValueList[0],
          label = _selectorValueList$.label,
          value = _selectorValueList$.value;
        innerNode = /*#__PURE__*/React.createElement("span", {
          key: "value",
          title: toTitle(label),
          className: "".concat(prefixCls, "-selection-selected-value")
        }, label || value);
      } else {
        innerNode = /*#__PURE__*/React.createElement("span", {
          key: "placeholder",
          className: "".concat(prefixCls, "-selection__placeholder")
        }, placeholder);
      }
      return /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-selection__rendered")
      }, innerNode);
    };
    _this.selectorRef = createRef();
    return _this;
  }
  _createClass(SingleSelector, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/React.createElement(Selector, _Object$assign({}, this.props, {
        ref: this.selectorRef,
        renderSelection: this.renderSelection
      }));
    }
  }]);
  return SingleSelector;
}(React.Component);
SingleSelector.propTypes = _Object$assign({}, selectorPropTypes);
export default SingleSelector;