import * as React from 'react';
import { UploadListProps, UploadFile, UploadListType } from './interface';
export default class UploadList extends React.Component<UploadListProps, any> {
    static defaultProps: {
        listType: UploadListType;
        progressAttr: {
            strokeWidth: number;
            showInfo: boolean;
        };
        prefixCls: string;
        showRemoveIcon: boolean;
        showPreviewIcon: boolean;
        maxFileCount: number;
        showDeleteAll: boolean;
    };
    handleClose: (file: UploadFile) => void;
    handleDeleteAll: () => void;
    handlePreview: (file: UploadFile, e: React.SyntheticEvent<HTMLElement>) => void;
    componentDidUpdate(): void;
    renderUploadList(Locale: any): any;
    render(): JSX.Element;
}
