import * as React from 'react';
import './component/vjsDownLoad';
import './component/vjsFullScreen';
import './component/vjsVolume';
import './component/vjsPlay';
import './component/vjsErrorDisplay';
interface VideoViewerProps {
    prefixCls?: string;
    className?: string;
    width?: string | number;
    height?: string | number;
    poster?: string;
    sources?: [];
    autoplay?: boolean;
    loop?: boolean;
    muted?: boolean;
    preload?: 'auto' | 'none' | 'metadata';
    controls?: boolean;
    download?: boolean;
    downloadSrc?: string;
    bigPlayButton?: boolean;
}
export default class VideoViewer extends React.Component<VideoViewerProps> {
    static propTypes: {
        prefixCls: any;
        className: any;
        width: any;
        height: any;
        poster: any;
        sources: any;
        autoplay: any;
        loop: any;
        muted: any;
        preload: any;
        controls: any;
        download: any;
        bigPlayButton: any;
    };
    static defaultProps: {
        prefixCls: string;
        className: string;
        width: number;
        height: number;
        poster: string;
        sources: any[];
        autoplay: boolean;
        loop: boolean;
        muted: boolean;
        preload: string;
        controls: boolean;
        download: boolean;
        bigPlayButton: boolean;
    };
    player: any;
    videoNode: React.ReactNode | Element;
    videoPlayerRef: HTMLDivElement;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    getVideoPlayer: () => any;
    handleSpaceKeyDown: (e: any) => void;
    render(): JSX.Element;
}
export {};
