import * as React from 'react';
export interface VideoModalProps {
    prefixCls?: string;
    width?: string | number;
    afterClose?: () => void;
    draggable?: boolean;
    mask?: boolean;
    onCancel?: () => void;
    visible?: boolean;
    children?: React.ReactNode | React.ReactChildren;
    wrapClassName?: string;
    maskStyle?: React.CSSProperties;
    closable?: boolean;
}
declare class VideoModal extends React.Component<VideoModalProps> {
    static propTypes: {
        prefixCls: any;
        children: any;
        wrapClassName: any;
        maskStyle: any;
        visible: any;
        draggable: any;
        mask: any;
        closable: any;
        onCancel: any;
        afterClose: any;
        width: any;
    };
    static defaultProps: {
        prefixCls: string;
        visible: boolean;
        draggable: boolean;
        closable: boolean;
        mask: boolean;
        width: number;
    };
    constructor(props: any);
    handleOnClose: () => void;
    render(): JSX.Element;
}
export default VideoModal;
