import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
import _Object$assign from "@babel/runtime-corejs3/core-js-stable/object/assign";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js-stable/instance/concat";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import * as React from 'react';
import PropTypes from 'prop-types';
import omit from 'omit.js';
import Modal from '../Modal';
import Icon from '../Icon';
var VideoModal = /*#__PURE__*/function (_React$Component) {
  _inherits(VideoModal, _React$Component);
  var _super = _createSuper(VideoModal);
  function VideoModal(props) {
    var _this;
    _classCallCheck(this, VideoModal);
    _this = _super.call(this, props);
    _this.handleOnClose = function () {
      _this.props.onCancel();
    };
    return _this;
  }
  _createClass(VideoModal, [{
    key: "render",
    value: function render() {
      var _context;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        children = _this$props.children,
        closable = _this$props.closable,
        _this$props$wrapClass = _this$props.wrapClassName,
        wrapClassName = _this$props$wrapClass === void 0 ? '' : _this$props$wrapClass,
        maskStyle = _this$props.maskStyle;
      var MODAL_WRAP = "".concat(prefixCls, "-modal-wrap");
      var otherProps = omit(this.props, ['prefixCls', 'wrapClassName', 'title', 'footer', 'maskStyle', 'closable']);
      var modalProps = _Object$assign(_Object$assign({}, otherProps), {
        wrapClassName: _concatInstanceProperty(_context = "".concat(wrapClassName, " ")).call(_context, MODAL_WRAP),
        className: 'fishd-modal',
        maskStyle: maskStyle ? maskStyle : {
          backgroundColor: 'rgba(0,0,0,0.2)'
        },
        // 不显示Modal自带的关闭按钮
        closable: false,
        title: null,
        footer: null
      });
      var content = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-content")
      }, children, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-header")
      }, closable ? /*#__PURE__*/React.createElement(Icon, {
        type: "picture-close",
        className: "icon-close",
        onClick: this.handleOnClose
      }) : null));
      return /*#__PURE__*/React.createElement(Modal, _Object$assign({}, modalProps), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, content));
    }
  }]);
  return VideoModal;
}(React.Component);
VideoModal.propTypes = {
  prefixCls: PropTypes.string,
  children: PropTypes.node,
  wrapClassName: PropTypes.string,
  maskStyle: PropTypes.object,
  visible: PropTypes.bool.isRequired,
  draggable: PropTypes.bool,
  mask: PropTypes.bool,
  closable: PropTypes.bool,
  onCancel: PropTypes.func,
  afterClose: PropTypes.func,
  width: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
};
VideoModal.defaultProps = {
  prefixCls: 'fishd-video-modal',
  visible: false,
  draggable: false,
  closable: true,
  mask: false,
  width: 640
};
export default VideoModal;