import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Icon from '../../Icon/index';
import Tooltip from '../../Tooltip/index';
import ConfigConsumer from '../../Config/Consumer';
var FullScreen = /*#__PURE__*/function (_Component) {
  _inherits(FullScreen, _Component);
  var _super = _createSuper(FullScreen);
  function FullScreen(props) {
    var _this;
    _classCallCheck(this, FullScreen);
    _this = _super.call(this, props);
    _this.setFullScreen = function () {
      _this.setState({
        isFullScreen: _this.player.isFullscreen()
      });
    };
    _this.handleClick = function () {
      var isFullScreen = _this.state.isFullScreen;
      if (!isFullScreen) {
        _this.player.requestFullscreen();
      } else {
        _this.player.exitFullscreen();
      }
      _this.setState({
        isFullScreen: !isFullScreen
      });
    };
    // 获取播放器实例
    _this.player = props.vjsComponent.player_;
    _this.state = {
      isFullScreen: _this.player.isFullscreen()
    };
    return _this;
  }
  _createClass(FullScreen, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.player.on('fullscreenchange', this.setFullScreen);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.player.off('fullscreenchange', this.setFullScreen);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var isFullScreen = this.state.isFullScreen;
      return /*#__PURE__*/React.createElement(ConfigConsumer, {
        componentName: "VideoViewer"
      }, function (Locale) {
        var title = !isFullScreen ? Locale.fullScreen : Locale.cancelFullScreen;
        return /*#__PURE__*/React.createElement("div", {
          className: classnames(prefixCls, 'fishd-video-js-customer-button'),
          onClick: function onClick() {
            return _this2.handleClick();
          }
        }, /*#__PURE__*/React.createElement(Tooltip, {
          title: /*#__PURE__*/React.createElement("span", {
            style: {
              wordBreak: 'keep-all'
            }
          }, title),
          getPopupContainer: function getPopupContainer(e) {
            return e.parentNode;
          }
        }, /*#__PURE__*/React.createElement("a", null, !isFullScreen ? /*#__PURE__*/React.createElement(Icon, {
          type: "video-fullscreen"
        }) : /*#__PURE__*/React.createElement(Icon, {
          type: "video-shrink"
        }))));
      });
    }
  }]);
  return FullScreen;
}(Component);
export { FullScreen as default };
FullScreen.propTypes = {
  prefixCls: PropTypes.string,
  vjsComponent: PropTypes.object
};
FullScreen.defaultProps = {
  prefixCls: 'fishd-video-viewer-fullscreen'
};