import _Reflect$construct from "@babel/runtime-corejs3/core-js-stable/reflect/construct";
import _classCallCheck from "@babel/runtime-corejs3/helpers/classCallCheck";
import _createClass from "@babel/runtime-corejs3/helpers/createClass";
import _inherits from "@babel/runtime-corejs3/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime-corejs3/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime-corejs3/helpers/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import Icon from '../../Icon/index';
var Play = /*#__PURE__*/function (_Component) {
  _inherits(Play, _Component);
  var _super = _createSuper(Play);
  function Play(props) {
    var _this;
    _classCallCheck(this, Play);
    _this = _super.call(this, props);
    _this.handleClick = function () {
      var isPlay = _this.state.isPlay;
      if (!isPlay) {
        _this.player.play();
      } else {
        _this.player.pause();
      }
      _this.setState({
        isPlay: !isPlay
      });
    };
    _this.setPlay = function (isPlay) {
      return function () {
        _this.setState({
          isPlay: isPlay
        });
      };
    };
    // 获取播放器实例
    _this.player = props.vjsComponent.player_;
    _this.state = {
      isPlay: false
    };
    return _this;
  }
  _createClass(Play, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.player.on('play', this.setPlay(true));
      this.player.on('pause', this.setPlay(false));
      this.player.on('ended', this.setPlay(false));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.player.off('play', this.setPlay(true));
      this.player.off('pause', this.setPlay(false));
      this.player.off('ended', this.setPlay(false));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var isPlay = this.state.isPlay;
      var pausePlayIcon = !isPlay ? 'play' : 'stop';
      return /*#__PURE__*/React.createElement("div", {
        className: classnames(prefixCls, 'fishd-video-js-customer-button'),
        onClick: function onClick() {
          return _this2.handleClick();
        }
      }, /*#__PURE__*/React.createElement("a", null, /*#__PURE__*/React.createElement(Icon, {
        className: "".concat(prefixCls, "-customer-handle"),
        type: pausePlayIcon
      })));
    }
  }]);
  return Play;
}(Component);
export { Play as default };
Play.propTypes = {
  prefixCls: PropTypes.string,
  vjsComponent: PropTypes.object
};
Play.defaultProps = {
  prefixCls: 'fishd-video-viewer-play'
};