import * as React from 'react';
import { Component } from 'react';
export interface ScrollNumberProps {
    prefixCls?: string;
    className?: string;
    count?: string | number | null;
    component?: string;
    onAnimated?: Function;
    style?: React.CSSProperties;
    title?: string | number | null;
}
export interface ScrollNumberState {
    animateStarted?: boolean;
    count?: string | number | null;
    prevProps: ScrollNumberProps;
    lastCount?: string | number | null;
    nextCount?: string | number | null;
}
declare class ScrollNumber extends Component<ScrollNumberProps, ScrollNumberState> {
    static defaultProps: {
        prefixCls: string;
        count: any;
        onAnimated(): void;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): {
        prevProps: any;
    } | {
        animateStarted: boolean;
        lastCount: any;
        nextCount: any;
        prevProps: any;
    };
    constructor(props: ScrollNumberProps);
    componentDidUpdate(prevProps: any, prevState: any): void;
    getPositionByNum(num: number, i: number): number;
    renderNumberList(position: number): React.ReactElement<any>[];
    renderCurrentNumber(num: number, i: number): React.DetailedReactHTMLElement<{
        className: string;
        style: {
            transition: string;
            msTransform: string;
            WebkitTransform: string;
            transform: string;
        };
        key: number;
    }, HTMLElement>;
    renderNumberElement(): string | number | React.DetailedReactHTMLElement<{
        className: string;
        style: {
            transition: string;
            msTransform: string;
            WebkitTransform: string;
            transform: string;
        };
        key: number;
    }, HTMLElement>[];
    render(): React.CElement<any, React.Component<any, React.ComponentState, any>>;
}
export default ScrollNumber;
