"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/slicedToArray"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = require("react-dom");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _rcTrigger = _interopRequireDefault(require("rc-trigger"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _utils = require("../../utils");
var _Panel = _interopRequireDefault(require("./Panel"));
var _placements = _interopRequireDefault(require("./placements"));
var _color = _interopRequireDefault(require("./helpers/color"));
var _QuickPanel = _interopRequireDefault(require("./QuickPanel"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function refFn(field, component) {
  this[field] = component;
}
function prevent(e) {
  e.preventDefault();
}
function noop() {}
var ColorPicker = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ColorPicker, _React$Component);
  var _super = _createSuper(ColorPicker);
  function ColorPicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ColorPicker);
    _this = _super.call(this, props);
    _this.onChange = function (colors) {
      _this.setState((0, _assign["default"])({}, colors), function () {
        _this.props.onChange(_this.state);
      });
    };
    _this.onBlur = function () {
      _this.setVisible(false);
    };
    _this.onVisibleChangeFromTrigger = function (visible) {
      _this.setVisible(visible);
    };
    _this.onPanelMount = function (panelDOMRef) {
      if (_this.state.visible) {
        (0, _setTimeout2["default"])(function () {
          panelDOMRef.focus();
        }, 0);
      }
    };
    _this.setVisible = function (visible, callback) {
      if (_this.state.visible !== visible) {
        _this.setState({
          visible: visible
        }, function () {
          if (typeof callback === 'function') callback();
          var _this$props = _this.props,
            onVisibleChange = _this$props.onVisibleChange,
            enableHistory = _this$props.enableHistory,
            maxHistory = _this$props.maxHistory;
          onVisibleChange(_this.state.visible);
          //关闭时记录历史记录
          if (!_this.state.visible && enableHistory) {
            var _context, _context2;
            var _this$state = _this.state,
              color = _this$state.color,
              _alpha = _this$state.alpha,
              colorHistory = _this$state.colorHistory;
            // @ts-ignore
            if (colorHistory.length && color === colorHistory[0].color && _alpha === colorHistory[0].alpha) return;
            var history = colorHistory.length >= maxHistory ? (0, _concat["default"])(_context = [{
              color: color,
              alpha: _alpha
            }]).call(_context, (0, _toConsumableArray2["default"])((0, _slice["default"])(colorHistory).call(colorHistory, 0, -1))) : (0, _concat["default"])(_context2 = [{
              color: color,
              alpha: _alpha
            }]).call(_context2, (0, _toConsumableArray2["default"])(colorHistory));
            // @ts-ignore
            _this.setState({
              colorHistory: history
            });
          }
        });
      }
    };
    _this.getRootDOMNode = function () {
      return (0, _reactDom.findDOMNode)((0, _assertThisInitialized2["default"])(_this));
    };
    _this.getTriggerDOMNode = function () {
      return (0, _reactDom.findDOMNode)(_this.triggerInstance);
    };
    _this.getPickerElement = function () {
      if (_this.props.quickMode) {
        return /*#__PURE__*/_react["default"].createElement(_QuickPanel["default"], {
          __useInComponent: true,
          onMount: _this.onPanelMount,
          defaultColor: _this.state.color,
          color: _this.state.color,
          onChange: _this.onChange,
          onVisibleChange: _this.setVisible,
          onBlur: _this.onBlur,
          colorMap: _this.props.colorMap,
          className: _this.props.className,
          userSelectColor: false,
          esc: _this.props.esc
        });
      }
      return /*#__PURE__*/_react["default"].createElement(_Panel["default"], {
        onMount: _this.onPanelMount,
        defaultColor: _this.state.color,
        alpha: _this.state.alpha,
        enableAlpha: _this.props.enableAlpha,
        prefixCls: "".concat(_this.props.prefixCls, "-panel"),
        onChange: _this.onChange,
        onBlur: _this.onBlur,
        mode: _this.props.mode,
        className: _this.props.className,
        colorHistory: _this.state.colorHistory,
        enableHistory: _this.props.enableHistory,
        maxHistory: _this.props.maxHistory
      });
    };
    _this.focus = function () {
      if (!_this.state.visible) {
        (0, _reactDom.findDOMNode)((0, _assertThisInitialized2["default"])(_this)).focus();
      }
    };
    _this.handleKeyDown = function (e) {
      var keyCode = e.keyCode;
      if (keyCode === _utils.KeyCode.ESC && _this.props.esc || keyCode === _utils.KeyCode.ENTER) {
        _this.setVisible(false);
      }
    };
    var alpha = typeof props.alpha === 'undefined' ? props.defaultAlpha : Math.min(props.alpha, props.defaultAlpha);
    _this.state = {
      color: props.color || props.defaultColor,
      alpha: alpha,
      visible: false,
      colorHistory: []
    };
    _this.saveTriggerRef = (0, _bind["default"])(refFn).call(refFn, (0, _assertThisInitialized2["default"])(_this), 'triggerInstance');
    return _this;
  }
  (0, _createClass2["default"])(ColorPicker, [{
    key: "render",
    value: function render() {
      var _classNames;
      var props = this.props;
      var state = this.state;
      var classes = ["".concat(props.prefixCls, "-wrap"), props.className];
      if (state.visible) {
        classes.push("".concat(props.prefixCls, "-open"));
      }
      var children = props.children;
      var _Color$RGB = (0, _slicedToArray2["default"])(new _color["default"](this.state.color).RGB, 3),
        r = _Color$RGB[0],
        g = _Color$RGB[1],
        b = _Color$RGB[2];
      var RGBA = [r, g, b];
      RGBA.push(this.state.alpha / 100);
      if (children) {
        children = /*#__PURE__*/_react["default"].cloneElement(children, {
          ref: this.saveTriggerRef,
          unselectable: 'unselectable',
          style: (0, _assign["default"])((0, _assign["default"])({}, props.style), {
            backgroundColor: "rgba(".concat(RGBA.join(','), ")")
          }),
          onMouseDown: prevent
        });
      }
      var prefixCls = props.prefixCls,
        popupStyle = props.popupStyle,
        getPopupContainer = props.getPopupContainer,
        align = props.align,
        animation = props.animation,
        disabled = props.disabled,
        transitionName = props.transitionName,
        quickMode = props.quickMode;
      var arrowCls = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-arrow"), true), (0, _defineProperty2["default"])(_classNames, "quick", quickMode), _classNames));
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classes.join(' ')
      }, /*#__PURE__*/_react["default"].createElement(_rcTrigger["default"], {
        popup: /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-content"),
          onKeyDown: this.handleKeyDown
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: arrowCls
        }), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-inner")
        }, this.getPickerElement())),
        popupAlign: align,
        builtinPlacements: _placements["default"],
        popupPlacement: 'topCenter',
        action: disabled ? [] : ['click'],
        destroyPopupOnHide: true,
        getPopupContainer: getPopupContainer,
        popupStyle: popupStyle,
        popupAnimation: animation,
        popupTransitionName: transitionName,
        popupVisible: state.visible,
        onPopupVisibleChange: this.onVisibleChangeFromTrigger,
        prefixCls: prefixCls
      }, children));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var newState = {};
      if ('color' in nextProps) {
        newState.color = nextProps.color;
      }
      if ('alpha' in nextProps && nextProps.alpha !== undefined && nextProps.alpha !== null) {
        newState.alpha = nextProps.alpha;
      }
      return newState;
    }
  }]);
  return ColorPicker;
}(_react["default"].Component);
ColorPicker.Panel = _Panel["default"];
ColorPicker.QuickPanel = _QuickPanel["default"];
ColorPicker.propTypes = {
  alpha: _propTypes["default"].number,
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  color: _propTypes["default"].string,
  colorMap: _propTypes["default"].array,
  defaultAlpha: _propTypes["default"].number,
  defaultColor: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  enableAlpha: _propTypes["default"].bool,
  enableHistory: _propTypes["default"].bool,
  maxHistory: _propTypes["default"].number,
  mode: _propTypes["default"].oneOf(['RGB', 'HSL', 'HSB']),
  onChange: _propTypes["default"].func,
  onVisibleChange: _propTypes["default"].func,
  prefixCls: _propTypes["default"].string.isRequired,
  quickMode: _propTypes["default"].bool,
  style: _propTypes["default"].object,
  popupStyle: _propTypes["default"].object,
  esc: _propTypes["default"].bool
};
ColorPicker.defaultProps = {
  children: /*#__PURE__*/_react["default"].createElement("span", {
    className: "fishd-color-picker-trigger"
  }),
  className: '',
  colorMap: ['#33bbff', '#337eff', '#8a73ff', '#bb67e6', '#f290b6', '#f24957', '#cc613d', '#faa702', '#ffe500', '#aacc00', '#26bf40', '#3dd9af'],
  defaultAlpha: 100,
  defaultColor: '#33bbff',
  disabled: false,
  enableAlpha: false,
  enableHistory: true,
  maxHistory: 8,
  onChange: noop,
  onVisibleChange: noop,
  prefixCls: 'fishd-color-picker',
  quickMode: false,
  style: {},
  popupStyle: {},
  esc: true
};
(0, _reactLifecyclesCompat.polyfill)(ColorPicker);
var _default = ColorPicker;
exports["default"] = _default;