"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _color = _interopRequireDefault(require("./helpers/color"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Preview = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Preview, _React$Component);
  var _super = _createSuper(Preview);
  function Preview() {
    var _this;
    (0, _classCallCheck2["default"])(this, Preview);
    _this = _super.apply(this, arguments);
    _this.onChange = function (e) {
      var value = e.target.value;
      var color = new _color["default"](value);
      _this.props.onChange(color);
      e.stopPropagation();
    };
    _this.getPrefixCls = function () {
      return "".concat(_this.props.rootPrefixCls, "-preview");
    };
    return _this;
  }
  (0, _createClass2["default"])(Preview, [{
    key: "render",
    value: function render() {
      var prefixCls = this.getPrefixCls();
      var hex = this.props.color.toHexString();
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: prefixCls
      }, /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          backgroundColor: hex,
          opacity: this.props.alpha / 100
        }
      }), /*#__PURE__*/_react["default"].createElement("input", {
        type: "color",
        value: hex,
        onChange: this.onChange,
        onClick: this.props.onInputClick
      }));
    }
  }]);
  return Preview;
}(_react["default"].Component);
exports["default"] = Preview;
Preview.propTypes = {
  alpha: _propTypes["default"].number,
  color: _propTypes["default"].object,
  onChange: _propTypes["default"].func,
  onInputClick: _propTypes["default"].func,
  rootPrefixCls: _propTypes["default"].string
};