"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BasePicker2 = _interopRequireDefault(require("./BasePicker"));
var _DatePanel = _interopRequireDefault(require("./panel/DatePanel"));
var _TimeSelectPanel = _interopRequireDefault(require("./panel/TimeSelectPanel"));
var _TimePanel = _interopRequireDefault(require("./panel/TimePanel"));
var _TimePicker = require("./TimePicker");
var _date = require("../../utils/date");
var _DateRangePicker = _interopRequireDefault(require("./DateRangePicker"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var DatePicker = /*#__PURE__*/function (_BasePicker) {
  (0, _inherits2["default"])(DatePicker, _BasePicker);
  var _super = _createSuper(DatePicker);
  function DatePicker(props) {
    (0, _classCallCheck2["default"])(this, DatePicker);
    var type = props.showTime ? 'datetime' : 'date';
    switch (props.mode) {
      // case SELECTION_MODES.YEAR:
      //   type = 'year'; break;
      // case SELECTION_MODES.MONTH:
      //   type = 'month'; break;
      case _date.SELECTION_MODES.WEEK:
        type = 'week';
        break;
    }
    return _super.call(this, props, type, {});
  }
  (0, _createClass2["default"])(DatePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      // 带时间的日期面板，需要检查时间的合法性
      var dateValid = (0, _get2["default"])((0, _getPrototypeOf2["default"])(DatePicker.prototype), "isDateValid", this).call(this, value) && _DatePanel["default"].isValid(value, this.props.disabledDate);
      if (this.props.showTime) {
        var timeSelectValid = this.props.timeSelectMode === 'TimeSelect' && _TimeSelectPanel["default"].isValid(this.dateToStr(value).split(' ')[1], this.props.timeSelectModeProps);
        var timePickerValid = this.props.timeSelectMode === 'TimePicker' && _TimePanel["default"].isValid(value, (0, _TimePicker.converSelectRange)({
          selectableRange: this.props.timeSelectableRange
        }));
        return dateValid && (timeSelectValid || timePickerValid);
      } else {
        return dateValid;
      }
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(_DatePanel["default"], (0, _assign["default"])({}, this.props, {
        value: value,
        onPick: this.onPicked,
        onCancelPicked: this.onCancelPicked
      }));
    }
  }], [{
    key: "propTypes",
    get: function get() {
      var _context;
      return (0, _assign["default"])({}, {
        placeholder: _propTypes["default"].string,
        value: _propTypes["default"].instanceOf(Date),
        mode: _propTypes["default"].oneOf((0, _map["default"])(_context = (0, _keys["default"])(_date.SELECTION_MODES)).call(_context, function (e) {
          return _date.SELECTION_MODES[e];
        }))
      }, _BasePicker2["default"].propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return (0, _assign["default"])({}, _DatePanel["default"].defaultProps, _BasePicker2["default"].defaultProps);
    }
  }]);
  return DatePicker;
}(_BasePicker2["default"]);
exports["default"] = DatePicker;
DatePicker.DateRangePicker = _DateRangePicker["default"];