/// <reference types="react" />
import BasePicker from './BasePicker';
import TimeSelect from './TimeSelect';
export declare const converSelectRange: (props: any) => any[];
export default class TimePicker extends BasePicker {
    _onSelectionChange: (range: any) => void;
    refInputRoot: any;
    static TimeSelect: typeof TimeSelect;
    static get propTypes(): {
        selectableRange: any;
        isShowCurrent: any;
        footer: any;
        onValueChange: any;
    } & {
        className: any;
        placeholder: any;
        format: any;
        disabledDate: any;
        footer: any;
        showTime: any;
        showWeekNumber: any;
        shortcuts: any;
        placement: any;
        prefixCls: any;
        firstDayOfWeek: any;
        getPopupContainer: any;
        showTrigger: any;
        allowClear: any;
        disabled: any;
        esc: any;
        value: any;
        onFocus: any;
        onBlur: any;
        onChange: any;
        onVisibleChange: any;
        style: any;
        yearCount: any;
    };
    static get defaultProps(): {
        isShowCurrent: boolean;
    } & {
        placeholder: string;
        placement: string;
        prefixCls: string;
        showTrigger: boolean;
        allowClear: boolean;
        disabled: boolean;
        esc: boolean;
        onFocus: () => void;
        onBlur: () => void;
        onChange: () => void;
        onVisibleChange: () => void;
    };
    constructor(props: any);
    isDateValid(value: any): boolean;
    onSelectionChange: (start: any, end: any) => void;
    pickerPanel(state: any): JSX.Element;
}
