"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BasePicker2 = _interopRequireDefault(require("./BasePicker"));
var _TimeSelectPanel = _interopRequireDefault(require("./panel/TimeSelectPanel"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var TimeSelect = /*#__PURE__*/function (_BasePicker) {
  (0, _inherits2["default"])(TimeSelect, _BasePicker);
  var _super = _createSuper(TimeSelect);
  function TimeSelect(props) {
    (0, _classCallCheck2["default"])(this, TimeSelect);
    //props, type, state
    return _super.call(this, props, 'timeselect', {});
  }
  (0, _createClass2["default"])(TimeSelect, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      return (0, _get2["default"])((0, _getPrototypeOf2["default"])(TimeSelect.prototype), "isDateValid", this).call(this, value) &&
      // @ts-ignore
      _TimeSelectPanel["default"].isValid(this.dateToStr(value), this.props);
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this = this;
      var value = state.value && this.isDateValid(state.value) ? this.dateToStr(state.value) : null;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/React.createElement(_TimeSelectPanel["default"], (0, _assign["default"])({}, _this.props, {
          value: value,
          onPicked: _this.onPicked,
          dateParser: function dateParser(str) {
            return str ? _this.parseDate(str) : null;
          }
        }));
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return (0, _assign["default"])({}, {
        start: _propTypes["default"].string,
        end: _propTypes["default"].string,
        step: _propTypes["default"].string,
        minTime: _propTypes["default"].string,
        maxTime: _propTypes["default"].string
      }, _BasePicker2["default"].propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return (0, _assign["default"])({}, _BasePicker2["default"].defaultProps);
    }
  }]);
  return TimeSelect;
}(_BasePicker2["default"]);
exports["default"] = TimeSelect;