"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = _interopRequireDefault(require("../../Popover/index"));
var _domScrollIntoView = _interopRequireDefault(require("dom-scroll-into-view"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var YearAndMonthPopover = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(YearAndMonthPopover, _React$Component);
  var _super = _createSuper(YearAndMonthPopover);
  function YearAndMonthPopover(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, YearAndMonthPopover);
    _this = _super.call(this, props);
    _this.scrollToOption = function () {
      var menu = _this.refs.root;
      var active = menu.getElementsByClassName('active')[0];
      active && (0, _domScrollIntoView["default"])(active, menu, {
        offsetTop: 91,
        alignWithTop: true
      });
    };
    _this.handleVisibleChange = function (visible) {
      _this.setState({
        visible: visible
      }, function () {
        if (visible) {
          _this.scrollToOption();
        }
      });
    };
    _this.state = {
      visible: false
    };
    return _this;
  }
  (0, _createClass2["default"])(YearAndMonthPopover, [{
    key: "handleOnClick",
    value: function handleOnClick(item) {
      var _this2 = this;
      this.setState({
        visible: false
      }, function () {
        _this2.props.onChange(item);
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;
      var _this$props = this.props,
        children = _this$props.children,
        sourceData = _this$props.sourceData,
        value = _this$props.value,
        prefixCls = _this$props.prefixCls;
      var content = function content() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          ref: "root",
          className: "".concat(prefixCls, "-year-and-month-popover")
        }, (0, _map["default"])(sourceData).call(sourceData, function (item) {
          var _classNames, _context;
          return /*#__PURE__*/_react["default"].createElement("li", {
            className: (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-year-and-month-popover-item"), true), (0, _defineProperty2["default"])(_classNames, "active", value == item || typeof item === 'string' && (0, _slice["default"])(item).call(item, -1) == '月' && value == (0, _slice["default"])(item).call(item, 0, -1)), _classNames)),
            key: item,
            onClick: (0, _bind["default"])(_context = _this3.handleOnClick).call(_context, _this3, item)
          }, item);
        }));
      };
      return /*#__PURE__*/_react["default"].createElement(_index["default"], {
        transitionName: '',
        content: content(),
        trigger: "click",
        placement: "bottom",
        visible: this.state.visible,
        onVisibleChange: this.handleVisibleChange,
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        },
        forceRender: true
      }, children);
    }
  }]);
  return YearAndMonthPopover;
}(_react["default"].Component);
exports["default"] = YearAndMonthPopover;
YearAndMonthPopover.propTypes = {
  sourceData: _propTypes["default"].array.isRequired,
  onChange: _propTypes["default"].func,
  children: _propTypes["default"].node,
  value: _propTypes["default"].number,
  prefixCls: _propTypes["default"].string
};
YearAndMonthPopover.defaultProps = {
  prefixCls: 'fishd'
};