"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _echartsForReact = _interopRequireDefault(require("echarts-for-react"));
var _defaultTheme = _interopRequireDefault(require("./default-theme"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Echart = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Echart, _Component);
  var _super = _createSuper(Echart);
  function Echart(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Echart);
    _this = _super.call(this, props);
    _this.echarts_react = null;
    return _this;
  }
  (0, _createClass2["default"])(Echart, [{
    key: "getInstance",
    value: function getInstance() {
      // @ts-ignore
      return this.echarts_react.getEchartsInstance();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        className = _this$props.className,
        style = _this$props.style,
        theme = _this$props.theme,
        option = _this$props.option,
        opts = _this$props.opts,
        events = _this$props.events,
        notMerge = _this$props.notMerge,
        lazyUpdate = _this$props.lazyUpdate,
        onChartReady = _this$props.onChartReady,
        loadingOption = _this$props.loadingOption,
        showLoading = _this$props.showLoading;
      return /*#__PURE__*/_react["default"].createElement(_echartsForReact["default"], {
        ref: function ref(e) {
          return _this2.echarts_react = e;
        },
        className: (0, _classnames["default"])(prefixCls, className),
        style: style,
        option: option,
        opts: opts,
        onEvents: events,
        theme: theme,
        notMerge: notMerge,
        lazyUpdate: lazyUpdate,
        onChartReady: onChartReady,
        loadingOption: loadingOption,
        showLoading: showLoading
      });
    }
  }]);
  return Echart;
}(_react.Component);
exports["default"] = Echart;
Echart.propTypes = {
  prefixCls: _propTypes["default"].string,
  option: _propTypes["default"].object,
  opts: _propTypes["default"].object,
  events: _propTypes["default"].object,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  theme: _propTypes["default"].string,
  notMerge: _propTypes["default"].bool,
  lazyUpdate: _propTypes["default"].bool,
  onChartReady: _propTypes["default"].func,
  loadingOption: _propTypes["default"].object,
  showLoading: _propTypes["default"].bool
};
Echart.defaultProps = {
  prefixCls: 'fishd-chart',
  theme: _defaultTheme["default"],
  notMerge: false,
  lazyUpdate: false,
  style: {
    height: '300px'
  },
  className: '',
  onChartReady: function onChartReady() {},
  showLoading: false,
  loadingOption: null,
  onEvents: {},
  opts: {}
};