import * as React from 'react';
import { TooltipProps } from '../Tooltip';
export declare const getStrFullLength: (str?: string) => number;
export declare const cutStrByFullLength: (str: string, maxLength: number) => string;
export interface EllipsisTextProps {
    prefix: string;
    text: React.ReactNode | string;
    length: number;
    tooltip: boolean;
    className: string;
    fullWidthRecognition: boolean;
    tooltipProps: TooltipProps;
}
declare const EllipsisText: React.SFC<EllipsisTextProps>;
export default EllipsisText;
