"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var PropTypes = _interopRequireWildcard(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var stringOrNumber = PropTypes.oneOfType([PropTypes.string, PropTypes.number]);
var objectOrNumber = PropTypes.oneOfType([PropTypes.object, PropTypes.number]);
var Col = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Col, _React$Component);
  var _super = _createSuper(Col);
  function Col() {
    (0, _classCallCheck2["default"])(this, Col);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Col, [{
    key: "render",
    value: function render() {
      var _context, _context12, _context13, _context14, _context15, _context16, _classNames;
      var props = this.props;
      var span = props.span,
        order = props.order,
        offset = props.offset,
        push = props.push,
        pull = props.pull,
        className = props.className,
        style = props.style,
        children = props.children,
        _props$prefixCls = props.prefixCls,
        prefixCls = _props$prefixCls === void 0 ? 'fishd-col' : _props$prefixCls,
        others = __rest(props, ["span", "order", "offset", "push", "pull", "className", "style", "children", "prefixCls"]);
      var sizeClassObj = {};
      (0, _forEach["default"])(_context = ['xs', 'sm', 'md', 'lg', 'xl', 'xxl']).call(_context, function (size) {
        var _context2, _context3, _context4, _context5, _context6, _context7, _context8, _context9, _context10, _context11, _Object$assign2;
        var sizeProps = {};
        if (typeof props[size] === 'number') {
          sizeProps.span = props[size];
        } else if ((0, _typeof2["default"])(props[size]) === 'object') {
          sizeProps = props[size] || {};
        }
        delete others[size];
        sizeClassObj = (0, _assign["default"])((0, _assign["default"])({}, sizeClassObj), (_Object$assign2 = {}, (0, _defineProperty2["default"])(_Object$assign2, (0, _concat["default"])(_context2 = (0, _concat["default"])(_context3 = "".concat(prefixCls, "-")).call(_context3, size, "-")).call(_context2, sizeProps.span), sizeProps.span !== undefined), (0, _defineProperty2["default"])(_Object$assign2, (0, _concat["default"])(_context4 = (0, _concat["default"])(_context5 = "".concat(prefixCls, "-")).call(_context5, size, "-order-")).call(_context4, sizeProps.order), sizeProps.order || sizeProps.order === 0), (0, _defineProperty2["default"])(_Object$assign2, (0, _concat["default"])(_context6 = (0, _concat["default"])(_context7 = "".concat(prefixCls, "-")).call(_context7, size, "-offset-")).call(_context6, sizeProps.offset), sizeProps.offset || sizeProps.offset === 0), (0, _defineProperty2["default"])(_Object$assign2, (0, _concat["default"])(_context8 = (0, _concat["default"])(_context9 = "".concat(prefixCls, "-")).call(_context9, size, "-push-")).call(_context8, sizeProps.push), sizeProps.push || sizeProps.push === 0), (0, _defineProperty2["default"])(_Object$assign2, (0, _concat["default"])(_context10 = (0, _concat["default"])(_context11 = "".concat(prefixCls, "-")).call(_context11, size, "-pull-")).call(_context10, sizeProps.pull), sizeProps.pull || sizeProps.pull === 0), _Object$assign2));
      });
      var classes = (0, _classnames["default"])((_classNames = {}, (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context12 = "".concat(prefixCls, "-")).call(_context12, span), span !== undefined), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context13 = "".concat(prefixCls, "-order-")).call(_context13, order), order), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context14 = "".concat(prefixCls, "-offset-")).call(_context14, offset), offset), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context15 = "".concat(prefixCls, "-push-")).call(_context15, push), push), (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context16 = "".concat(prefixCls, "-pull-")).call(_context16, pull), pull), _classNames), className, sizeClassObj);
      return /*#__PURE__*/React.createElement("div", (0, _assign["default"])({}, others, {
        className: classes,
        style: style
      }), children);
    }
  }]);
  return Col;
}(React.Component);
exports["default"] = Col;
Col.propTypes = {
  span: stringOrNumber,
  order: stringOrNumber,
  offset: stringOrNumber,
  push: stringOrNumber,
  pull: stringOrNumber,
  className: PropTypes.string,
  style: PropTypes.object,
  children: PropTypes.node,
  xs: objectOrNumber,
  sm: objectOrNumber,
  md: objectOrNumber,
  lg: objectOrNumber,
  xl: objectOrNumber,
  xxl: objectOrNumber
};