import * as React from 'react';
import TextArea, { TextAreaProps } from './TextArea';
export interface CounterProps extends TextAreaProps {
    inputPrefixCls?: string;
    prefixCls?: string;
    limit: number;
    count?: (value: string) => number;
    value: any;
    defaultValue: any;
}
export interface CounterState {
    value?: any;
    prevProps: CounterProps;
}
declare class Counter extends React.Component<CounterProps, CounterState> {
    static defaultProps: {
        inputPrefixCls: string;
        prefixCls: string;
    };
    static getDerivedStateFromProps(nextProps: any, prevState: any): CounterState;
    constructor(props: any);
    private textarea;
    focus(): void;
    blur(): void;
    saveTextarea: (node: TextArea) => void;
    getTextAreaClassName(): any;
    handleClick: () => void;
    handleTextareaChange: (e: React.ChangeEvent<HTMLTextAreaElement>) => void;
    getCount: () => number;
    render(): JSX.Element;
}
export default Counter;
