"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _util = require("./util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var MenuItemGroup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(MenuItemGroup, _React$Component);
  var _super = _createSuper(MenuItemGroup);
  function MenuItemGroup() {
    var _this;
    (0, _classCallCheck2["default"])(this, MenuItemGroup);
    _this = _super.apply(this, arguments);
    _this.renderInnerMenuItem = function (item) {
      var _this$props = _this.props,
        renderMenuItem = _this$props.renderMenuItem,
        index = _this$props.index;
      return renderMenuItem(item, index, _this.props.subMenuKey);
    };
    return _this;
  }
  (0, _createClass2["default"])(MenuItemGroup, [{
    key: "render",
    value: function render() {
      var _context, _context2;
      var props = __rest(this.props, []);
      var _props$className = props.className,
        className = _props$className === void 0 ? '' : _props$className,
        rootPrefixCls = props.rootPrefixCls;
      var titleClassName = "".concat(rootPrefixCls, "-item-group-title");
      var listClassName = "".concat(rootPrefixCls, "-item-group-list");
      var title = props.title,
        children = props.children;
      (0, _forEach["default"])(_util.menuAllProps).call(_util.menuAllProps, function (key) {
        return delete props[key];
      });
      // Set onClick to null, to ignore propagated onClick event
      delete props.onClick;
      return /*#__PURE__*/_react["default"].createElement("li", (0, _assign["default"])({}, props, {
        className: (0, _concat["default"])(_context = "".concat(className, " ")).call(_context, rootPrefixCls, "-item-group")
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: titleClassName,
        title: typeof title === 'string' ? title : undefined
      }, title), /*#__PURE__*/_react["default"].createElement("ul", {
        className: listClassName
      }, (0, _map["default"])(_context2 = _react["default"].Children).call(_context2, children, this.renderInnerMenuItem)));
    }
  }]);
  return MenuItemGroup;
}(_react["default"].Component);
MenuItemGroup.propTypes = {
  renderMenuItem: _propTypes["default"].func,
  index: _propTypes["default"].number,
  className: _propTypes["default"].string,
  subMenuKey: _propTypes["default"].string,
  rootPrefixCls: _propTypes["default"].string
};
MenuItemGroup.defaultProps = {
  disabled: true
};
MenuItemGroup.isMenuItemGroup = true;
var _default = MenuItemGroup;
exports["default"] = _default;