"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _quill = require("../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Embed = _quill.Quill["import"]('blots/embed');
var Attach = /*#__PURE__*/function (_Embed) {
  (0, _inherits2["default"])(Attach, _Embed);
  var _super = _createSuper(Attach);
  function Attach() {
    (0, _classCallCheck2["default"])(this, Attach);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Attach, [{
    key: "format",
    value: function format(name, data) {
      this.statics.formatCursor = true;
      if (data) {
        this.domNode.setAttribute(name, data && data.toString());
        var label = this.domNode.querySelector('a');
        if (name === 'data-iconUrl') {
          var img = this.domNode.querySelector('img');
          img.src = data;
        } else if (name === 'data-href') {
          label.setAttribute('href', data && data.toString());
        } else if (name === 'data-title') {
          label.innerText = data;
          label.setAttribute('download', data || '');
        }
      }
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(Attach.prototype), "format", this).call(this, name, data);
    }
  }], [{
    key: "create",
    value: function create(data) {
      this.formatCursor = false;
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(Attach), "create", this).call(this, data);
      var defaultImage = data.iconUrl;
      var img = document.createElement('img');
      img.src = defaultImage;
      img.setAttribute('class', 'attach_icon');
      img.style.cssText = 'width: 25px;height: 25px;';
      node.appendChild(img);
      var ALabel = document.createElement('a');
      ALabel.innerText = data.name;
      ALabel.href = data.url;
      ALabel.target = '_blank';
      ALabel.style.cssText = "\n      margin-left: 4px;\n      vertical-align: middle;\n      text-decoration: none;\n      display: inline;\n    ";
      ALabel.setAttribute('download', data.name || '');
      node.appendChild(ALabel);
      node.style.cssText = "display:inline-block;border:1px solid #ddd;padding:4px;margin: 4px;user-select: text;";
      node.setAttribute('contenteditable', 'false');
      node.setAttribute('data-title', data.name);
      node.setAttribute('data-href', data.url);
      node.setAttribute('data-iconUrl', defaultImage);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      return {
        'data-href': node.getAttribute('data-href') || node.getAttribute('href'),
        'data-title': node.getAttribute('data-title') || node.getAttribute('title'),
        'data-iconUrl': node.getAttribute('data-iconUrl') || node.getAttribute('iconUrl')
      };
    }
  }]);
  return Attach;
}(Embed);
exports["default"] = Attach;
Attach.blotName = 'attach';
Attach.tagName = 'div';
Attach.className = 'attach_file';