export interface quill {
    root: HTMLElement;
    getSelection: Function;
    getLength: Function;
    getFormat: Function;
    updateContents: Function;
    setSelection: Function;
    insertEmbed: Function;
    insertText: Function;
}
export default class FileDrop {
    quill: quill;
    customDropFile: any;
    private attachmentIconMap;
    constructor(quill: any, options?: {
        customDropFile: any;
        attachmentIconMap: any;
    });
    handleDrop(evt: DragEvent): void;
    handlePaste(evt: ClipboardEvent): void;
    handleFileInsert(fileInfo: any): void;
    insert(fileList: any): void;
}
