"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Image = exports.ATTRIBUTES = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _quill = require("../../../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
// BEGIN allow image alignment styles
var ATTRIBUTES = ['alt', 'height', 'width', 'style', 'data-size'];
exports.ATTRIBUTES = ATTRIBUTES;
var BaseImageFormat = _quill.Quill["import"]('formats/image');
var Image = /*#__PURE__*/function (_BaseImageFormat) {
  (0, _inherits2["default"])(Image, _BaseImageFormat);
  var _super = _createSuper(Image);
  function Image() {
    (0, _classCallCheck2["default"])(this, Image);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Image, [{
    key: "format",
    value: function format(name, value) {
      if ((0, _indexOf["default"])(ATTRIBUTES).call(ATTRIBUTES, name) > -1) {
        if (value) {
          this.domNode.setAttribute(name, value);
        } else {
          this.domNode.removeAttribute(name);
        }
      } else {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(Image.prototype), "format", this).call(this, name, value);
      }
    }
  }, {
    key: "handling",
    value: function handling(_handling) {
      this.domNode.__formats = this.constructor.formats(this.domNode);
      this.domNode.__handling = _handling;
    }
  }], [{
    key: "formats",
    value: function formats(domNode) {
      if (domNode.__handling && domNode.__formats) {
        return domNode.__formats;
      }
      return (0, _reduce["default"])(ATTRIBUTES).call(ATTRIBUTES, function (formats, attribute) {
        if (domNode.hasAttribute(attribute)) {
          formats[attribute] = domNode.getAttribute(attribute);
        }
        return formats;
      }, {});
    }
  }]);
  return Image;
}(BaseImageFormat);
exports.Image = Image;