declare const QuillMixin: {
    /**
    Creates an editor on the given element. The editor will
    be passed the configuration, have its events bound,
    */
    createEditor: ($el: any, config: any) => any;
    hookEditor: (editor: any) => void;
    unhookEditor: (editor: any) => void;
    setEditorReadOnly: (editor: any, value: any) => void;
    setEditorContents: (editor: any, value: any) => void;
    setEditorSelection: (editor: any, range: any) => void;
    setEditorTabIndex: (editor: any, tabIndex: any) => void;
    makeUnprivilegedEditor: (editor: any) => {
        getLength: () => any;
        getText: () => any;
        getHTML: () => string;
        getRawHTML: () => any;
        getContents: () => any;
        getSelection: () => any;
        getBounds: () => any;
        isEmptyContents: () => any;
    };
    isEmptyContents: (editor: any) => boolean;
};
export default QuillMixin;
