"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var Theme = /*#__PURE__*/function () {
  function Theme(quill, options) {
    (0, _classCallCheck2["default"])(this, Theme);
    this.quill = quill;
    this.options = options;
    this.modules = {};
  }
  (0, _createClass2["default"])(Theme, [{
    key: "init",
    value: function init() {
      var _context,
        _this = this;
      (0, _forEach["default"])(_context = (0, _keys["default"])(this.options.modules)).call(_context, function (name) {
        if (_this.modules[name] == null) {
          _this.addModule(name);
        }
      });
    }
  }, {
    key: "addModule",
    value: function addModule(name) {
      var ModuleClass = this.quill.constructor["import"]("modules/".concat(name));
      this.modules[name] = new ModuleClass(this.quill, this.options.modules[name] || {});
      return this.modules[name];
    }
  }]);
  return Theme;
}();
Theme.DEFAULTS = {
  modules: {}
};
Theme.themes = {
  "default": Theme
};
var _default = Theme;
exports["default"] = _default;