import * as React from 'react';
interface OptionProps {
    activeKey?: string | number;
    checked?: boolean | (() => void);
    children?: React.ReactNode | React.ReactChildren;
    disabled?: boolean;
    onOptionClick?: (e: React.MouseEvent<any>, option: any) => void;
    prefixCls?: string;
    showOptionCheckedIcon?: boolean;
    title?: string;
    value?: string | number | React.ReactNode;
}
export default class Option extends React.Component<OptionProps> {
    static isSelectOption: boolean;
    static propTypes: {
        activeKey: any;
        checked: any;
        children: any;
        disabled: any;
        onOptionClick: any;
        prefixCls: any;
        showOptionCheckedIcon: any;
        title: any;
        value: any;
    };
    static defaultProps: {
        prefixCls: string;
        showOptionCheckedIcon: boolean;
    };
    constructor(props: OptionProps);
    onOptionClick: (e: React.MouseEvent<any>, option: any) => void;
    render(): JSX.Element;
}
export {};
