"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _index = _interopRequireDefault(require("../../Tooltip/index"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Tip = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Tip, _React$Component);
  var _super = _createSuper(Tip);
  function Tip() {
    (0, _classCallCheck2["default"])(this, Tip);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Tip, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        visible = _this$props.visible,
        position = _this$props.position,
        vertical = _this$props.vertical,
        title = _this$props.title,
        prefixCls = _this$props.prefixCls;
      var tipStyle = {
        position: 'absolute'
      };
      if (position) {
        if (vertical) {
          tipStyle.top = position;
          tipStyle.height = 10;
          tipStyle.width = 5;
        } else {
          tipStyle.left = position - 5;
          tipStyle.width = 10;
          tipStyle.height = 5;
        }
      }
      return /*#__PURE__*/_react["default"].createElement(_index["default"], {
        title: title,
        visible: visible
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-all-handle"),
        style: tipStyle
      }));
    }
  }]);
  return Tip;
}(_react["default"].Component);
exports["default"] = Tip;
Tip.propTypes = {
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  position: _propTypes["default"].number,
  vertical: _propTypes["default"].bool,
  visible: _propTypes["default"].bool,
  title: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string])
};