"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _from = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/from"));
var _symbol = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/symbol"));
var _getIteratorMethod2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/get-iterator-method"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _reduce = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/reduce"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _slice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/slice"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _Modal = _interopRequireDefault(require("../Modal"));
var _Icon = _interopRequireDefault(require("../Icon"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _Table = _interopRequireDefault(require("../Table"));
var _TableDraggableHOC = _interopRequireDefault(require("./TableDraggableHOC"));
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof _symbol["default"] !== "undefined" && (0, _getIteratorMethod2["default"])(o) || o["@@iterator"];
  if (!it) {
    if ((0, _isArray["default"])(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      var F = function F() {};
      return {
        s: F,
        n: function n() {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function e(_e) {
          throw _e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var normalCompletion = true,
    didErr = false,
    err;
  return {
    s: function s() {
      it = it.call(o);
    },
    n: function n() {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function e(_e2) {
      didErr = true;
      err = _e2;
    },
    f: function f() {
      try {
        if (!normalCompletion && it["return"] != null) it["return"]();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}
function _unsupportedIterableToArray(o, minLen) {
  var _context13;
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = (0, _slice["default"])(_context13 = Object.prototype.toString.call(o)).call(_context13, 8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return (0, _from["default"])(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var getColumnKey = function getColumnKey(column) {
  if ('colSpan' in column) {
    return column.filtrateTitle || column.title;
  } else {
    return column.key || column.dataIndex || column.filtrateTitle || column.title;
  }
};
var flatten = function flatten(arr) {
  return (0, _reduce["default"])(arr).call(arr, function (prev, next) {
    return (0, _concat["default"])(prev).call(prev, (0, _isArray["default"])(next) ? flatten(next) : next);
  }, []);
};
var getCheckedOptions = function getCheckedOptions(columns, hideColumns, defaultColumns) {
  var _context, _context2, _context3;
  return (0, _map["default"])(_context = (0, _filter["default"])(_context2 = (0, _filter["default"])(_context3 = (0, _filter["default"])(columns
  // 去除默认列
  ).call(columns
  // 去除默认列
  , function (column) {
    return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 去除表头合并不显示的列
  ).call(_context3, function (column) {
    return column.colSpan !== 0;
  })
  // 去除初始化就被隐藏的列
  ).call(_context2, function (column) {
    return (0, _findIndex["default"])(hideColumns).call(hideColumns, function (key) {
      return key === getColumnKey(column);
    }) === -1;
  })
  // 只留uniqueId
  ).call(_context, function (column) {
    return getColumnKey(column);
  });
};
var getColSpanOption = function getColSpanOption(columns) {
  var colSpanOption = [];
  (0, _forEach["default"])(columns).call(columns, function (column, index) {
    if ('colSpan' in column && column.colSpan !== 0) {
      var _context4;
      colSpanOption.push({
        key: column.filtrateTitle || column.title,
        value: (0, _map["default"])(_context4 = (0, _slice["default"])(columns).call(columns, index, index + column.colSpan)).call(_context4, function (column) {
          return column.key || column.dataIndex;
        })
      });
    }
  });
  return colSpanOption;
};
var DraggableTable = null;
var ColumnFiltrateDraggableModal = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ColumnFiltrateDraggableModal, _React$Component);
  var _super = _createSuper(ColumnFiltrateDraggableModal);
  function ColumnFiltrateDraggableModal(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, ColumnFiltrateDraggableModal);
    _this = _super.call(this, props);
    _this.showModal = function () {
      _this.setState({
        visible: true
      });
    };
    _this.handleOk = function () {
      _this.setState({
        visible: false,
        checkedOptionConfirm: _this.state.checkedOption,
        okButtonDisabled: true
      }, function () {
        var _context5, _context6, _context9;
        // 被隐藏的列表key
        _this.props.onChange(flatten((0, _map["default"])(_context5 = (0, _filter["default"])(_context6 = _this.getOptions()).call(_context6, function (column) {
          var _context7;
          return (0, _indexOf["default"])(_context7 = _this.state.checkedOptionConfirm).call(_context7, column.value) === -1;
        })).call(_context5, function (column) {
          var _context8;
          var indexOfColSpan = (0, _findIndex["default"])(_context8 = _this.state.colSpanOption).call(_context8, function (option) {
            return option.key === column.value;
          });
          if (indexOfColSpan !== -1) {
            return _this.state.colSpanOption[indexOfColSpan].value;
          } else {
            return column.value;
          }
        })), (0, _concat["default"])(_context9 = _this.props.defaultColumns).call(_context9, _this.state.checkedOption));
      });
    };
    _this.handleCancel = function () {
      _this.setState({
        visible: false,
        checkedOption: _this.state.checkedOptionConfirm,
        okButtonDisabled: true
      });
    };
    _this.onChange = function (checkedOption) {
      _this.setState({
        checkedOption: checkedOption,
        okButtonDisabled: false
      });
    };
    _this.getOptions = function () {
      var _context10, _context11;
      var _this$props = _this.props,
        columns = _this$props.columns,
        defaultColumns = _this$props.defaultColumns;
      return (0, _filter["default"])(_context10 = (0, _map["default"])(_context11 = (0, _filter["default"])(columns
      // 去除表头合并的不显示的
      ).call(columns
      // 去除表头合并的不显示的
      , function (column) {
        return column.colSpan !== 0;
      })
      // 获取他们的label、value、disabled
      ).call(_context11, function (column) {
        var uniqKey = getColumnKey(column);
        //fixed /分组不能控制显示隐藏
        var disabled = !!column.fixed || !!column.children || !!column.filtrateDefault;
        var title = column.filtrateTitle || column.title;
        return {
          label: /*#__PURE__*/_react["default"].createElement(_Tooltip["default"], {
            title: title
          }, title),
          value: uniqKey,
          disabled: disabled
        };
      })
      // 去除默认展示数据项
      ).call(_context10, function (column) {
        return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
          return key === column.value;
        }) === -1;
      });
    };
    _this.getDataSource = function () {
      var _this$props2 = _this.props,
        columns = _this$props2.columns,
        defaultColumns = _this$props2.defaultColumns;
      var checkedOption = _this.state.checkedOption;
      var selectRows = (0, _filter["default"])(columns).call(columns, function (column) {
        return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
          return key === getColumnKey(column);
        }) != -1;
      });
      var unSelectRows = [];
      var _iterator = _createForOfIteratorHelper(checkedOption),
        _step;
      try {
        var _loop = function _loop() {
          var key = _step.value;
          selectRows = (0, _concat["default"])(selectRows).call(selectRows, (0, _filter["default"])(columns).call(columns, function (each) {
            return each.key == key;
          }));
        };
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          _loop();
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      var _iterator2 = _createForOfIteratorHelper((0, _filter["default"])(columns).call(columns, function (column) {
          return (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
            return key === getColumnKey(column);
          }) === -1;
        })),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var each = _step2.value;
          if ((0, _includes["default"])(checkedOption).call(checkedOption, each.key)) {
            each.selected = true;
          } else {
            each.selected = false;
            unSelectRows.push(each);
          }
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      return (0, _concat["default"])(selectRows).call(selectRows, unSelectRows);
    };
    var _this$props3 = _this.props,
      columns = _this$props3.columns,
      hideColumns = _this$props3.hideColumns,
      defaultColumns = _this$props3.defaultColumns;
    var option = getCheckedOptions(columns, hideColumns, defaultColumns);
    _this.state = {
      visible: false,
      checkedOption: option,
      checkedOptionConfirm: option,
      okButtonDisabled: true,
      prevProps: props,
      colSpanOption: getColSpanOption(columns)
    };
    return _this;
  }
  (0, _createClass2["default"])(ColumnFiltrateDraggableModal, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      DraggableTable = (0, _TableDraggableHOC["default"])(_Table["default"], {
        dnd: true,
        renderBodyRow: function renderBodyRow(props) {
          var index = props.index,
            restProps = __rest(props, ["index"]);
          return /*#__PURE__*/_react["default"].createElement("tr", (0, _assign["default"])({}, restProps));
        },
        dndRow: function dndRow(props) {
          if (props.record.selected) {
            return true;
          } else {
            return false;
          }
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props4 = this.props,
        prefixCls = _this$props4.prefixCls,
        defaultColumns = _this$props4.defaultColumns,
        locale = _this$props4.locale;
      var _this$state = this.state,
        visible = _this$state.visible,
        checkedOption = _this$state.checkedOption,
        okButtonDisabled = _this$state.okButtonDisabled;
      var draggableTableColumns = [{
        title: locale.draggableTitle,
        dataIndex: 'title',
        render: function render(val, row) {
          return /*#__PURE__*/_react["default"].createElement("span", null, val);
        }
      }, {
        title: locale.draggableAction,
        dataIndex: 'operate',
        render: function render(val, row) {
          var isDefault = (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
            return key === getColumnKey(row);
          }) != -1;
          if ((0, _findIndex["default"])(checkedOption).call(checkedOption, function (key) {
            return key === getColumnKey(row);
          }) != -1 && !isDefault) {
            return /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
              type: "sound-drag"
            });
          } else {
            return null;
          }
        }
      }];
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "Table"
      }, function (Locale) {
        return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_Icon["default"], {
          className: "".concat(prefixCls, "-filtrate-icon"),
          type: "Settingx",
          onClick: _this2.showModal
        }), /*#__PURE__*/_react["default"].createElement(_Modal["default"], {
          title: Locale.modalTitle,
          wrapClassName: "".concat(prefixCls, "-filtrate-modal"),
          visible: visible,
          width: 680,
          okButtonDisabled: okButtonDisabled,
          onOk: _this2.handleOk,
          onCancel: _this2.handleCancel,
          okText: Locale.okText,
          cancelText: Locale.cancelText
        }, DraggableTable ? /*#__PURE__*/_react["default"].createElement(DraggableTable, {
          rowKey: "key",
          columns: draggableTableColumns,
          dataSource: _this2.getDataSource(),
          pagination: false,
          rowSelection: {
            selectedRowKeys: checkedOption,
            hideDefaultSelections: true,
            showSelectAll: true,
            type: 'checkbox',
            onChange: _this2.onChange,
            getCheckboxProps: function getCheckboxProps(record) {
              var isDefault = (0, _findIndex["default"])(defaultColumns).call(defaultColumns, function (key) {
                return key === getColumnKey(record);
              }) != -1;
              return {
                disabled: isDefault || record.filtrateDefault,
                name: record.title,
                checked: isDefault || (0, _findIndex["default"])(checkedOption).call(checkedOption, function (key) {
                  return key === getColumnKey(record);
                }) != -1
              };
            }
          },
          onRowMoved: function onRowMoved(fields) {
            var _context12;
            var checkedOption = (0, _map["default"])(_context12 = (0, _filter["default"])(fields).call(fields, function (each) {
              return each.selected;
            })).call(_context12, function (column) {
              return getColumnKey(column);
            });
            _this2.onChange(checkedOption);
          }
        }) : null));
      });
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var _prevState$prevProps = prevState.prevProps,
        prevProps = _prevState$prevProps === void 0 ? {} : _prevState$prevProps;
      var newState = {
        prevProps: nextProps
      };
      //监听column个数变化，重新初始化checkedOption
      if ('columns' in nextProps && nextProps.columns.length !== prevProps.columns.length) {
        var columns = nextProps.columns,
          hideColumns = nextProps.hideColumns,
          defaultColumns = nextProps.defaultColumns;
        var option = getCheckedOptions(columns, hideColumns, defaultColumns);
        newState.checkedOption = option;
        newState.checkedOptionConfirm = option;
        newState.colSpanOption = getColSpanOption(columns);
      }
      return newState;
    }
  }]);
  return ColumnFiltrateDraggableModal;
}(_react["default"].Component);
ColumnFiltrateDraggableModal.defaultProps = {
  columns: [],
  defaultColumns: [],
  hideColumns: []
};
(0, _reactLifecyclesCompat.polyfill)(ColumnFiltrateDraggableModal);
var _default = ColumnFiltrateDraggableModal;
exports["default"] = _default;