"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _utils = require("../../../utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var ExpandIcon = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(ExpandIcon, _React$Component);
  var _super = _createSuper(ExpandIcon);
  function ExpandIcon() {
    (0, _classCallCheck2["default"])(this, ExpandIcon);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(ExpandIcon, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !(0, _utils.shallowEqual)(nextProps, this.props);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        expandable = _this$props.expandable,
        prefixCls = _this$props.prefixCls,
        onExpand = _this$props.onExpand,
        needIndentSpaced = _this$props.needIndentSpaced,
        expanded = _this$props.expanded,
        record = _this$props.record;
      if (expandable) {
        var _context, _context2;
        var expandClassName = expanded ? 'expanded' : 'collapsed';
        return /*#__PURE__*/_react["default"].createElement("span", {
          className: (0, _concat["default"])(_context = (0, _concat["default"])(_context2 = "".concat(prefixCls, "-expand-icon ")).call(_context2, prefixCls, "-")).call(_context, expandClassName),
          onClick: function onClick(e) {
            return onExpand(record, e);
          }
        });
      } else if (needIndentSpaced) {
        var _context3;
        return /*#__PURE__*/_react["default"].createElement("span", {
          className: (0, _concat["default"])(_context3 = "".concat(prefixCls, "-expand-icon ")).call(_context3, prefixCls, "-spaced")
        });
      }
      return null;
    }
  }]);
  return ExpandIcon;
}(_react["default"].Component);
exports["default"] = ExpandIcon;
ExpandIcon.propTypes = {
  record: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string,
  expandable: _propTypes["default"].bool,
  expanded: _propTypes["default"].bool,
  needIndentSpaced: _propTypes["default"].bool,
  onExpand: _propTypes["default"].func
};