"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames2 = _interopRequireDefault(require("classnames"));
var _utils = require("./utils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var TabPane = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TabPane, _React$Component);
  var _super = _createSuper(TabPane);
  function TabPane() {
    (0, _classCallCheck2["default"])(this, TabPane);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(TabPane, [{
    key: "render",
    value: function render() {
      var _classnames;
      var _a = this.props,
        className = _a.className,
        destroyInactiveTabPane = _a.destroyInactiveTabPane,
        active = _a.active,
        forceRender = _a.forceRender,
        rootPrefixCls = _a.rootPrefixCls,
        style = _a.style,
        children = _a.children,
        placeholder = _a.placeholder,
        restProps = __rest(_a, ["className", "destroyInactiveTabPane", "active", "forceRender", "rootPrefixCls", "style", "children", "placeholder"]);
      this._isActived = this._isActived || active;
      var prefixCls = "".concat(rootPrefixCls, "-tabpane");
      var cls = (0, _classnames2["default"])((_classnames = {}, (0, _defineProperty2["default"])(_classnames, prefixCls, 1), (0, _defineProperty2["default"])(_classnames, "".concat(prefixCls, "-inactive"), !active), (0, _defineProperty2["default"])(_classnames, "".concat(prefixCls, "-active"), active), (0, _defineProperty2["default"])(_classnames, className, className), _classnames));
      var isRender = destroyInactiveTabPane ? active : this._isActived;
      return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
        style: style,
        role: "tabpanel",
        "aria-hidden": active ? 'false' : 'true',
        className: cls
      }, (0, _utils.getDataAttr)(restProps)), isRender || forceRender ? children : placeholder);
    }
  }]);
  return TabPane;
}(_react["default"].Component);
exports["default"] = TabPane;
TabPane.propTypes = {
  className: _propTypes["default"].string,
  active: _propTypes["default"].bool,
  // style: PropTypes.any,
  style: _propTypes["default"].object,
  destroyInactiveTabPane: _propTypes["default"].bool,
  forceRender: _propTypes["default"].bool,
  placeholder: _propTypes["default"].node,
  rootPrefixCls: _propTypes["default"].string,
  children: _propTypes["default"].node
};
TabPane.defaultProps = {
  placeholder: null
};