"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var RcContent = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(RcContent, _React$Component);
  var _super = _createSuper(RcContent);
  function RcContent() {
    (0, _classCallCheck2["default"])(this, RcContent);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(RcContent, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var trigger = this.props.trigger;
      if (trigger) {
        trigger.forcePopupAlign();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        overlay = _this$props.overlay,
        prefixCls = _this$props.prefixCls,
        id = _this$props.id;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(prefixCls, "-inner"),
        id: id
      }, typeof overlay === 'function' ? overlay() : overlay);
    }
  }]);
  return RcContent;
}(_react["default"].Component);
exports["default"] = RcContent;
RcContent.propTypes = {
  prefixCls: _propTypes["default"].string,
  overlay: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].func]).isRequired,
  id: _propTypes["default"].string,
  trigger: _propTypes["default"].oneOfType([_propTypes["default"].object, _propTypes["default"].node])
};