import * as React from 'react';
import RcTreeSelect from './rcTreeSelect';
import { TreeSelectProps } from './interface';
import './style/index.less';
export default class TreeSelect extends React.Component<TreeSelectProps, any> {
    static TreeNode: {
        (props: any): JSX.Element;
        propTypes: {
            value: any;
            eventKey: any;
            prefixCls: any;
            className: any;
            style: any;
            root: any;
            onSelect: any;
            expanded: any;
            selected: any;
            checked: any;
            loaded: any;
            loading: any;
            halfChecked: any;
            children: any;
            title: any;
            pos: any;
            dragOver: any;
            dragOverGapTop: any;
            dragOverGapBottom: any;
            isLeaf: any;
            selectable: any;
            disabled: any;
            checkable: any;
            disableCheckbox: any;
            icon: any;
            switcherIcon: any;
        };
        isTreeNode: number;
    };
    static SHOW_ALL: string;
    static SHOW_PARENT: string;
    static SHOW_CHILD: string;
    static defaultProps: {
        autoClearSearchValue: boolean;
        autoExpandParent: boolean;
        choiceTransitionName: string;
        editable: boolean;
        esc: boolean;
        required: boolean;
        prefixCls: string;
        showCheckedStrategy: string;
        showSearch: boolean;
        tagWidth: number;
        transitionName: string;
        treeCheckStrictly: boolean;
        placement: string;
        uniqueTreeNodeByLabel: boolean;
        getPopupContainer: () => HTMLElement;
    };
    private rcTreeSelect;
    constructor(props: TreeSelectProps);
    genPropsByLocale: (Locale: any) => {
        searchPlaceholder: any;
        placeholder: any;
        treeNodeResetTitle: any;
    };
    focus(): void;
    blur(): void;
    saveTreeSelect: (node: typeof RcTreeSelect) => void;
    render(): JSX.Element;
}
