"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _BasePopup = _interopRequireDefault(require("../Base/BasePopup"));
var _SearchInput = _interopRequireDefault(require("../SearchInput"));
var _util = require("../util");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var SinglePopup = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(SinglePopup, _React$Component);
  var _super = _createSuper(SinglePopup);
  function SinglePopup() {
    var _this;
    (0, _classCallCheck2["default"])(this, SinglePopup);
    _this = _super.call(this);
    _this.onPlaceholderClick = function () {
      _this.inputRef.current.focus();
    };
    _this.renderPlaceholder = function () {
      var _this$props = _this.props,
        searchPlaceholder = _this$props.searchPlaceholder,
        searchValue = _this$props.searchValue,
        prefixCls = _this$props.prefixCls;
      if (!searchPlaceholder) {
        return null;
      }
      return /*#__PURE__*/_react["default"].createElement("span", {
        style: {
          display: searchValue ? 'none' : 'block'
        },
        onClick: _this.onPlaceholderClick,
        className: "".concat(prefixCls, "-search__field__placeholder")
      }, searchPlaceholder);
    };
    _this.renderSearch = function () {
      var _this$props2 = _this.props,
        showSearch = _this$props2.showSearch,
        dropdownPrefixCls = _this$props2.dropdownPrefixCls;
      if (!showSearch) {
        return null;
      }
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(dropdownPrefixCls, "-search")
      }, /*#__PURE__*/_react["default"].createElement(_SearchInput["default"], (0, _assign["default"])({}, _this.props, {
        ref: _this.inputRef,
        renderPlaceholder: _this.renderPlaceholder
      })));
    };
    _this.renderResetItem = function () {
      var _this$props3 = _this.props,
        dropdownPrefixCls = _this$props3.dropdownPrefixCls,
        treeNodeResetTitle = _this$props3.treeNodeResetTitle,
        resetSelect = _this$props3.resetSelect;
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "".concat(dropdownPrefixCls, "-reset"),
        onClick: resetSelect
      }, treeNodeResetTitle);
    };
    _this.inputRef = (0, _util.createRef)();
    return _this;
  }
  (0, _createClass2["default"])(SinglePopup, [{
    key: "render",
    value: function render() {
      var required = this.props.required;
      return /*#__PURE__*/_react["default"].createElement(_BasePopup["default"], (0, _assign["default"])({}, this.props, {
        renderSearch: this.renderSearch,
        renderResetItem: required ? null : this.renderResetItem
      }));
    }
  }]);
  return SinglePopup;
}(_react["default"].Component);
SinglePopup.propTypes = (0, _assign["default"])((0, _assign["default"])({}, _BasePopup["default"].propTypes), {
  searchValue: _propTypes["default"].string,
  showSearch: _propTypes["default"].bool,
  dropdownPrefixCls: _propTypes["default"].string,
  disabled: _propTypes["default"].bool,
  required: _propTypes["default"].bool,
  searchPlaceholder: _propTypes["default"].string,
  treeNodeResetTitle: _propTypes["default"].string,
  resetSelect: _propTypes["default"].func
});
var _default = SinglePopup;
exports["default"] = _default;