"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = _interopRequireDefault(require("../../Icon/index"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Play = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Play, _Component);
  var _super = _createSuper(Play);
  function Play(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Play);
    _this = _super.call(this, props);
    _this.handleClick = function () {
      var isPlay = _this.state.isPlay;
      if (!isPlay) {
        _this.player.play();
      } else {
        _this.player.pause();
      }
      _this.setState({
        isPlay: !isPlay
      });
    };
    _this.setPlay = function (isPlay) {
      return function () {
        _this.setState({
          isPlay: isPlay
        });
      };
    };
    // 获取播放器实例
    _this.player = props.vjsComponent.player_;
    _this.state = {
      isPlay: false
    };
    return _this;
  }
  (0, _createClass2["default"])(Play, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.player.on('play', this.setPlay(true));
      this.player.on('pause', this.setPlay(false));
      this.player.on('ended', this.setPlay(false));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.player.off('play', this.setPlay(true));
      this.player.off('pause', this.setPlay(false));
      this.player.off('ended', this.setPlay(false));
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var isPlay = this.state.isPlay;
      var pausePlayIcon = !isPlay ? 'play' : 'stop';
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(prefixCls, 'fishd-video-js-customer-button'),
        onClick: function onClick() {
          return _this2.handleClick();
        }
      }, /*#__PURE__*/_react["default"].createElement("a", null, /*#__PURE__*/_react["default"].createElement(_index["default"], {
        className: "".concat(prefixCls, "-customer-handle"),
        type: pausePlayIcon
      })));
    }
  }]);
  return Play;
}(_react.Component);
exports["default"] = Play;
Play.propTypes = {
  prefixCls: _propTypes["default"].string,
  vjsComponent: _propTypes["default"].object
};
Play.defaultProps = {
  prefixCls: 'fishd-video-viewer-play'
};