"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactTransitionGroup = require("react-transition-group");
var _child = _interopRequireDefault(require("./child"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var noop = function noop() {};
var FirstChild = function FirstChild(props) {
  var childrenArray = _react["default"].Children.toArray(props.children);
  return childrenArray[0] || null;
};
var Animate = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Animate, _Component);
  var _super = _createSuper(Animate);
  function Animate() {
    (0, _classCallCheck2["default"])(this, Animate);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Animate, [{
    key: "normalizeNames",
    value: function normalizeNames(names) {
      if (typeof names === 'string') {
        return {
          appear: "".concat(names, "-appear"),
          appearActive: "".concat(names, "-appear-active"),
          enter: "".concat(names, "-enter"),
          enterActive: "".concat(names, "-enter-active"),
          leave: "".concat(names, "-leave"),
          leaveActive: "".concat(names, "-leave-active")
        };
      }
      if ((0, _typeof2["default"])(names) === 'object') {
        return {
          appear: names.appear,
          appearActive: "".concat(names.appear, "-active"),
          enter: "".concat(names.enter),
          enterActive: "".concat(names.enter, "-active"),
          leave: "".concat(names.leave),
          leaveActive: "".concat(names.leave, "-active")
        };
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;
      var _a = this.props,
        animation = _a.animation,
        children = _a.children,
        animationAppear = _a.animationAppear,
        singleMode = _a.singleMode,
        component = _a.component,
        beforeAppear = _a.beforeAppear,
        onAppear = _a.onAppear,
        afterAppear = _a.afterAppear,
        beforeEnter = _a.beforeEnter,
        onEnter = _a.onEnter,
        afterEnter = _a.afterEnter,
        beforeLeave = _a.beforeLeave,
        onLeave = _a.onLeave,
        afterLeave = _a.afterLeave,
        _a$timeout = _a.timeout,
        timeout = _a$timeout === void 0 ? 500 : _a$timeout,
        others = __rest(_a, ["animation", "children", "animationAppear", "singleMode", "component", "beforeAppear", "onAppear", "afterAppear", "beforeEnter", "onEnter", "afterEnter", "beforeLeave", "onLeave", "afterLeave", "timeout"]);
      var animateChildren = (0, _map["default"])(_react.Children).call(_react.Children, children, function (child) {
        return /*#__PURE__*/_react["default"].createElement(_child["default"]
        // @ts-ignore
        , {
          // @ts-ignore
          key: child.key,
          names: _this.normalizeNames(animation),
          onAppear: beforeAppear,
          onAppearing: onAppear,
          onAppeared: afterAppear,
          onEnter: beforeEnter,
          onEntering: onEnter,
          onEntered: afterEnter,
          onExit: beforeLeave,
          onExiting: onLeave,
          onExited: afterLeave,
          timeout: timeout
        }, child);
      });
      return /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.TransitionGroup, (0, _assign["default"])({
        appear: animationAppear,
        component: singleMode ? FirstChild : component
      }, others), animateChildren);
    }
  }]);
  return Animate;
}(_react.Component);
Animate.propTypes = {
  animation: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  animationAppear: _propTypes["default"].bool,
  component: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].string]),
  singleMode: _propTypes["default"].bool,
  children: _propTypes["default"].oneOfType([_propTypes["default"].element, _propTypes["default"].arrayOf(_propTypes["default"].element)]),
  beforeAppear: _propTypes["default"].func,
  onAppear: _propTypes["default"].func,
  afterAppear: _propTypes["default"].func,
  beforeEnter: _propTypes["default"].func,
  onEnter: _propTypes["default"].func,
  afterEnter: _propTypes["default"].func,
  beforeLeave: _propTypes["default"].func,
  onLeave: _propTypes["default"].func,
  afterLeave: _propTypes["default"].func,
  timeout: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].object])
};
Animate.defaultProps = {
  animationAppear: true,
  component: 'span',
  singleMode: true,
  beforeAppear: noop,
  onAppear: noop,
  afterAppear: noop,
  beforeEnter: noop,
  onEnter: noop,
  afterEnter: noop,
  beforeLeave: noop,
  onLeave: noop,
  afterLeave: noop
};
var _default = Animate;
exports["default"] = _default;