"use strict";

function _typeof3(obj) { "@babel/helpers - typeof"; return _typeof3 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof3(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactTransitionGroup = require("react-transition-group");
var _utils = require("../../utils");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var noop = function noop() {};
function _off(node, eventName, callback) {
  var useCapture = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (node.removeEventListener) {
    node.removeEventListener(eventName, callback, useCapture);
  }
}
function on(node, eventName, callback) {
  var useCapture = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  if (node.addEventListener) {
    node.addEventListener(eventName, callback, useCapture);
  }
  return {
    off: function off() {
      return _off(node, eventName, callback, useCapture);
    }
  };
}
function getStyleProperty(node, name) {
  var prefixes = ['-webkit-', '-moz-', '-o-', 'ms-', ''];
  var style = window.getComputedStyle(node);
  var ret = '';
  for (var i = 0; i < prefixes.length; i++) {
    ret = style.getPropertyValue(prefixes[i] + name);
    if (ret) {
      break;
    }
  }
  return ret;
}
var AnimateChild = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(AnimateChild, _React$Component);
  var _super = _createSuper(AnimateChild);
  function AnimateChild(props) {
    var _this2;
    (0, _classCallCheck2["default"])(this, AnimateChild);
    _this2 = _super.call(this, props);
    _this2.endListeners = {
      transitionend: [],
      animationend: []
    };
    _this2.node = null;
    _this2.generateEndListener = function (node, done, eventName, id) {
      var _this = (0, _assertThisInitialized2["default"])(_this2);
      return function endListener(e) {
        if (e && e.target === node) {
          if (_this.timeoutMap[id]) {
            clearTimeout(_this.timeoutMap[id]);
            delete _this.timeoutMap[id];
          }
          done();
          _off(node, eventName, endListener);
          var listeners = _this.endListeners[eventName];
          var index = (0, _indexOf["default"])(listeners).call(listeners, endListener);
          index > -1 && (0, _splice["default"])(listeners).call(listeners, index, 1);
        }
      };
    };
    _this2.addEndListener = function (node, done) {
      if (_utils.supportAni.transition || _utils.supportAni.animation) {
        var id = (0, _utils.guid)();
        _this2.node = node;
        if (_utils.supportAni.transition) {
          var transitionEndListener = _this2.generateEndListener(node, done, 'transitionend', id);
          on(node, 'transitionend', transitionEndListener);
          _this2.endListeners.transitionend.push(transitionEndListener);
        }
        if (_utils.supportAni.animation) {
          var animationEndListener = _this2.generateEndListener(node, done, 'animationend', id);
          on(node, 'animationend', animationEndListener);
          _this2.endListeners.animationend.push(animationEndListener);
        }
        (0, _setTimeout2["default"])(function () {
          var transitionDelay = (0, _parseFloat2["default"])(getStyleProperty(node, 'transition-delay')) || 0;
          var transitionDuration = (0, _parseFloat2["default"])(getStyleProperty(node, 'transition-duration')) || 0;
          var animationDelay = (0, _parseFloat2["default"])(getStyleProperty(node, 'animation-delay')) || 0;
          var animationDuration = (0, _parseFloat2["default"])(getStyleProperty(node, 'animation-duration')) || 0;
          var time = Math.max(transitionDuration + transitionDelay, animationDuration + animationDelay);
          _this2.timeoutMap[id] = (0, _setTimeout2["default"])(function () {
            done();
          }, time * 1000 + 200);
        }, 15);
      } else {
        done();
      }
    };
    _this2.removeEndtListener = function () {
      _this2.transitionOff && _this2.transitionOff();
      _this2.animationOff && _this2.animationOff();
    };
    _this2.removeClassNames = function (node, names) {
      var _context;
      (0, _forEach["default"])(_context = (0, _keys["default"])(names)).call(_context, function (key) {
        (0, _utils.removeClass)(node, names[key], false);
      });
    };
    _this2.handleEnter = function (node, isAppearing) {
      var names = _this2.props.names;
      if (names) {
        _this2.removeClassNames(node, names);
        var className = isAppearing ? 'appear' : 'enter';
        (0, _utils.addClass)(node, names[className], false);
      }
      var hook = isAppearing ? _this2.props.onAppear : _this2.props.onEnter;
      hook(node);
    };
    _this2.handleEntering = function (node, isAppearing) {
      (0, _setTimeout2["default"])(function () {
        var names = _this2.props.names;
        if (names) {
          var className = isAppearing ? 'appearActive' : 'enterActive';
          (0, _utils.addClass)(node, names[className], false);
        }
        var hook = isAppearing ? _this2.props.onAppearing : _this2.props.onEntering;
        hook(node);
      }, 10);
    };
    _this2.handleEntered = function (node, isAppearing) {
      var names = _this2.props.names;
      if (names && (0, _typeof2["default"])(names) === 'object') {
        var classNames = isAppearing ? [names.appear, names.appearActive] : [names.enter, names.enterActive];
        (0, _forEach["default"])(classNames).call(classNames, function (className) {
          (0, _utils.removeClass)(node, className, false);
        });
      }
      var hook = isAppearing ? _this2.props.onAppeared : _this2.props.onEntered;
      hook(node);
    };
    _this2.handleExit = function (node) {
      var names = _this2.props.names;
      if (names) {
        _this2.removeClassNames(node, names);
        (0, _utils.addClass)(node, names.leave, false);
      }
      _this2.props.onExit(node);
    };
    _this2.handleExiting = function (node) {
      (0, _setTimeout2["default"])(function () {
        var names = _this2.props.names;
        if (names) {
          (0, _utils.addClass)(node, names.leaveActive, false);
        }
        _this2.props.onExiting(node);
      }, 10);
    };
    _this2.handleExited = function (node) {
      var names = _this2.props.names;
      if (names) {
        var _context2;
        (0, _forEach["default"])(_context2 = [names.leave, names.leaveActive]).call(_context2, function (className) {
          (0, _utils.removeClass)(node, className, false);
        });
      }
      _this2.props.onExited(node);
    };
    _this2.endListeners = {
      transitionend: [],
      animationend: []
    };
    _this2.timeoutMap = {};
    return _this2;
  }
  (0, _createClass2["default"])(AnimateChild, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _context3,
        _this3 = this;
      (0, _forEach["default"])(_context3 = (0, _keys["default"])(this.endListeners)).call(_context3, function (eventName) {
        var _context4;
        (0, _forEach["default"])(_context4 = _this3.endListeners[eventName]).call(_context4, function (listener) {
          _off(_this3.node, eventName, listener);
        });
      });
      this.endListeners = {
        transitionend: [],
        animationend: []
      };
    }
  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
        names = _a.names,
        onAppear = _a.onAppear,
        onAppeared = _a.onAppeared,
        onAppearing = _a.onAppearing,
        onEnter = _a.onEnter,
        onEntering = _a.onEntering,
        onEntered = _a.onEntered,
        onExit = _a.onExit,
        onExiting = _a.onExiting,
        onExited = _a.onExited,
        others = __rest(_a, ["names", "onAppear", "onAppeared", "onAppearing", "onEnter", "onEntering", "onEntered", "onExit", "onExiting", "onExited"]);
      return /*#__PURE__*/React.createElement(_reactTransitionGroup.Transition, (0, _assign["default"])({}, others, {
        onEnter: this.handleEnter,
        onEntering: this.handleEntering,
        onEntered: this.handleEntered,
        onExit: this.handleExit,
        onExiting: this.handleExiting,
        onExited: this.handleExited,
        addEndListener: this.addEndListener
      }));
    }
  }]);
  return AnimateChild;
}(React.Component);
exports["default"] = AnimateChild;
AnimateChild.propTypes = {
  names: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].object]),
  onAppear: _propTypes["default"].func,
  onAppearing: _propTypes["default"].func,
  onAppeared: _propTypes["default"].func,
  onEnter: _propTypes["default"].func,
  onEntering: _propTypes["default"].func,
  onEntered: _propTypes["default"].func,
  onExit: _propTypes["default"].func,
  onExiting: _propTypes["default"].func,
  onExited: _propTypes["default"].func,
  timeout: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].object])
};
AnimateChild.defaultProps = {
  onAppear: noop,
  onAppearing: noop,
  onAppeared: noop,
  onEnter: noop,
  onEntering: noop,
  onEntered: noop,
  onExit: noop,
  onExiting: noop,
  onExited: noop
};