"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _reactDom = require("react-dom");
var _debounce = _interopRequireDefault(require("lodash/debounce"));
var _classnames = _interopRequireDefault(require("classnames"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/* eslint-disable @typescript-eslint/no-var-requires */

// matchMedia polyfill for
// https://github.com/WickyNilliams/enquire.js/issues/82
if (typeof window !== 'undefined') {
  var matchMediaPolyfill = function matchMediaPolyfill(mediaQuery) {
    return {
      media: mediaQuery,
      matches: false,
      addListener: function addListener() {},
      removeListener: function removeListener() {}
    };
  };
  window.matchMedia = window.matchMedia || matchMediaPolyfill;
}
// Use require over import (will be lifted up)
// make sure matchMedia polyfill run before require('react-slick')
// Fix https://github.com/ant-design/ant-design/issues/6560
// Fix https://github.com/ant-design/ant-design/issues/3308
var SlickCarousel = require('react-slick')["default"];
function CustomArrow(props) {
  var className = props.className,
    style = props.style,
    onClick = props.onClick;
  return /*#__PURE__*/React.createElement("div", {
    className: className,
    style: (0, _assign["default"])((0, _assign["default"])({}, style), {
      display: 'flex'
    }),
    onClick: onClick
  });
}
var Carousel = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Carousel, _React$Component);
  var _super = _createSuper(Carousel);
  function Carousel(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, Carousel);
    _this = _super.call(this, props);
    _this.onWindowResized = function () {
      // Fix https://github.com/ant-design/ant-design/issues/2550
      var autoplay = _this.props.autoplay;
      if (autoplay && _this.slick && _this.slick.innerSlider && _this.slick.innerSlider.autoPlay) {
        _this.slick.innerSlider.autoPlay();
      }
    };
    _this.saveSlick = function (node) {
      _this.slick = node;
    };
    _this.onWindowResized = (0, _debounce["default"])(_this.onWindowResized, 500, {
      leading: false
    });
    return _this;
  }
  (0, _createClass2["default"])(Carousel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      var _this$props = this.props,
        autoplay = _this$props.autoplay,
        autoplaySpeed = _this$props.autoplaySpeed,
        dotsPosition = _this$props.dotsPosition,
        dotsTimer = _this$props.dotsTimer;
      if (autoplay) {
        window.addEventListener('resize', this.onWindowResized);
      }
      // https://github.com/ant-design/ant-design/issues/7191
      this.innerSlider = this.slick && this.slick.innerSlider;
      this.slickDOM = (0, _reactDom.findDOMNode)(this.slick);
      if (autoplay && dotsTimer) {
        var _context;
        var aniName = dotsPosition == 'left' || dotsPosition == 'right' ? 'dotsAniVertical' : 'dotsAni',
          timerEl = this.slickDOM.querySelector('.timer');
        !!timerEl && timerEl.style.setProperty('--dots-ani', (0, _concat["default"])(_context = "".concat(aniName, " ")).call(_context, autoplaySpeed / 1000, "s infinite"));
        this.slickDOM.addEventListener('mouseover', function () {
          var timerEl = _this2.slickDOM.querySelector('.timer');
          !!timerEl && timerEl.style.setProperty('--dots-ani', 'none');
        });
        this.slickDOM.addEventListener('mouseout', function () {
          var _context2;
          var timerEl = _this2.slickDOM.querySelector('.timer');
          !!timerEl && timerEl.style.setProperty('--dots-ani', (0, _concat["default"])(_context2 = "".concat(aniName, " ")).call(_context2, autoplaySpeed / 1000, "s infinite"));
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var autoplay = this.props.autoplay;
      if (autoplay) {
        window.removeEventListener('resize', this.onWindowResized);
        this.onWindowResized.cancel();
      }
    }
  }, {
    key: "next",
    value: function next() {
      this.slick.slickNext();
    }
  }, {
    key: "prev",
    value: function prev() {
      this.slick.slickPrev();
    }
  }, {
    key: "goTo",
    value: function goTo(slide) {
      this.slick.slickGoTo(slide);
    }
  }, {
    key: "render",
    value: function render() {
      var _context3;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        className = _a.className,
        style = _a.style,
        dotsPosition = _a.dotsPosition,
        dotsTimer = _a.dotsTimer,
        nextArrow = _a.nextArrow,
        prevArrow = _a.prevArrow,
        centerMode = _a.centerMode,
        centerPadding = _a.centerPadding,
        slidesToShow = _a.slidesToShow,
        restProps = __rest(_a, ["prefixCls", "className", "style", "dotsPosition", "dotsTimer", "nextArrow", "prevArrow", "centerMode", "centerPadding", "slidesToShow"]);
      var cls = (0, _classnames["default"])(prefixCls, (0, _concat["default"])(_context3 = "".concat(prefixCls, "-")).call(_context3, dotsPosition), className);
      var dotsCls = (0, _classnames["default"])('slick-dots', {
        'slick-dots-vertical': dotsPosition == 'left' || dotsPosition == 'right',
        timer: restProps.autoplay && dotsTimer
      });
      if (restProps.effect === 'fade') {
        restProps.fade = true;
      }
      return /*#__PURE__*/React.createElement("div", {
        className: cls,
        style: style
      }, /*#__PURE__*/React.createElement(SlickCarousel, (0, _assign["default"])({}, restProps, {
        ref: this.saveSlick,
        nextArrow: nextArrow ? nextArrow : /*#__PURE__*/React.createElement(CustomArrow, {
          className: "slick-next",
          onClick: this.next
        }),
        prevArrow: prevArrow ? prevArrow : /*#__PURE__*/React.createElement(CustomArrow, {
          className: "slick-prev",
          onClick: this.prev
        }),
        centerMode: centerMode,
        centerPadding: centerPadding,
        slidesToShow: slidesToShow,
        dotsClass: dotsCls
      })));
    }
  }]);
  return Carousel;
}(React.Component);
exports["default"] = Carousel;
Carousel.defaultProps = {
  dots: true,
  arrows: false,
  prefixCls: 'fishd-carousel',
  draggable: false,
  dotsTimer: false,
  autoplaySpeed: 3000,
  dotsPosition: 'bottom',
  centerMode: false,
  centerPadding: '50px',
  slidesToShow: 1
};