"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/toConsumableArray"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));
var _fill = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/fill"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _findIndex = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/find-index"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/includes"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _Panel = _interopRequireDefault(require("./Panel"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function toArray(activeKey) {
  var currentActiveKey = activeKey;
  if (!(0, _isArray["default"])(currentActiveKey)) {
    currentActiveKey = currentActiveKey ? [currentActiveKey] : [];
  }
  return currentActiveKey;
}
var Collapse = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Collapse, _Component);
  var _super = _createSuper(Collapse);
  function Collapse(props) {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, Collapse);
    _this = _super.call(this, props);
    // class fields
    _this.collapse = null;
    // class fields
    _this.currentKey = null;
    var activeKey = props.activeKey,
      defaultActiveKey = props.defaultActiveKey,
      statusList = props.statusList;
    var currentActiveKey = defaultActiveKey;
    if ('activeKey' in props) {
      currentActiveKey = activeKey;
    }
    _this.state = {
      // 已激活面板的key
      activeKey: toArray(currentActiveKey),
      statusList: statusList || (0, _fill["default"])(_context = new Array(_this.props.children.length)).call(_context, true),
      prevProps: props
    };
    // 当前点击的key
    _this.currentKey = null;
    return _this;
  }
  (0, _createClass2["default"])(Collapse, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      this.scrollToHeader();
    }
  }, {
    key: "onClickItem",
    value: function onClickItem(key) {
      var _this2 = this;
      return function () {
        var activeKey = _this2.state.activeKey;
        // 手风琴效果,只展开一项,收起其他项
        if (_this2.props.accordion) {
          activeKey = activeKey[0] === key ? [] : [key];
        } else {
          // @ts-ignore
          activeKey = (0, _toConsumableArray2["default"])(activeKey);
          var index = (0, _indexOf["default"])(activeKey).call(activeKey, key);
          var isActive = index > -1;
          if (isActive) {
            // remove active state
            (0, _splice["default"])(activeKey).call(activeKey, index, 1);
          } else {
            activeKey.push(key);
          }
        }
        // 当前点击的key
        _this2.currentKey = key;
        _this2.setActiveKey(activeKey);
      };
    }
  }, {
    key: "onCloseItem",
    value: function onCloseItem(key) {
      var _this3 = this;
      return function () {
        var _this3$props = _this3.props,
          children = _this3$props.children,
          statusList = _this3$props.statusList;
        var keyList = (0, _map["default"])(_react.Children).call(_react.Children, children, function (child, index) {
          return child.key || String(index);
        });
        var index = (0, _findIndex["default"])(keyList).call(keyList, function (item) {
          return key == item;
        });
        statusList[index] = false;
        _this3.props.close(statusList);
      };
    }
  }, {
    key: "getItems",
    value: function getItems() {
      var _this4 = this;
      var activeKey = this.state.activeKey;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        accordion = _this$props.accordion,
        showClose = _this$props.showClose;
      return (0, _map["default"])(_react.Children).call(_react.Children, this.props.children, function (child, index) {
        var _context2, _context3;
        if (!_this4.state.statusList[index]) {
          return null;
        }
        // If there is no key provide, use the panel order as default key
        var key = child.key || String(index);
        var header = child.props.header;
        var isActive = false;
        if (accordion) {
          isActive = activeKey[0] === key;
        } else {
          isActive = (0, _indexOf["default"])(activeKey).call(activeKey, key) > -1;
        }
        var props = {
          itemKey: function itemKey(el) {
            return _this4[key] = el;
          },
          header: header,
          showClose: showClose,
          isActive: isActive,
          prefixCls: prefixCls,
          children: child.props.children,
          onItemClick: (0, _bind["default"])(_context2 = _this4.onClickItem(key)).call(_context2, _this4),
          onCloseItem: (0, _bind["default"])(_context3 = _this4.onCloseItem(key)).call(_context3, _this4)
        };
        return /*#__PURE__*/_react["default"].cloneElement(child, props);
      });
    }
  }, {
    key: "setActiveKey",
    value: function setActiveKey(activeKey) {
      if (!('activeKey' in this.props)) {
        this.setState({
          activeKey: activeKey
        });
      }
      this.props.onChange(this.props.accordion ? activeKey[0] : activeKey);
    }
  }, {
    key: "scrollToHeader",
    value: function scrollToHeader() {
      var activeKey = this.state.activeKey;
      var isScrollToHeader = this.props.isScrollToHeader;
      var currentKey = this.currentKey;
      var collapse = this.collapse;
      if (!isScrollToHeader || !currentKey || !(0, _includes["default"])(activeKey).call(activeKey, currentKey)) {
        return;
      }
      var el = this[currentKey];
      var collapseRect = collapse && collapse.getBoundingClientRect();
      var elRect = el && el.getBoundingClientRect();
      var diff = collapse.scrollHeight - collapse.clientHeight;
      if (collapseRect && elRect) {
        var toTop = collapse.scrollTop + elRect.top - collapseRect.top;
        if (toTop < diff) {
          collapse.scrollTop = toTop;
        }
      }
      this.currentKey = null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this5 = this;
      var _this$props2 = this.props,
        prefixCls = _this$props2.prefixCls,
        className = _this$props2.className,
        isScrollToHeader = _this$props2.isScrollToHeader,
        bordered = _this$props2.bordered;
      var clsObj = {};
      var style = null;
      clsObj[prefixCls] = true;
      if (className) {
        clsObj[className] = true;
      }
      if (!bordered) {
        clsObj["".concat(prefixCls, "-borderless")] = true;
      }
      if (isScrollToHeader) {
        style = {
          overflowY: 'auto',
          overflowX: 'hidden'
        };
      }
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(clsObj),
        ref: function ref(node) {
          return _this5.collapse = node;
        },
        style: style
      }, this.getItems());
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      var prevProps = prevState.prevProps;
      var newState = {
        prevProps: nextProps
      };
      if ('activeKey' in nextProps) {
        newState.activeKey = toArray(nextProps.activeKey);
      }
      if (nextProps.statusList !== prevProps.statusList) {
        newState.statusList = nextProps.statusList;
      }
      return newState;
    }
  }]);
  return Collapse;
}(_react.Component);
Collapse.propTypes = {
  children: _propTypes["default"].node,
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  defaultActiveKey: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
  activeKey: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].arrayOf(_propTypes["default"].string)]),
  // 是否开启功能：点击header后将header置顶
  isScrollToHeader: _propTypes["default"].bool,
  // 是否开启功能：手风琴效果，既每次点击header只展开一项
  accordion: _propTypes["default"].bool,
  // 是否开启删除功能
  showClose: _propTypes["default"].bool,
  // 是否显示边框
  bordered: _propTypes["default"].bool,
  // 是否显示面板的状态数组
  statusList: _propTypes["default"].array,
  onChange: _propTypes["default"].func,
  close: _propTypes["default"].func
};
Collapse.defaultProps = {
  prefixCls: 'fishd-collapse',
  isScrollToHeader: false,
  accordion: false,
  showClose: false,
  bordered: true,
  onChange: function onChange(value) {},
  close: function close(e) {}
};
Collapse.Panel = _Panel["default"];
(0, _reactLifecyclesCompat.polyfill)(Collapse);
var _default = Collapse;
exports["default"] = _default;