"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _DateRangeBasePicker2 = _interopRequireDefault(require("./DateRangeBasePicker"));
var _DateRangePanel = _interopRequireDefault(require("./panel/DateRangePanel"));
var _TimeSelectPanel = _interopRequireDefault(require("./panel/TimeSelectPanel"));
var _TimePanel = _interopRequireDefault(require("./panel/TimePanel"));
var _TimePicker = require("./TimePicker");
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var DateRangePicker = /*#__PURE__*/function (_DateRangeBasePicker) {
  (0, _inherits2["default"])(DateRangePicker, _DateRangeBasePicker);
  var _super = _createSuper(DateRangePicker);
  // FIXME: props typing
  function DateRangePicker(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, DateRangePicker);
    _this = _super.call(this, props, props.showTime ? 'datetimerange' : 'daterange', {});
    _this.getFormatSeparator = function () {
      return _this.props.separator;
    };
    _this.onError = function (value) {
      return _this.props.onError && typeof _this.props.onError === 'function' ? _this.props.onError(value) : undefined;
    };
    return _this;
  }
  (0, _createClass2["default"])(DateRangePicker, [{
    key: "isDateValid",
    value: function isDateValid(value) {
      var dateValid = (0, _get2["default"])((0, _getPrototypeOf2["default"])(DateRangePicker.prototype), "isDateValid", this).call(this, value) && _DateRangePanel["default"].isValid(value, this.props.disabledDate);
      // 带时间的日期范围面板，需要检查时间的合法性
      if (this.props.showTime) {
        var startTime = value && value.length >= 2 ? value[0] : null;
        var endTime = value && value.length >= 2 ? value[1] : null;
        var startTimeSelectValid = startTime && this.props.startTimeSelectMode === 'TimeSelect' && _TimeSelectPanel["default"].isValid(this.dateToStr(startTime).split(' ')[1], this.props.startTimeSelectModeProps);
        var startTimePickerValid = startTime && this.props.startTimeSelectMode === 'TimePicker' && _TimePanel["default"].isValid(startTime, (0, _TimePicker.converSelectRange)({
          selectableRange: this.props.startTimeSelectableRange
        }));
        var endTimeSelectValid = endTime && this.props.endTimeSelectMode === 'TimeSelect' && _TimeSelectPanel["default"].isValid(this.dateToStr(endTime).split(' ')[1], this.props.endTimeSelectModeProps);
        var endTimePickerValid = endTime && this.props.endTimeSelectMode === 'TimePicker' && _TimePanel["default"].isValid(endTime, (0, _TimePicker.converSelectRange)({
          selectableRange: this.props.endTimeSelectableRange
        }));
        return dateValid && (startTimeSelectValid || startTimePickerValid) && (endTimeSelectValid || endTimePickerValid);
      } else {
        return dateValid;
      }
    }
  }, {
    key: "pickerPanel",
    value: function pickerPanel(state) {
      var _this2 = this;
      var value = state.value && this.isDateValid(state.value) ? state.value : null;
      return /*#__PURE__*/React.createElement(_Consumer["default"], {
        componentName: "DatePicker"
      }, function (Locales) {
        return /*#__PURE__*/(
          // @ts-ignore to much unmatched props
          React.createElement(_DateRangePanel["default"], (0, _assign["default"])({}, _this2.props, {
            value: value,
            onPick: _this2.onPicked,
            onCancelPicked: _this2.onCancelPicked,
            dateToStr: _this2.dateToStr
          }))
        );
      });
    }
  }], [{
    key: "propTypes",
    get: function get() {
      return (0, _assign["default"])({}, {
        separator: _propTypes["default"].string,
        yearCount: _propTypes["default"].number,
        shortcuts: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          text: _propTypes["default"].string.isRequired,
          onClick: _propTypes["default"].func.isRequired
        })),
        disabledDate: _propTypes["default"].func,
        firstDayOfWeek: _propTypes["default"].number,
        footer: _propTypes["default"].func,
        onError: _propTypes["default"].func
      }, _DateRangeBasePicker2["default"].propTypes);
    }
  }, {
    key: "defaultProps",
    get: function get() {
      return (0, _assign["default"])({}, _DateRangePanel["default"].defaultProps, _DateRangeBasePicker2["default"].defaultProps);
    }
  }]);
  return DateRangePicker;
}(_DateRangeBasePicker2["default"]);
exports["default"] = DateRangePicker;