"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Divider;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _classnames = _interopRequireDefault(require("classnames"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
function Divider(_a) {
  var _context, _context2, _classNames, _context3;
  var _a$prefixCls = _a.prefixCls,
    prefixCls = _a$prefixCls === void 0 ? 'fishd' : _a$prefixCls,
    _a$type = _a.type,
    type = _a$type === void 0 ? 'horizontal' : _a$type,
    _a$orientation = _a.orientation,
    orientation = _a$orientation === void 0 ? '' : _a$orientation,
    className = _a.className,
    children = _a.children,
    dashed = _a.dashed,
    textStyle = _a.textStyle,
    restProps = __rest(_a, ["prefixCls", "type", "orientation", "className", "children", "dashed", "textStyle"]);
  var orientationPrefix = orientation.length > 0 ? '-' + orientation : orientation;
  var classString = (0, _classnames["default"])(className, "".concat(prefixCls, "-divider"), (0, _concat["default"])(_context = "".concat(prefixCls, "-divider-")).call(_context, type), (_classNames = {}, (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context2 = "".concat(prefixCls, "-divider-with-text")).call(_context2, orientationPrefix), children), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-divider-dashed"), dashed), _classNames));
  //纵向文字仅支持字符串格式
  var verticalText = type === 'vertical' && children && (0, _map["default"])(_context3 = children.toString().split('')).call(_context3, function (text, i) {
    return /*#__PURE__*/_react["default"].createElement("span", {
      className: "".concat(prefixCls, "-divider-vertical-child"),
      key: i
    }, text);
  });
  return /*#__PURE__*/_react["default"].createElement("div", (0, _assign["default"])({
    className: classString
  }, restProps), children && /*#__PURE__*/_react["default"].createElement("span", {
    className: "".concat(prefixCls, "-divider-inner-text"),
    style: textStyle
  }, verticalText ? verticalText : children));
}