import React, { Component } from 'react';
interface EventMap {
    [key: string]: (...args: any[]) => any;
}
declare type Option = {
    [key: string]: any;
};
export interface EchartCoreProps {
    prefixCls?: string;
    option?: Option;
    opts?: Option;
    events?: EventMap;
    className?: string;
    style?: React.CSSProperties;
    theme?: string;
    notMerge?: boolean;
    lazyUpdate?: boolean;
    onChartReady?: () => void;
    loadingOption?: Option;
    showLoading?: boolean;
    echarts?: any;
}
export default class EchartCore extends Component<EchartCoreProps, any> {
    static propTypes: {
        prefixCls: any;
        option: any;
        opts: any;
        events: any;
        className: any;
        style: any;
        theme: any;
        notMerge: any;
        lazyUpdate: any;
        onChartReady: any;
        loadingOption: any;
        showLoading: any;
        echarts: any;
    };
    static defaultProps: {
        prefixCls: string;
        theme: string;
        echarts: {};
        notMerge: boolean;
        lazyUpdate: boolean;
        style: {
            height: string;
        };
        className: string;
        onChartReady: () => void;
        showLoading: boolean;
        loadingOption: any;
        onEvents: {};
        opts: {};
    };
    constructor(props: any);
    echarts_react: any;
    getInstance(): any;
    render(): JSX.Element;
}
export {};
