"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Tooltip = _interopRequireDefault(require("../Tooltip"));
var _EllipsisText = _interopRequireDefault(require("./EllipsisText"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
/* eslint react/no-did-mount-set-state: 0 */
/* eslint no-param-reassign: 0 */
// @ts-ignore
var isSupportLineClamp = document.body.style.webkitLineClamp !== undefined;
var Ellipsis = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Ellipsis, _React$Component);
  var _super = _createSuper(Ellipsis);
  function Ellipsis() {
    var _this;
    (0, _classCallCheck2["default"])(this, Ellipsis);
    _this = _super.apply(this, arguments);
    _this.state = {
      text: '',
      targetCount: 0,
      tooltipVisible: false
    };
    _this.getTargetNode = function () {
      var target;
      if (_this.props.width) {
        target = _this.widthNode;
      } else if (_this.props.lines && isSupportLineClamp) {
        target = _this.lineClampNode;
      }
      return target;
    };
    _this.computeLine = function () {
      var lines = _this.props.lines;
      if (lines && !isSupportLineClamp) {
        var text = _this.shadowChildren.innerText || _this.shadowChildren.textContent;
        var lineHeight = (0, _parseInt2["default"])(getComputedStyle(_this.root).lineHeight, 10);
        var targetHeight = lines * lineHeight;
        _this.content.style.height = "".concat(targetHeight, "px");
        var totalHeight = _this.shadowChildren.offsetHeight;
        var shadowNode = _this.shadow.firstChild;
        if (totalHeight <= targetHeight) {
          _this.setState({
            text: text,
            targetCount: text.length
          });
          return;
        }
        // bisection
        var len = text.length;
        var mid = Math.ceil(len / 2);
        var count = _this.bisection(targetHeight, mid, 0, len, text, shadowNode);
        _this.setState({
          text: text,
          targetCount: count
        });
      }
    };
    _this.bisection = function (th, m, b, e, text, shadowNode) {
      var suffix = '...';
      var mid = m;
      var end = e;
      var begin = b;
      shadowNode.innerHTML = text.substring(0, mid) + suffix;
      var sh = shadowNode.offsetHeight;
      if (sh <= th) {
        shadowNode.innerHTML = text.substring(0, mid + 1) + suffix;
        sh = shadowNode.offsetHeight;
        if (sh > th || mid === begin) {
          return mid;
        }
        begin = mid;
        if (end - begin === 1) {
          mid = 1 + begin;
        } else {
          mid = Math.floor((end - begin) / 2) + begin;
        }
        return _this.bisection(th, mid, begin, end, text, shadowNode);
      }
      if (mid - 1 < 0) {
        return mid;
      }
      shadowNode.innerHTML = text.substring(0, mid - 1) + suffix;
      sh = shadowNode.offsetHeight;
      if (sh <= th) {
        return mid - 1;
      }
      end = mid;
      mid = Math.floor((end - begin) / 2) + begin;
      return _this.bisection(th, mid, begin, end, text, shadowNode);
    };
    _this.handleRoot = function (n) {
      _this.root = n;
    };
    _this.handleContent = function (n) {
      _this.content = n;
    };
    _this.handleNode = function (n) {
      _this.node = n;
    };
    _this.handleShadow = function (n) {
      _this.shadow = n;
    };
    _this.handleShadowChildren = function (n) {
      _this.shadowChildren = n;
    };
    _this.handleTooltipVisibleChange = function (visible) {
      var node = _this.getTargetNode();
      if (!node) {
        return;
      }
      var tooltipVisible = visible && (node.offsetHeight < node.scrollHeight || node.offsetWidth < node.scrollWidth);
      _this.setState(function (state) {
        var shouldReset = state.tooltipVisible !== tooltipVisible;
        return shouldReset ? {
          tooltipVisible: tooltipVisible
        } : null;
      });
    };
    return _this;
  }
  (0, _createClass2["default"])(Ellipsis, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.node) {
        this.computeLine();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(perProps) {
      var _this$props = this.props,
        lines = _this$props.lines,
        children = _this$props.children;
      if (lines !== perProps.lines || children !== perProps.children) {
        this.computeLine();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
        _this2 = this,
        _context;
      var _this$state = this.state,
        text = _this$state.text,
        targetCount = _this$state.targetCount,
        tooltipVisible = _this$state.tooltipVisible;
      var _a = this.props,
        children = _a.children,
        lines = _a.lines,
        length = _a.length,
        width = _a.width,
        className = _a.className,
        tooltip = _a.tooltip,
        style = _a.style,
        fullWidthRecognition = _a.fullWidthRecognition,
        prefix = _a.prefix,
        tooltipProps = _a.tooltipProps,
        restProps = __rest(_a, ["children", "lines", "length", "width", "className", "tooltip", "style", "fullWidthRecognition", "prefix", "tooltipProps"]);
      var cls = (0, _classnames["default"])("".concat(prefix, "-ellipsis"), className, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefix, "-width-mode"), width), (0, _defineProperty2["default"])(_classNames, "".concat(prefix, "-line"), lines && !isSupportLineClamp), (0, _defineProperty2["default"])(_classNames, "".concat(prefix, "-lineClamp"), lines && isSupportLineClamp), _classNames));
      // 一种限制都没有返回原值
      if (!lines && !length && !width) {
        return /*#__PURE__*/React.createElement("span", (0, _assign["default"])({
          className: cls
        }, restProps), children);
      }
      // 宽度限制
      if (width) {
        var node = /*#__PURE__*/React.createElement("span", (0, _assign["default"])({
          ref: function ref(node) {
            return _this2.widthNode = node;
          },
          className: cls
        }, restProps, {
          style: (0, _assign["default"])((0, _assign["default"])({}, style), {
            maxWidth: width
          })
        }), children);
        return tooltip ? /*#__PURE__*/React.createElement(_Tooltip["default"], (0, _assign["default"])({}, tooltipProps, {
          overlayClassName: "".concat(prefix, "-tooltip"),
          title: children,
          visible: tooltipVisible,
          onVisibleChange: this.handleTooltipVisibleChange
        }), node) : node;
      }
      // 字数限制
      if (length) {
        return /*#__PURE__*/React.createElement(_EllipsisText["default"], (0, _assign["default"])({
          prefix: prefix,
          className: cls,
          tooltipProps: tooltipProps,
          length: length,
          text: children || '',
          tooltip: tooltip,
          fullWidthRecognition: fullWidthRecognition
        }, restProps));
      }
      //行数限制
      var id = "fishd-ellipsis-".concat((0, _concat["default"])(_context = "".concat(new Date().getTime())).call(_context, Math.floor(Math.random() * 100)));
      // support document.body.style.webkitLineClamp
      if (isSupportLineClamp) {
        var _context2;
        var _style = (0, _concat["default"])(_context2 = "#".concat(id, "{-webkit-line-clamp:")).call(_context2, lines, ";-webkit-box-orient: vertical;}");
        var _node = /*#__PURE__*/React.createElement("div", (0, _assign["default"])({
          ref: function ref(node) {
            return _this2.lineClampNode = node;
          },
          id: id,
          className: cls
        }, restProps), /*#__PURE__*/React.createElement("style", null, _style), children);
        return tooltip ? /*#__PURE__*/React.createElement(_Tooltip["default"], (0, _assign["default"])({}, tooltipProps, {
          overlayClassName: "".concat(prefix, "-tooltip"),
          title: children,
          visible: tooltipVisible,
          onVisibleChange: this.handleTooltipVisibleChange
        }), _node) : _node;
      }
      var childNode = /*#__PURE__*/React.createElement("span", {
        ref: this.handleNode
      }, targetCount > 0 && text.substring(0, targetCount), targetCount > 0 && targetCount < text.length && '...');
      return /*#__PURE__*/React.createElement("div", (0, _assign["default"])({}, restProps, {
        ref: this.handleRoot,
        className: cls
      }), /*#__PURE__*/React.createElement("div", {
        ref: this.handleContent
      }, tooltip ? /*#__PURE__*/React.createElement(_Tooltip["default"], {
        overlayClassName: "".concat(prefix, "-tooltip"),
        title: text
      }, childNode) : childNode, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "-shadow"),
        ref: this.handleShadowChildren
      }, children), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefix, "-shadow"),
        ref: this.handleShadow
      }, /*#__PURE__*/React.createElement("span", null, text))));
    }
  }]);
  return Ellipsis;
}(React.Component);
exports["default"] = Ellipsis;
Ellipsis.defaultProps = {
  prefix: 'fishd-ellipsis',
  fullWidthRecognition: false,
  tooltip: true,
  tooltipProps: {}
};
Ellipsis.propTypes = {
  prefix: _propTypes["default"].string,
  lines: _propTypes["default"].number,
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  length: _propTypes["default"].number,
  tooltip: _propTypes["default"].bool,
  tooltipProps: _propTypes["default"].object,
  fullWidthRecognition: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  style: _propTypes["default"].object,
  children: _propTypes["default"].node
};