"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Button = _interopRequireDefault(require("../Button"));
require("./style/index.less");
var _Consumer = _interopRequireDefault(require("../Config/Consumer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var noop = function noop() {};
var LoadMore = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(LoadMore, _React$Component);
  var _super = _createSuper(LoadMore);
  function LoadMore(props) {
    (0, _classCallCheck2["default"])(this, LoadMore);
    return _super.call(this, props);
  }
  (0, _createClass2["default"])(LoadMore, [{
    key: "render",
    value: function render() {
      var _a = this.props,
        defaultText = _a.defaultText,
        onLoadMore = _a.onLoadMore,
        status = _a.status,
        buttonSize = _a.buttonSize,
        loadingText = _a.loadingText,
        errorText = _a.errorText,
        endText = _a.endText,
        extraCls = _a.extraCls,
        otherProps = __rest(_a, ["defaultText", "onLoadMore", "status", "buttonSize", "loadingText", "errorText", "endText", "extraCls"]);
      return /*#__PURE__*/_react["default"].createElement(_Consumer["default"], {
        componentName: "LoadMore"
      }, function (Locale) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('fishd-loadmore', (0, _defineProperty2["default"])({}, "".concat(extraCls), !!extraCls))
        }, status === 'end' ? /*#__PURE__*/_react["default"].createElement("span", {
          className: "z-load-end"
        }, Locale.endText) : /*#__PURE__*/_react["default"].createElement(_Button["default"], (0, _assign["default"])({
          size: buttonSize,
          onClick: onLoadMore,
          loading: status === 'loading'
        }, otherProps), function () {
          switch (status) {
            case 'default':
              return Locale.defaultText;
              break;
            case 'loading':
              return Locale.loadingText;
              break;
            case 'error':
              return Locale.errorText;
              break;
            case 'end':
              return Locale.endText;
          }
        }()));
      });
    }
  }]);
  return LoadMore;
}(_react["default"].Component);
exports["default"] = LoadMore;
LoadMore.propTypes = {
  onLoadMore: _propTypes["default"].func,
  className: _propTypes["default"].string,
  status: _propTypes["default"].string,
  defaultText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  loadingText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  errorText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  endText: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  extraCls: _propTypes["default"].string,
  buttonSize: _propTypes["default"].string
};
LoadMore.defaultProps = {
  onLoadMore: noop,
  status: 'default',
  defaultText: '查看更多',
  loadingText: '加载中',
  errorText: '加载失败，请重试',
  endText: '没有更多了',
  buttonSize: 'default'
};