declare type keyString = {
    [propName: string]: string;
};
declare type keyStringObj = {
    [propName: string]: string | object;
};
export interface LocaleProperties {
    locale: string;
    LoadMore?: keyString;
    AudioPlayer?: keyString;
    AutoComplete?: keyString;
    Cascader?: keyString;
    global?: keyString;
    Table?: keyString;
    Modal?: keyString;
    Guide?: keyString;
    List?: keyString;
    DatePicker?: keyStringObj;
    Spin?: keyString;
    RichEditor?: keyString;
    Pagination?: keyString;
    VideoViewer?: keyString;
    Select?: keyString;
    Transfer?: keyString;
    TreeSelect?: keyString;
    Upload?: keyString;
}
declare const Locale: {
    zh_CN: LocaleProperties;
    en_US: LocaleProperties;
    zh_TW: LocaleProperties;
};
export default Locale;
