"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var DOMWrap = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(DOMWrap, _React$Component);
  var _super = _createSuper(DOMWrap);
  function DOMWrap() {
    (0, _classCallCheck2["default"])(this, DOMWrap);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(DOMWrap, [{
    key: "render",
    value: function render() {
      var props = (0, _assign["default"])({}, this.props);
      if (!props.visible) {
        props.className += " ".concat(props.hiddenClassName);
      }
      var Tag = props.tag;
      delete props.tag;
      delete props.hiddenClassName;
      delete props.visible;
      return /*#__PURE__*/_react["default"].createElement(Tag, (0, _assign["default"])({}, props));
    }
  }]);
  return DOMWrap;
}(_react["default"].Component);
exports["default"] = DOMWrap;
DOMWrap.propTypes = {
  tag: _propTypes["default"].string,
  hiddenClassName: _propTypes["default"].string,
  visible: _propTypes["default"].bool
};
DOMWrap.defaultProps = {
  tag: 'div',
  className: ''
};