"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _Modal = _interopRequireDefault(require("./Modal"));
var _confirm = _interopRequireDefault(require("./confirm"));
require("./style/index.less");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
_Modal["default"].info = function (props) {
  var config = (0, _assign["default"])({
    type: 'info',
    iconType: 'hints-notification',
    okCancel: false
  }, props);
  return (0, _confirm["default"])(config);
};
_Modal["default"].success = function (props) {
  var config = (0, _assign["default"])({
    type: 'success',
    iconType: 'hints-success',
    okCancel: false
  }, props);
  return (0, _confirm["default"])(config);
};
_Modal["default"].error = function (props) {
  var config = (0, _assign["default"])({
    type: 'error',
    iconType: 'hints-error',
    okCancel: false
  }, props);
  return (0, _confirm["default"])(config);
};
_Modal["default"].warning = _Modal["default"].warn = function (props) {
  var config = (0, _assign["default"])({
    type: 'warning',
    iconType: 'hints-warning',
    okCancel: false
  }, props);
  return (0, _confirm["default"])(config);
};
_Modal["default"].confirm = function (props) {
  var config = (0, _assign["default"])({
    type: 'confirm',
    okCancel: true
  }, props);
  return (0, _confirm["default"])(config);
};
var _default = _Modal["default"];
exports["default"] = _default;