"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _quill = require("../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Embed = _quill.Quill["import"]('blots/embed');
var EmojiBlot = /*#__PURE__*/function (_Embed) {
  (0, _inherits2["default"])(EmojiBlot, _Embed);
  var _super = _createSuper(EmojiBlot);
  function EmojiBlot() {
    (0, _classCallCheck2["default"])(this, EmojiBlot);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(EmojiBlot, null, [{
    key: "create",
    value: function create(value) {
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(EmojiBlot), "create", this).call(this);
      if (value.type === 'defaultEmoji') {
        node.setAttribute('class', 'portrait_icon');
        node.setAttribute('data-id', value.id);
      } else if (value.type === 'customEmoji') {
        node.setAttribute('class', 'custom_icon');
      }
      node.setAttribute('data-type', value.type);
      node.setAttribute('alt', value.alt);
      node.setAttribute('src', value.src);
      node.setAttribute('width', value.width);
      node.setAttribute('height', value.height);
      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      return {
        id: node.getAttribute('data-id'),
        type: node.getAttribute('data-type'),
        alt: node.getAttribute('alt'),
        src: node.getAttribute('src'),
        width: node.getAttribute('width'),
        height: node.getAttribute('height')
      };
    }
  }, {
    key: "value",
    value: function value(node) {
      return {
        id: node.getAttribute('data-id'),
        type: node.getAttribute('data-type'),
        alt: node.getAttribute('alt'),
        src: node.getAttribute('src'),
        width: node.getAttribute('width'),
        height: node.getAttribute('height')
      };
    }
  }]);
  return EmojiBlot;
}(Embed);
EmojiBlot.blotName = 'emoji';
EmojiBlot.tagName = 'img';
var _default = EmojiBlot;
exports["default"] = _default;