"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _quill = require("../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Inline = _quill.Quill["import"]('blots/inline');
var setAttr = function setAttr(node, value) {
  if (typeof value == 'string' || typeof value == 'number') {
    node.style.fontSize = value;
  } else if (Object.prototype.toString.call(value) == '[object Object]') {
    if (value.editable != null) {
      node.setAttribute('contenteditable', value.editable);
    }
    if (value.fontSize != null) {
      node.style.fontSize = value.fontSize;
    }
    if (value.lineHeight) {
      node.style.lineHeight = value.lineHeight;
      node.style.display = 'inline-block';
    }
  }
  return node;
};
// 自定义span标签的字体大小和contenteditable属性
var CustomAttrBlot = /*#__PURE__*/function (_Inline) {
  (0, _inherits2["default"])(CustomAttrBlot, _Inline);
  var _super = _createSuper(CustomAttrBlot);
  function CustomAttrBlot() {
    (0, _classCallCheck2["default"])(this, CustomAttrBlot);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(CustomAttrBlot, [{
    key: "format",
    value: function format(name, value) {
      if (name !== this.statics.blotName || !value) {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(CustomAttrBlot.prototype), "format", this).call(this, name, value);
      } else {
        setAttr(this.domNode, value);
      }
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(CustomAttrBlot), "create", this).call(this);
      return setAttr(node, value);
    }
  }, {
    key: "formats",
    value: function formats(node) {
      // 返回值不能为 null（Fix bug: Cannot read property 'mutations' of undefined）
      return {
        lineHeight: node.style.lineHeight,
        fontSize: node.style.fontSize,
        editable: node.getAttribute('contenteditable')
      };
    }
  }]);
  return CustomAttrBlot;
}(Inline);
CustomAttrBlot.blotName = 'customAttr';
CustomAttrBlot.tagName = 'span';
var _default = CustomAttrBlot;
exports["default"] = _default;