"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _typeof2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/typeof"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));
var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));
var _quill = require("../quill");
var _image = require("./image");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var BlockEmbed = _quill.Quill["import"]('blots/block/embed');
var Video = /*#__PURE__*/function (_BlockEmbed) {
  (0, _inherits2["default"])(Video, _BlockEmbed);
  var _super = _createSuper(Video);
  function Video() {
    (0, _classCallCheck2["default"])(this, Video);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Video, [{
    key: "format",
    value: function format(name, value) {
      (0, _get2["default"])((0, _getPrototypeOf2["default"])(Video.prototype), "format", this).call(this, name, value);
    }
  }], [{
    key: "create",
    value: function create(value) {
      var node = (0, _get2["default"])((0, _getPrototypeOf2["default"])(Video), "create", this).call(this, value);
      if (Object.prototype.toString.call(value) == '[object Object]') {
        var _context;
        // 默认带控制条
        if (value['controls'] === false) {
          delete value['controls'];
        } else {
          value['controls'] = true;
        }
        (0, _forEach["default"])(_context = (0, _keys["default"])(value)).call(_context, function (key) {
          var valType = (0, _typeof2["default"])(value[key]);
          if (valType == 'function' || valType == 'object') {
            return;
          }
          try {
            node.setAttribute(key, value[key]);
          } catch (e) {
            console.error(e); // eslint-disable-line
          }
        });
      }

      return node;
    }
  }, {
    key: "formats",
    value: function formats(node) {
      return (0, _image.getAttrs)(node);
    }
  }, {
    key: "value",
    value: function value(node) {
      return (0, _image.getAttrs)(node);
    }
  }]);
  return Video;
}(BlockEmbed);
Video.blotName = 'myVideo';
Video.className = 'ql-video';
Video.tagName = 'video';
var _default = Video;
exports["default"] = _default;