"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _quill = require("../quill");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Clipboard = _quill.Quill["import"]('modules/clipboard');
var Delta = _quill.Quill["import"]('delta');
var CustomClipboard = /*#__PURE__*/function (_Clipboard) {
  (0, _inherits2["default"])(CustomClipboard, _Clipboard);
  var _super = _createSuper(CustomClipboard);
  function CustomClipboard(quill, options) {
    (0, _classCallCheck2["default"])(this, CustomClipboard);
    return _super.call(this, quill, options);
  }
  (0, _createClass2["default"])(CustomClipboard, [{
    key: "onPaste",
    value: function onPaste(range, _ref) {
      var text = _ref.text,
        html = _ref.html;
      if (this.options) {
        var _this$options = this.options,
          pastePlainText = _this$options.pastePlainText,
          pasteFormater = _this$options.pasteFormater;
        var newText = text;
        var newHtml = html ? html : text; // fix: empty html string on Windows
        if (pastePlainText) {
          newHtml = text;
          if (pasteFormater) {
            newHtml = pasteFormater(newHtml);
          }
          newText = newHtml.innerText ? newHtml.innerText() : newHtml;
          var delta = new Delta().retain(range.index)["delete"](range.length).insert(newText),
            index = newText.length + range.index,
            length = 0;
          this.quill.updateContents(delta, 'silent');
          this.quill.setSelection(index, length, 'silent');
          this.quill.scrollIntoView();
        } else if (pasteFormater) {
          newHtml = pasteFormater(newHtml);
          newText = newHtml.innerText ? newHtml.innerText() : newHtml;
          (0, _get2["default"])((0, _getPrototypeOf2["default"])(CustomClipboard.prototype), "onPaste", this).call(this, range, {
            text: newText,
            html: newHtml
          });
        } else {
          (0, _get2["default"])((0, _getPrototypeOf2["default"])(CustomClipboard.prototype), "onPaste", this).call(this, range, {
            text: text,
            html: html
          });
        }
      } else {
        (0, _get2["default"])((0, _getPrototypeOf2["default"])(CustomClipboard.prototype), "onPaste", this).call(this, range, {
          text: text,
          html: html
        });
      }
    }
  }]);
  return CustomClipboard;
}(Clipboard);
var _default = CustomClipboard;
exports["default"] = _default;