"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AlignStyle = exports.AlignClass = exports.AlignAttribute = void 0;
var _parchment = require("parchment");
var config = {
  scope: _parchment.Scope.BLOCK,
  whitelist: ['right', 'center', 'justify']
};
var AlignAttribute = new _parchment.Attributor('align', 'align', config);
exports.AlignAttribute = AlignAttribute;
var AlignClass = new _parchment.ClassAttributor('align', 'ql-align', config);
exports.AlignClass = AlignClass;
var AlignStyle = new _parchment.StyleAttributor('align', 'text-align', config);
exports.AlignStyle = AlignStyle;