"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DirectionStyle = exports.DirectionClass = exports.DirectionAttribute = void 0;
var _parchment = require("parchment");
var config = {
  scope: _parchment.Scope.BLOCK,
  whitelist: ['rtl']
};
var DirectionAttribute = new _parchment.Attributor('direction', 'dir', config);
exports.DirectionAttribute = DirectionAttribute;
var DirectionClass = new _parchment.ClassAttributor('direction', 'ql-direction', config);
exports.DirectionClass = DirectionClass;
var DirectionStyle = new _parchment.StyleAttributor('direction', 'direction', config);
exports.DirectionStyle = DirectionStyle;