"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SizeStyle = exports.SizeClass = void 0;
var _parchment = require("parchment");
var SizeClass = new _parchment.ClassAttributor('size', 'ql-size', {
  scope: _parchment.Scope.INLINE,
  whitelist: ['small', 'large', 'huge']
});
exports.SizeClass = SizeClass;
var SizeStyle = new _parchment.StyleAttributor('size', 'font-size', {
  scope: _parchment.Scope.INLINE,
  whitelist: ['10px', '18px', '32px']
});
exports.SizeStyle = SizeStyle;