import * as React from 'react';
import Step, { StepProps } from './Step';
declare type StepsProps = {
    direction?: string;
    labelPlacement?: any;
    size?: string;
    current?: number;
    initial?: number;
} & StepProps;
interface StepsState {
    flexSupported: boolean;
    lastStepOffsetWidth: number;
}
export default class Steps extends React.Component<StepsProps, StepsState> {
    static propTypes: {
        prefixCls: any;
        className: any;
        iconPrefix: any;
        direction: any;
        labelPlacement: any;
        children: any;
        status: any;
        size: any;
        progressDot: any;
        style: any;
        initial: any;
        current: any;
        icons: any;
    };
    static defaultProps: {
        prefixCls: string;
        iconPrefix: string;
        direction: string;
        labelPlacement: string;
        initial: number;
        current: number;
        status: string;
        size: string;
        progressDot: boolean;
    };
    static Step: typeof Step;
    private calcTimeout;
    constructor(props: any);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    calcStepOffsetWidth: () => any;
    render(): JSX.Element;
}
export {};
