import * as React from 'react';
import { CheckboxChangeEvent } from '../Checkbox';
import { SelectionCheckboxAllProps, SelectionCheckboxAllState, SelectionItem } from './interface';
declare class SelectionCheckboxAll<T> extends React.Component<SelectionCheckboxAllProps<T>, SelectionCheckboxAllState> {
    unsubscribe: () => void;
    defaultSelections: SelectionItem[];
    static getDerivedStateFromProps(nextProps: any, prevState: any): SelectionCheckboxAllState;
    constructor(props: SelectionCheckboxAllProps<T>);
    componentDidMount(): void;
    componentWillUnmount(): void;
    subscribe(): void;
    handleSelectAllChange: (e: CheckboxChangeEvent) => void;
    renderMenus(selections: SelectionItem[]): JSX.Element[];
    render(): JSX.Element;
}
export default SelectionCheckboxAll;
