"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/get-own-property-symbols"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _classnames = _interopRequireDefault(require("classnames"));
var _omit = _interopRequireDefault(require("omit.js"));
var _reactLifecyclesCompat = require("react-lifecycles-compat");
var _index = _interopRequireDefault(require("../Icon/index"));
var _CheckableTag = _interopRequireDefault(require("./CheckableTag"));
require("./style/index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && (0, _indexOf["default"])(e).call(e, p) < 0) t[p] = s[p];
  if (s != null && typeof _getOwnPropertySymbols["default"] === "function") for (var i = 0, p = (0, _getOwnPropertySymbols["default"])(s); i < p.length; i++) {
    if ((0, _indexOf["default"])(e).call(e, p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var Tag = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Tag, _React$Component);
  var _super = _createSuper(Tag);
  function Tag() {
    var _this;
    (0, _classCallCheck2["default"])(this, Tag);
    _this = _super.apply(this, arguments);
    _this.state = {
      closing: false,
      closed: false,
      visible: true
    };
    _this.handleIconClick = function (e) {
      var onClose = _this.props.onClose;
      if (onClose) {
        onClose(e);
      }
      if (e.defaultPrevented || 'visible' in _this.props) {
        return;
      }
      _this.setState({
        visible: false
      });
    };
    _this.close = function () {
      if (_this.state.closing || _this.state.closed) {
        return;
      }
      var dom = ReactDOM.findDOMNode((0, _assertThisInitialized2["default"])(_this));
      dom.style.width = "".concat(dom.getBoundingClientRect().width, "px");
      // It's Magic Code, don't know why
      dom.style.width = "".concat(dom.getBoundingClientRect().width, "px");
      _this.setState({
        closing: true
      });
    };
    _this.show = function () {
      _this.setState({
        closed: false
      });
    };
    _this.animationEnd = function (_, existed) {
      if (!existed && !_this.state.closed) {
        _this.setState({
          closed: true,
          closing: false
        });
        var afterClose = _this.props.afterClose;
        if (afterClose) {
          afterClose();
        }
      } else {
        _this.setState({
          closed: false
        });
      }
    };
    return _this;
  }
  (0, _createClass2["default"])(Tag, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(_prevProps, prevState) {
      if (prevState.visible && !this.state.visible) {
        this.close();
      } else if (!prevState.visible && this.state.visible) {
        this.show();
      }
    }
  }, {
    key: "isPresetColor",
    value: function isPresetColor(color) {
      return false;
      // if (!color) { return false; }
      // return (
      //   /^(pink|red|yellow|orange|cyan|green|blue|purple|geekblue|magenta|volcano|gold|lime)(-inverse)?$/
      //   .test(color)
      // );
    }
  }, {
    key: "render",
    value: function render() {
      var _context, _classNames;
      var _a = this.props,
        prefixCls = _a.prefixCls,
        closable = _a.closable,
        color = _a.color,
        className = _a.className,
        children = _a.children,
        style = _a.style,
        autoShowClose = _a.autoShowClose,
        otherProps = __rest(_a, ["prefixCls", "closable", "color", "className", "children", "style", "autoShowClose"]);
      var isPresetColor = this.isPresetColor(color);
      var classString = (0, _classnames["default"])(prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, (0, _concat["default"])(_context = "".concat(prefixCls, "-")).call(_context, color), isPresetColor), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-has-color"), color && !isPresetColor), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-close"), this.state.closing), _classNames), className);
      // fix https://fb.me/react-unknown-prop
      var divProps = (0, _omit["default"])(otherProps, ['onClose', 'afterClose', 'visible']);
      var tagStyle = (0, _assign["default"])({
        backgroundColor: color && !isPresetColor ? color : null
      }, style);
      var closeIcon = null;
      if (closable) {
        if (autoShowClose) {
          closeIcon = /*#__PURE__*/React.createElement(_index["default"], {
            type: "close-modal-line",
            onClick: this.handleIconClick
          });
        } else {
          closeIcon = /*#__PURE__*/React.createElement(_index["default"], {
            type: "close-modal-line",
            onClick: this.handleIconClick,
            className: "invisible"
          });
        }
      }
      var tag = this.state.closed ? null : /*#__PURE__*/React.createElement("div", (0, _assign["default"])({
        "data-show": !this.state.closing
      }, divProps, {
        className: classString,
        style: tagStyle
      }), children, closeIcon);
      return /*#__PURE__*/React.createElement(_rcAnimate["default"], {
        component: "",
        showProp: "data-show",
        transitionName: "".concat(prefixCls, "-zoom"),
        transitionAppear: true,
        onEnd: this.animationEnd
      }, tag);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps) {
      return 'visible' in nextProps ? {
        visible: nextProps.visible
      } : null;
    }
  }]);
  return Tag;
}(React.Component);
Tag.CheckableTag = _CheckableTag["default"];
Tag.defaultProps = {
  prefixCls: 'fishd-tag',
  closable: false,
  autoShowClose: true
};
(0, _reactLifecyclesCompat.polyfill)(Tag);
var _default = Tag;
exports["default"] = _default;