"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/defineProperty"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));
var _setTimeout2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-timeout"));
var _filter = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/filter"));
var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));
var _every = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/every"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));
var _trim = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/trim"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var ReactDOM = _interopRequireWildcard(require("react-dom"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Checkbox = _interopRequireDefault(require("../Checkbox"));
var _PureRenderMixin = _interopRequireDefault(require("../Checkbox/src/PureRenderMixin"));
var _Search = _interopRequireDefault(require("./Search"));
var _Item = _interopRequireDefault(require("./Item"));
var _rcAnimate = _interopRequireDefault(require("rc-animate"));
var _triggerEvent = _interopRequireDefault(require("../../utils/triggerEvent"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
// case sensitive
function isIEorEDGE() {
  return document.documentMode || /Edge/.test(navigator.userAgent);
}
function noop() {}
function isRenderResultPlainObject(result) {
  return result && ! /*#__PURE__*/React.isValidElement(result) && Object.prototype.toString.call(result) === '[object Object]';
}
var TransferList = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(TransferList, _React$Component);
  var _super = _createSuper(TransferList);
  function TransferList(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, TransferList);
    _this = _super.call(this, props);
    _this.handleSelect = function (selectedItem, direction) {
      var _this$props = _this.props,
        checkedKeys = _this$props.checkedKeys,
        mode = _this$props.mode;
      if (mode === 'single') {
        if (direction === 'right') {
          return;
        }
        _this.props.handleSelect(selectedItem, true);
      } else {
        var result = (0, _some["default"])(checkedKeys).call(checkedKeys, function (key) {
          return key === selectedItem.key;
        });
        _this.props.handleSelect(selectedItem, !result);
      }
    };
    // single模式下，点击目标列表中的关闭按钮
    _this.handleClose = function (selectedItem) {
      _this.props.handleClose(selectedItem);
    };
    _this.handleFilter = function (e) {
      _this.props.handleFilter(e);
      if (!e.target.value) {
        return;
      }
      // Manually trigger scroll event for lazy search bug
      // https://github.com/ant-design/ant-design/issues/5631
      _this.triggerScrollTimer = (0, _setTimeout2["default"])(function () {
        var transferNode = ReactDOM.findDOMNode((0, _assertThisInitialized2["default"])(_this));
        var listNode = transferNode.querySelectorAll('.fishd-transfer-list-content')[0];
        if (listNode) {
          (0, _triggerEvent["default"])(listNode, 'scroll');
        }
      }, 0);
      _this.fixIERepaint();
    };
    _this.handleClear = function () {
      _this.props.handleClear();
      _this.fixIERepaint();
    };
    _this.matchFilter = function (text, item) {
      var _this$props2 = _this.props,
        filter = (0, _filter["default"])(_this$props2),
        filterOption = _this$props2.filterOption;
      if (filterOption) {
        return filterOption(filter, item);
      }
      return (0, _indexOf["default"])(text).call(text, filter) >= 0;
    };
    _this.renderItem = function (item) {
      var _this$props$render = _this.props.render,
        render = _this$props$render === void 0 ? noop : _this$props$render;
      var renderResult = render(item);
      var isRenderResultPlain = isRenderResultPlainObject(renderResult);
      return {
        renderedText: isRenderResultPlain ? renderResult.value : renderResult,
        renderedEl: isRenderResultPlain ? renderResult.label : renderResult
      };
    };
    _this.saveNotFoundRef = function (node) {
      _this.notFoundNode = node;
    };
    _this.state = {
      mounted: false
    };
    return _this;
  }
  (0, _createClass2["default"])(TransferList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;
      this.timer = (0, _setTimeout2["default"])(function () {
        _this2.setState({
          mounted: true
        });
      }, 0);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      clearTimeout(this.triggerScrollTimer);
      clearTimeout(this.fixIERepaintTimer);
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      return _PureRenderMixin["default"].shouldComponentUpdate.apply(this, args);
    }
  }, {
    key: "getCheckStatus",
    value: function getCheckStatus(filteredDataSource) {
      var checkedKeys = this.props.checkedKeys;
      if (checkedKeys.length === 0) {
        return 'none';
      } else if ((0, _every["default"])(filteredDataSource).call(filteredDataSource, function (item) {
        return (0, _indexOf["default"])(checkedKeys).call(checkedKeys, item.key) >= 0;
      })) {
        return 'all';
      }
      return 'part';
    }
    // Fix IE/Edge repaint
    // https://github.com/ant-design/ant-design/issues/9697
    // https://stackoverflow.com/q/27947912/3040605
  }, {
    key: "fixIERepaint",
    value: function fixIERepaint() {
      var _this3 = this;
      if (!isIEorEDGE()) {
        return;
      }
      this.fixIERepaintTimer = (0, _setTimeout2["default"])(function () {
        if (_this3.notFoundNode) {
          // eslint-disable-next-line no-self-assign
          _this3.notFoundNode.className = _this3.notFoundNode.className;
        }
      }, 0);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this,
        _context,
        _context2;
      var _this$props3 = this.props,
        mode = _this$props3.mode,
        direction = _this$props3.direction,
        prefixCls = _this$props3.prefixCls,
        dataSource = _this$props3.dataSource,
        titleText = _this$props3.titleText,
        checkedKeys = _this$props3.checkedKeys,
        lazy = _this$props3.lazy,
        _this$props3$body = _this$props3.body,
        body = _this$props3$body === void 0 ? noop : _this$props3$body,
        _this$props3$footer = _this$props3.footer,
        footer = _this$props3$footer === void 0 ? noop : _this$props3$footer,
        showSearch = _this$props3.showSearch,
        style = _this$props3.style,
        filter = (0, _filter["default"])(_this$props3),
        searchPlaceholder = _this$props3.searchPlaceholder,
        notFoundContent = _this$props3.notFoundContent,
        itemUnit = _this$props3.itemUnit,
        itemsUnit = _this$props3.itemsUnit,
        onScroll = _this$props3.onScroll;
      // Custom Layout
      var footerDom = footer((0, _assign["default"])({}, this.props));
      var bodyDom = body((0, _assign["default"])({}, this.props));
      var listCls = (0, _classnames["default"])(prefixCls, (0, _defineProperty2["default"])({}, "".concat(prefixCls, "-with-footer"), !!footerDom));
      var filteredDataSource = [];
      var totalDataSource = [];
      var showItems = (0, _map["default"])(dataSource).call(dataSource, function (item) {
        var _this4$renderItem = _this4.renderItem(item),
          renderedText = _this4$renderItem.renderedText,
          renderedEl = _this4$renderItem.renderedEl;
        if (filter && (0, _trim["default"])(filter).call(filter) && !_this4.matchFilter(renderedText, item)) {
          return null;
        }
        // all show items
        totalDataSource.push(item);
        if (!item.disabled) {
          // response to checkAll items
          filteredDataSource.push(item);
        }
        var checked = (0, _indexOf["default"])(checkedKeys).call(checkedKeys, item.key) >= 0;
        return /*#__PURE__*/React.createElement(_Item["default"], {
          mode: mode,
          direction: direction,
          key: item.key,
          item: item,
          lazy: lazy,
          renderedText: renderedText,
          renderedEl: renderedEl,
          checked: checked,
          prefixCls: prefixCls,
          onClick: _this4.handleSelect,
          onClose: _this4.handleClose
        });
      });
      var unit = dataSource.length > 1 ? itemsUnit : itemUnit;
      var search = showSearch ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-body-search-wrapper")
      }, /*#__PURE__*/React.createElement(_Search["default"], {
        prefixCls: "".concat(prefixCls, "-search"),
        onChange: this.handleFilter,
        handleClear: this.handleClear,
        placeholder: searchPlaceholder,
        value: filter
      })) : null;
      var listBody = bodyDom || /*#__PURE__*/React.createElement("div", {
        className: showSearch ? (0, _concat["default"])(_context = "".concat(prefixCls, "-body ")).call(_context, prefixCls, "-body-with-search") : "".concat(prefixCls, "-body")
      }, search, /*#__PURE__*/React.createElement(_rcAnimate["default"], {
        component: "ul",
        componentProps: {
          onScroll: onScroll
        },
        className: "".concat(prefixCls, "-content"),
        transitionName: this.state.mounted ? "".concat(prefixCls, "-content-item-highlight") : '',
        transitionLeave: false
      }, showItems), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-body-not-found"),
        ref: this.saveNotFoundRef
      }, notFoundContent));
      var listFooter = footerDom ? /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-footer")
      }, footerDom) : null;
      var checkStatus = this.getCheckStatus(filteredDataSource);
      var checkedAll = checkStatus === 'all';
      var checkAllCheckbox = /*#__PURE__*/React.createElement(_Checkbox["default"], {
        ref: "checkbox",
        checked: checkedAll,
        indeterminate: checkStatus === 'part',
        onChange: function onChange() {
          return _this4.props.handleSelectAll(filteredDataSource, checkedAll);
        }
      });
      return /*#__PURE__*/React.createElement("div", {
        className: listCls,
        style: style
      }, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-header")
      }, mode === 'multiple' ? checkAllCheckbox : null, /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-header-title")
      }, titleText), /*#__PURE__*/React.createElement("span", {
        className: "".concat(prefixCls, "-header-selected")
      }, mode === 'multiple' ? (0, _concat["default"])(_context2 = "".concat(checkedKeys.length, "/")).call(_context2, totalDataSource.length) : "".concat(totalDataSource.length), ' ', unit)), listBody, listFooter);
    }
  }]);
  return TransferList;
}(React.Component);
exports["default"] = TransferList;
TransferList.defaultProps = {
  dataSource: [],
  titleText: '',
  showSearch: false,
  render: noop,
  lazy: {}
};