"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var React = _interopRequireWildcard(require("react"));
var _Button = _interopRequireDefault(require("../Button"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var Operation = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(Operation, _React$Component);
  var _super = _createSuper(Operation);
  function Operation() {
    (0, _classCallCheck2["default"])(this, Operation);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Operation, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
        mode = _this$props.mode,
        arrowText = _this$props.arrowText,
        moveToLeft = _this$props.moveToLeft,
        moveToRight = _this$props.moveToRight,
        _this$props$leftArrow = _this$props.leftArrowText,
        leftArrowText = _this$props$leftArrow === void 0 ? '' : _this$props$leftArrow,
        _this$props$rightArro = _this$props.rightArrowText,
        rightArrowText = _this$props$rightArro === void 0 ? '' : _this$props$rightArro,
        leftActive = _this$props.leftActive,
        rightActive = _this$props.rightActive,
        className = _this$props.className,
        style = _this$props.style;
      if (mode === 'single') {
        return /*#__PURE__*/React.createElement("div", {
          className: className,
          style: style
        }, arrowText);
      } else {
        return /*#__PURE__*/React.createElement("div", {
          className: className,
          style: style
        }, /*#__PURE__*/React.createElement(_Button["default"], {
          type: "primary",
          size: "small",
          disabled: !rightActive,
          onClick: moveToRight,
          icon: "right"
        }, rightArrowText), /*#__PURE__*/React.createElement(_Button["default"], {
          type: "primary",
          size: "small",
          disabled: !leftActive,
          onClick: moveToLeft,
          icon: "left"
        }, leftArrowText));
      }
    }
  }]);
  return Operation;
}(React.Component);
exports["default"] = Operation;