"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _assign = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/assign"));
var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));
var React = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _omit = _interopRequireDefault(require("omit.js"));
var _Modal = _interopRequireDefault(require("../Modal"));
var _Icon = _interopRequireDefault(require("../Icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var VideoModal = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2["default"])(VideoModal, _React$Component);
  var _super = _createSuper(VideoModal);
  function VideoModal(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, VideoModal);
    _this = _super.call(this, props);
    _this.handleOnClose = function () {
      _this.props.onCancel();
    };
    return _this;
  }
  (0, _createClass2["default"])(VideoModal, [{
    key: "render",
    value: function render() {
      var _context;
      var _this$props = this.props,
        prefixCls = _this$props.prefixCls,
        children = _this$props.children,
        closable = _this$props.closable,
        _this$props$wrapClass = _this$props.wrapClassName,
        wrapClassName = _this$props$wrapClass === void 0 ? '' : _this$props$wrapClass,
        maskStyle = _this$props.maskStyle;
      var MODAL_WRAP = "".concat(prefixCls, "-modal-wrap");
      var otherProps = (0, _omit["default"])(this.props, ['prefixCls', 'wrapClassName', 'title', 'footer', 'maskStyle', 'closable']);
      var modalProps = (0, _assign["default"])((0, _assign["default"])({}, otherProps), {
        wrapClassName: (0, _concat["default"])(_context = "".concat(wrapClassName, " ")).call(_context, MODAL_WRAP),
        className: 'fishd-modal',
        maskStyle: maskStyle ? maskStyle : {
          backgroundColor: 'rgba(0,0,0,0.2)'
        },
        // 不显示Modal自带的关闭按钮
        closable: false,
        title: null,
        footer: null
      });
      var content = /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-content")
      }, children, /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-header")
      }, closable ? /*#__PURE__*/React.createElement(_Icon["default"], {
        type: "picture-close",
        className: "icon-close",
        onClick: this.handleOnClose
      }) : null));
      return /*#__PURE__*/React.createElement(_Modal["default"], (0, _assign["default"])({}, modalProps), /*#__PURE__*/React.createElement("div", {
        className: "".concat(prefixCls, "-inner")
      }, content));
    }
  }]);
  return VideoModal;
}(React.Component);
VideoModal.propTypes = {
  prefixCls: _propTypes["default"].string,
  children: _propTypes["default"].node,
  wrapClassName: _propTypes["default"].string,
  maskStyle: _propTypes["default"].object,
  visible: _propTypes["default"].bool.isRequired,
  draggable: _propTypes["default"].bool,
  mask: _propTypes["default"].bool,
  closable: _propTypes["default"].bool,
  onCancel: _propTypes["default"].func,
  afterClose: _propTypes["default"].func,
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
};
VideoModal.defaultProps = {
  prefixCls: 'fishd-video-modal',
  visible: false,
  draggable: false,
  closable: true,
  mask: false,
  width: 640
};
var _default = VideoModal;
exports["default"] = _default;