"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _index = _interopRequireDefault(require("../../Icon/index"));
var _index2 = _interopRequireDefault(require("../../Popover/index"));
var _index3 = _interopRequireDefault(require("../../Slider/index"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var FullScreen = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(FullScreen, _Component);
  var _super = _createSuper(FullScreen);
  function FullScreen(props) {
    var _this;
    (0, _classCallCheck2["default"])(this, FullScreen);
    _this = _super.call(this, props);
    // 音量值变化
    _this.handleChangeVolume = function (value) {
      _this.setState({
        currentVolume: value,
        lastVolume: value,
        isMuted: !value
      });
    };
    // 音量面板状态变化
    _this.onVolumeVisibleChange = function (state) {
      _this.setState({
        volumeOpen: state
      });
    };
    // 点击音量
    _this.handleVolumeClick = function () {
      var _this$state = _this.state,
        isMuted = _this$state.isMuted,
        lastVolume = _this$state.lastVolume;
      _this.setState({
        isMuted: !isMuted,
        currentVolume: isMuted ? lastVolume : 0
      });
    };
    _this.player = props.vjsComponent.player_;
    _this.state = {
      isMuted: false,
      currentVolume: (0, _parseInt2["default"])(_this.player.volume() * 100),
      lastVolume: (0, _parseInt2["default"])(_this.player.volume() * 100),
      volumeOpen: false // 是否打开音量控制
    };

    return _this;
  }
  (0, _createClass2["default"])(FullScreen, [{
    key: "render",
    value: function render() {
      var _this2 = this;
      var prefixCls = this.props.prefixCls;
      var _this$state2 = this.state,
        isMuted = _this$state2.isMuted,
        currentVolume = _this$state2.currentVolume,
        volumeOpen = _this$state2.volumeOpen;
      // 设置播放器音量
      this.player.volume(currentVolume / 100);
      var volumeIcon = function volumeIcon() {
        if (isMuted || currentVolume === 0) {
          return 'sound-mute';
        } else if (currentVolume > 0 && currentVolume <= 50) {
          return 'sound-medium';
        } else {
          return 'sound-loud';
        }
      };
      var getVolumePopupContent = function getVolumePopupContent() {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-volume-box")
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-volume-value")
        }, currentVolume, "%"), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(prefixCls, "-volume-slider")
        }, /*#__PURE__*/_react["default"].createElement(_index3["default"], {
          vertical: true,
          min: 0,
          max: 100,
          step: 1,
          handle: /*#__PURE__*/_react["default"].createElement("div", {
            className: "".concat(prefixCls, "-customer-handle")
          }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
            type: "sound-drag"
          })),
          tipFormatter: null,
          value: currentVolume,
          onChange: function onChange(value) {
            return _this2.handleChangeVolume(value);
          }
        })));
      };
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: (0, _classnames["default"])(prefixCls, 'fishd-video-js-customer-button')
      }, /*#__PURE__*/_react["default"].createElement(_index2["default"], {
        trigger: "hover",
        placement: "top",
        content: getVolumePopupContent(currentVolume),
        visible: volumeOpen,
        onVisibleChange: this.onVolumeVisibleChange,
        getPopupContainer: function getPopupContainer(node) {
          return node.parentNode;
        }
      }, /*#__PURE__*/_react["default"].createElement(_index["default"], {
        className: "control-volume",
        type: volumeIcon(),
        onClick: this.handleVolumeClick
      })));
    }
  }]);
  return FullScreen;
}(_react.Component);
exports["default"] = FullScreen;
FullScreen.propTypes = {
  prefixCls: _propTypes["default"].string,
  vjsComponent: _propTypes["default"].object
};
FullScreen.defaultProps = {
  prefixCls: 'fishd-video-viewer-volume'
};