"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _construct = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/reflect/construct"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));
var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));
var _bind = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/bind"));
var _react = _interopRequireDefault(require("react"));
var _reactDom = _interopRequireDefault(require("react-dom"));
var _video = _interopRequireDefault(require("video.js"));
var _Volume = _interopRequireDefault(require("./Volume"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = (0, _getPrototypeOf2["default"])(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor;
      result = (0, _construct["default"])(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return (0, _possibleConstructorReturn2["default"])(this, result);
  };
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !_construct["default"]) return false;
  if (_construct["default"].sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call((0, _construct["default"])(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
var vjsComponent = _video["default"].getComponent('Component');
var vjsVolume = /*#__PURE__*/function (_vjsComponent) {
  (0, _inherits2["default"])(vjsVolume, _vjsComponent);
  var _super = _createSuper(vjsVolume);
  function vjsVolume(player, options) {
    var _context;
    var _this;
    (0, _classCallCheck2["default"])(this, vjsVolume);
    _this = _super.call(this, player, options);
    /* Bind the current class context to the mount method */
    _this.mount = (0, _bind["default"])(_context = _this.mount).call(_context, (0, _assertThisInitialized2["default"])(_this));
    /* When player is ready, call method to mount React component */
    player.ready(function () {
      _this.mount();
    });
    /* Remove React root when component is destroyed */
    _this.on("dispose", function () {
      _reactDom["default"].unmountComponentAtNode(_this.el());
    });
    return _this;
  }
  /**
   * We will render out the React component into the DOM element
   * generated automatically by the VideoJS createEl() method.
   *
   * We fetch that generated element using `this.el()`, a method provided by the
   * vjsComponent class that this class is extending.
   */
  (0, _createClass2["default"])(vjsVolume, [{
    key: "mount",
    value: function mount() {
      var el = this.el();
      el.className = "vjs-control vjs-button vjs-customer-button vjs-volume";
      _reactDom["default"].render( /*#__PURE__*/_react["default"].createElement(_Volume["default"], {
        vjsComponent: this
      }), el);
    }
  }]);
  return vjsVolume;
}(vjsComponent);
/**
 * Make sure to register the vjsComponent so Video JS knows it exists
 */
vjsComponent.registerComponent('vjsVolume', vjsVolume);
var _default = vjsVolume;
exports["default"] = _default;